// common2.c
// Copyright : 2019-02-01 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <conio.h>
#include <stdio.h>

#include <windows.h>
#include <imagehlp.h>
#include <shlwapi.h>

#include "common2.h"


// O[oϐ
wchar_t recovery_file[MAX_LEN];	// JoEt@C̃pX
wchar_t base_dir[MAX_LEN];		// \[XEt@C̊fBNg
wchar_t ini_path[MAX_LEN];		// ʃt@C̃pX

int base_len;		// \[XEt@C̊fBNg̒
int recovery_limit;	// 쐬̓JoEt@C̃TCY
int first_num;		// 쐬͍ŏ̃peBEubNԍA͏߂Č
int switch_b;		// obNAbv邩 (쐬̓\[XEubN̊ƊTCY)

int file_num;		// \[XEt@C̐
int entity_num;		// ̂̂t@C̐ (recovery set Ɋ܂܂t@C)
int recovery_num;	// JoEt@C̐
int source_num;		// \[XEubN̐
int parity_num;		// peBEubN̐

unsigned int block_size;	// ubNETCY
unsigned int split_size;	// TCY
__int64 total_file_size;	// vt@CETCY

// ϒTCŸ̗Ƀt@CL^
wchar_t *list_buf;	// \[XEt@C̃Xg
int list_len;		// t@CEXg̕
int list_max;		// t@CEXg̍ő啶

wchar_t *recv_buf;	// JoEt@C̃Xg
int recv_len;		// t@CEXg̕

wchar_t *list2_buf;	// w肳ꂽΏۂ̃t@C̃Xg
int list2_len;
int list2_max;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

unsigned int cp_output;	// Console Output Code Page

// w肳ꂽ Code Page  UTF-16 ɕϊ
int cp_to_utf16(char *in, wchar_t *out, unsigned int cp)
{
	int err = 0;
	unsigned int dwFlags = MB_ERR_INVALID_CHARS;	// sK؂ȕx

	if (cp == CP_UTF8)
		dwFlags = 0;

	if (MultiByteToWideChar(cp, dwFlags, in, -1, out, MAX_LEN) == 0){
		err = GetLastError();
		if ((dwFlags != 0) && (err == ERROR_INVALID_FLAGS)){
			//printf("MultiByteToWideChar, ERROR_INVALID_FLAGS\n");
			if (MultiByteToWideChar(cp, 0, in, -1, out, MAX_LEN) != 0)
				return 0;
			err = GetLastError();
		}
		out[0] = 0;
		return err;
	}
	return 0;
}

// Windown OS  UTF-16 w肳ꂽ Code Page ɕϊ
int utf16_to_cp(wchar_t *in, char *out, unsigned int cp)
{
	unsigned int dwFlags = WC_NO_BEST_FIT_CHARS;	// ւ̎ϊsȂ

	if (cp == CP_UTF8)
		dwFlags = 0;

	if (WideCharToMultiByte(cp, dwFlags, in, -1, out, MAX_LEN * 3, NULL, NULL) == 0){
		if ((dwFlags != 0) && (GetLastError() == ERROR_INVALID_FLAGS)){
			//printf("WideCharToMultiByte, ERROR_INVALID_FLAGS\n");
			if (WideCharToMultiByte(cp, 0, in, -1, out, MAX_LEN * 3, NULL, NULL) != 0)
				return 0;
		}
		strcpy(out, "cannot encode");
		return 1;
	}
	return 0;
}

// Windows OS  UTF-8  UTF-16 ɕϊ
void utf8_to_utf16(char *in, wchar_t *out)
{
	// UTF-16 <-> UTF-8 Ԃł͕ȊÕG[͔Ȃ
	if (MultiByteToWideChar(CP_UTF8, 0, in, -1, out, MAX_LEN) == 0)
		wcscpy(out, L"too long");
}

// Windown OS  UTF-16  UTF-8 ɕϊ
void utf16_to_utf8(wchar_t *in, char *out)
{
	// UTF-16 <-> UTF-8 Ԃł͕ȊÕG[͔Ȃ
	WideCharToMultiByte(CP_UTF8, 0, in, -1, out, MAX_LEN * 3, NULL, NULL);
}

//  UTF-8 ǂ𔻒肷 (0 = maybe UTF-8)
int check_utf8(unsigned char *text)
{
	unsigned char c1;
	int tail_len = 0;	// UTF8-tail oCg

	while (*text != 0){
		c1 = *text;
		// ֎~ 0xC0`0xC1C0xF5`0xFF
		if ((c1 == 0xC0) || (c1 == 0xC1) || (c1 >= 0xF5))
			return 1;	// ֎~
		if (tail_len == 0){	// 1oCgȂ
			// 1oCg
			if (c1 <= 0x7F){
				tail_len = 0;
			// 2oCg̑1oCg
			} else if ((c1 >= 0xC2) && (c1 <= 0xDF)){
				tail_len = 1;
			// 3oCg̑1oCg
			} else if ((c1 >= 0xE0) && (c1 <= 0xEF)){
				tail_len = 2;
			// 4oCg̑1oCg
			} else if (c1 >= 0xF0){
				tail_len = 3;
			} else {
				return 2;	//  1oCgƂĕsKȕ
			}
		} else {	// 2oCgȌȂ
			if ((c1 >= 0x80) && (c1 <= 0xBF)){
				tail_len--;
			} else {
				return 2;	// 2oCgȌƂĕsKȕ
			}
		}
		text++;	// ̕
	}
	return 0;
}

// t@CEpXA擪ɂ "\\?\" ȂāAw肳ꂽ Code Page ɕϊ
int path_to_cp(wchar_t *path, char *out, unsigned int cp)
{
	unsigned int dwFlags = WC_NO_BEST_FIT_CHARS;	// ւ̎ϊsȂ

	if (cp == CP_UTF8)
		dwFlags = 0;

	if (wcsncmp(path, L"\\\\?\\", 4) == 0){	// "\\?\" Ȃ
		path += 4;
		if (wcsncmp(path, L"UNC\\", 4) == 0){	// "\\?\UNC" Ȃ "\" ǉ
			path += 3;
			*out = '\\';
			out += 1;
		}
	}

	if (WideCharToMultiByte(cp, dwFlags, path, -1, out, MAX_LEN * 3, NULL, NULL) == 0){
		if ((dwFlags != 0) && (GetLastError() == ERROR_INVALID_FLAGS)){
			//printf("WideCharToMultiByte, ERROR_INVALID_FLAGS\n");
			if (WideCharToMultiByte(cp, 0, path, -1, out, MAX_LEN * 3, NULL, NULL) != 0)
				return 0;
		}
		strcpy(out, "cannot encode");
		return 1;
	}
	return 0;
}

// UTF-16 ̃t@CEpXʏo͗p Code Page gĕ\
void printf_cp(unsigned char *format, wchar_t *path)
{
	unsigned char buf[MAX_LEN * 3];
	path_to_cp(path, buf, cp_output);
	printf(format, buf);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// t@C offset oCgڂ size oCg̃f[^ buf ɓǂݍ
int file_read_data(
	HANDLE hFileRead,
	__int64 offset,
	unsigned char *buf,
	unsigned int size)
{
	unsigned int rv;

	// t@C̈ʒu offsetoCgڂɂ
	if (!SetFilePointerEx(hFileRead, *((PLARGE_INTEGER)&offset), NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// size oCgǂݍ
	if (!ReadFile(hFileRead, buf, size, &rv, NULL)){
		print_win32_err();
		return 1;
	}
	if (size != rv)
		return 1;	// wTCYǂݍ߂ȂG[ɂȂ

	return 0;
}

// t@C offset oCgڂ size oCg̃f[^ buf 珑
int file_write_data(
	HANDLE hFileWrite,
	__int64 offset,
	unsigned char *buf,
	unsigned int size)
{
	unsigned int rv;

	// t@C̈ʒu offsetoCgڂɂ
	if (!SetFilePointerEx(hFileWrite, *((PLARGE_INTEGER)&offset), NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// size oCg
	if (!WriteFile(hFileWrite, buf, size, &rv, NULL)){
		print_win32_err();
		return 1;
	}

	return 0;
}

// t@C offset oCgڂ size oCg̎wl
int file_fill_data(
	HANDLE hFileWrite,
	__int64 offset,
	unsigned char value,
	unsigned int size)
{
	unsigned char buf[IO_SIZE];
	unsigned int rv, len;

	// t@C̈ʒu offsetoCgڂɂ
	if (!SetFilePointerEx(hFileWrite, *((PLARGE_INTEGER)&offset), NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// w肳ꂽlŖ߂
	memset(buf, value, IO_SIZE);
	while (size){
		len = IO_SIZE;
		if (size < IO_SIZE)
			len = size;
		size -= len;
		if (!WriteFile(hFileWrite, buf, len, &rv, NULL)){
			print_win32_err();
			return 1;
		}
	}

	return 0;
}

// t@C̎woCgڂ size oCg̃f[^ʂ̃t@Cɏ
int file_copy_data(
	HANDLE hFileRead,
	__int64 offset_read,
	HANDLE hFileWrite,
	__int64 offset_write,
	unsigned int size)
{
	unsigned char buf[IO_SIZE];
	unsigned int rv, len;

	// t@C̈ʒu offset_read oCgڂɂ
	if (!SetFilePointerEx(hFileRead, *((PLARGE_INTEGER)&offset_read), NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// t@C̈ʒu offset_write oCgڂɂ
	if (!SetFilePointerEx(hFileWrite, *((PLARGE_INTEGER)&offset_write), NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// Rs[
	while (size){
		len = IO_SIZE;
		if (size < IO_SIZE)
			len = size;
		size -= len;
		if (!ReadFile(hFileRead, buf, len, &rv, NULL)){
			print_win32_err();
			return 1;	// wTCYǂݍ߂ȂĂG[ɂȂ
		}
		if (rv < len){
			memset(buf + rv, 0, len - rv);	// Ȃ 0 Ŗ߂
			size = 0;
		}
		if (!WriteFile(hFileWrite, buf, len, &rv, NULL)){
			print_win32_err();
			return 1;
		}
	}

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// C̃e|Et@C̖O
//  _par.tmp ǉ (ADD_LEN ȉ̕)
void get_temp_name(
	wchar_t *file_path,		// t@CEpX
	wchar_t *temp_path)		// e|Et@C̃pX
{
	wcscpy(temp_path, file_path);
	wcscat(temp_path, L"_par.tmp");	// ɒǉ
}

// Ɨp̃[Ŗ߂ꂽe|Et@C쐬
int create_temp_file(
	wchar_t *file_path,		// t@C̃pX
	__int64 file_size)		// t@C̃TCY
{
	HANDLE hFile;

	hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE){
		if (GetLastError() == ERROR_PATH_NOT_FOUND){	// Path not found (3)
			make_dir(file_path);	// r̃tH_݂Ȃ̂Ȃ쐬
			hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		}
		if (hFile == INVALID_HANDLE_VALUE){
			print_win32_err();
			return 1;
		}
	}

	// {̃TCYɂ
	if (!SetFilePointerEx(hFile, *((PLARGE_INTEGER)&file_size), NULL, FILE_BEGIN)){
		print_win32_err();
		CloseHandle(hFile);
		return 1;
	}
	if (!SetEndOfFile(hFile)){
		print_win32_err();
		CloseHandle(hFile);
		return 1;
	}
	CloseHandle(hFile);

	return 0;
}

#define FILE_WAIT_SEC	200	// t@CANZX̑҂ ms
#define FILE_WAIT_NUM	5

// Ɨp̃\[XEt@CJ
HANDLE handle_temp_file(
	wchar_t *file_name,		// \[XEt@C
	wchar_t *file_path)		// ƗpAfBNgĂ
{
	int rv, retry_time = FILE_WAIT_NUM;
	HANDLE hFile;

	get_temp_name(file_name, file_path + base_len);
	hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	while (hFile == INVALID_HANDLE_VALUE){
		rv = GetLastError();
		if ((rv == 32) ||		// ERROR_SHARING_VIOLATION
				(rv == 33)){	// ERROR_LOCK_VIOLATION
			Sleep(FILE_WAIT_SEC);	// ҂ĂĒ킷
			hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
		} else {
			break;
		}
		retry_time--;
		if (retry_time == 0)
			break;
	}
	if (hFile == INVALID_HANDLE_VALUE){
		print_win32_err();
		printf_cp("cannot open file, %s\n", file_path);
	}

	return hFile;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// t@CEpXt@CEXgɊɑ݂邩ׂ
int search_file_path(
	wchar_t *list,			// t@CEXg
	int total_len,			// t@CEXg̕
	wchar_t *search_file)	// t@C̃pX
{
	int off = 0;

	while (off < total_len){
		if (_wcsicmp(list + off, search_file) == 0)
			return 1;
		// ̃t@C̈ʒu
		//off += (wcslen(list + off) + 1);
		while (list[off] != 0)
			off++;
		off++;
	}

	return 0;
}

// t@CEXg̓eёւ
void sort_list(
	wchar_t *list,	// t@CEXg
	int total_len)	// t@CEXg̕
{
	wchar_t *work_buf;
	int off1 = 0, off2, off3, work_off = 0;

	// ƃobt@[mۂ
	work_buf = (wchar_t *)calloc(total_len, 2);
	if (work_buf == NULL)
		return;	// בւs

	while (off1 < total_len){
		if (list[off1] == 0){
			break;
		} else if (list[off1] == '*'){	// ɃRs[ςȂ
			//off1 += (wcslen(list + off1) + 1);
			while (list[off1] != 0)
				off1++;
			off1++;
			continue;
		}
		off3 = off1;

		//off2 = off3 + wcslen(list + off3) + 1;	// ̍
		off2 = off3;
		while (list[off2] != 0)
			off2++;
		off2++;
		while (off2 < total_len){
//printf("%S (%d), %S (%d)\n", list + off3, off3, list + off2, off2);
			if (list[off2] != '*'){	// ܂Ȃ獀ڂr
				//if (wcscmp(list + off3, list + off2) > 0)	// QuickPar ͂̏
				if (CompareString(LOCALE_USER_DEFAULT, 0, list + off3, -1, list + off2, -1) > 2)
					off3 = off2;
			}
			//off2 += (wcslen(list + off2) + 1);	// ̍
			while (list[off2] != 0)
				off2++;
			off2++;
		}

		// ԂɃRs[Ă
//printf("get %S (%d)\n", list + off3, off3);
		wcscpy(work_buf + work_off, list + off3);
		work_off += ((int)wcslen(work_buf + work_off) + 1);
		list[off3] = '*';	// Rs[
		if (off3 == off1){
			//off1 += (wcslen(list + off1) + 1);
			while (list[off1] != 0)
				off1++;
			off1++;
		}
	}

	// ƃobt@[߂
	memcpy(list, work_buf, total_len * 2);
	free(work_buf);
}

// \[XEt@C̃XgɐVt@Cǉ
int add_file_path(wchar_t *filename)	// ǉt@C
{
	wchar_t *tmp_p;
	int len;

	len = (int)wcslen(filename);

	if (list_len + len >= list_max){	// ̈悪ȂȂȂg
		list_max += ALLOC_LEN;
		tmp_p = (wchar_t *)realloc(list_buf, list_max * 2);
		if (tmp_p == NULL){
			return 1;
		} else {
			list_buf = tmp_p;
		}
	}

	wcscpy(list_buf + list_len, filename);
	list_len += len + 1;

	return 0;
}

// t@CEXgw肳ꂽt@CEpX菜
// 炵̃t@CEXg̕Ԃ
int remove_file_path(
	wchar_t *list,	// t@CEXg
	int total_len,	// t@CEXg̕
	int file_off)	// 菜t@CEpẌʒu
{
	int off, len;

	if (file_off > total_len)
		return total_len;

	len = (int)wcslen(list + file_off) + 1;	// NULL܂߂
	if (len < total_len){
		for (off = file_off; off < total_len - len; off++)
			list[off] = list[off + len];
		for (off = total_len - len; off < total_len; off++)
			list[off] = 0;
		return total_len - len;
	} else {
		for (off = 0; off < total_len; off++)
			list[off] = 0;
		return 0;
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// t@CEpXt@C̈ʒu߂
wchar_t * offset_file_name(wchar_t *file_path)
{
	int i;

	for (i = (int)wcslen(file_path) - 2; i >= 0; i--){
		if ((file_path[i] == '\\') || (file_path[i] == '/'))
			break;
	}
	i++;
	return file_path + i;
}

// t@CEpXt@Co
void get_file_name(
	wchar_t *file_path,		// t@CEpX
	wchar_t *file_name)		// t@C
{
	int i, len, find = -1;

	len = (int)wcslen(file_path);
	for (i = len - 2; i >= 0; i--){
		if ((file_path[i] == '\\') || (file_path[i] == '/')){
			find = i;
			break;
		}
	}
	find++;
	for (i = find; i < len + 1; i++){
		file_name[i - find] = file_path[i];
	}
}

// t@CEpXfBNgoÁu\vu/v
void get_base_dir(
	wchar_t *file_path,		// t@CEpX
	wchar_t *base_path)		// fBNg
{
	int i, len, find = 0;

	len = (int)wcslen(file_path);
	if (len <= 1){
		base_path[0] = 0;
		return;
	}

	// ŏ疖u\vu/vȂ
	if ((file_path[len - 1] == '\\') || (file_path[len - 1] == '/'))
		len--;	// 菜ĂЂƂẽfBNgԂ
	for (i = len - 1; i >= 0; i--){
		if (find == 0){
			if ((file_path[i] == '\\') || (file_path[i] == '/')){
				find = 1;
				base_path[i] = file_path[i];
				base_path[i + 1] = 0;
			}
		} else {
			base_path[i] = file_path[i];
		}
	}
	if (find == 0)
		base_path[0] = 0;
}

// fBNgĹu\vu/vɒu
void unix_directory(wchar_t *path)
{
	wchar_t *tmp_p;

	tmp_p = wcschr(path, '\\');
	while (tmp_p != NULL){
		*tmp_p = '/';
		tmp_p = wcschr(tmp_p, '\\');
	}
}

// ΃pXǂ𔻒肷
int is_full_path(wchar_t *path)
{
	if ((path[0] == 0) || (path[1] == 0))
		return 0;	// 2ȉƒZ

	// ʏ̃hCuwuc:\v̌`
	if ((path[1] == ':') && ((path[2] == '\\') || (path[2] == '/')))
		return 1;

	//u\\?\vt̂͐΃pX
	// lbg[N UNC pXȂu\\<server>\<share>v
	if (((path[0] == '\\') || (path[0] == '/')) && ((path[1] == '\\') || (path[1] == '/')))
		return 1;

	return 0;
}

// t@C̃fBNgʒuǂ𒲂ׂ
// tH_ɂ͑ΉĂȂƂɒ!
int compare_directory(wchar_t *path1, wchar_t *path2)
{
	int len1, len2;

	// pX̒
	len1 = 0;
	while (path1[len1] != 0)
		len1++;
	// tH_̈ʒu𒲂ׂ͖́u\v𖳎
//	if (accept_folder != 0)
//		len1--;
	// TuEfBNg̒ɂ
	while ((len1 > 0) && (path1[len1] != '\\'))
		len1--;

	// pX̒
	len2 = 0;
	while (path2[len2] != 0)
		len2++;
	// tH_̈ʒu𒲂ׂ͖́u\v𖳎
//	if (accept_folder != 0)
//		len2--;
	// TuEfBNg̒ɂ
	while ((len2 > 0) && (path2[len2] != '\\'))
		len2--;

	// TuEfBNg̒r
	if (len1 > len2)
		return 1;	// path1  path2 傫
	if (len1 < len2)
		return -1;	// path1  path2 菬

	// fBNg̒Ȃ
	return _wcsnicmp(path1, path2, len1);
}

// ChJ[h܂ޕRs[
// o͕Ԃ (null܂)AsȃpXȂ 0 Ԃ
int copy_wild(wchar_t *dst, wchar_t *src)
{
	wchar_t s;
	int len = 0;

	while ((src[0] == '\\') || (src[0] == '/'))	// 擪́u\v͖
		src++;

	do {
		s = src[0];
		if (s == '/'){	// fBNgL𓝈ꂷ
			s = '\\';
			if ((src[1] == '\\') || (src[1] == '/'))
				return 0;
		} else if (s == '\\'){	// u\\v̓pXɊ܂܂Ȃ
			if ((src[1] == '\\') || (src[1] == '/'))
				return 0;
		} else if ((s >= 'A') && (s <= 'Z')){	// 啶ɕϊ
			s += 32;
		} else if ((s == '*') && (src[1] == '*')){	// Oȏ́u*vɂ
			while (src[2] == '*')
				src++;
		} else if ((s == '.') && (src[1] == '.')){	// u..v̓pXɊ܂܂Ȃ
			return 0;
		}

		dst[len++] = s;
		src++;
	} while (s != 0);

	return len;	//  null Ɋ܂ނƂɒ
}

// ChJ[h('*', '?')găjR[h̃pXr
// u*vƁu?v̓fBNgLɈvȂ
// u**v̓fBNgLɈv
int PathMatchWild(
	wchar_t *text,	// r镶
	wchar_t *wild)	// ChJ[h (ɂ邱)
{
	wchar_t next_char, *wild_prev, *wild_dir, *text_dir;
	int stop_dir;

	next_char = 0;
	wild_prev = NULL;
	wild_dir = NULL;
	text_dir = text;
	stop_dir = 0;

	while (*text != 0){
		//printf("%c, %c \n", *text, *wild);
		if (*wild == '*'){
			wild++;
			if (*wild == '*'){	// u**v
				while (*wild == '*')	// Au*v𖳎
					wild++;
				stop_dir = 0;
				wild_dir = wild;
			} else {	// u*v
				stop_dir = 1;
			}

			if (*wild == 0){	// u*v̎ΈvƂ݂Ȃ
				if (stop_dir){	// fBNgL݂Εsv
					while (*text != 0){
						if (*text == '\\'){
							stop_dir = 2;
							break;
						}
						text++;
					}
					if (stop_dir == 2){
						if (wild_dir != NULL){
							stop_dir = 0;
							wild_prev = wild_dir;
							text = text_dir + 1;
							wild = wild_dir;
							next_char = *wild;
							//printf("\n agian last: %c, %c \n", *text, next_char);
							continue;
						}
						//printf("\n last * != include \\ \n");
						return 0;
					}
				}
				return 1;
			} else {
				next_char = *wild;	// u*v̎̕
				wild_prev = wild;	// Ṓu*v̈ʒu
				//printf("next = %c, stop_dir = %d\n", next_char, stop_dir);
			}
		}

		if ((*text == '\\') && (stop_dir))	// fBNgL݂ȂĔrȂ
			wild_prev = NULL;

		if (next_char != 0){	// u*v̌Ȃ
			if ((next_char == towlower(*text)) || ((*text != '\\') && (next_char == '?'))){
				wild++;
				next_char = 0;
				text_dir = text;
			}
			if ((*text == '\\') && (stop_dir))	// fBNgL݂Ȃ烏ChJ[h𖳌ɂ
				next_char = 0;
			text++;

		} else if ((*wild == towlower(*text)) || ((*text != '\\') && (*wild == '?'))){	// Ȃ
			wild++;
			text++;

		} else {	// ႤȂ
			if (wild_prev != NULL){	// ÕChJ[hrȂ
				wild = wild_prev;
				next_char = *wild;
				//printf("\n agian: %c, %c \n", *text, next_char);

			} else if ((stop_dir != 0) && (wild_dir != NULL)){
				stop_dir = 0;
				wild_prev = wild_dir;
				text = text_dir + 1;
				wild = wild_dir;
				next_char = *wild;
				//printf("\n agian dir: %c, %c \n", *text, next_char);

			} else{
				//printf("\n diff: %c, %c \n", *text, *wild);
				return 0;	// ȏvȂ
			}
		}
	}

	while (*wild == '*')	// ću*v𖳎
		wild++;
	if (*wild == 0)	// ChJ[hI[ȂvƂ݂Ȃ
		return 1;

	return 0;
}

/*
int PathMatchWild1(
	wchar_t *text,	// r镶
	wchar_t *wild)	// ChJ[h (ɂ邱)
{
	wchar_t next_char, *wild_prev;

	next_char = 0;
	wild_prev = NULL;

	while (*text != 0){
		//printf("%c, %c \n", *text, *wild);

		if (*wild == '*'){
			wild++;
			while (*wild == '*')	// Au*v𖳎
				wild++;

			if (*wild == 0){	// u*v̎ΈvƂ݂Ȃ
				return 1;
			} else {
				next_char = *wild;	// u*v̎̕
				wild_prev = wild;	// Ṓu*v̈ʒu
			}
		}

		if (next_char != 0){	// u*v̌Ȃ
			if ((next_char == towlower(*text)) || (next_char == '?')){
				wild++;
				next_char = 0;
			}
			text++;

		} else if ((*wild == towlower(*text)) || (*wild == '?')){	// Ȃ
			wild++;
			text++;

		} else {	// ႤȂ
			if (wild_prev != NULL){	// ÕChJ[hrȂ
				wild = wild_prev;
				next_char = *wild;
				//printf("\n agian: %c, %c \n", *text, next_char);

			} else{
				return 0;	// ȏvȂ
			}
		}
	}

	while (*wild == '*')	// ću*v𖳎
		wild++;
	if (*wild == 0)	// ChJ[hI[ȂvƂ݂Ȃ
		return 1;

	return 0;
}
*/

// t@C̃pXOXgƔr
int exclude_path(wchar_t *path)
{
	int off = 0, deny = 0;

	deny = list2_max;
	while (off < list2_len){
		if (list2_buf[off++] == '+'){	// allow
			if ((deny != 0) && (PathMatchWild(path, list2_buf + off) != 0)){
			//	printf_cp("allow: '%s'", path);
			//	printf_cp(" : '%s'\n", list2_buf + off);
				deny = 0;
			}
		} else {	// deny
			if (PathMatchWild(path, list2_buf + off) != 0){
			//	printf_cp("deny : '%s'", path);
			//	printf_cp(" : '%s'\n", list2_buf + off);
				return 1;
			}
		}
		off += (int)wcslen(list2_buf + off) + 1;
	}

//	if ((list2_max != 0) && (deny != 0))
//		printf_cp("not  : '%s'\n", path);

	return deny;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define PREFIX_LEN	4	// u\\?\v̒

// ΃pX΃pXɕϊApX̐擪 "\\?\" ǉ
// ߂l : 0=G[, 5`=VpX̒
int copy_path_prefix(
	wchar_t *new_path,	// VpX
	int max_len,		// VpX̍ő咷 ( null܂)
	wchar_t *src_path,	// ̃pX (΃pXł悢)
	wchar_t *dir_path)	// ΃pX̏ꍇɊƂȂfBNg (NULL ȂJgEfBNg)
{
	wchar_t tmp_path[MAX_LEN];
	int len;

	// sȃt@Cۂ (L͋)
	if (src_path[0] == 0)
		return 0;
	if (wcspbrk(src_path, L"\"<>|"))	// WinOS ł̓t@CɁu\/:*?"<>|v͎̕gȂ
		return 0;

	// ΃pXɑ΂ĊƂȂfBNgw肳ĂȂ
	if ((dir_path != NULL) && (is_full_path(src_path) == 0)){
		// ̂܂܊fBNgAĐ΃pXɂ
		len = (int)wcslen(dir_path);
		if (len + (int)wcslen(src_path) >= max_len)
			return 0;
		wcscpy(tmp_path, dir_path);	// dir_path ̖́u\vɂĂ
		wcscpy(tmp_path + len, src_path);
		if (_wfullpath(new_path, tmp_path, max_len) == NULL)
			return 0;
	} else {	// JgEfBNgg
		// ΃pX΃pXɕϊ (fBNgLu\vɓꂳ)
		if (_wfullpath(new_path, src_path, max_len) == NULL)
			return 0;
	}

	// 擪 "\\?\" ݂ȂȂAǉ
	if ((wcsncmp(new_path, L"\\\\?\\", PREFIX_LEN) != 0)){
		len = (int)wcslen(new_path);
		if ((new_path[0] == '\\') && (new_path[1] == '\\')){	// UNC pXȂ
			if (len + PREFIX_LEN + 2 >= max_len)
				return 0;	// obt@[ETCYȂĒǉłȂ
			memmove(new_path + (PREFIX_LEN + 3), new_path + 1, len * 2);
			new_path[PREFIX_LEN    ] = 'U';
			new_path[PREFIX_LEN + 1] = 'N';
			new_path[PREFIX_LEN + 2] = 'C';
		} else {	// ʏ̃hCuLŎn܂pXȂ
			if (len + PREFIX_LEN >= max_len)
				return 0;	// obt@[ETCYȂĒǉłȂ
			memmove(new_path + PREFIX_LEN, new_path, (len + 1) * 2);
		}
		memcpy(new_path, L"\\\\?\\", PREFIX_LEN * 2);
	}

	// 8.3`̒Zt@C𒷂t@Cɕϊ
	if (GetFileAttributes(new_path) == INVALID_FILE_ATTRIBUTES){
		// w肳ꂽt@C݂Ȃꍇ (쐬PARt@Cu*?vŌ\[XEt@C)
		for (len = PREFIX_LEN; new_path[len] != 0; len++){
			if ((new_path[len] == '*') || (new_path[len] == '?'))
				break;	// ChJ[h܂ރpX
		}
		// ChJ[hÕfBNgLT
		for (; len >= 0; len--){
			if (new_path[len] == '\\')
				break;
		}
		len++;
		wcscpy(tmp_path, new_path + len);	// ݂Ȃt@CL^Ă
		new_path[len] = 0;	// t@C
		len = GetLongPathName(new_path, new_path, max_len);
		if (len == 0){	// tH_[t@C݂ȂĂG[IȂ
			//printf("GetLongPathName (not exist) : err = %d\n", GetLastError());
			//print_win32_err();
			wcscat(new_path, tmp_path);
			len = (int)wcslen(new_path);
		} else {	// ޔĂt@Cǉ
			len += (int)wcslen(tmp_path);
			if (len < max_len)
				wcscat(new_path, tmp_path);
		}
	} else {
		len = GetLongPathName(new_path, new_path, max_len);
		if (len == 0){	// ϊG[
			//printf("GetLongPathName (exist) : err = %d\n", GetLastError());
			return 0;
		}
	}
	if (len >= max_len)
		return 0;

	return len;
}

// t@CEpXA擪ɂ "\\?\" Ȃ߂
int len_without_prefix(wchar_t *file_path)
{
	// ŏ "\\?\" 
	if (wcsncmp(file_path, L"\\\\?\\", PREFIX_LEN) != 0)
		return (int)wcslen(file_path);	// ̂܂܂̒

	// "\\?\UNC\<server>\<share>" Ȃlbg[NEpX
	if (wcsncmp(file_path + PREFIX_LEN, L"UNC\\", 4) == 0)
		return (int)wcslen(file_path + PREFIX_LEN + 2);	// "\\?\UNC\" -> "\\" Ȃ̂6炷

	// "\\?\<drive:>\<path>" Ȃ
	return (int)wcslen(file_path + PREFIX_LEN);	// "\\?\" Ȃ̂4炷
}

// t@CEpXA擪ɂ "\\?\" ȂăRs[
int copy_without_prefix(
	wchar_t *dst_path,	// Rs[ (Rs[ƓAhXł悢)
	wchar_t *src_path)	// Rs[̃pX
{
	int i, len;

	len = (int)wcslen(src_path);	// ̕

	// ŏ "\\?\" 
	if (wcsncmp(src_path, L"\\\\?\\", PREFIX_LEN) != 0){
		for (i = 0; i <= len; i++)
			dst_path[i] = src_path[i];	// ̂܂܃Rs[
		return len;
	}

	// "\\?\UNC\<server>\<share>" Ȃlbg[NEpX
	if (wcsncmp(src_path + PREFIX_LEN, L"UNC\\", 4) == 0){
		len -= PREFIX_LEN + 2;	// "\\?\UNC\" -> "\\" Ȃ̂6炷
		for (i = 1; i <= len; i++)
			dst_path[i] = src_path[PREFIX_LEN + 2 + i];
		dst_path[0] = '\\';	// 擪 "\\" ɕςĂ
		return len;
	}

	// "\\?\<drive:>\<path>" Ȃ
	len -= PREFIX_LEN;	// "\\?\UNC\" -> "\\" Ȃ̂6炷
	for (i = 0; i <= len; i++)
		dst_path[i] = src_path[PREFIX_LEN + i];
	return len;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// ԂɃTuEfBNg쐬
int make_dir(
	wchar_t *file_path)		// TuEfBNg܂ރt@CEpX
{
	wchar_t dir_path[MAX_LEN];
	unsigned int rv;

	get_base_dir(file_path, dir_path);	// efBNg擾
	if (dir_path[0] == 0)
		return 0;	// fBNgȂȂo
	rv = (int)wcslen(dir_path);
	if ((dir_path[rv - 1] == '\\') || (dir_path[rv - 1] == '/'))	// ́u/v菜
		dir_path[rv - 1] = 0;

	rv = GetFileAttributes(dir_path);
	if (rv == INVALID_FILE_ATTRIBUTES){	// tH_܂݂Ȃꍇ
		// ɐetH_쐬
		if (rv = make_dir(dir_path))
			return rv;
		if (!CreateDirectory(dir_path, NULL))
			return 1;
	} else if ((rv & FILE_ATTRIBUTE_DIRECTORY) == 0){
		// łɓÕt@C݂ꍇ̓G[
		return 2;
	}
	return 0;
}

// t@Cu (t@C̏CAe|[Et@C̏߂Ȃ)
int replace_file(
	wchar_t *dest_path,		// ũpX (ړACꂽt@C)
	wchar_t *sorc_path)		// u錳̃pX (ړÃ݂t@C)
{
	unsigned int rv, num, retry_time = FILE_WAIT_NUM;

	// ړ̃t@C݂邩ǂ
	num = GetFileAttributes(sorc_path);
	if (num == INVALID_FILE_ATTRIBUTES){
		return 1;	// ړt@C݂Ȃ
	} else {
		if (num & FILE_ATTRIBUTE_DIRECTORY){	// ΏۂtH_Ȃ疖́u\v菜
			rv = (unsigned int)wcslen(sorc_path);
			if (sorc_path[rv - 1] == '\\')
				sorc_path[rv - 1] = 0;
			rv = (unsigned int)wcslen(dest_path);
			if (dest_path[rv - 1] == '\\')
				dest_path[rv - 1] = 0;
		}
		if (num & FILE_ATTRIBUTE_READONLY){	// ǂݎpȂȂ
			if (SetFileAttributes(sorc_path, num ^ FILE_ATTRIBUTE_READONLY) == 0)
				return 2;	// ړ̓ǂݎpłȂ
		}
	}
	//printf_cp("dest_path = %s\n", dest_path);
	//printf_cp("sorc_path = %s\n", sorc_path);

	// ړ̃t@C݂邩ǂ
	rv = GetFileAttributes(dest_path);
	if (rv == INVALID_FILE_ATTRIBUTES){	// t@C݂ȂȂÂ܂܈ړ
		if (MoveFile(sorc_path, dest_path) == 0){
			if (GetLastError() == ERROR_PATH_NOT_FOUND){	// Path not found (3)
				make_dir(dest_path);	// r̃tH_݂Ȃ̂Ȃ쐬
				if (MoveFile(sorc_path, dest_path) == 0)
					return 3;	// łړs
			} else {
				return 4;	// ړs
			}
		}
		if (num & FILE_ATTRIBUTE_READONLY){	// ǂݎpt
			rv = GetFileAttributes(dest_path);
			SetFileAttributes(dest_path, rv | FILE_ATTRIBUTE_READONLY);	// sĂG[ɂȂ
		}

	} else if ((num & FILE_ATTRIBUTE_DIRECTORY) != (rv & FILE_ATTRIBUTE_DIRECTORY)){
		// t@C̈ړɃtH_A܂̓tH_̈ړɃt@C݂Ȃ
		move_away_file(dest_path);	// ǂ
		if (MoveFile(sorc_path, dest_path) == 0)
			return 5;	// ړs
		if (num & FILE_ATTRIBUTE_READONLY){	// ǂݎpt
			rv = GetFileAttributes(dest_path);
			SetFileAttributes(dest_path, rv | FILE_ATTRIBUTE_READONLY);	// sĂG[ɂȂ
		}

	} else {	// Ƀt@C݂Ȃ
		wchar_t back_path[MAX_LEN];

		back_path[0] = 0;
		if (switch_b & 3){	// ̃t@C폜ɕʖŎc
			for (num = 1; num < 100; num++){
				swprintf(back_path, _countof(back_path), L"%s.%d", dest_path, num);	// obNAbvEt@C̃pX
				if (GetFileAttributes(back_path) == INVALID_FILE_ATTRIBUTES)
					break;	// ݂ȂȂ OK
			}
			if (num >= 100)
				back_path[0] = 0;	// obNAbvςȂ炻ȏȂ
		}
		if (back_path[0] != 0){	// obNAbvĒu
			//printf_cp("back_path = %s\n", back_path);
			num = ReplaceFile(dest_path, sorc_path, back_path, REPLACEFILE_IGNORE_MERGE_ERRORS, 0, 0);
			while (num == 0){
				num = GetLastError();
				//printf("error = %d\n", num);
				// The process cannot access the file because it is being used by another process.
				if ((num == 32) ||			// ERROR_SHARING_VIOLATION
						(num == 33) ||		// ERROR_LOCK_VIOLATION
						(num == 1175) ||	// ERROR_UNABLE_TO_REMOVE_REPLACED
						(num == 1176)){		// ERROR_UNABLE_TO_MOVE_REPLACEMENT
					Sleep(FILE_WAIT_SEC);
					num = ReplaceFile(dest_path, sorc_path, back_path, REPLACEFILE_IGNORE_MERGE_ERRORS, 0, 0);
				} else if (num == 1177){	// ERROR_UNABLE_TO_MOVE_REPLACEMENT_2
					Sleep(FILE_WAIT_SEC);
					num = MoveFile(sorc_path, dest_path);	// t@C̓obNAbvς݂ȂAړ邾
				} else {
					return 6;
				}
				retry_time--;
				if (retry_time == 0)
					break;
			}
			if (num == 0)
				return 7;
			if (switch_b & 2)	// obNAbvS~ɓ
				delete_file_recycle(back_path);
		} else {	// ̃t@C폜Ēu
			if (rv & FILE_ATTRIBUTE_READONLY){	// ǂݎpȂAȖ
				if (SetFileAttributes(dest_path, rv ^ FILE_ATTRIBUTE_READONLY) == 0)
					return 7;	// ړ̓ǂݎpłȂ = 폜łȂ
			}
			num = ReplaceFile(dest_path, sorc_path, NULL, REPLACEFILE_IGNORE_MERGE_ERRORS, 0, 0);
			while (num == 0){
				num = GetLastError();
				//printf("error = %d\n", num);
				if ((num == 32) ||			// ERROR_SHARING_VIOLATION
						(num == 33) ||		// ERROR_LOCK_VIOLATION
						(num == 1175)){		// ERROR_UNABLE_TO_REMOVE_REPLACED
					Sleep(FILE_WAIT_SEC);
					num = ReplaceFile(dest_path, sorc_path, NULL, REPLACEFILE_IGNORE_MERGE_ERRORS, 0, 0);
				} else if (num == 1176){	// ERROR_UNABLE_TO_MOVE_REPLACEMENT
					Sleep(FILE_WAIT_SEC);
					num = MoveFile(sorc_path, dest_path);	// t@C͍폜ς݂ȂAړ邾
				} else {
					return 8;
				}
				retry_time--;
				if (retry_time == 0)
					break;
			}
			if (num == 0)
				return 9;
			if (rv & FILE_ATTRIBUTE_READONLY){	// ǂݎpt
				rv = GetFileAttributes(dest_path);
				SetFileAttributes(dest_path, rv | FILE_ATTRIBUTE_READONLY);	// sĂG[ɂȂ
			}
		}
	}

	return 0;
}

// t@C܂̓tH_ǂ
void move_away_file(
	wchar_t *file_path)		// t@CEpX
{
	wchar_t new_path[MAX_LEN];
	unsigned int rv, num;

	rv = GetFileAttributes(file_path);
	if (rv != INVALID_FILE_ATTRIBUTES){	// Ƀt@C݂Ȃ
		if (rv & FILE_ATTRIBUTE_READONLY){	// ǂݎpȂAȖ
			if (SetFileAttributes(file_path, rv ^ FILE_ATTRIBUTE_READONLY) == 0)
				return;	// t@C̓ǂݎpłȂ
		}

		if (switch_b & 3){	// 폜ɕʖŎc
			for (num = 1; num < 100; num++){
				swprintf(new_path, _countof(new_path), L"%s.%d", file_path, num);
				if (MoveFile(file_path, new_path) != 0){
					break;	// 烋[v甲
				} else if (GetLastError() != ERROR_ALREADY_EXISTS){
					break;	// Destination file already exists (183) ňړłȂĎs
				}
			}
			if (num < 100){	// ړł
				if (rv & FILE_ATTRIBUTE_READONLY){	// ǂݎpt
					rv = GetFileAttributes(new_path);
					SetFileAttributes(new_path, rv | FILE_ATTRIBUTE_READONLY);	// sĂG[ɂȂ
				}
				if (switch_b & 2)	// S~ɓ
					delete_file_recycle(new_path);
				return;
			}
		}

		// 폜
		if (rv & FILE_ATTRIBUTE_DIRECTORY){
			RemoveDirectory(file_path);	// tH_폜
		} else {
			DeleteFile(file_path);	// 폜
		}
	}
}

// t@CwTCYɏk
int shorten_file(
	wchar_t *file_path,		// t@CEpX
	__int64 new_size)
{
	wchar_t back_path[MAX_LEN];
	unsigned int rv, len, num;
	HANDLE hFileWrite;
	LARGE_INTEGER qwi;	// Quad Word Integer

	back_path[0] = 0;
	if (switch_b & 3){	// ̃t@C폜ɕʖŎc
		for (num = 1; num < 100; num++){
			swprintf(back_path, _countof(back_path), L"%s.%d", file_path, num);	// obNAbvEt@C̃pX
			if (GetFileAttributes(back_path) == INVALID_FILE_ATTRIBUTES)
				break;	// ݂ȂȂ OK
		}
		if (num >= 100)
			back_path[0] = 0;	// obNAbvςȂ炻ȏȂ
	}

	if (back_path[0] != 0){	// obNAbvĒu
		wchar_t temp_path[MAX_LEN];
		// e|[Et@Căt@CeRs[
		get_temp_name(file_path, temp_path);
		hFileWrite = CreateFile(temp_path, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFileWrite == INVALID_HANDLE_VALUE){	// Ȃ
			back_path[0] = 0;
		} else if (new_size <= 0){
			CloseHandle(hFileWrite);
		} else {
			// t@CETCYwTCYɂ
			qwi.QuadPart = new_size;
			if (!SetFilePointerEx(hFileWrite, qwi, NULL, FILE_BEGIN)){
				back_path[0] = 0;
			} else if (!SetEndOfFile(hFileWrite)){
				back_path[0] = 0;
			} else {
				// |C^[擪ɖ߂
				qwi.QuadPart = 0;
				if (!SetFilePointerEx(hFileWrite, qwi, NULL, FILE_BEGIN)){
					back_path[0] = 0;
				} else {
					__int64 left_size = new_size;
					HANDLE hFileRead;
					hFileRead = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
					if (hFileRead == INVALID_HANDLE_VALUE){
						back_path[0] = 0;
					} else {	// wTCY܂ŃRs[
						unsigned char buf[IO_SIZE];
						while (left_size > 0){
							len = IO_SIZE;
							if (left_size < IO_SIZE)
								len = (unsigned int)left_size;
							left_size -= len;
							if (!ReadFile(hFileRead, buf, len, &rv, NULL) || (len != rv)){
								back_path[0] = 0;
								break;
							}
							if (!WriteFile(hFileWrite, buf, len, &rv, NULL)){
								back_path[0] = 0;
								break;
							}
						}
						CloseHandle(hFileRead);
					}
				}
			}
			CloseHandle(hFileWrite);
			if (back_path[0] == 0)	// se|[Et@C͍폜
				DeleteFile(temp_path);
		}

		if (back_path[0] != 0){	// obNAbvĒu
			if (ReplaceFile(file_path, temp_path, back_path, REPLACEFILE_IGNORE_MERGE_ERRORS, 0, 0) == 0){
				DeleteFile(temp_path);
				return 1;
			}
			if (switch_b & 2)	// obNAbvS~ɓ
				delete_file_recycle(back_path);
			return 0;
		}
	}

	num = GetFileAttributes(file_path);
	if (num & FILE_ATTRIBUTE_READONLY){	// ǂݎpȂAȖ
		if (SetFileAttributes(file_path, num ^ FILE_ATTRIBUTE_READONLY) == 0)
			return 1;	// ǂݎpłȂ = kłȂ
	}

	// ڊJďk
	hFileWrite = CreateFile(file_path, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFileWrite == INVALID_HANDLE_VALUE)
		return 1;
	// t@CETCYwTCYɂ
	qwi.QuadPart = new_size;
	if (!SetFilePointerEx(hFileWrite, qwi, NULL, FILE_BEGIN)){
		CloseHandle(hFileWrite);
		return 1;
	}
	if (!SetEndOfFile(hFileWrite)){
		CloseHandle(hFileWrite);
		return 1;
	}
	CloseHandle(hFileWrite);

	if (num & FILE_ATTRIBUTE_READONLY){	// ǂݎpt
		num = GetFileAttributes(file_path);
		SetFileAttributes(file_path, num | FILE_ATTRIBUTE_READONLY);	// sĂG[ɂȂ
	}

	return 0;
}

// foCXǂ𔻒肷
static int check_device_name(wchar_t *name, int len)
{
	if (len >= 3){
		if ((name[3] == 0) || (name[3] == '.') || (name[3] == '\\')){
			if (_wcsnicmp(name, L"CON", 3) == 0)
				return 1;
			if (_wcsnicmp(name, L"PRN", 3) == 0)
				return 1;
			if (_wcsnicmp(name, L"AUX", 3) == 0)
				return 1;
			if (_wcsnicmp(name, L"NUL", 3) == 0)
				return 1;
		}
		if (len >= 4){
			if ((name[4] == 0) || (name[4] == '.') || (name[4] == '\\')){
				if (_wcsnicmp(name, L"COM", 3) == 0){
					if ((name[3] >= 0x31) && (name[3] <= 0x39))
						return 1;
				}
				if (_wcsnicmp(name, L"LPT", 3) == 0){
					if ((name[3] >= 0x31) && (name[3] <= 0x39))
						return 1;
				}
			}
			if (len >= 6){
				if ((name[6] == 0) || (name[6] == '.') || (name[6] == '\\')){
					if (_wcsnicmp(name, L"CLOCK$", 6) == 0)
						return 1;
				}
			}
		}
	}

	return 0;
}

// t@CLm߂āA肪Ώ򉻂
// ߂l 0=ύX, +1=fBNgL, +2=򉻂, +4=ς, 16=G[
int sanitize_filename(
	wchar_t *name,		// t@C
	file_ctx_r *files,	// e\[XEt@C̏
	int num)			// r珜Ot@Cԍ
{
	int i, j, rv = 0, len = 0;

	// 䕶 1`31 (s^uȂ) 폜
	while (len < MAX_LEN){
		if (name[len] == 0){
			break;
		} else if (name[len] < 32){
			i = len;
			do {
				name[i] = name[i + 1];
				i++;
			} while (name[i] != 0);
			rv |= 4;
		} else {
			len++;
		}
	}
	if (len == 0)
		name[0] = 0;

	// WinOS ł̓t@CɁu\/:*?"<>|v͎̕gȂ̂Œu
	for (i = 0; i < len; i++){
		if ((name[i] == '\\') || (name[i] == ':') || (name[i] == '*') || (name[i] == '?') || (name[i] == '"')
				|| (name[i] == '<') || (name[i] == '>') || (name[i] == '|')){
			name[i] = '_';	// u\,:,*,?,",<,>,|v ->u_v
			rv |= 2;
		} else if (name[i] == '/'){	// fBNgLϊ
			name[i] = '\\';	// u/v -> u\v
			rv |= 1;
		}
	}

	// ́u.vu v폜
	while (len > 0){
		if ((name[len - 1] == '.') || (name[len - 1] == ' ')){
			name[len - 1] = 0;
			len--;
			rv |= 4;
		} else {
			break;
		}
	}

	// u\v̑OɁu.vu v΍폜 (sȃt@CƃfBNgړh)
	i = len - 1;
	while (i > 0){
		if ((name[i] == '\\') && ((name[i - 1] == '.') || (name[i - 1] == ' '))){
			for (j = i - 1; j < len; j++)
				name[j] = name[j + 1];
			len--;
			rv |= 4;
		}
		i--;
	}

	// Au\vꕶɂ
	i = 0;
	while (i < len){
		if ((name[i] == '\\') && (name[i + 1] == '\\')){
			for (j = i + 1; j < len; j++)
				name[j] = name[j + 1];
			len--;
			rv |= 4;
		} else {
			i++;
		}
	}

	// 擪́u\v폜
	if (name[0] == '\\'){
		for (i = 0; i < len; i++)
			name[i] = name[i + 1];
		len--;
		rv |= 4;
	}

	// foCX͋Ȃ (TuEfBNg܂߂)
	i = len;
	while (i > 0){
		i--;
		if ((i == 0) || ((i > 0) && (name[i - 1] == '\\'))){
			if (check_device_name(name + i, len) != 0){
				if (len >= MAX_LEN - 1)
					return 16;
				for (j = len; j >= i; j--)
					name[j + 1] = name[j];
				name[i] = '_';	// 擪Ɂu_vǉ
				len++;
				rv |= 4;
			}
		}
	}

	// ɓ̃t@C݂ȂAɁu(l)vǉ
	if (files != NULL){
		int k;
		if (len == 0){	// t@CɂȂꍇ͕Kǉ
			i = 0;
		} else {
			// 啶ƏʂVXeōꂽ PAR t@C Windows OS ł͖ɂȂ
			for (i = 0; i < file_num; i++){
				if (i == num){
					if (rv & 6){
						continue;	// ̃t@CƂ͔rȂ
					} else {
						i = file_num;
						break;		// ܂ł̃t@CƂr
					}
				}
				if (files[i].name <= 0)
					continue;	// t@C擾łȂt@CƂ͔rȂ
				if (_wcsicmp(name, list_buf + files[i].name) == 0)
					break;	// t@C
			}
		}
		if (i < file_num){
			if (len >= MAX_LEN - 3)
				return 16;
			k = 0;
			for (j = len - 1; j > 0; j--){
				if (name[j] == '.'){
					k = j;
					break;
				}
				if (name[j] == '\\'){	// TuEfBNg͏O
					if (j == len - 1)
						k = len - 1;	// tH_Ȃ
					break;
				}
			}
			if (k > 0){	// gqȂAgq̑Oɒǉ
				for (j = len; j >= k; j--)
					name[j + 3] = name[j];
				name[k    ] = '(';
				name[k + 2] = ')';
				k = k + 1;
			} else {	// gqΖɒǉ
				name[len    ] = '(';
				name[len + 2] = ')';
				name[len + 3] = 0;
				k = len + 1;
			}
			len += 3;
			rv |= 4;
			for (j = 1; j < 10; j++){
				name[k] = (unsigned short)(0x30 + j);
				for (i = 0; i < file_num; i++){
					if (i == num){
						if (rv & 6){
							continue;	// ̃t@CƂ͔rȂ
						} else {
							i = file_num;
							break;		// ܂ł̃t@CƂr
						}
					}
					if (files[i].name <= 0)
						continue;	// t@C擾łȂt@CƂ͔rȂ
					if (_wcsicmp(name, list_buf + files[i].name) == 0)
						break;	// t@C
				}
				if (i == file_num)
					break;
			}
			if (j >= 10)
				return 16;	// ɂȂt@C߂
		}
	}

	return rv;
}

// JoEt@C̃pXgqƃ{[ԍ菜
void get_base_filename(
	wchar_t *file_path,		// JoEt@C̃pX
	wchar_t *base_path,		// t@C̃pX
	wchar_t *file_ext)		// gq (݂Ȃ)
{
	wchar_t *tmp_p, *file_name;
	int len, match;

	file_ext[0] = 0;
	wcscpy(base_path, file_path);
	file_name = offset_file_name(base_path);
	tmp_p = wcsrchr(file_name, '.');
	if (tmp_p != NULL){	// gq܂́u.vol*v݂Ύ菜
		// gqꍇl
		if (_wcsnicmp(tmp_p, L".vol", 4) == 0){
			match = 0;
			len = 4;
			while (tmp_p[len] != 0){
				if ((tmp_p[len] >= 48) && (tmp_p[len] <= 57)){
					match |= 1;	// ͉Ă悢
				} else if ((tmp_p[len] == '+') || (tmp_p[len] == '-') || (tmp_p[len] == '_')){
					match += 2;	// L͈
				} else {	// ȊOȂ画I
					break;
				}
				len++;
			}
			if (match == 3)
				tmp_p[0] = 0;	// 菜
		}
		if (tmp_p[0] != 0){	// gqȂ
			if (wcslen(tmp_p) < EXT_LEN){
				wcscpy(file_ext, tmp_p);	// gqL^Ă
				tmp_p[0] = 0;	// gq菜
			}
		}
		// XɁu.vol*v΂菜
		tmp_p = wcsrchr(file_name, '.');
		if (tmp_p != NULL){
			if (_wcsnicmp(tmp_p, L".vol", 4) == 0){
				match = 0;
				len = 4;
				while (tmp_p[len] != 0){
					if ((tmp_p[len] >= 48) && (tmp_p[len] <= 57)){
						match |= 1;	// ͉Ă悢
					} else if ((tmp_p[len] == '+') || (tmp_p[len] == '-') || (tmp_p[len] == '_')){
						match += 2;	// L͈
					} else {	// ȊOȂ画I
						break;
					}
					len++;
				}
				if (match == 3)
					tmp_p[0] = 0;	// 菜
			}
		}
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
// oCgƂ16i\ɂA\ȗ̈mۂĂ
void byte_encode(wchar_t *out, unsigned char *in, int len)
{
	int i, c;

	for (i = 0; i < len; i++){
		c = in[i] >> 4;
		if (c < 10){	// 0 to 9
			*out = c + 48;
		} else {		// A to Z
			*out = c - 10 + 65;
		}
		out++;
		c = in[i] & 15;
		if (c < 10){	// 0 to 9
			*out = c + 48;
		} else {		// A to Z
			*out = c - 10 + 65;
		}
		out++;
	}
	*out = 0;
}

void byte_decode(unsigned char *out, wchar_t *in, int len)
{
	unsigned int c1, c2;

	while (len >= 2){
		c1 = *in;
		in++;
		if ((c1 >= 48) && (c1 <= 57)){			// 0 to 9
			c1 -= 48;
		} else if ((c1 >= 65) && (c1 <= 90)){	// A to Z
			c1 -= 65 - 10;
		} else {
			break;
		}
		c2 = *in;
		in++;
		if ((c2 >= 48) && (c2 <= 57)){			// 0 to 9
			c2 -= 48;
		} else if ((c2 >= 65) && (c2 <= 90)){	// A to Z
			c2 -= 65 - 10;
		} else {
			break;
		}
		*out = (unsigned char)((c1 << 4) | c2);
		out++;
		len -= 2;
	}
}
*/

// nbVl\
void print_hash(unsigned char hash[16])
{
	printf("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",
		hash[0], hash[1], hash[2], hash[3], hash[4], hash[5], hash[6], hash[7],
		hash[8], hash[9], hash[10], hash[11], hash[12], hash[13], hash[14], hash[15]);
}

// 64-bit ̕߂
// by n-trino, http://d.hatena.ne.jp/n-trino/20080225
unsigned int sqrt64(__int64 num)
{
	unsigned int i, result = 0;
	__int64 rest = 0, sum = 0;

	if (num <= 1)
		return 1;	// 1菬l͂邱Ƃ͖

	for (i = 0; i < 32; i++){
		rest = ( rest << 2 ) | ( ( num >> 62 ) & 3 );
		num <<= 2;
		result <<= 1;
		sum <<= 1;
		if ( ( sum | 1 ) <= rest ){
			sum |= 1;
			rest -= sum;
			sum++;
			result |= 1;
		}
	}

	return result;
}

int sqrt32(int num)
{
	int i, result = 0, rest = 0, sum = 0;

	if (num <= 1)
		return 1;	// 1菬l͂邱Ƃ͖

	for (i = 0; i < 16; i++){
		rest = ( rest << 2 ) | ( ( num >> 30 ) & 3 );
		num <<= 2;
		result <<= 1;
		sum <<= 1;
		if ( ( sum | 1 ) <= rest ){
			sum |= 1;
			rest -= sum;
			sum++;
			result |= 1;
		}
	}

	return result;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

int cpu_num = 1;	// CPU/Core Ăꍇ́Aʂɖ{̐u
// /arch:SSE2, +1=SSSE3, +2=SSE4.1, +4=SSE4.2, +8=CLMUL, +16=AVX2, +128=JIT(SSE2), +256=Old
unsigned int cpu_flag = 0;
unsigned int memory_use;	// [gp 0=auto, 1`7 -> 1/8 ` 7/8

static int count_bit(unsigned int value)
{
	int bitCount = 0;

	// Shift gȂ@AvZʂ͕ (n/2)
	while (value != 0){
		bitCount++;
		value &= (value - 1);
	}

	return bitCount;
}

// AMD CPU_ID
static int count_associativity(int bit_value)
{
	switch (bit_value & 0xF){
	case 1:
		return 1;
	case 2:
		return 2;
	case 4:
		return 4;
	case 6:
		return 8;
	case 8:
		return 16;
	case 10:
		return 32;
	case 11:
		return 48;
	case 12:
		return 64;
	case 13:
		return 96;
	case 14:
		return 128;
	default:
		return 256;
	}
}

void check_cpu(void)
{
	int core_count, use_count;
	unsigned int CPUInfo[4];
	unsigned int ProcessAffinityMask;
	unsigned int cache_limit, cache_size;
	unsigned int returnLength, byteOffset;
	PSYSTEM_LOGICAL_PROCESSOR_INFORMATION buffer = NULL, ptr;

	// CPU ̊g@\𒲂ׂ
	__cpuid(CPUInfo, 1);
	cpu_flag |= (CPUInfo[3] & (1 << 26)) >> 19;	// SSE2 Ή
	cpu_flag |= (CPUInfo[2] & (1 << 9)) >> 9;	// SSSE3 Ή
	cpu_flag |= (CPUInfo[2] & (1 << 19)) >> 18;	// SSE4.1 Ή
	cpu_flag |= (CPUInfo[2] & (1 << 20)) >> 18;	// SSE4.2 Ή
	cpu_flag |= (CPUInfo[2] & (1 << 1)) << 2;	// CLMUL Ή
	if ((CPUInfo[2] & (1 << 28)) != 0){	// AVX ΉȂ
		wchar_t path[MAX_PATH];
		byteOffset = 0;
		returnLength = GetModuleFileName(NULL, path, MAX_PATH);	// st@CƓꏊ DLL ݂邩
		if ((returnLength > 0) && (returnLength < MAX_PATH - 17)){
			while (path[returnLength] != '\\')
				returnLength--;
			returnLength++;
#ifdef _WIN64	// 64-bit łȂ
			wcscpy(path + returnLength, L"par2j64_extra.dll");
#else
			wcscpy(path + returnLength, L"par2j_extra.dll");
#endif
			//printf("DLL path = '%S'\n", path);
			// DLL  PE checksum ؂
			returnLength = MapFileAndCheckSum(path, &cache_limit, &cache_size);
			if ((returnLength == CHECKSUM_SUCCESS) && (cache_limit == cache_size)){
				byteOffset = GetVersion();
				byteOffset = ((byteOffset & 0x00FF) << 8) | ((byteOffset & 0xFF00) >> 8);
				//printf("OS version = %0X\n", byteOffset);
			}
		}
		if (byteOffset >= 0x0601){	// Windows 7 ȍ~Ȃ AVX2 ̔
			__cpuid(CPUInfo, 0);
			if (CPUInfo[0] >= 7){	// AVX2 p̊{ߗ̈悪Ȃ
				__cpuidex(CPUInfo, 7, 0);
				cpu_flag |= (CPUInfo[1] & (1 << 5)) >> 1;	// AVX2 Ή
			}
		}
	}

	// gp\ȃRAƃLbV\𒲂ׂ
	if (GetProcessAffinityMask(GetCurrentProcess(), (PDWORD_PTR)&ProcessAffinityMask, (PDWORD_PTR)&returnLength) != 0){
		cpu_num = count_bit(ProcessAffinityMask);
		//printf("ProcessAffinityMask = 0x%08x, available logical processor cores = %d\n\n", ProcessAffinityMask, cpu_num);
	}
	if (cpu_num <= 0){	// vZXgp\ȃRA̎擾Ɏs瑍g
		SYSTEM_INFO si;
		ProcessAffinityMask = 0xFFFFFFFF;
		GetSystemInfo(&si);
		cpu_num = si.dwNumberOfProcessors;
		//printf("total logical processor cores = %d\n\n", cpu_num);
	}
	core_count = cache_limit = 0;

	// CPU 擾
	returnLength = 0;
	if (GetLogicalProcessorInformation(buffer, &returnLength) == FALSE){
		if (GetLastError() == ERROR_INSUFFICIENT_BUFFER){
			buffer = malloc(returnLength);
			if (buffer != NULL){
				if (GetLogicalProcessorInformation(buffer, &returnLength) == FALSE){
					free(buffer);
					buffer = NULL;
				}
			}
		}
	}

	// ڂƂɉ͂
	if (buffer != NULL){
		byteOffset = 0;
		ptr = buffer;
		while (byteOffset + sizeof(SYSTEM_LOGICAL_PROCESSOR_INFORMATION) <= returnLength){
			//printf("Relationship = %d, ProcessorMask = 0x%08x\n", ptr->Relationship, ptr->ProcessorMask);
			if (ptr->ProcessorMask & ProcessAffinityMask){
				switch (ptr->Relationship){
				case RelationProcessorCore:
					//printf("ProcessorCore.Flags = %d, ProcessorMask = 0x%08x\n", ptr->ProcessorCore.Flags, ptr->ProcessorMask);
					if (ptr->ProcessorCore.Flags){
						// Logical processors share functional units, as in Hyperthreading or SMT.
						core_count += 1;
					} else {
						// Logical processors do not share functional units.
						core_count += count_bit((unsigned int)(ptr->ProcessorMask));
					}
					break;
				case RelationCache:
					// Cache data is in ptr->Cache, one CACHE_DESCRIPTOR structure for each cache.
					if ((ptr->Cache.Level >= 2) && (ptr->Cache.Associativity != 0) && ((ptr->Cache.Type & 1) == 0)){
						//printf("Cache: Level = %d, Size = %d KB, Associativity = %d, Type = %d, Mask = 0x%02x\n", ptr->Cache.Level, ptr->Cache.Size >> 10, ptr->Cache.Associativity, ptr->Cache.Type, ptr->ProcessorMask);
						cache_size = ptr->Cache.Size / ptr->Cache.Associativity;
						if (cache_limit < cache_size)
							cache_limit = cache_size;
					}
					break;
				}
			}
			byteOffset += sizeof(SYSTEM_LOGICAL_PROCESSOR_INFORMATION);
			ptr++;
		}
		free(buffer);
		//printf("Number of available physical processor cores: %d\n", core_count);
		//printf("Limit size of Cache Blocking: %d KB\n", cache_limit >> 10);
	}

	if ((cache_limit == 0) && ((GetVersion() & 0xFF) < 6)){	// Windows Vista ȑOȂ CPUID QƂ
		// CPU x_[ʂ
		__cpuid(CPUInfo, 0);
		if ((CPUInfo[1] == 0x756E6547) && (CPUInfo[2] == 0x6C65746E) && (CPUInfo[3] == 0x49656E69)){
			// BIOS ݒ CPUID 𐧌ĂꍇA
			// Pentium 3  Pentium 4 ̏ (Willamette & Northwood) ł
			// Windows OS ̓LbVETCY擾łȂB
			unsigned char *ids;
			//printf("Intel\n");	//  Intel p
			__cpuid(CPUInfo, 2);
			//printf("CPUID #2: 0x%08X, 0x%08X, 0x%08X, 0x%08X\n", CPUInfo[0], CPUInfo[1], CPUInfo[2], CPUInfo[3]);
			if (CPUInfo[0] & 0x80000000){
				CPUInfo[0] = 0;
			} else {
				CPUInfo[0] &= 0xFFFFFF00;
			}
			if (CPUInfo[1] & 0x80000000)
				CPUInfo[1] = 0;
			if (CPUInfo[2] & 0x80000000)
				CPUInfo[2] = 0;
			if (CPUInfo[3] & 0x80000000)
				CPUInfo[3] = 0;
			ids = (unsigned char *)&(CPUInfo[0]);
			for (byteOffset = 0; byteOffset < 16; byteOffset++){
				if (ids[byteOffset] != 0){
					cache_size = 0;
					switch (ids[byteOffset]){
					case 0x41:
					case 0x7A:
					case 0x82:
						cache_size = 32 << 10;	// 32 KB
						break;
					case 0x42:
					case 0x7B:
					case 0x83:
						cache_size = 64 << 10;	// 64 KB
						break;
					case 0x22:
					case 0x23:
					case 0x43:
					case 0x78:
					case 0x7C:
					case 0x84:
					case 0x86:
					case 0x87:
						cache_size = 128 << 10;	// 128 KB
						break;
					case 0x25:
					case 0x44:
					case 0x7D:
					case 0x85:
						cache_size = 256 << 10;	// 256 KB
						break;
					case 0x29:
					case 0x45:
						cache_size = 512 << 10;	// 512 KB
						break;
					}
					if (cache_limit < cache_size)
						cache_limit = cache_size;
				}
			}

		} else if ((CPUInfo[1] == 0x68747541) && (CPUInfo[2] == 0x444D4163) && (CPUInfo[3] == 0x69746E65)){
			//printf("AMD\n");	// AMD p
			__cpuid(CPUInfo, 0x80000000);
			//printf("max extended CPUID = 0x%08X\n", CPUInfo[0]);
			if (CPUInfo[0] >= 0x80000008){
				if (core_count == 0){
					__cpuid(CPUInfo, 0x80000008);
					core_count = (CPUInfo[2] & 0xFF) + 1;
					//printf("core count = %d (0x%08X)\n", core_count, CPUInfo[2]);
					if (core_count > cpu_num)	// pRA܂łɂ
						core_count = cpu_num;
				}
				__cpuid(CPUInfo, 0x80000006);
				//printf("L2 cache info = 0x%08x, size = %d KB, associativity = %d\n", CPUInfo[2], CPUInfo[2] >> 16, count_associativity(CPUInfo[2] >> 12));
				//printf("L3 cache info = 0x%08x, size = %d KB, associativity = %d\n", CPUInfo[3], (CPUInfo[3] >> 18) * 512, count_associativity(CPUInfo[3] >> 12));
				cache_size = ((CPUInfo[2] >> 16) << 10) / count_associativity(CPUInfo[2] >> 12);
				if (cache_limit < cache_size)
					cache_limit = cache_size;
				cache_size = ((CPUInfo[3] >> 18) << 19) / count_associativity(CPUInfo[3] >> 12);
				if (cache_limit < cache_size)
					cache_limit = cache_size;
			}
		}
		//printf("Limit size of Cache Blocking: %d KB\n", cache_limit >> 10);
	}

	if (core_count == 0){	// RAsȂA_RAƓɂ
		core_count = cpu_num;
		use_count = cpu_num;
	} else if (core_count < cpu_num){	// RALĂȂ
		if (core_count >= 7){			// 7 ~ 8 RAȂ炻ȏ㑝₳Ȃ
			use_count = core_count;
		} else if (core_count >= 5){	// 5 ~ 6 RAȂ 1₷
			use_count = core_count + 1;
		} else {	// 2~4 RAȂAHyper-Threading ɂ_RA𔼕g
			use_count = core_count + (cpu_num - core_count) / 2;
		}
	} else {
		use_count = core_count;
	}
	if (use_count > MAX_CPU)	// pRA̐zȂ悤ɂ
		use_count = MAX_CPU;
	//printf("Core count: logical, physical, use = %d, %d, %d\n", cpu_num, core_count, use_count);
	// ʂɘ_RAƕRAAʂɗpRAzu
	cpu_num = (cpu_num << 24) | (core_count << 16) | use_count;

	// cpu_flag ̏ 17-bit ɃLbV̐TCYu
	cpu_flag |= cache_limit & ~0x00007FFF;	// 32 KB ͖
}

// OS  32-bit  64-bit 𒲂ׂ
int check_OS64(void)
{
	unsigned int dwVersion;

	dwVersion = GetVersion();
	dwVersion = ((dwVersion & 0x00FF) << 8) | ((dwVersion & 0xFF00) >> 8);	// Major  Minor ւ
	if (dwVersion >= 0x0502){
		FARPROC ProcAdd;

		ProcAdd = GetProcAddress(GetModuleHandleA("kernel32"), "IsWow64Process");
		if (ProcAdd != NULL){	// IsWow64Process ݂Ȃ
			BOOL bWow64Process = FALSE;

			(ProcAdd)(GetCurrentProcess(), &bWow64Process);
			if (bWow64Process)	// 64-bit OS œĂ
				return 1;
		}
	}

	return 0;
}

// 󂫃[ʂƐlgpł郁[ʂvZ
size_t get_mem_size(size_t trial_alloc)
{
	size_t mem_size;
	MEMORYSTATUSEX statex;

	statex.dwLength = sizeof(statex);
	if (GlobalMemoryStatusEx(&statex)){
		unsigned __int64 mem_size64, cache_size;
/*
		printf("MemoryLoad    = %d\n", statex.dwMemoryLoad);
		printf("TotalPhys     = %10I64d\n", statex.ullTotalPhys);
		printf("AvailPhys     = %10I64d\n", statex.ullAvailPhys);
		printf("TotalPageFile = %10I64d\n", statex.ullTotalPageFile);
		printf("AvailPageFile = %10I64d\n", statex.ullAvailPageFile);
		printf("TotalVirtual  = %10I64d\n", statex.ullTotalVirtual);
		printf("AvailVirtual  = %10I64d\n", statex.ullAvailVirtual);
*/
		cache_size = statex.ullAvailPhys >> 3;	// available size / 8
		if (memory_use){	// manual setting
			mem_size64 = cache_size * memory_use;	// using size = available size / 8 * memory_use
		} else {	// auto setting (mostly for 32-bit OS)
			// disk cache size is range from 100MB to 200MB.
			cache_size += statex.ullTotalPhys >> 4;	// cache size = available size / 8 + total size / 16
			if (cache_size > statex.ullAvailPhys >> 2)
				cache_size = statex.ullAvailPhys >> 2;	// cache size should be less than 1/4 of available size.
			mem_size64 = statex.ullAvailPhys - cache_size;	// using size = available size - cache size
		}
		if (mem_size64 + 0x00200000 > statex.ullAvailVirtual)
			mem_size64 = statex.ullAvailVirtual - 0x00200000;	// reserve 2MB for other task

#ifndef _WIN64	// 32-bit łȂ
		if (mem_size64 > MAX_MEM_SIZE)	// mۂőTCY 2GB ܂łɂ
			mem_size64 = MAX_MEM_SIZE;
		if (check_OS64() == 0){	// 32-bit OS ȂXɐ
			if (mem_size64 > MAX_MEM_SIZE32)
				mem_size64 = MAX_MEM_SIZE32;
		}
#endif
		mem_size = (size_t)mem_size64 & ~(size_t)0xFFFF;	// multiple of 64KB

	} else {
		print_win32_err();
		mem_size = 0x20000000;	// [ʂFłȂꍇ 512MB Ɖ肷
	}

	// try to allocate for test
	if (trial_alloc){
		unsigned char *tmp_p;
		if (mem_size > trial_alloc)	// no need to test over than required size
			mem_size = trial_alloc;
		//printf("\nget_mem_size: try %d MB ... ", mem_size >> 20);
		tmp_p = malloc(mem_size);
		while ((tmp_p == NULL) && (mem_size > 0x08000000)){	// if over than 128MB
#ifndef _WIN64	// 32-bit łȂ
			mem_size -= 0x01000000;	// reduce 16MB
#else
			mem_size -= 0x02000000;	// reduce 32MB
#endif
			tmp_p = malloc(mem_size);
		}
		if (tmp_p != NULL)
			free(tmp_p);
		//printf("%d MB ok\n", mem_size >> 20);
	}

	return mem_size;
}

// L^u̓𒲂ׂ邽߂ɁA̋LQlɂB
//uSSD Ȃ瓮ςAvP[Vvby NyaRuRu
//uSSDǂC#画ʂ vby EMO

// Returns 0 if |physical_drive_path| has no seek penalty.
// Returns 1 otherwise.
// Returns 2 or 3 if fails to retrieve the status.
int check_seek_penalty(wchar_t *dir_path){	// fBNgw肷
	wchar_t *drive_letter, logical_drive[8];
	unsigned int return_value, return_size;
	HANDLE handle;
	STORAGE_PROPERTY_QUERY query_seek_penalty;
	DEVICE_SEEK_PENALTY_DESCRIPTOR query_seek_penalty_desc;

	// hCu擾
	drive_letter = dir_path;
	if (wcsncmp(dir_path, L"\\\\?\\", PREFIX_LEN) == 0)
		drive_letter += PREFIX_LEN;
	if (drive_letter[1] != ':')
		return 2;	// uC:\`v̂悤Ȍ`ɂΉ
	if ((drive_letter[0] >= 0x41) && (drive_letter[0] <= 0x5A)){	// 啶 A`Z Ȃ
		logical_drive[4] = drive_letter[0];
	} else if ((drive_letter[0] >= 0x61) && (drive_letter[0] <= 0x7A)){	//  a`z Ȃ
		logical_drive[4] = drive_letter[0];
	} else {
		return 2;	// hCułȂȂ炾
	}
	// "\\\\.\\C:" ̃tH[}bgɂ
	logical_drive[0] = '\\';
	logical_drive[1] = '\\';
	logical_drive[2] = '.';
	logical_drive[3] = '\\';
	logical_drive[5] = ':';
	logical_drive[6] = 0;

	// We do not need write permission.
	handle = CreateFile(logical_drive, FILE_READ_ATTRIBUTES,
					FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if (handle == INVALID_HANDLE_VALUE)
		return 2;

	return_size = 0;
	query_seek_penalty.PropertyId = 7;	// StorageDeviceSeekPenaltyProperty
	query_seek_penalty.QueryType = 0;	// PropertyStandardQuery
	return_value = DeviceIoControl(handle, IOCTL_STORAGE_QUERY_PROPERTY,
			&query_seek_penalty, sizeof(query_seek_penalty),
			&query_seek_penalty_desc, sizeof(query_seek_penalty_desc),
			&return_size, NULL);
	CloseHandle(handle);
	if (return_value == 0)
		return 3;	// failed to retrieve data.
/*	printf("Version = %d, Size = %d, IncursSeekPenalty = %d\n",
		query_seek_penalty_desc.Version,
		query_seek_penalty_desc.Size,
		query_seek_penalty_desc.IncursSeekPenalty);*/
	if (query_seek_penalty_desc.Size != sizeof(query_seek_penalty_desc))
		return 3;

	if (query_seek_penalty_desc.IncursSeekPenalty != 0)
		return 1;
	return 0;	// no seek penalty = SSD drive ?
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define MAX_NAME_LEN	69	// oߕ\̃^Cg̍ő啶 ( null ܂)

int prog_last;	// OƓi󋵂͏o͂Ȃ̂ŋL^Ă
int count_last;

// t@CEpXZkꂽt@CɂăRs[
// ASCII  1, ȊO 2ƂĐ邱ƂɒӁI
static void copy_filename(wchar_t *out, wchar_t *in)
{
	int i, len, name_off, ext_off, ext_len;

	// t@C̕𐔂
	name_off = 0;
	ext_off = 0;
	len = 0;
	for (i = 0; in[i] != 0; i++){
		if ((in[i] == '\\') && (in[i + 1] != 0)){
			len = 0;
			name_off = i + 1;
		} else {
			if (in[i] < 0x80){
				len += 1;
				if ((in[i] == '.') && (in[i + 1] != 0))
					ext_off = i;
			} else {
				len += 2;
				ext_off = 0;	// gq ASCIIɂ
			}
		}
	}
	if (len < MAX_NAME_LEN){
		wcscpy(out, in + name_off);
		return;
	}

	// gq̒𒲂ׂ
	ext_len = 0;
	if (ext_off > name_off){
		while (in[ext_off + ext_len] != 0)
			ext_len++;
		if (ext_len >= EXT_LEN)
			ext_len = 0;
	}

	// t@Cꍇ́AȂĊgqǉ
	len = 0;
	for (i = 0; in[name_off + i] != 0; i++){
		if (in[name_off + i] < 0x80){
			if (len >= MAX_NAME_LEN - 2 - ext_len)
				break;
			len += 1;
		} else {
			if (len >= MAX_NAME_LEN - 3 - ext_len)
				break;
			len += 2;
		}
		out[i] = in[name_off + i];
	}
	out[i++] = '~';
	while (ext_len > 0){
		out[i++] = in[ext_off++];
		ext_len--;
	}
	out[i] = 0;
}

// o߂̃p[Zg\
// i 0 ԂALZ 0ȊO
int print_progress(int prog_now)	// \ % l
{
	if (prog_now < 0)	// ͈͊OȂ
		return 0;

	if (_kbhit()){	// L[͂邩
		int ch = _getch();
		if ((ch == 'c') || (ch == 'C')){	// Cancel
			printf("\nCancel\n");
			return 2;
		}

		// ꎞ~ƍĊJ̏
		if ((ch == 'p') || (ch == 'P')){	// Pause
			printf(" Pause\r");	// p[Zg㏑
			do {
				ch = _getch();	// ēx͂܂ő҂ACPU L 0%
				if ((ch == 'c') || (ch == 'C')){	// ~łLZ͎󂯕t
					printf("\nCancel\n");
					return 2;
				}
			} while ((ch != 'r') && (ch != 'R'));	// Resume
			prog_last = -1;	// Pause ̕㏑
		}
	}

	// OƓi󋵂͏o͂Ȃ
	if (prog_now == prog_last)
		return 0;
	printf("%3d.%d%%\r", prog_now / 10, prog_now % 10);
	prog_last = prog_now;
	fflush(stdout);

	return 0;
}

// o߂̃p[ZgƃeLXg\
void print_progress_text(int prog_now, char *text)
{
	if (prog_now < 0)	// ͈͊OȂ
		return;
	printf("%3d.%d%% : %s\r", prog_now / 10, prog_now % 10, text);
	prog_last = prog_now;
	fflush(stdout);
}

// o߂̃p[Zgt@C\
// ̓}CiXȂ\Ȃ
int print_progress_file(int prog_now, int count_now, wchar_t *file_name)
{
	if ((count_now >= 0) && (count_now != count_last)){
		printf("%d \r", count_now);	// \
		count_last = count_now;
		if (prog_now == prog_last)
			prog_last = prog_now + 1;	// ̕㏑
	}

	if (prog_now < 0)	// ͈͊OȂ
		return 0;

	if (_kbhit()){	// L[͂邩
		int ch = _getch();
		if ((ch == 'c') || (ch == 'C')){	// Cancel
			if (prog_last >= 0)
				printf("\n");
			printf("Cancel\n");
			return 2;
		}

		// ꎞ~ƍĊJ̏
		if ((ch == 'p') || (ch == 'P')){	// Pause
			printf(" Pause\r");	// p[Zg㏑
			do {
				ch = _getch();	// ēx͂܂ő҂ACPU L 0%
				if ((ch == 'c') || (ch == 'C')){	// ~łLZ͎󂯕t
					printf("\nCancel\n");
					return 2;
				}
			} while ((ch != 'r') && (ch != 'R'));	// Resume
			if (prog_now == prog_last)
				prog_last = prog_now + 1;	// Pause ̕㏑
		}
	}

	if (prog_last < 0){	// ߂Čo߂\鎞t@C\
		char text[MAX_NAME_LEN * 3];
		wchar_t short_name[MAX_NAME_LEN];

		copy_filename(short_name, file_name);
		utf16_to_cp(short_name, text, cp_output);
		printf("%3d.%d%% : \"%s\"\r", prog_now / 10, prog_now % 10, text);
	} else if (prog_now == prog_last){	// OƓi󋵂͏o͂Ȃ
		return 0;
	} else {
		printf("%3d.%d%%\r", prog_now / 10, prog_now % 10);
	}
	prog_last = prog_now;
	fflush(stdout);

	return 0;
}

void print_progress_done(void)	// IƉs\
{
	if (prog_last >= 0){	// oߕ\Ȃꍇ͕\Ȃ
		if (prog_last != 1000){
			printf("100.0%%\n");
		} else {
			printf("\n");
		}
		fflush(stdout);
		prog_last = -1;	// i󋵂Zbg
	}
}

// LZƈꎞ~s
int cancel_progress(void)
{
	if (_kbhit()){	// L[͂邩
		int ch = _getch();
		if ((ch == 'c') || (ch == 'C')){	// Cancel
			printf("Cancel\n");
			return 2;
		}

		// ꎞ~ƍĊJ̏
		if ((ch == 'p') || (ch == 'P')){	// Pause
			printf(" Pause\r");
			do {
				ch = _getch();	// ēx͂܂ő҂ACPU L 0%
				if ((ch == 'c') || (ch == 'C')){	// ~łLZ͎󂯕t
					printf("Cancel\n");
					return 2;
				}
			} while ((ch != 'r') && (ch != 'R'));	// Resume
		}
	}

	return 0;
}

// Win32 API ̃G[EbZ[W\
void print_win32_err(void)
{
	unsigned int en;
	LPVOID lpMsgBuf = NULL;

	en = GetLastError();
	if (cp_output == CP_UTF8){
		if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK,
				NULL, en, 0, (LPWSTR) &lpMsgBuf, 0, NULL) > 0){
			char buf[MAX_LEN * 3];
			// GR[h UTF-16  UTF-8 ɕϊ
			utf16_to_utf8(lpMsgBuf, buf);
			printf("0x%X, %s\n", en, buf);
		}
	} else {
		if (FormatMessageA(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK,
				NULL, en, 0, (LPSTR) &lpMsgBuf, 0, NULL) > 0){
			printf("0x%X, %s\n", en, lpMsgBuf);
		}
	}
	if (lpMsgBuf != NULL)
		LocalFree(lpMsgBuf);
}

// t@CS~Ɉڂ
int delete_file_recycle(wchar_t *file_path)
{
	wchar_t temp_path[MAX_PATH + PREFIX_LEN];
	int rv;
	SHFILEOPSTRUCT FileOp;

	// "\\?\" tĂ ShellAPI 삵Ȃ̂Ŏ菜
	rv = len_without_prefix(file_path);
	if (rv >= MAX_PATH - 1){	// pX̕ MAX_PATH - 1 ȉłȂƂȂ
		// ZpXɕϊĂ݂
		rv = GetShortPathName(file_path, temp_path, MAX_PATH + PREFIX_LEN);
		if ((rv == 0) || (rv >= MAX_PATH + PREFIX_LEN))
			return 1;	// pXŒZkłȂH
		// XɃvtBbNX菜
		rv = copy_without_prefix(temp_path, temp_path);
		//printf("\n short path = '%S'\n", temp_path);
	} else {
		rv = copy_without_prefix(temp_path, file_path);
	}
	temp_path[rv + 1] = 0;	// ɂ null ǉ

	memset(&FileOp, 0, sizeof(FileOp));
	FileOp.wFunc = FO_DELETE;
	FileOp.pFrom = temp_path;
	FileOp.fFlags = FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_SILENT;
	rv = SHFileOperation(&FileOp);
	if (FileOp.fAnyOperationsAborted == TRUE)
		rv = 1;	// 폜LZꂽ
//	if (rv != 0)
//		printf("\n SHFileOperation: error = %d\n", rv);
	return rv;
}

