#ifndef _CRC_H_
#define _CRC_H_

#ifdef __cplusplus
extern "C" {
#endif


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// CRC-32 vZp

extern unsigned int crc_table[256];
extern unsigned int reverse_table[256];	// CRC-32 tZp̃e[u

// CRC vZp̃e[u
void init_crc_table(void);

// CRC-32 XV
unsigned int crc_update(unsigned int crc, unsigned char *buf, unsigned int len);
unsigned int crc_update_std(unsigned int crc, unsigned char *buf, unsigned int len);

// S 0 ̃f[^ CRC-32 XV
unsigned int crc_update_zero(unsigned int crc, unsigned int len);

// eS 0 ̃f[^ CRC-32 tZ邽߂̊֐
unsigned int crc_reverse_zero(unsigned int crc, unsigned int len);

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// par2cmdline Qlɂ֐
// window TCY CRC vZĂ鏊ɁA1oCgǉƍ폜āACRC XV
extern unsigned int window_table[256];
extern unsigned int window_mask;

void onepass_window_gen(unsigned int window_size);
void onepass_window_gen_short(unsigned int short_size, unsigned int short_table[256]);

// }NȂ
#define CRC_SLIDE_CHAR(x,y,z) (crc_table[((x) & 0xFF) ^ (y)] ^ ((x) >> 8) ^ window_table[z])

/*
// CCWJȂ
__inline unsigned int crc_slide_char(unsigned int crc, unsigned char chNew, unsigned char chOld){
	return crc_table[(crc & 0xFF) ^ chNew] ^ (crc >> 8) ^ window_table[chOld];
}
*/


#ifdef __cplusplus
}
#endif

#endif

