// ini.c
// Copyright : 2018-02-13 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <malloc.h>
#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "crc.h"
#include "md5_crc.h"
#include "ini.h"

/*
t@C 2_#.bin (2+32+4 = 38)
u#v Set ID  16i\LɂB

t@CEtH[}bg
<!-- ʃt@Cʗp -->
2: ʂ̏o[W
4: 6oCgڈȍ~ CRC-32 `FbNT
4: .INI t@C CRC-32 `FbNT
<!-- JoEZbg̎ʗp -->
4: ubNETCY (32-bit ȉ)
4: vt@C
4: JoEZbg̃t@C
4: t@CpɊmۂ̈̕ (SẴt@C񂾂ǂ̎)
<!-- JoEZbgɋL^Ă\[XEt@C̃f[^JԂ -->
8: t@CETCY
16: MD5 nbVl
16: MD5-16k nbVl
2: t@C (UTF-8) ̃oCg ( null ͊܂߂Ȃ)
1`MAX_LEN *3: UTF-8 ̃t@C ( null ͊܂߂Ȃ)
<!-- ܂Ń\[XEt@C̐JԂ -->

<!-- JoEt@C̏̓t@CƂɋL^ -->
8: JoEt@C̃TCY
4: JoEt@C̍쐬
4: JoEt@C̍XV
4: JoEt@CɊ܂܂pPbg̐
4: JoEt@CɊ܂܂peBEubN̐
1: JoEt@C̏ 0xFF=, 0=S, ̑=炩̃G[
<!-- JoEt@CɊ܂܂peBEubÑf[^JԂ -->
2: peBEubN̔ԍ
8: peBEubN̊Jnʒu
<!-- ܂ŃpeBEubN̐JԂ -->

<!-- \[XEubÑ`FbNT͈ӏɋL^ -->
20 * \[XEubN̐: MD5 & CRC-32 JԂ

<!-- \[XEubÑ`FbNTȂĂL^ -->
1 * \[XEt@C̐: ̃t@C̃`FbNTĂ邩 (0xFF=)
20 * \[XEubN̐: MD5 & CRC-32 JԂ

<!-- \[XEt@C̃nbVľʂ͌₲ƂɋL^ -->
8: t@Č݂̃TCY (\[XEt@C{̃TCYƂ͕)
4: t@C̍쐬
4: t@C̍XV
4: t@Č 0`=ubNڂ܂ňv, -3=SɈv

<!-- jt@ČԂ̓t@CPʂŋL^ -->
8: t@Č݂̃TCY
4: t@C̍쐬
4: t@C̍XV
4: L^\[XEubN̍ڐ
<!-- t@CɊ܂܂\[XEubÑf[^JԂ -->
2: \[XEubN̔ԍ
8: \[XEubN̊Jnʒu
1: \[XEubŇo 0=S, 1=G[Kv, 8/9=ꂽubN
<!-- ܂Ń\[XEubN̐JԂ -->

.INI t@C̓e (UTF-16ŃGR[hꂽeLXg)
[Set]
Creator = ̂܂܂ŋL^
Comment = 򉻂ĂL^
Checksum = \[XEubÑ`FbNT̊Jnʒu

[PAR]
t@Cʔԍ = JoEt@C̊Jnʒu

[State]
\[XEt@Cԍƃt@Cʔԍ = t@C̏ԂƃnbVľ

[Damage]  [Simple]
\[XEt@Cԍƃt@Cʔԍ = t@CԂƃ\[XEubN̊Jnʒu
(rΏۂw肳ĖȂA\[XEt@CԍL^Ȃ)

*/

#define INI_VERSION	0x1270	// ʂ̏܂̃o[W
#define REUSE_MIN	16384	// t@CETCY傫Όʂ𗘗p (16KB ȏ 2GB )
#define HEADER_SIZE	26
#define HEADER_EACH	42
#define PARITY_SIZE	25
#define PARITY_EACH	10
#define CHKSUM_EACH	20
#define STATE_SIZE	20
#define STATE_COUNT	5
#define SOURCE_EACH	11
#define MAX_EACH	512
//#define VERBOSE		1		// Ԃ璷ɏo͂

static HANDLE hIniBin = NULL;	// oCiEf[^p̌ʃt@C
static int ini_off;

// ʂǂ̂炢̊ԕۑ邩
int recent_data = 0;
/*
  0 = ʂ̍ėp@\𖳌ɂ(ǂݍ܂ȂAL^Ȃ)
1`7= ǑʂǂݍŁÂL^B
      w肳ꂽԂo߂ÂL^͍폜B
      1= 1, 2= 3, 3= 1T, 4= , 5= 1, 6= 1N, 7= 
 +8 = Zbg̋L^폜Ǎʂ͋L^B
      ̃Zbg͎w肳ꂽԂÂ̂폜B
+16 = ̃t@ČʂQƁEL^
*/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// File Time (UTC)  UNIX Time (UTC) ɕϊ
static unsigned int time_f_u(FILETIME *file_time)
{
	unsigned __int64 int8;

	// 1970/01/01  File Time Ƃ̍߂
	memcpy(&int8, file_time, 8);
	int8 = (int8 - 116444736000000000) / 10000000;

	return (unsigned int)int8;
}

#ifdef VERBOSE
// File Time (UTC) t̕ɕϊ
static void time_f_date(FILETIME *ft, char *buf)
{
	int len;
	SYSTEMTIME st_utc, st;

	FileTimeToSystemTime(ft, &st_utc);
	if (SystemTimeToTzSpecificLocalTime(NULL, &st_utc, &st) == 0)
		memcpy(&st, &st_utc, sizeof(SYSTEMTIME));
	len = GetDateFormatA(LOCALE_USER_DEFAULT, DATE_SHORTDATE | LOCALE_USE_CP_ACP, &st, NULL, buf, 32);
	if (len > 0){
		buf[len - 1] = ' ';
		len = GetTimeFormatA(LOCALE_USER_DEFAULT, LOCALE_USE_CP_ACP, &st, NULL, buf + len, 32 - len);
	}
	if (len == 0){
		sprintf(buf, "%4d/%02d/%02d %2d:%02d:%02d",
		st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
	}
}
#endif

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
BASE32 ŃoCgz𕶎ɂ
12-byte -> 96-bit -> 5-bit * 20
15-byte -> 120-bit -> 5-bit * 24
*/
static void base32_encode3(
	wchar_t *buf,		// ő 21Kv ( null ܂߂)
	unsigned int v2,
	unsigned int v1,
	unsigned int v0)
{
	wchar_t base32_table[] = L"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

	buf[ 0] = base32_table[ v2 >> 31        ];
	buf[ 1] = base32_table[(v2 >> 26) & 0x1F];
	buf[ 2] = base32_table[(v2 >> 21) & 0x1F];
	buf[ 3] = base32_table[(v2 >> 16) & 0x1F];
	buf[ 4] = base32_table[(v2 >> 11) & 0x1F];
	buf[ 5] = base32_table[(v2 >>  6) & 0x1F];
	buf[ 6] = base32_table[(v2 >>  1) & 0x1F];
	buf[ 7] = base32_table[((v2 << 4) | (v1 >> 28)) & 0x1F];
	buf[ 8] = base32_table[(v1 >> 23) & 0x1F];
	buf[ 9] = base32_table[(v1 >> 18) & 0x1F];
	buf[10] = base32_table[(v1 >> 13) & 0x1F];
	buf[11] = base32_table[(v1 >>  8) & 0x1F];
	buf[12] = base32_table[(v1 >>  3) & 0x1F];
	buf[13] = base32_table[((v1 << 2) | (v0 >> 30)) & 0x1F];
	buf[14] = base32_table[(v0 >> 25) & 0x1F];
	buf[15] = base32_table[(v0 >> 20) & 0x1F];
	buf[16] = base32_table[(v0 >> 15) & 0x1F];
	buf[17] = base32_table[(v0 >> 10) & 0x1F];
	buf[18] = base32_table[(v0 >>  5) & 0x1F];
	buf[19] = base32_table[ v0        & 0x1F];
	buf[20] = 0;
}

static void base32_encode4(
	wchar_t *buf,		// ő 25Kv ( null ܂߂)
	unsigned int v3,	// t@Cԍ 3oCg܂
	unsigned int v2,
	unsigned int v1,
	unsigned int v0)
{
	wchar_t base32_table[] = L"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

	v3 += 1;	// num = 0 ł base32_encode3 ƌt悤 +1 

	buf[ 0] = base32_table[(v3 >> 19) & 0x1F];
	buf[ 1] = base32_table[(v3 >> 14) & 0x1F];
	buf[ 2] = base32_table[(v3 >>  9) & 0x1F];
	buf[ 3] = base32_table[(v3 >>  4) & 0x1F];
	buf[ 4] = base32_table[((v3 << 1) | (v2 >> 31)) & 0x1F];
	buf[ 5] = base32_table[(v2 >> 26) & 0x1F];
	buf[ 6] = base32_table[(v2 >> 21) & 0x1F];
	buf[ 7] = base32_table[(v2 >> 16) & 0x1F];
	buf[ 8] = base32_table[(v2 >> 11) & 0x1F];
	buf[ 9] = base32_table[(v2 >>  6) & 0x1F];
	buf[10] = base32_table[(v2 >>  1) & 0x1F];
	buf[11] = base32_table[((v2 << 4) | (v1 >> 28)) & 0x1F];
	buf[12] = base32_table[(v1 >> 23) & 0x1F];
	buf[13] = base32_table[(v1 >> 18) & 0x1F];
	buf[14] = base32_table[(v1 >> 13) & 0x1F];
	buf[15] = base32_table[(v1 >>  8) & 0x1F];
	buf[16] = base32_table[(v1 >>  3) & 0x1F];
	buf[17] = base32_table[((v1 << 2) | (v0 >> 30)) & 0x1F];
	buf[18] = base32_table[(v0 >> 25) & 0x1F];
	buf[19] = base32_table[(v0 >> 20) & 0x1F];
	buf[20] = base32_table[(v0 >> 15) & 0x1F];
	buf[21] = base32_table[(v0 >> 10) & 0x1F];
	buf[22] = base32_table[(v0 >>  5) & 0x1F];
	buf[23] = base32_table[ v0        & 0x1F];
	buf[24] = 0;
}

// k
static void compress_text(wchar_t *buf)
{
	wchar_t replace_table[] = L"!#$%&()*,-.:<>?@]^_`{|}~";
	int i, j, len;

	// 擪 (ŏ)  0 (BASE32/64 ̕\Lł A) 
	if (buf[0] == 'A'){
		len = 1;	// A 
		while (buf[len] == 'A')
			len++;
		// c擪Ɉڂ
		for (i = len; buf[i] != 0; i++)
			buf[i - len] = buf[i];
		buf[i - len] = 0;
	}

	// A 0 (BASE32/64 ̕\Lł A) ꕶɒu
	for (j = 0; buf[j] != 0; j++){
		if ((buf[j] == 'A') && (buf[j + 1] == 'A')){
			len = 2;	// A 
			while (buf[j + len] == 'A')
				len++;
			// 24̒u 25A܂őΉł
			buf[j] = replace_table[len - 2];
			// cOɈڂ
			for (i = j + len; buf[i] != 0; i++)
				buf[i - len + 1] = buf[i];
			buf[i - len + 1] = 0;
		}
	}
}

// u̔ԍԂ
static int replace_decode(wchar_t c)
{
	// uṕ̕u "';=[\vO 24
	wchar_t replace_table[] = L"!#$%&()*,-.:<>?@]^_`{|}~";
	int i;

	for (i = 0; i < 24; i++){
		if (replace_table[i] == c)
			break;
	}

	return i;	// up̕Ŗꍇ 24 ߂
}

// L
static void expand_text(wchar_t *buf, int orig_count)
{
	int i, j, len, cur_count;

	cur_count = (int)wcslen(buf);

	// uꂽTāAɖ߂
	for (j = 0; buf[j] != 0; j++){
		len = replace_decode(buf[j]) + 2;	// A Ă̂
		if (len < 26){
			// cɈڂ
			for (i = cur_count; i > j; i--)
				buf[i + len - 1] = buf[i];
			// A A ɖ߂
			for (i = j; i < j + len; i++)
				buf[i] = 'A';
			cur_count += len - 1;	// 𑝂₵Ă
			j += len - 1;
		}
	}

	if (cur_count < orig_count){	// {̕ZȂ
		len = orig_count - cur_count;
		// c𖖔Ɉڂ
		for (i = cur_count; i >= 0; i--)
			buf[i + len] = buf[i];
		// 擪 A ǉ
		for (i = 0; i < len; i++)
			buf[i] = 'A';
	}
}

// t@C̃IuWFNgID + {[̃VAԍ 𕶎ɐ`
static void format_id(
	wchar_t *buf,
	int num,
	unsigned int id[3])
{
	if (num >= 0){	// t@Cԍw肷
		base32_encode4(buf, num, id[2], id[1], id[0]);
	} else {
		base32_encode3(buf, id[2], id[1], id[0]);
	}
	compress_text(buf);
}

/*
BASE64 ŃoCgzƕϊ
19-byte -> 152-bit -> 6-bit * 26
*/
static void base64_encode5(
	wchar_t *buf,			// ő 27Kv ( null ܂߂)
	unsigned int state[4],
	int result)			// ʂ 3oCg܂
{
	wchar_t base64_table[] = L"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	unsigned int v0, v1, v2, v3, v4; 

	v4 = state[1];	// 64-bit ̃t@CETCY̏ (0 ɂȂ邱Ƃ)
	v3 = state[0];	// 64-bit ̃t@CETCỶ
	v2 = state[2];	// 쐬
	v1 = state[3] - state[2];	// XVƍ쐬̍
	v0 = result + 3;	// ̐ɂ邽߁A-3 -> 0, 0` -> 3` ɂȂ

	// ʂɑ 0 擪ɒu߁At@CETCYƓ Big endian ŋL^
	buf[ 0] = base64_table[(v4 >> 26) & 0x3F];
	buf[ 1] = base64_table[(v4 >> 20) & 0x3F];
	buf[ 2] = base64_table[(v4 >> 14) & 0x3F];
	buf[ 3] = base64_table[(v4 >>  8) & 0x3F];
	buf[ 4] = base64_table[(v4 >>  2) & 0x3F];
	buf[ 5] = base64_table[((v4 << 4) | (v3 >> 28)) & 0x3F];
	buf[ 6] = base64_table[(v3 >> 22) & 0x3F];
	buf[ 7] = base64_table[(v3 >> 16) & 0x3F];
	buf[ 8] = base64_table[(v3 >> 10) & 0x3F];
	buf[ 9] = base64_table[(v3 >>  4) & 0x3F];
	buf[10] = base64_table[((v3 << 2) | (v2 >> 30)) & 0x3F];
	buf[11] = base64_table[(v2 >> 24) & 0x3F];
	buf[12] = base64_table[(v2 >> 18) & 0x3F];
	buf[13] = base64_table[(v2 >> 12) & 0x3F];
	buf[14] = base64_table[(v2 >>  6) & 0x3F];
	buf[15] = base64_table[ v2        & 0x3F];
	// ʂɑ 0 𖖔ɒu߁A̍ v0  Little endian ŋL^
	buf[16] = base64_table[ v1        & 0x3F];
	buf[17] = base64_table[(v1 >>  6) & 0x3F];
	buf[18] = base64_table[(v1 >> 12) & 0x3F];
	buf[19] = base64_table[(v1 >> 18) & 0x3F];
	buf[20] = base64_table[(v1 >> 24) & 0x3F];
	buf[21] = base64_table[((v1 >> 30) | (v0 << 2)) & 0x3F];
	buf[22] = base64_table[(v0 >>  4) & 0x3F];
	buf[23] = base64_table[(v0 >> 10) & 0x3F];
	buf[24] = base64_table[(v0 >> 16) & 0x3F];
	buf[25] = base64_table[(v0 >> 22) & 0x3F];
	buf[26] = 0;

	//printf("0x%08X, 0x%08X, 0x%08X, 0x%08X, 0x%08X\n", v4, v3, v2, v1, v0);
	//printf("BASE64: %S\n", buf);
	compress_text(buf);
	//printf("Write : %S\n", buf);
}

// BASE64 ̔ԍԂ
static int base64_decode(wchar_t c)
{
	wchar_t base64_table[] = L"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	int i;

	for (i = 0; i < 64; i++){
		if (base64_table[i] == c)
			break;
	}

	return i;
}

static unsigned int base64_decode5(
	wchar_t *buf,			// ő 27Kv ( null ܂߂)
	unsigned int state[4])
{
	unsigned int v0, v1, v2, v3, v4; 

	//printf("Read  : %S\n", buf);
	expand_text(buf, 26);
	//printf("BASE64: %S\n", buf);

	// t@CETCYƓ Big endian œǂݎ
	v4  = base64_decode(buf[ 0]) << 26;
	v4 |= base64_decode(buf[ 1]) << 20;
	v4 |= base64_decode(buf[ 2]) << 14;
	v4 |= base64_decode(buf[ 3]) <<  8;
	v4 |= base64_decode(buf[ 4]) <<  2;
	v3  = base64_decode(buf[ 5]);
	v4 |= v3 >> 4;
	v3  = v3 << 28;
	v3 |= base64_decode(buf[ 6]) << 22;
	v3 |= base64_decode(buf[ 7]) << 16;
	v3 |= base64_decode(buf[ 8]) << 10;
	v3 |= base64_decode(buf[ 9]) <<  4;
	v2  = base64_decode(buf[10]);
	v3 |= v2 >> 2;
	v2  = v2 << 30;
	v2 |= base64_decode(buf[11]) << 24;
	v2 |= base64_decode(buf[12]) << 18;
	v2 |= base64_decode(buf[13]) << 12;
	v2 |= base64_decode(buf[14]) <<  6;
	v2 |= base64_decode(buf[15]);
	// ̍ v0  Little endian œǂݎ
	v1  = base64_decode(buf[16]);
	v1 |= base64_decode(buf[17]) <<  6;
	v1 |= base64_decode(buf[18]) << 12;
	v1 |= base64_decode(buf[19]) << 18;
	v1 |= base64_decode(buf[20]) << 24;
	v0  = base64_decode(buf[21]);
	v1 |= v0 << 30;
	v0  = v0 >> 2;
	v0 |= base64_decode(buf[22]) <<  4;
	v0 |= base64_decode(buf[23]) << 10;
	v0 |= base64_decode(buf[24]) << 16;
	v0 |= base64_decode(buf[25]) << 22;

	state[1] = v4;	// 64-bit ̃t@CETCY̏
	state[0] = v3;	// 64-bit ̃t@CETCỶ
	state[2] = v2;	// 쐬
	state[3] = v2 + v1;
	//printf("0x%08X, 0x%08X, 0x%08X, 0x%08X, 0x%08X\n", v4, v3, v2, v1, v0);
	return v0 - 3;	// ̐ɂ邽߁A-3 -> 0, 0` -> 3` ɂȂ
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// ʃt@C𗘗pׂ̊֐

// JoEt@C̐VK쐬ɁA Set ID ̋L^ΏĂ
void reset_ini_file(unsigned char *set_id)
{
	int i;
	wchar_t ini_name[INI_NAME_LEN + 1];

	// ݒt@C̃pX
	swprintf(ini_name, _countof(ini_name), L"2_%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X.bin",
		set_id[0], set_id[1], set_id[2], set_id[3], set_id[4], set_id[5], set_id[6], set_id[7],
		set_id[8], set_id[9], set_id[10], set_id[11],set_id[12], set_id[13], set_id[14], set_id[15]);

	// oCiEf[^p̐ݒt@C
	wcscat(ini_path, ini_name);
	DeleteFile(ini_path);	// .bin t@C폜

	// .INI t@CɊgqςĂ
	i = (int)wcslen(ini_path);
	ini_path[i - 3] = 'i';
	ini_path[i - 2] = 'n';
	ini_path[i - 1] = 'i';
	DeleteFile(ini_path);	// .ini t@C폜
}

// ini_path Ŏw肳Ă錟ʃt@C폜
static void delete_ini_file(void)
{
	int len;

	// JĂȂ
	if (hIniBin != NULL){
		CloseHandle(hIniBin);
		hIniBin = NULL;
	}

	DeleteFile(ini_path);	// .ini t@C폜
	len = (int)wcslen(ini_path);
	ini_path[len - 3] = 'b';
	ini_path[len - 2] = 'i';
	ini_path[len - 1] = 'n';
	DeleteFile(ini_path);	// .bin t@C폜

	recent_data = 0;	// ȍ~͌ʂ͗płȂ
}

// 郊JoEt@Cł΁AČKv͖
int check_ini_file(unsigned char *set_id)
{
	unsigned char set_data[HEADER_SIZE * 2];
	wchar_t path[MAX_LEN], ini_name[INI_NAME_LEN + 1];
	int i, match;
	unsigned int file_time, time_now, time_limit;
	HANDLE hFind;
	WIN32_FIND_DATA FindData;
	FILETIME ft;

	if (recent_data == 0)
		return 0;

	// ݒt@C̃pX
	swprintf(ini_name, _countof(ini_name), L"2_%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X.bin",
		set_id[0], set_id[1], set_id[2], set_id[3], set_id[4], set_id[5], set_id[6], set_id[7],
		set_id[8], set_id[9], set_id[10], set_id[11],set_id[12], set_id[13], set_id[14], set_id[15]);

	// ݒ肷
	switch (recent_data & 7){
	case 1:
		time_limit = 3600 * 24;	// 1 day
		break;
	case 2:
		time_limit = 3600 * 24 * 3;	// 3 days
		break;
	case 3:
		time_limit = 3600 * 24 * 7;	// 1 week
		break;
	case 4:
		time_limit = 3600 * 24 * 15;	// half month
		break;
	case 5:
		time_limit = 3600 * 24 * 30;	// 1 month
		break;
	case 6:
		time_limit = 3600 * 24 * 365;	// 1 year
		break;
	case 7:
		time_limit = 0xFFFFFFFF;	// unlimited
		break;
	default:	// Ԃw肳ĂȂ
		recent_data = 0;
		return 0;
	}
	GetSystemTimeAsFileTime(&ft);	// ݂̃VXe (UTC) 擾
	time_now = time_f_u(&ft);	// UNIX Time ɕϊ

	// L^̓𒲂ׂāAÂ͍̂폜
	match = 0;
	wcscpy(path, ini_path);
	wcscat(path, L"2_*.bin");	// ͌Ń`FbN
	hFind = FindFirstFile(path, &FindData);
	if (hFind != INVALID_HANDLE_VALUE){
		do {
			if (((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0) &&
					(wcslen(FindData.cFileName) == INI_NAME_LEN)){
				// w莞ԂÂL^͍폜
				file_time = time_f_u(&(FindData.ftLastWriteTime));	// XV
				if (time_now - file_time > time_limit){
					wcscpy(path, ini_path);
					wcscat(path, FindData.cFileName);
					DeleteFile(path);
					i = (int)wcslen(path);
					path[i - 3] = 'i';
					path[i - 2] = 'n';
					path[i - 1] = 'i';
					DeleteFile(path);
#if VERBOSE > 1
					time_f_date(&(FindData.ftLastWriteTime), (char *)path);
					printf("Delete result: %S, %s\n", FindData.cFileName, (char *)path);
#endif
				} else if (wcscmp(FindData.cFileName, ini_name) == 0){
					if (recent_data & 8){	// ʂǂݍ܂ȂÂ͏ޏꍇ
						// ȑǑʂ݂΍폜
						wcscpy(path, ini_path);
						wcscat(path, ini_name);
						DeleteFile(path);
						i = (int)wcslen(path);
						path[i - 3] = 'i';
						path[i - 2] = 'n';
						path[i - 1] = 'i';
						DeleteFile(path);
#if VERBOSE > 1
						printf("Delete result: %S\n", ini_name);
#endif
					} else {
						match = 1;	// ݒt@C݂
					}
#ifdef VERBOSE
					ft = FindData.ftLastWriteTime;	// ʂ̍XV
#endif
				}
			}
		} while (FindNextFile(hFind, &FindData));	// ̃t@C
		FindClose(hFind);
	}

	// oCiEf[^p̐ݒt@CJ
	wcscat(ini_path, ini_name);
	hIniBin = CreateFile(ini_path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS,
					FILE_ATTRIBUTE_NOT_CONTENT_INDEXED | FILE_FLAG_RANDOM_ACCESS, NULL);
	if (hIniBin == INVALID_HANDLE_VALUE){
		hIniBin = NULL;
		recent_data = 0;	// JȂꍇ͍ėpȂ
		return 0;
	}
	// .INI t@CɊgqςĂ
	i = (int)wcslen(ini_path);
	ini_path[i - 3] = 'i';
	ini_path[i - 2] = 'n';
	ini_path[i - 1] = 'i';
	//printf("ini file path = %S\n", ini_path);

	// ɓ (Set ID ) t@C݂ꍇ
	set_data[0] = INI_VERSION >> 8;	// ʂ̏o[W
	set_data[1] = INI_VERSION & 0xFF;
	memset(set_data +  2, 0, 8);	// CRC-32 ͌ŏ
	memcpy(set_data + 10, &block_size, 4);
	memcpy(set_data + 14, &file_num, 4);
	memcpy(set_data + 18, &entity_num, 4);
	memset(set_data + 22, 0, 4);	// ̈ 0 ɂĂ
	if (match == 1){
		i = file_read_data(hIniBin, 0, set_data + HEADER_SIZE, HEADER_SIZE);
		if ((set_data[HEADER_SIZE    ] != (INI_VERSION >> 8)) ||
			(set_data[HEADER_SIZE + 1] != (INI_VERSION & 0xFF))){
			i = 1;	// Âo[W̌ʂ͎QƂȂ
		}
		if (i == 0){	// ʂjĂȂm߂
			if (SetFilePointer(hIniBin, 6, 0, FILE_BEGIN) != INVALID_SET_FILE_POINTER)
				time_now = file_crc_part(hIniBin);
			i = memcmp(&time_now, set_data + (HEADER_SIZE + 2), 4);
			if (i == 0){	// .INI t@C̔jm߂
				HANDLE hFile;
				time_limit = 0;
				hFile = CreateFile(ini_path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
				if (hFile != INVALID_HANDLE_VALUE){
					time_limit = file_crc_part(hFile);
					CloseHandle(hFile);
				} else {	// .INI t@Cւ̓ǂݏłȂ΍ėpȂ
					CloseHandle(hIniBin);
					hIniBin = NULL;
					recent_data = 0;
					return 0;
				}
				i = memcmp(&time_limit, set_data + (HEADER_SIZE + 6), 4);
			}
		}
		if (i == 0)		// ubNETCYƃt@Cr
			i = memcmp(set_data + 10, set_data + (HEADER_SIZE + 10), 12);
		if (i != 0){	// ID ł Set eقȂꍇ͍폜
			DeleteFile(ini_path);
			if (SetFilePointer(hIniBin, 0, 0, FILE_BEGIN) != INVALID_SET_FILE_POINTER)
				SetEndOfFile(hIniBin);
			match = 0;
		}
	}

	// vȂꍇ͍̃f[^L^
	if (match == 0){
		if (file_write_data(hIniBin, 0, set_data, HEADER_SIZE) != 0)
			delete_ini_file();
		return 0;
#ifdef VERBOSE
	} else {
		time_f_date(&ft, (char *)path);
		printf("Date of result: %s\n", (char *)path);
#endif
	}

	return match;
}

// ʃt@C
void close_ini_file(void)
{
	if (((recent_data & 0x0F) != 0) && (hIniBin != NULL)){
		unsigned int new_crc, old_crc;
		HANDLE hFile;

		// OɌʂ CRC-32 vZċL^Ă
		hFile = CreateFile(ini_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){
			new_crc = file_crc_part(hFile);
			CloseHandle(hFile);
		} else {
			CloseHandle(hIniBin);
			hIniBin = NULL;
			return;
		}
		file_read_data(hIniBin, 6, (unsigned char *)&old_crc, 4);
		if (new_crc != old_crc)	// .INI t@CύXĂ΁A
			file_write_data(hIniBin, 6, (unsigned char *)&new_crc, 4);
		FlushFileBuffers(hIniBin);
		file_read_data(hIniBin, 2, (unsigned char *)&old_crc, 4);
		new_crc = file_crc_part(hIniBin);
		if (new_crc != old_crc)	// ʂȂXVȂ
			file_write_data(hIniBin, 2, (unsigned char *)&new_crc, 4);
		CloseHandle(hIniBin);
		hIniBin = NULL;
	}
}

void write_ini_file2(unsigned char *par_client, wchar_t *par_comment)
{
	if (recent_data == 0)
		return;

	// NG[^[ ASCII Ȃ̂Łu"vň͂ŋL^
	if (par_client[0] != 0){
		wchar_t uni_buf[COMMENT_LEN + 2];
		int i;
		uni_buf[0] = '"';
		for (i = 0; par_client[i] != 0; i++){
			uni_buf[i + 1] = par_client[i];
		}
		uni_buf[i + 1] = '"';
		uni_buf[i + 2] = 0;
		WritePrivateProfileString(L"Set", L"Creator", uni_buf, ini_path);
	} else {
		WritePrivateProfileString(L"Set", L"Creator", NULL, ini_path);
	}

	// RgL^ (䕶͏򉻍ς)
	if (par_comment[0] != 0){
		int i;
		// 7-bit ASCII ͈̔͂Ɏ܂邩ׂ
		for (i = 0; par_comment[i] != 0; i++){
			if (par_comment[i] & 0xFF80){
				i = -1;
				break;
			}
		}
		if (i < 0){	// UTF-16 -> 16iɕϊċL^
			wchar_t uni_buf[COMMENT_LEN * 4];
			for (i = 0; par_comment[i] != 0; i++){
				swprintf(uni_buf + (i * 4), _countof(uni_buf) - i * 4, L"%04X", (unsigned short)(par_comment[i]));
			}
			uni_buf[i * 4] = 0;
			WritePrivateProfileString(L"Set", L"Comment", uni_buf, ini_path);
		} else {	// ASCII  Unicode Ƌʂ邽߂ () ň͂ŋL^
			wchar_t uni_buf[COMMENT_LEN + 2];
			uni_buf[0] = '(';
			for (i = 0; par_comment[i] != 0; i++){
				uni_buf[i + 1] = par_comment[i];
			}
			uni_buf[i + 1] = ')';
			uni_buf[i + 2] = 0;
			WritePrivateProfileString(L"Set", L"Comment", uni_buf, ini_path);
		}
	} else {
		WritePrivateProfileString(L"Set", L"Comment", NULL, ini_path);
	}
}

void write_ini_file(
	file_ctx_r *files)	// e\[XEt@C̏
{
	unsigned char buf[MAX_LEN * 3];
	int i, len;

	if (recent_data == 0)
		return;

	for (i = 0; i < file_num; i++){
		if (files[i].name <= 0)
			return;	// File Description packet Ăꍇ͋L^Ȃ
	}

	// t@Cʒu HEADER_SIZE ɂ
	i = SetFilePointer(hIniBin, HEADER_SIZE, NULL, FILE_BEGIN);
	if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
		delete_ini_file();
		return;
	}
	for (i = 0; i < file_num; i++){
		// \[XEt@C̏
		memcpy(buf    , &(files[i].size), 8);
		memcpy(buf + 8, files[i].hash, 32);
		// t@C UTF-8 ɕϊĂL^
		utf16_to_utf8(list_buf + files[i].name, buf + HEADER_EACH);
		len = (int)strlen(buf + HEADER_EACH);
		memcpy(buf + 40, &len, 2);
		if (WriteFile(hIniBin, buf, HEADER_EACH + len, &len, NULL) == 0){
			delete_ini_file();
			return;
		}
	}

	// t@C̈̕t@CSď񂾈ɂ
	if (file_write_data(hIniBin, HEADER_SIZE - 4, (unsigned char *)(&list_max), 4) != 0)
		delete_ini_file();
}

int read_ini_file(
	wchar_t *uni_buf,
	file_ctx_r *files)	// e\[XEt@C̏
{
	unsigned char buf[MAX_LEN * 3];
	int i, j, len;

	// t@C̈̕擾
	if (file_read_data(hIniBin, HEADER_SIZE - 4, (unsigned char *)(&list_max), 4) != 0){
		delete_ini_file();
		return 1;
	}
	if (list_max == 0)	// \[XEt@ČĂȂ
		return 1;		// Ǒʂ͂̂܂܂ōēx
	list_len = 1;	// 擪ɕsp null u
	list_buf = (wchar_t *)malloc(list_max * 2);
	if (list_buf == NULL){
		delete_ini_file();
		return 1;
	}
	list_buf[0] = 0;

	// t@Cʒu HEADER_SIZE ɂ
	i = SetFilePointer(hIniBin, HEADER_SIZE, NULL, FILE_BEGIN);
	if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
		free(list_buf);
		delete_ini_file();
		return 1;
	}
	for (j = 0; j < file_num; j++){
		if (!ReadFile(hIniBin, buf, HEADER_EACH, &i, NULL) || (HEADER_EACH != i)){
			print_win32_err();
			free(list_buf);
			delete_ini_file();
			return 1;
		}
		// \[XEt@C̏
		memcpy(&(files[j].size), buf, 8);
		memcpy(files[j].hash, buf + 8, 32);
		len = 0;
		memcpy(&len, buf + 40, 2);
		if (!ReadFile(hIniBin, buf, len, &i, NULL) || (len != i)){
			print_win32_err();
			free(list_buf);
			delete_ini_file();
			return 1;
		}
		buf[len] = 0;	//  null ǉĂ
		utf8_to_utf16(buf, uni_buf);
		len = (int)wcslen(uni_buf);	// t@C̕
		wcscpy(list_buf + list_len, uni_buf);
		//printf("list_max = %d, list_len = %d, len = %d\n", list_max, list_len, len);
		//printf("%S\nhash = %02X, size = %I64d\n", list_buf + list_len, files[j].hash[0], files[j].size);
		files[j].name = list_len;
		list_len += (len + 1);
	}

	if (GetPrivateProfileString(L"Set", L"Creator", L"", uni_buf, COMMENT_LEN, ini_path) > 0)
		printf("Creator : %S\n", uni_buf);	// ASCII Ȃ̂ł̂܂ܕ\

	i = GetPrivateProfileString(L"Set", L"Comment", L"", uni_buf, MAX_LEN, ini_path);
	if (i > 0){
		if (uni_buf[0] < '0'){
			uni_buf[i - 1] = 0;
			printf("Comment : %S\n", uni_buf + 1);	// ASCII Ȃ̂ł̂܂ܕ\
		} else {
			wchar_t tmp_buf[5];
			tmp_buf[4] = 0;
			for (i = 0; uni_buf[i * 4] >= '0'; i++){
				tmp_buf[0] = uni_buf[i * 4    ];
				tmp_buf[1] = uni_buf[i * 4 + 1];
				tmp_buf[2] = uni_buf[i * 4 + 2];
				tmp_buf[3] = uni_buf[i * 4 + 3];
				uni_buf[i] = (unsigned short)wcstoul(tmp_buf, NULL, 16);
			}
			uni_buf[i] = 0;
			if (utf16_to_cp(uni_buf, buf, cp_output))
				buf[0] = 0;
			if (buf[0] != 0)
				printf("Comment : %s\n", buf);
		}
	}

	return 0;
}

// 郊JoEt@Cł΁AČKv͖
int check_ini_recovery(
	HANDLE hFile,			// JoEt@C̃nh
	unsigned int meta[7])	// TCYA쐬AXVA{[ԍAIuWFNgԍ
{
	unsigned char buf[PARITY_SIZE];
	wchar_t item[32];
	BY_HANDLE_FILE_INFORMATION fi;

	// ݂̃t@C擾
	recent_data &= ~0x10;
	memset(&fi, 0, sizeof(BY_HANDLE_FILE_INFORMATION));
	if (GetFileInformationByHandle(hFile, &fi) != 0){
		meta[0] = fi.nFileSizeLow;
		meta[1] = fi.nFileSizeHigh;
		if ((recent_data == 0) || ((fi.nFileSizeLow <= REUSE_MIN) && (fi.nFileSizeHigh == 0)))
			return 0;	// ȃt@C̓TCY߂
		meta[2] = time_f_u(&(fi.ftCreationTime));
		meta[3] = time_f_u(&(fi.ftLastWriteTime));
		meta[4] = fi.dwVolumeSerialNumber;
		meta[5] = fi.nFileIndexLow;
		meta[6] = fi.nFileIndexHigh;
		recent_data |= 0x10;	// 傫ȃt@CʂQƂ
	} else {
		return -1;	// ̓ǂݎG[
	}

	// L^Ăf[^Ɣr
	format_id(item, -1, meta + 4);	// t@Cʔԍږɂ
	ini_off = GetPrivateProfileInt(L"PAR", item, 0, ini_path);
	if (ini_off != 0){	// JoEt@ČL^Ȃ
		if (file_read_data(hIniBin, ini_off, buf, PARITY_SIZE) != 0){
			delete_ini_file();
			return 0;
		}
#ifdef VERBOSE
	printf("check state, offset = %d, state = %02X\n", ini_off, buf[24]);
#endif
		if (memcmp(buf, meta, 16) != 0)	// t@CԂقȂ
			ini_off = 0;
	}

	// vȂꍇ͍̃f[^L^
	if (ini_off == 0){
		ini_off = GetFileSize(hIniBin, NULL);	// ݒt@C̃TCY =  offset
		// Ȃ̂ŏԂ 0xFF Ŗ߂
		memcpy(buf, meta, 16);
		memset(buf + 16, 0xFF, PARITY_SIZE - 16);
		if (file_write_data(hIniBin, ini_off, buf, PARITY_SIZE) != 0)
			delete_ini_file();
#ifdef VERBOSE
	printf("start state, offset = %d\n", ini_off);
#endif
		return 0;
	}

	return 1;
}

// peBEubN̏Ԃ
void write_ini_recovery(
	int id,		// peBEubN̔ԍ
	__int64 off)
{
	unsigned char buf[PARITY_EACH];
	int i;

	if ((recent_data & 0x10) == 0)
		return;	// ȃt@C͌ʂL^Ȃ

	memcpy(buf    , &id, 2);	// id  2oCgŕۑ
	memcpy(buf + 2, &off, 8);
	if (WriteFile(hIniBin, buf, PARITY_EACH, &i, NULL) == 0){
		delete_ini_file();
		return;
	}
}

// JoEt@C̏Ԃ
void write_ini_recovery2(
	int packet_count,		// ̃JoEt@CɊ܂܂pPbg̐
	int block_count,		// ̃JoEt@CɊ܂܂peBEubN̐
	int bad_flag,			// ̃JoEt@C̏
	unsigned int meta[7])	// TCYA쐬AXVA{[ԍAIuWFNgԍ
{
	if ((recent_data & 0x10) == 0)
		return;	// ȃt@C͌ʂL^Ȃ
	recent_data &= ~0x10;

	if (packet_count != -1){
		unsigned char buf[PARITY_SIZE];
		wchar_t item[32], uni_buf[16];
		// peBEubN̐
		memcpy(buf    , &packet_count, 4);
		memcpy(buf + 4, &block_count, 4);
		memcpy(buf + 8, &bad_flag, 1);
		if (file_write_data(hIniBin, ini_off + 16, buf, PARITY_SIZE - 16) != 0){
			delete_ini_file();
			return;
		}
		format_id(item, -1, meta + 4);	// t@Cʔԍږɂ
		swprintf(uni_buf, _countof(uni_buf), L"%d", ini_off);
		WritePrivateProfileString(L"PAR", item, uni_buf, ini_path);
#ifdef VERBOSE
		printf("write state, offset = %d, state = %02X\n", ini_off, bad_flag);
#endif

	} else {	// G[Ȃr܂ł̌ʂ폜
		int i = SetFilePointer(hIniBin, ini_off, NULL, FILE_BEGIN);
		if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
			delete_ini_file();
			return;
		}
		if (!SetEndOfFile(hIniBin)){
			delete_ini_file();
			return;
		}
#ifdef VERBOSE
		printf("clear state, offset = %d\n", ini_off);
#endif
	}
}

int read_ini_recovery(
	int num,
	int *packet_count,		// ̃JoEt@CɊ܂܂pPbg̐
	int *block_count,		// ̃JoEt@CɊ܂܂peBEubN̐
	int *bad_flag,			// ̃JoEt@C̏
	parity_ctx_r *p_blk)	// epeBEubN̏
{
	unsigned char buf[PARITY_EACH * MAX_EACH], *buf_p;
	int i, j, max, left, new_count = 0;

	// Ԃǂݍ
	if (file_read_data(hIniBin, ini_off + 16, buf, PARITY_SIZE - 16) != 0){
		delete_ini_file();
		return -1;
	}
	*bad_flag = 0;
	memcpy(packet_count, buf    , 4);
	memcpy(block_count , buf + 4, 4);
	memcpy(bad_flag    , buf + 8, 1);

	// peBEubNǂݍ
	max = *block_count;
	left = 0;
	for (i = 0; i < max; i++){
		if (left == 0){	// f[^ő MAX_EACH ǂݍ
			left = max - i;
			if (left > MAX_EACH)
				left = MAX_EACH;
			if (!ReadFile(hIniBin, buf, PARITY_EACH * left, &j, NULL) || ((PARITY_EACH * left) != j)){
				delete_ini_file();
				return -1;
			}
			buf_p = buf;
		}
		j = 0;
		memcpy(&j, buf_p, 2);
		if (p_blk[j].exist == 0){
			new_count++;	// JoEt@C̐VpeBEubN̐
			p_blk[j].exist = 1;
			p_blk[j].file = num;
			memcpy(&(p_blk[j].off), buf_p + 2, 8);
		}
		buf_p += PARITY_EACH;	// ̃f[^
		left--;
	}

	return new_count;
}

// Input File Slice Checksum 
void write_ini_checksum(
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	unsigned char buf[CHKSUM_EACH * MAX_EACH];
	int i, j, k, max;

	if (recent_data == 0)
		return;

	ini_off = GetPrivateProfileInt(L"Set", L"Checksum", 0, ini_path);
	if (ini_off != 0)	// Ƀ`FbNTL^ĂȂ
		return;

	// `FbNT̊Jnʒu
	ini_off = GetFileSize(hIniBin, NULL);	// ݒt@C̃TCY =  offset
	// `FbNT̏Iʒu܂Ńt@Cg傷
	i = SetFilePointer(hIniBin, ini_off + (source_num * CHKSUM_EACH), NULL, FILE_BEGIN);
	if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
		delete_ini_file();
		return;
	}
	if (SetEndOfFile(hIniBin) == 0){
		delete_ini_file();
		return;
	}

	for (j = 0; j < entity_num; j++){
		if (files[j].size > 0){
			max = files[j].b_off;
			// t@Cʒu\[XEt@Cɍ킹
			i = SetFilePointer(hIniBin, ini_off + (CHKSUM_EACH * max), NULL, FILE_BEGIN);
			if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
				delete_ini_file();
				return;
			}
			max += files[j].b_num;
			i = files[j].b_off;
			while (i < max){
				for (k = 0; (k < MAX_EACH) && (i + k < max); k++)
					memcpy(buf + (CHKSUM_EACH * k), s_blk[i + k].hash, CHKSUM_EACH);
				i += k;
				if (!WriteFile(hIniBin, buf, CHKSUM_EACH * k, &k, NULL)){
					delete_ini_file();
					return;
				}
			}
		}
	}
	// `FbNT𐳂߂ꍇڂ
	swprintf((wchar_t *)buf, sizeof(buf) / 2, L"%d", ini_off);
	WritePrivateProfileString(L"Set", L"Checksum", (wchar_t *)buf, ini_path);
}

// Input File Slice Checksum ǂݍ
int read_ini_checksum(
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	unsigned char buf[CHKSUM_EACH * MAX_EACH], *buf_p;
	int i, j, k, max, left;

	if (recent_data == 0)
		return -1;

	// `FbNTL^Ă邩m߂
	ini_off = GetPrivateProfileInt(L"Set", L"Checksum", 0, ini_path);
	if (ini_off == 0)	// `FbNTL^ĖȂ
		return -1;

	// ݂Ȃ`FbNT͋L^ǂݍ
	for (j = 0; j < entity_num; j++){
		if ((files[j].size > 0) && (files[j].state & 0x80)){
			max = files[j].b_off;
			// t@Cʒu\[XEt@Cɍ킹
			i = SetFilePointer(hIniBin, ini_off + (CHKSUM_EACH * max), NULL, FILE_BEGIN);
			if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
				delete_ini_file();
				return -1;
			}
			max += files[j].b_num;
			left = 0;
			for (i = files[j].b_off; i < max; i++){
				if (left == 0){	// f[^ MAX_EACH ǂݍ
					left = max - i;
					if (left > MAX_EACH)
						left = MAX_EACH;
					if (!ReadFile(hIniBin, buf, CHKSUM_EACH * left, &k, NULL) || ((CHKSUM_EACH * left) != k)){
						delete_ini_file();
						return -1;
					}
					buf_p = buf;
				}
				memcpy(s_blk[i].hash, buf_p, 20);
				memcpy(&(s_blk[i].crc), buf_p + 16, 4);
				s_blk[i].crc ^= window_mask;	// CRC ̏lƍŏI 0xFFFFFFFF 菜
				buf_p += CHKSUM_EACH;	// ̃f[^
				left--;
			}
			files[j].state = 0;	// ̃t@C̃`FbNTSēǂݍ
		}
	}

#ifdef VERBOSE
	printf("read checksum, offset = %d\n", ini_off);
#endif
	return 0;
}

// Input File Slice Checksum sSłǂݏ
void update_ini_checksum(
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	unsigned char buf[CHKSUM_EACH * MAX_EACH], *buf_p, checksum_state;
	int i, j, k, max, left, first_time = 0;

	if (recent_data == 0)
		return;

	ini_off = GetPrivateProfileInt(L"Set", L"Checksum2", 0, ini_path);
	if (ini_off == 0){	// `FbNT܂L^ĖȂAL^̈mۂ
		// t@Cʒu𖖔ɂ
		i = SetFilePointer(hIniBin, 0, NULL, FILE_END);
		if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
			delete_ini_file();
			return;
		}
		// `FbNT̊Jnʒu
		ini_off = GetFileSize(hIniBin, NULL);	// ݒt@C̃TCY =  offset
		// `FbNT̏Iʒu܂Ńt@Cg傷
		i = SetFilePointer(hIniBin, source_num * CHKSUM_EACH + entity_num, NULL, FILE_CURRENT);
		if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
			delete_ini_file();
			return;
		}
		if (SetEndOfFile(hIniBin) == 0){
			delete_ini_file();
			return;
		}
		first_time = -1;
	}

	for (j = 0; j < entity_num; j++){
		if (files[j].size > 0){
			if (first_time){
				checksum_state = 1;
			} else {	// `FbNTԂǂݍ
				if (file_read_data(hIniBin, ini_off + j, &checksum_state, 1) != 0){
					delete_ini_file();
					return;
				}
			}
			max = files[j].b_off;
			// t@Cʒu\[XEt@Cɍ킹
			i = SetFilePointer(hIniBin, ini_off + (CHKSUM_EACH * max + entity_num), NULL, FILE_BEGIN);
			if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
				delete_ini_file();
				return;
			}
			if ((checksum_state != 0) && ((files[j].state & 0x80) == 0)){	// ݂`FbNTL^
				max += files[j].b_num;
				i = files[j].b_off;
				while (i < max){
					for (k = 0; (k < MAX_EACH) && (i + k < max); k++)
						memcpy(buf + (CHKSUM_EACH * k), s_blk[i + k].hash, CHKSUM_EACH);
					i += k;
					if (!WriteFile(hIniBin, buf, CHKSUM_EACH * k, &k, NULL)){
						delete_ini_file();
						return;
					}
				}
			} else if ((checksum_state == 0) && ((files[j].state & 0x80) != 0)){	// ݂Ȃ`FbNT͋L^ǂݍ
				max += files[j].b_num;
				left = 0;
				for (i = files[j].b_off; i < max; i++){
					if (left == 0){	// f[^ MAX_EACH ǂݍ
						left = max - i;
						if (left > MAX_EACH)
							left = MAX_EACH;
						if (!ReadFile(hIniBin, buf, CHKSUM_EACH * left, &k, NULL) || ((CHKSUM_EACH * left) != k)){
							delete_ini_file();
							return;
						}
						buf_p = buf;
					}
					memcpy(s_blk[i].hash, buf_p, 20);
					memcpy(&(s_blk[i].crc), buf_p + 16, 4);
					s_blk[i].crc ^= window_mask;	// CRC ̏lƍŏI 0xFFFFFFFF 菜
					buf_p += CHKSUM_EACH;	// ̃f[^
					left--;
				}
				files[j].state = 0;	// ̃t@C̃`FbNTSēǂݍ
			}
			// `FbNT̏ԂL^
			if ((first_time) || ((checksum_state != 0) && ((files[j].state & 0x80) == 0))){
				checksum_state = (unsigned char)(files[j].state);
				if (file_write_data(hIniBin, ini_off + j, &checksum_state, 1) != 0){
					delete_ini_file();
					return;
				}
			}
		}
	}

#ifdef VERBOSE
	printf("update checksum, offset = %d\n", ini_off);
#endif
	if (first_time){	// ŏɃ`FbNT𐳂߂ꍇڂ
		swprintf((wchar_t *)buf, sizeof(buf) / 2, L"%d", ini_off);
		WritePrivateProfileString(L"Set", L"Checksum2", (wchar_t *)buf, ini_path);
	}
}

// \[XEt@C̃nbVľʂL^
void write_ini_state(
	int num,				// t@Cԍ
	unsigned int meta[7],	// TCYA쐬AXVA{[ԍAIuWFNgԍ
	int result)				//  0`=ubNڂ܂ňv, -3=SɈv
{
	wchar_t item[32], uni_buf[32];

	if ((recent_data & 0x10) == 0)
		return;	// ȃt@C͌ʂL^Ȃ
	recent_data &= ~0x10;

	// ̏Ԃ
	format_id(item, num, meta + 4);	// t@Cʔԍږɂ
	base64_encode5(uni_buf, meta, result);
	WritePrivateProfileString(L"State", item, uni_buf, ini_path);
#ifdef VERBOSE
	printf("write state, num = %d, state = %d\n", num, result);
#endif
}

// \[XEt@C̃nbVľʂL^Ă邩ǂ
// -1=̓ǂݎG[, -2=L^Ȃ, 0`=ubNڂ܂ňv, -3=SɈv
int check_ini_state(
	int num,				// t@Cԍ
	unsigned int meta[7],	// TCYA쐬AXVA{[ԍAIuWFNgԍ
	HANDLE hFile)			// ̃t@C̃nh
{
	wchar_t item[32], uni_buf[32];
	int state[4], result;
	BY_HANDLE_FILE_INFORMATION fi;

	// ݂̃t@C擾
	recent_data &= ~0x10;
	memset(&fi, 0, sizeof(BY_HANDLE_FILE_INFORMATION));
	if (GetFileInformationByHandle(hFile, &fi) != 0){
		meta[0] = fi.nFileSizeLow;
		meta[1] = fi.nFileSizeHigh;
		if ((recent_data == 0) || ((fi.nFileSizeLow <= REUSE_MIN) && (fi.nFileSizeHigh == 0)))
			return -2;	// ȃt@C̓TCY߂
		meta[2] = time_f_u(&(fi.ftCreationTime));
		meta[3] = time_f_u(&(fi.ftLastWriteTime));
		meta[4] = fi.dwVolumeSerialNumber;
		meta[5] = fi.nFileIndexLow;
		meta[6] = fi.nFileIndexHigh;
		recent_data |= 0x10;	// 傫ȃt@CʂQƂ
	} else {
		return -1;	// ̓ǂݎG[ÂsȂ
	}

	// L^ĂԂǂݍ
	format_id(item, num, meta + 4);	// t@Cʔԍږɂ
	result = GetPrivateProfileString(L"State", item, L"", uni_buf, _countof(uni_buf), ini_path);
	if (result == 0)	// ڂȂ
		return -2;
	result = base64_decode5(uni_buf, state);
	if (memcmp(meta, state, 16) != 0)	// t@CԂقȂ
		return -2;
#ifdef VERBOSE
	printf("check state, num = %d, state = %d\n", num, result);
#endif

	return result;
}

// pXŎw肳ꂽ\[XEt@CSƏ
void write_ini_complete(
	int num,				// t@Cԍ
	wchar_t *file_path)		// \[XEt@C̐΃pX
{
	wchar_t item[32], uni_buf[32];
	unsigned int meta[7];
	HANDLE hFile;
	BY_HANDLE_FILE_INFORMATION fi;

	if ((recent_data & 0x0F) == 0)
		return;

	hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return;
	// ݂̃t@C擾
	memset(&fi, 0, sizeof(BY_HANDLE_FILE_INFORMATION));
	if (GetFileInformationByHandle(hFile, &fi) != 0){
		meta[0] = fi.nFileSizeLow;
		meta[1] = fi.nFileSizeHigh;
		if ((fi.nFileSizeHigh == 0) && (fi.nFileSizeLow <= REUSE_MIN)){
			CloseHandle(hFile);
			return;	// ȃt@C͌ʂL^Ȃ
		}
		meta[2] = time_f_u(&(fi.ftCreationTime));
		meta[3] = time_f_u(&(fi.ftLastWriteTime));
		meta[4] = fi.dwVolumeSerialNumber;
		meta[5] = fi.nFileIndexLow;
		meta[6] = fi.nFileIndexHigh;
	} else {
		CloseHandle(hFile);
		return;	// ̓ǂݎG[
	}
	CloseHandle(hFile);

	// SƂԂ
	format_id(item, num, meta + 4);	// t@Cʔԍږɂ
	base64_encode5(uni_buf, meta, -3);	// S = -3
	WritePrivateProfileString(L"State", item, uni_buf, ini_path);
#ifdef VERBOSE
	printf("write state, num = %d, state = complete\n", num);
#endif
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// r؂ꂽׁ̈AwTCYǂݍ߂ȂꍇłG[ɂȂ
static int file_read_slice(
	HANDLE hFileRead,
	__int64 offset,
	unsigned char *buf,
	unsigned int size)
{
	unsigned int rv, rv2;

	// t@C̈ʒu offsetoCgڂɂ
	rv2 = (unsigned int)(offset >> 32);
	rv = (unsigned int)offset;
	rv = SetFilePointer(hFileRead, rv, &rv2, FILE_BEGIN);
	if ((rv == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
		print_win32_err();
		return 1;
	}

	// size oCgǂݍ
	if (!ReadFile(hFileRead, buf, size, &rv, NULL)){
		print_win32_err();
		return 2;	// wTCYǂݍ߂ȂĂG[ɂȂ
	}
	if (rv < size)
		memset(buf + rv, 0, size - rv);	// Ȃ 0 Ŗ߂

	return 0;
}

// XCXfЂǂݎă[Ɉꎞۊǂ
static void read_flake(
	HANDLE hFile,		// \[XEt@C̃nh
	__int64 file_off,
	int id,			// ubNԍ
	int flake_size,	// fЂ̃TCY
	int side,		// ǂ瑤 1=front, 0=rear
	slice_ctx *sc)
{
	unsigned char *p;
	int i, rv;
	flake_ctx *fc;

	rv = -1;	// g邩ǂ (󂫗̈̔ԍ)
	if (sc->flake_count > 0){	// ۊǏꏊ邩ׂ
		p = sc->flk_buf;
		for (i = 0; i < sc->flake_count; i++){
			fc = (flake_ctx *)p;
			p += sizeof(flake_ctx);
			if (fc->id == id){	// ɃXCXfЂL^Ă
				//printf("read flake[%d] = %d, size = %d, add ok\n", i, id, flake_size);
				if (side){	// Oɏ㏑Rs[
					if (file_read_slice(hFile, file_off, p, flake_size) != 0)
						return;	// ǂݍݎs
					fc->front_size = flake_size;
					if (fc->rear_size < 0)	// ς݂̈
						fc->rear_size = -(fc->rear_size);
				} else {	// 㔼ɏ㏑Rs[
					if (file_read_slice(hFile, file_off, p + (block_size - flake_size), flake_size) != 0)
						return;	// ǂݍݎs
					fc->rear_size = flake_size;
					if (fc->front_size < 0)	// ς݂̈
						fc->front_size = -(fc->front_size);
				}
				return;	// ǉďI
			} else if (fc->id == -1){	// 󂫗̈悪݂
				rv = i;	// gKvȂ
			}
			p += block_size;	// ̕ۊǗ̈
		}
	}

	if (rv == -1){	// XCXfЂ̋L^̈g
		int max_count;
		__int64 mem_size;
		mem_size = get_mem_size(0) - (4 << 20);	// 4MB ]TĂ
		max_count = (int)(mem_size / (__int64)(sizeof(flake_ctx) + block_size));
		if (max_count > source_num / 2)
			max_count = source_num / 2;	// IɕfЂ̓\[XEubN̔ȉ
		//printf("mem_size = %I64d MB, max_count = %d \n", mem_size >> 20, max_count);
		if (sc->flake_count < max_count){
			i = sc->flake_count + 1;
			i *= sizeof(flake_ctx) + block_size;
			p = (unsigned char *)realloc(sc->flk_buf, i);
			if (p != NULL){
				sc->flk_buf = p;
				rv = sc->flake_count;	// VK쐬̈̔ԍ
				sc->flake_count += 1;
			}
		}
		if (rv == -1){
			if (sc->flake_count > 0){	// ȏgłȂȂ疖ɓ
				rv = 0;	// 擪󂯂Ă炷
			} else {	// ̈掩̂mۂłȂꍇ͕ۊǂȂ
				sc->flake_count = -1;
				return;
			}
		}
	}
	if (rv < sc->flake_count - 1){	// ̈ȊO󂢂ĂȂ
		i = (sizeof(flake_ctx) + block_size) * rv;
		p = sc->flk_buf + i;
		i = (sizeof(flake_ctx) + block_size) * (sc->flake_count - rv - 1);
		//printf("slide from %d to %d, %d bytes \n", p + ((sizeof(flake_ctx) + block_size)), p, i);
		memmove(p, p + ((sizeof(flake_ctx) + block_size)), i);
		rv = sc->flake_count - 1;	// Oɂ炵Ė̈ɕۊǂ
	}

	//printf("read flake[%d] = %d, size = %d, save ok\n", rv, id, flake_size);
	p = sc->flk_buf;
	p += rv * (sizeof(flake_ctx) + block_size);
	fc = (flake_ctx *)p;
	p += sizeof(flake_ctx);
	fc->id = -1;	// ǂݍݎŝ߂ɏĂ
	if (side){	// Oɏ㏑Rs[
		if (file_read_slice(hFile, file_off, p, flake_size) != 0)
			return;	// ǂݍݎs
		fc->front_size = flake_size;
		fc->rear_size = 0;
	} else {	// 㔼ɏ㏑Rs[
		if (file_read_slice(hFile, file_off, p + (block_size - flake_size), flake_size) != 0)
			return;	// ǂݍݎs
		fc->front_size = 0;
		fc->rear_size = flake_size;
	}
	fc->id = id;
}

// XCXPʂ̌
// 0`=̃t@CɊ܂܂XCX̐, -1=G[, -3=L^Ȃ
int check_ini_verify(
	wchar_t *file_name,		// \t@C
	HANDLE hFile,			// t@C̃nh
	int num1,				// `FbNTrt@C̔ԍ
	unsigned int meta[7],	// TCYA쐬AXVA{[ԍAIuWFNgԍ
	int switch_v,			// @A0=W, 1=Ȉ, +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)			// XCXp̏
{
	unsigned char buf[SOURCE_EACH * MAX_EACH], *buf_p, err_mag;
	wchar_t item[MAX_LEN];
	int i, j, max, left, num;
	unsigned int err_off, flag;
	unsigned int time_last;
	__int64 file_off, file_size;
	BY_HANDLE_FILE_INFORMATION fi;

	// ݂̃t@C擾
	recent_data &= ~0x10;
	memset(&fi, 0, sizeof(BY_HANDLE_FILE_INFORMATION));
	if (GetFileInformationByHandle(hFile, &fi) != 0){
		meta[0] = fi.nFileSizeLow;
		meta[1] = fi.nFileSizeHigh;
		if ((recent_data == 0) || ((fi.nFileSizeLow <= REUSE_MIN) && (fi.nFileSizeHigh == 0)))
			return -3;	// ȃt@C̓TCY߂
		meta[2] = time_f_u(&(fi.ftCreationTime));
		meta[3] = time_f_u(&(fi.ftLastWriteTime));
		meta[4] = fi.dwVolumeSerialNumber;
		meta[5] = fi.nFileIndexLow;
		meta[6] = fi.nFileIndexHigh;
		recent_data |= 0x10;	// 傫ȃt@CʂQƂ
	} else {
		meta[0] = 0;
		meta[1] = 0;
		return -1;	// ̓ǂݎG[
	}

	// t@Cԍw肳Ăꍇ́AԍL^
	format_id(item, num1, meta + 4);	// t@Cʔԍږɂ
	if (switch_v & 1){	// ȈՌƏڍ׌ʂ
		ini_off = GetPrivateProfileInt(L"Simple", item, 0, ini_path);
	} else {
		ini_off = GetPrivateProfileInt(L"Damage", item, 0, ini_path);
	}

	if (ini_off != 0){
		if (file_read_data(hIniBin, ini_off, buf, STATE_SIZE) != 0){
			delete_ini_file();
			return -3;
		}
		memcpy(&max, buf + 16, 4);
		//printf("offset = %d, count = %d\n", ini_off, max);
		if (memcmp(meta, buf, 16) != 0)	// t@CԂقȂ
			ini_off = 0;
	}

	// vȂꍇ͍̃f[^L^
	if (ini_off == 0){
		ini_off = GetFileSize(hIniBin, NULL);	// ݒt@C̃TCY =  offset
		memcpy(buf, meta, 16);
		memset(buf + 16, 0xFF, 4);	// ̈
		if (file_write_data(hIniBin, ini_off, buf, STATE_SIZE) != 0){
			delete_ini_file();
			return -3;
		}
#ifdef VERBOSE
		printf("start state, offset = %d, switch = %d\n", ini_off, switch_v & 3);
#endif
		return -3;
	}

#ifdef VERBOSE
	printf("read  state, offset = %d, switch = %d, find_num = %d\n", ini_off, switch_v & 3, max);
#endif

	// vȂL^Ăf[^ǂݍ
	//printf("read_ini, %S = %d\n", item, max);
	time_last = GetTickCount();
	memcpy(&file_size, meta, 8);
	i = SetFilePointer(hIniBin, ini_off + STATE_SIZE, NULL, FILE_BEGIN);
	if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
		delete_ini_file();
		return -3;
	}
	wcscpy(item, base_dir);	// fBNgĂ
	left = 0;
	for (i = 0; i < max; i++){
		if (left == 0){	// f[^ MAX_EACH ǂݍ
			left = max - i;
			if (left > MAX_EACH)
				left = MAX_EACH;
			if (!ReadFile(hIniBin, buf, SOURCE_EACH * left, &j, NULL) || ((SOURCE_EACH * left) != j)){
				delete_ini_file();
				return -3;
			}
			buf_p = buf;
		}
		flag = 0;
		memcpy(&flag, buf_p + 10, 1);	// G[邩ǂ
		j = 0;
		memcpy(&j, buf_p, 2);	// \[XEubN̔ԍ
		memcpy(&file_off, buf_p + 2, 8);
		//printf("id = %d, off = %I64d, flag = %d\n", j, file_off, flag);
		if (flag & 8){	// ꂽf
			if ((sc->flake_count >= 0) && (s_blk[j].exist == 0)){	// ̃ubNȂ
				if (flag == 8){	// 㔼̒f
					read_flake(hFile, 0, j, (int)file_off, 0, sc);
				} else {	// O̒f
					__int64 file_size;
					memcpy(&file_size, meta, 8);
					read_flake(hFile, file_off, j, (int)(file_size - file_off), 1, sc);
				}
			}
		} else {
			if (s_blk[j].exist == 0){	// ̃ubNȂ
				s_blk[j].exist = 2;
				first_num += 1;
				if (switch_v & 16){	// Rs[
					num = s_blk[j].file;
					if (open_temp_file(item, num, files, sc))
						return -1;
					if (flag != 1){	// ̂܂܃Rs[
						if (file_copy_data(hFile, file_off, sc->hFile_tmp,
								(__int64)(j - files[num].b_off) * (__int64)block_size, s_blk[j].size)){
							printf("file_copy_data, %d\n", j);
							return -1;
						}
					} else {	// ڍ׌ŃG[ĂRs[
						if (file_read_slice(hFile, file_off, sc->buf, s_blk[j].size) != 0){
							printf("file_read_slice, %d\n", j);
							return -1;
						} else {	// G[ubN͏Ȃ̂ł̏ CRC tZ
							flag = crc_reverse_zero(s_blk[j].crc, block_size - s_blk[j].size);
							if (correct_error(sc->buf, s_blk[j].size, s_blk[j].hash, flag, &err_off, &err_mag) < 0){
								printf("fail to correct slice, %d\n", j);
								return -1;
							} else {
								if (file_write_data(sc->hFile_tmp, (__int64)(j - files[num].b_off) * (__int64)block_size, sc->buf, s_blk[j].size) != 0){
									printf("file_write_data, %d\n", j);
									return -1;
								}
							}
						}
					}

					// oߕ\
					if (GetTickCount() - time_last >= UPDATE_TIME){
						if (print_progress_file((int)((file_off * 1000) / file_size), first_num, file_name))
							return -2;
						time_last = GetTickCount();
					}
				}
			}
			s_blk[j].exist |= 0x1000;	// ̃t@CŌ
		}
		buf_p += SOURCE_EACH;	// ̃f[^
		left--;
	}
	return max;
}

// \[XEubN̏Ԃ
void write_ini_verify(
	int id,		// \[XEubN̔ԍ
	int flag,	// 1=G[Kv, 8=fЂ̌㔼, 9=fЂ̑O
	__int64 off)
{
	unsigned char buf[SOURCE_EACH];
	int i;

	if ((recent_data & 0x10) == 0)
		return;	// ȃt@C͌ʂL^Ȃ

	memcpy(buf     , &id, 2);
	memcpy(buf +  2, &off, 8);
	memcpy(buf + 10, &flag, 1);
	if (WriteFile(hIniBin, buf, SOURCE_EACH, &i, NULL) == 0){
		delete_ini_file();
		return;
	}
}

void write_ini_verify2(
	int num1,				// `FbNTrt@C̔ԍ
	unsigned int meta[7],	// TCYA쐬AXVA{[ԍAIuWFNgԍ
	int switch_v,			// @A0=W, 1=Ȉ
	int max)				// L^ubN
{
	if ((recent_data & 0x10) == 0)
		return;	// ȃt@C͌ʂL^Ȃ
	recent_data &= ~0x10;

	if (max >= 0){
		wchar_t item[32], uni_buf[16];
		// \[XEubN̐
		if (file_write_data(hIniBin, ini_off + 16, (unsigned char *)(&max), 4) != 0){
			delete_ini_file();
			return;
		}
		// t@Cԍw肳Ăꍇ́AԍL^
		format_id(item, num1, meta + 4);	// t@Cʔԍږɂ
		swprintf(uni_buf, _countof(uni_buf), L"%d", ini_off);
		if (switch_v & 1){	// ȈՌƏڍ׌ʂ
			WritePrivateProfileString(L"Simple", item, uni_buf, ini_path);
		} else {
			WritePrivateProfileString(L"Damage", item, uni_buf, ini_path);
		}
#ifdef VERBOSE
		printf("write state, offset = %d, switch = %d\n", ini_off, switch_v);
#endif

	} else {	// G[Ȃr܂ł̌ʂ폜
		int i = SetFilePointer(hIniBin, ini_off, NULL, FILE_BEGIN);
		if ((i == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR)){
			delete_ini_file();
			return;
		}
		if (!SetEndOfFile(hIniBin)){
			delete_ini_file();
			return;
		}
#ifdef VERBOSE
		printf("clear state, offset = %d, error = %d\n", ini_off, -max);
#endif
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// Ɨp̃e|Et@CJ
int open_temp_file(
	wchar_t *temp_path,		// ƗpAfBNgĂ
	int num,				// XCXt@Cԍ
	file_ctx_r *files,		// e\[XEt@C̏
	slice_ctx *sc)
{
	if (num == sc->num)
		return 0;	// ɊJĂȂ炻̂܂

	if (sc->hFile_tmp)	// ̍ƃt@CɊJĂȂ
		CloseHandle(sc->hFile_tmp);

	// XCXƃt@CJ
	sc->hFile_tmp = handle_temp_file(list_buf + files[num].name, temp_path);
	if (sc->hFile_tmp == INVALID_HANDLE_VALUE){
		sc->hFile_tmp = NULL;
		return 1;
	}
	sc->num = num;

	return 0;
}

