// list.c
// Copyright : 2015-08-25 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "md5_crc.h"
#include "verify.h"
#include "ini.h"
#include "list.h"


// recovery set ̃t@C̃nbVl𒲂ׂ (̃t@C͏)
// 0x00 = t@C݂ĊSł
// 0x01 = t@C݂Ȃ
// 0x02 = t@CjĂ
// 0x10 = t@CɒǉĂ
static long check_file_hash(
	char *ascii_buf,		// t@CĂ
	wchar_t *file_path,		// Ɨp
	long num,				// file_ctx ɂt@Cԍ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	long i, bad_flag = 0;
	unsigned long meta_data[7];
	__int64 file_size;	// ݂t@C̃TCY͖{̃TCYƂ͈قȂ邱Ƃ
	HANDLE hFile;

	// t@C݂邩
	wcscpy(file_path, base_dir);
	wcscpy(file_path + base_len, list_buf + files[num].name);
/*
// fBXNELbVgȂꍇ̎p
i = file_hash_direct(num, file_path, list_buf + files[num].name, files, s_blk);
printf("file_hash_direct = %d\n", i);
if (i == -2)
	return 2;	// ɃLZꂽ
*/
	hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE){	// t@C݂Ȃ
		bad_flag = 1;
	} else {	// t@C̏ԂL^Ă邩ׂ
		i = check_ini_state(num, meta_data, hFile);
		if (i == -1){	// G[
			CloseHandle(hFile);
			bad_flag = 1;	// 擾łȂt@C͏Ɣ肷
		}
	}
	if (bad_flag == 0){	// t@C݂ȂԂmF
		memcpy(&file_size, meta_data, 8);
		if (file_size >= files[num].size){	// {̃TCY܂ł̃nbVlv邩m߂
			if (i == -2){	// ʂ̋L^
				i = file_hash_check(num, list_buf + files[num].name, hFile, 0, files, s_blk);
				if (i == -2)
					return 2;	// ɃLZꂽ
				// MD5-16k vʂL^
				if (i != -1)
					write_ini_state(num, meta_data, i);
			}
			if (i != -3){	// t@C̃nbVlقȂ
				bad_flag = 2;	// IO G[łjɂď𑱍s
				if (i > 0)		// 擪ɊSȃubNĂȂ
					bad_flag |= i << 8;	//  24-bit ɊSȃubŇL^
				// MD5-16k قȂ̂͌oubN 0ƂĈ
			} else if (file_size > files[num].size){	// {̃TCY܂ł̃nbVl͓
				bad_flag = 16;	// ɃS~tĂȂׂ
			}
		} else {	// file_size < files[num].size
			bad_flag = 2;
		}
		CloseHandle(hFile);
	}

	files[num].state = bad_flag;
	if (bad_flag == 1){	// 
		printf("            - Missing  : \"%s\"\n", ascii_buf);
	} else {	// SAj܂͒ǉ (ǉ͓Ȕj)
		long b_last;
		if (bad_flag & 2){	// jȂ 24-bit ɊSȃubŇL^Ă
			bad_flag >>= 8;
			b_last = files[num].b_off + bad_flag;	// r܂ŗLƌȂ
			for (i = files[num].b_off; i < b_last; i++)
				s_blk[i].exist = 2;
			first_num += bad_flag;	// ubNWv
			print_progress_file(-1, first_num, NULL);	// dOvubN\
			printf("%13I64d %8d : \"%s\"\n", file_size, bad_flag, ascii_buf);
		} else {	// Sǉ
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++)
				s_blk[i].exist = 1;	// SubNLƌȂ
			first_num += files[num].b_num;	// ubNWv
			print_progress_file(-1, first_num, NULL);	// dOvubN\
			if (bad_flag == 0){	// TCYŃnbVlv犮S
				printf("            = Complete : \"%s\"\n", ascii_buf);
			} else {			// {̃TCY܂ŃnbVlvǉ
				printf("%13I64d Appended : \"%s\"\n", file_size, ascii_buf);
			}
		}
	}

	return 0;
}

// ubÑ`FbNTĂt@C
// 0x80 = t@C݂ĊSł (SẴubNSƂ݂Ȃ)
// 0x81 = t@C݂Ȃ
// 0x82 = t@CjĂ
// 0x90 = t@CɒǉĂ (SẴubNSƂ݂Ȃ)
long check_file_hash_incomplete(
	char *ascii_buf,		// t@CĂ
	wchar_t *file_path,		// Ɨp
	long num,				// file_ctx ɂt@Cԍ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	long i, bad_flag = 0;
	unsigned long meta_data[7];
	__int64 file_size;	// ݂t@C̃TCY͖{̃TCYƂ͈قȂ邱Ƃ
	HANDLE hFile;

	// t@C݂邩
	wcscpy(file_path, base_dir);
	wcscpy(file_path + base_len, list_buf + files[num].name);
	hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE){	// t@C݂Ȃ
		bad_flag = 1;
	} else {	// t@C̏ԂL^Ă邩ׂ
		i = check_ini_state(num, meta_data, hFile);
		if (i == -1){	// G[
			CloseHandle(hFile);
			bad_flag = 1;	// 擾łȂt@C͏Ɣ肷
		}
	}
	if (bad_flag == 0){	// t@C݂ȂԂmF
		memcpy(&file_size, meta_data, 8);
		if (file_size >= files[num].size){	// {̃TCY܂ł̃nbVlv邩m߂
			if (i == -2){	// ʂ̋L^
				i = file_hash_check(num, list_buf + files[num].name, hFile, INT_MAX, files, NULL);
				if (i == -2)
					return 2;	// ɃLZꂽ
				// MD5-16k vʂL^
				if (i != -1)
					write_ini_state(num, meta_data, i);
			}
			if (i != -3){	// t@C̃nbVlقȂ
				bad_flag = 2;	// IO G[łjɂď𑱍s
			} else if (file_size > files[num].size){	// {̃TCY܂ł̃nbVl͓
				bad_flag = 16;	// ɃS~tĂȂׂ
			}
		} else {	// file_size < files[num].size
			bad_flag = 2;
		}
		CloseHandle(hFile);
	}

	files[num].state = bad_flag | 0x80;	// `FbNT݂Ȃ
	if (bad_flag == 1){	// 
		printf("            - Missing  : \"%s\"\n", ascii_buf);
	} else {	// SAj܂͒ǉ (ǉ͓Ȕj)
		if (bad_flag & 2){	// ubNPʂ̌łȂ̂őSĔjƂĈ
			printf("%13I64d Damaged  : \"%s\"\n", file_size, ascii_buf);
		} else {	// Sǉ
			// ubNPʂ̌͂łȂƂ肠LƂĈ
			long b_last;
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++)
				s_blk[i].exist = 1;	// SubNLƌȂ
			first_num += files[num].b_num;	// ubNWv
			print_progress_file(-1, first_num, NULL);	// dOvubN\
			if (bad_flag == 0){
				printf("            = Complete : \"%s\"\n", ascii_buf);
			} else {
				printf("%13I64d Appended : \"%s\"\n", file_size, ascii_buf);
			}
		}
	}

	return 0;
}

// t@CtH_݂邩ׂ
// non-recovery set ̃t@C݂ĔjĂȂׂ
//  0 = t@C݂ĊSł
//  1 = t@C݂Ȃ
//  2 = t@CjĂ
// 16 = t@CɒǉĂ
// 64 = tH_݂
// 65 = tH_݂Ȃ
static long check_file_exist(
	char *ascii_buf,		// t@CĂ
	wchar_t *file_path,		// Ɨp
	long num,				// file_ctx ɂt@Cԍ
	file_ctx_r *files)		// e\[XEt@C̏
{
	long i, bad_flag = 0;
	unsigned long meta_data[7];
	__int64 file_size;
	HANDLE hFile;

	wcscpy(file_path, base_dir);
	wcscpy(file_path + base_len, list_buf + files[num].name);
	i = (long)wcslen(file_path);
	if ((i > 1) && (file_path[i - 1] == '\\')){	// tH_Ȃ
		bad_flag = 64;
		i = GetFileAttributes(file_path);
		if ((i == INVALID_FILE_ATTRIBUTES) || ((i & FILE_ATTRIBUTE_DIRECTORY) == 0)){
			bad_flag = 65;	// tH_݂Ȃ
			printf("            - Missing  : \"%s\"\n", ascii_buf);
		} else {	// tH_݂
			printf("            0 Complete : \"%s\"\n", ascii_buf);
		}
		files[num].state = bad_flag;
		return 0;
	}

	// t@C݂邩
	hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE){	// t@C݂Ȃ
		bad_flag = 1;
	} else {
		// t@C̃TCY𒲂ׂ
		i = check_ini_state(num, meta_data, hFile);
		if (i == -1){	// G[
			CloseHandle(hFile);
			bad_flag = 1;	// 擾łȂt@C͏Ɣ肷
		}
	}
	if (bad_flag == 0){	// t@C݂ȂԂmF
		memcpy(&file_size, meta_data, 8);
		if (files[num].size == 0){	// TCY 0 Ɣj悤Ȃ
			if (file_size > 0)	// ɃS~tĂ
				bad_flag = 16;
		} else if (file_size >= files[num].size){	// {̃TCY܂ł̃nbVlv邩m߂
			if (i == -2){	// ʂ̋L^
				i = file_hash_check(num, list_buf + files[num].name, hFile, INT_MAX, files, NULL);
				if (i == -2)
					return 2;	// ɃLZꂽ
				// MD5-16k vʂL^
				if (i != -1)
					write_ini_state(num, meta_data, i);
			}
			if (i != -3){	// t@C̃nbVlقȂ
				bad_flag = 2;	// IO G[łjɂď𑱍s
			} else if (file_size > files[num].size){	// {̃TCY܂ł̃nbVl͓
				bad_flag = 16;	// ɃS~tĂȂׂ
			}
		} else {	// file_size < files[num].size
			bad_flag = 2;
		}
		CloseHandle(hFile);
	}

	files[num].state = bad_flag;
	switch (bad_flag){
	case 0:		// Sȃt@C
		printf("            = Complete : \"%s\"\n", ascii_buf);
		break;
	case 1:		// t@C
		printf("            - Missing  : \"%s\"\n", ascii_buf);
		break;
	case 2:		// jt@C
		printf("%13I64d Damaged  : \"%s\"\n", file_size, ascii_buf);
		break;
	case 16:	// ǉꂽt@C
		printf("%13I64d Appended : \"%s\"\n", file_size, ascii_buf);
		break;
	}

	return 0;
}

// \[XEt@CSǂ𒲂ׂ
// 0=, 1=G[, 2=LZ
long check_file_complete(
	char *ascii_buf,
	wchar_t *file_path,		// Ɨp
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	long i, rv;

	printf("\nVerifying Input File   :\n");
	printf("         Size Status   :  Filename\n");
	fflush(stdout);
	count_last = 0;
	first_num = 0;	// ߂Č\[XEubN̐
	for (i = 0; i < entity_num; i++){
		if (cancel_progress() != 0)	// LZ
			return 2;
		utf16_to_cp(list_buf + files[i].name, ascii_buf, cp_output);

		if (files[i].size == 0){	// tH_܂͋t@C݂邩ׂ
			rv = check_file_exist(ascii_buf, file_path, i, files);
		} else {
			if (files[i].state & 0x80){	// `FbNTĂĂSǂ͔
				rv = check_file_hash_incomplete(ascii_buf, file_path, i, files, s_blk);
			} else {	// \[XEt@C̏ (SAAj) 𔻒肷
				rv = check_file_hash(ascii_buf, file_path, i, files, s_blk);
			}
		}
		if (rv != 0)
			return rv;
		fflush(stdout);
	}
	for (i = entity_num; i < file_num; i++){
		if (cancel_progress() != 0)	// LZ
			return 2;
		utf16_to_cp(list_buf + files[i].name, ascii_buf, cp_output);
		if (rv = check_file_exist(ascii_buf, file_path, i, files))
			return rv;
		fflush(stdout);
	}

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// w肳ꂽtH_󂩂ǂ𒲂ׂ
static long is_folder_empty(wchar_t *folder_path)	// tH_̃pX
{
	long len;
	HANDLE hFind;
	WIN32_FIND_DATA FindData;

	len = (long)wcslen(folder_path);
	folder_path[len    ] = '*';
	folder_path[len + 1] = 0;
	hFind = FindFirstFile(folder_path, &FindData);
	folder_path[len    ] = 0;	// ɖ߂
	if (hFind != INVALID_HANDLE_VALUE){
		do {
			if ((wcscmp(FindData.cFileName, L".") != 0) && (wcscmp(FindData.cFileName, L"..") != 0)){
				len = 0;	// ł͂Ȃ
				break;
			}
		} while (FindNextFile(hFind, &FindData));
	}
	FindClose(hFind);

	return len;
}

// wtH_̕ʖt@CT
// 0=I, 1=G[, 2=LZ
static long recursive_search(
	char *ascii_buf,		// Ɨp
	wchar_t *search_path,	// t@C̐efBNgAʖt@C̑΃pX߂
	long dir_len,			// fBNg̒
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	__int64 file_size;	// ݂t@C̃TCY͖{̃TCYƂ͈قȂ邱Ƃ
	long rv, i, num, b_last, source_len;
	unsigned long meta_data[5];
	HANDLE hFile, hFind;
	WIN32_FIND_DATA FindData;

	// \[XEt@C̗̈܂łrȂ (ʖt@Cô͈񂾂)
	source_len = list_len - 1;

	// w肳ꂽfBNg̃t@CƔr
	wcscpy(search_path + dir_len, L"*");
	hFind = FindFirstFile(search_path, &FindData);
	if (hFind != INVALID_HANDLE_VALUE){
		do {
			if (cancel_progress() != 0){	// LZ
				FindClose(hFind);
				return 2;
			}
			if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0){	// tH_Ȃ
				// efBNg͖
				if ((wcscmp(FindData.cFileName, L".") == 0) || (wcscmp(FindData.cFileName, L"..") == 0))
					continue;
				// tH_ꍇ͖
				if (dir_len + wcslen(FindData.cFileName) + 2 >= MAX_LEN)	// Ɂu\*vǉ
					continue;
				// ݂̃fBNgɌtH_A
				wcscpy(search_path + dir_len, FindData.cFileName);
				wcscat(search_path + dir_len, L"\\");
				// ̃\[XEt@C͖
				if (search_file_path(list_buf + 1, source_len, search_path + base_len))	// fBNg̑΃pXŔr
					continue;

				// tH_oΏۂƈv邩ǂm߂
				for (num = entity_num; num < file_num; num++){	// tH_ non-recovery set ɂ݂Ȃ
					if (files[num].state == 65){	// tH_Ȃ
						if (_wcsicmp(search_path + dir_len, offset_file_name(list_buf + files[num].name)) == 0){
							// ̃t@C̃TuEfBNg͓Ȃ̂ŁAĝtH_͖
							if (is_folder_empty(search_path) == 0)
								continue;
							// ړꂽtH_
							files[num].name2 = list_len;	// ړꂽtH_L^
							if (add_file_path(search_path + base_len)){
								printf("add_file_path\n");
								FindClose(hFind);
								return 1;
							}
							utf16_to_cp(search_path + base_len, ascii_buf, cp_output);	// ړꂽtH_\
							printf("            0 Found    : \"%s\"\n", ascii_buf);
							files[num].state = 64 | 32;	// ړꂽtH_
							utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);	// {̃tH_\
							printf("            = Moved    : \"%s\"\n", ascii_buf);
							break;	// ꍇ́Aȍ~̃\[XEt@CƔrȂ
						}
					}
				}
				continue;
			}

			// t@Cꍇ͖
			if (dir_len + wcslen(FindData.cFileName) >= MAX_LEN)
				continue;
			// ݂̃fBNgɌt@CA
			wcscpy(search_path + dir_len, FindData.cFileName);
			// jĂȂJoEt@C͖
			if (search_file_path(recv_buf, recv_len, search_path))	// tEpXŔr
				continue;
			// ̃\[XEt@C͖
			if (search_file_path(list_buf + 1, source_len, search_path + base_len))	// fBNg̑΃pXŔr
				continue;

			// t@CETCYoΏۂ̃TCYƈv邩ǂ
			file_size = ((__int64)(FindData.nFileSizeHigh) << 32) | (__int64)(FindData.nFileSizeLow);
			for (num = 0; num < file_num; num++){
				if ((files[num].state & 0x03) && (files[num].size == file_size)){
					if (file_size > 0){
						//printf("find size %I64d, %S\n", file_size, search_path + base_len);
						// ʖt@C̃nbVl𒲂ׂ
						hFile = CreateFile(search_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
						if (hFile != INVALID_HANDLE_VALUE){	// t@CJȂemF
							prog_last = -1;	// oߕ\܂̈
							rv = check_ini_state(num, meta_data, hFile);
							if (rv == -2){	// ʂ̋L^
								if ((num >= entity_num) || ((files[num].state & 0x80) != 0)){
									// non-recovery set ̃t@C܂̓`FbNT\[XEt@C
									rv = file_hash_check(num, FindData.cFileName, hFile, INT_MAX, files, NULL);
								} else {	// ʂ̃\[XEt@C
									if (files[num].state & 0x02){	// {̃t@CjȂXCX̏dJEg
										rv = files[num].state >> 8;
									} else {
										rv = 0;
									}
									rv = file_hash_check(num, FindData.cFileName, hFile, rv, files, s_blk);
								}
								if (rv == -2){
									CloseHandle(hFile);
									FindClose(hFind);
									return 2;	// G[͖đs邪ALZȂ璆f
								}
								// MD5-16k vʂL^
								if (rv != -1)
									write_ini_state(num, meta_data, rv);
							}
							CloseHandle(hFile);
							if (rv == -3){	// t@C̃nbVlv
								b_last = files[num].b_off + files[num].b_num;
								for (i = files[num].b_off; i < b_last; i++)
									s_blk[i].exist = 1;	// SubNLƌȂ
								files[num].name2 = list_len;	// ʖEړ̃t@CL^
								if (add_file_path(search_path + base_len)){
									printf("add_file_path\n");
									FindClose(hFind);
									return 1;
								}
								if (files[num].state & 0x01){	// {̃t@CĂȂ
									files[num].state ^= 0x21;	// ĕʖEړ 0x01 -> 0x20
									first_num += files[num].b_num;	// ubNWv
								} else {
									files[num].state ^= 0x2A;	// jĕʖEړ 0x02 -> 0x28 (XCX͈ێ)
									first_num += files[num].b_num - (files[num].state >> 8);	// VȃubNǉ
								}
								print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\
								utf16_to_cp(search_path + base_len, ascii_buf, cp_output);	// ʖEړ̃t@C\
								printf("%13I64d Found    : \"%s\"\n", file_size, ascii_buf);
								utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);	// {̃t@C\
								if (compare_directory(list_buf + files[num].name, search_path + base_len) == 0){	// ꏊȂʖ
									printf("            = Misnamed : \"%s\"\n", ascii_buf);
								} else {	// ʂ̏ꏊȂړ
									printf("            = Moved    : \"%s\"\n", ascii_buf);
								}
								break;	// ꍇ́Aȍ~̃\[XEt@CƔrȂ
							} else {
								if (rv > 0){	// ʖ̔jt@CɃXCXAIɌΏۂɒǉ
									//printf("rv = %d, %S\n", rv, search_path + base_len);
									if (list2_buf == NULL){
										list2_len = 0;
										list2_max = ALLOC_LEN;
										list2_buf = (wchar_t *)malloc(list2_max * 2);
									}
									if (list2_buf){
										wchar_t *tmp_p;
										long len = (long)wcslen(search_path);
										if (!search_file_path(list2_buf, list2_len, search_path)){	// t@CdȂ悤ɂ
											if (list2_len + len >= list2_max){ // ̈悪ȂȂȂg
												list2_max += ALLOC_LEN;
												tmp_p = (wchar_t *)realloc(list2_buf, list2_max * 2);
												if (tmp_p == NULL){
													printf("realloc, %d\n", list2_max);
													FindClose(hFind);
													return 1;
												} else {
													list2_buf = tmp_p;
												}
											}
											// ̃t@Cǉ
											//printf_cp("add external file, %s\n", search_path);
											wcscpy(list2_buf + list2_len, search_path);
											list2_len += len + 1;
										}
									}
									if (prog_last >= 0)	// r܂ł̃XCX\Ăꍇ
										print_progress_file(-1, first_num, NULL);	// ̐ɖ߂Ă
								}
								print_progress_done();	// oߕ\ 100% ɂĂ
							}
						}
					} else {	// TCY 0 (t@C) ̏ꍇ
						if (files[num].state & 64)
							continue;	// rΏۂtH_Ȃ疳 (t@C̔rł͂˂邩svH)
						// t@Cǂm߂
						if (_wcsicmp(FindData.cFileName, offset_file_name(list_buf + files[num].name)) == 0){
							// ړꂽt@C
							files[num].name2 = list_len;	// ړꂽt@CL^
							if (add_file_path(search_path + base_len)){
								printf("add_file_path\n");
								FindClose(hFind);
								return 1;
							}
							utf16_to_cp(search_path + base_len, ascii_buf, cp_output);	// ړꂽt@C\
							printf("            0 Found    : \"%s\"\n", ascii_buf);
							files[num].state = 0x20;	// t@C͔jȂ̂ŁAĈړ̂
							utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);	// {̃t@C\
							printf("            = Moved    : \"%s\"\n", ascii_buf);
							break;	// ꍇ́Aȍ~̃\[XEt@CƔrȂ
						}
					}
				}
			}
		} while (FindNextFile(hFind, &FindData));	// ̃t@C
	}
	FindClose(hFind);

	// w肳ꂽfBNgȉ̃tH_ċAIɒׂ
	wcscpy(search_path + dir_len, L"*");
	hFind = FindFirstFile(search_path, &FindData);
	if (hFind != INVALID_HANDLE_VALUE){
		do {
			// tH_ȊO͖
			if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)
				continue;
			// efBNg͖
			if ((wcscmp(FindData.cFileName, L".") == 0) || (wcscmp(FindData.cFileName, L"..") == 0))
				continue;
			// tH_ꍇ͖
			if (dir_len + wcslen(FindData.cFileName) + 2 >= MAX_LEN)	// Ɂu\*vǉ
				continue;
			// ̃tH_̓VȌΏۂɂ
			wcscpy(search_path + dir_len, FindData.cFileName);
			wcscat(search_path + dir_len, L"\\");	// fBNgĹu\vɓꂵĂ
			//printf_cp("inner search... %s\n", search_path + base_len);
			rv = recursive_search(ascii_buf, search_path, (long)wcslen(search_path), files, s_blk);
			if (rv != 0){
				// G[A܂̓LZꂽ
				FindClose(hFind);
				return rv;
			}
		} while (FindNextFile(hFind, &FindData));	// ̃tH_
	}
	FindClose(hFind);

	return 0;
}

// \[XEt@CsSȂʖEړt@CT
// 0=, 1=G[, 2=LZ
long search_misnamed_file(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	wchar_t find_path[MAX_LEN];
	long i, rv, num, b_last;

	// sSȃ\[XEt@C݂邩ׂ
	i = 0;		//  0x01, 0x81, tH_̏ 0x41 
	rv = 0;		// j 0x02, 0x82, ǉ 0x10 
	b_last = 0;	// jȂʖt@CT
	for (num = 0; num < file_num; num++){
		if (files[num].state & 0x01)
			i++;	// t@C̐
		if (files[num].state & 0x12)
			rv++;	// jEǉ̃t@C̐
		if (files[num].state & 0x03)	//  0x01Aj 0x02 Ȃʖt@CT
			b_last++;	// TKvt@C̐
	}
	printf("\nComplete file count\t: %d\n", file_num - i - rv);
	if (b_last == 0){	// TȂꍇ̓t@C̏Wv
		printf("Misnamed file count\t: %d\n", 0);
		printf("Damaged file count\t: %d\n", rv);
		printf("Missing file count\t: %d\n", i);
		return 0;	// TȂŏI
	}

	// t@CƂɌʂ\
	printf("\nSearching misnamed file: %d\n", b_last);	// TΏۂ̃t@C
	printf("         Size Status   :  Filename\n");
	fflush(stdout);
	wcscpy(find_path, base_dir);	// fBNgȉċAIɌ
	if (rv = recursive_search(ascii_buf, find_path, base_len, files, s_blk))
		return rv;

	// ԂƂɃt@CWv
	i = 0;		//  0x01, 0x81, tH_̏ 0x41 
	rv = 0;		// j 0x02, 0x82, ǉ 0x10 
	b_last = 0;	// ĕʖEړ 0x20, 0xA0, jĕʖEړ 0x28, 0xA8, tH_̈ړ 0x60
	for (num = 0; num < file_num; num++){
		if (files[num].state & 0x01)
			i++;	// t@C̐
		if (files[num].state & 0x12)
			rv++;	// jEǉ̃t@C̐
		if (files[num].state & 0x20)
			b_last++;	// ʖEړ̐
	}
	printf("\n");
	printf("Misnamed file count\t: %d\n", b_last);
	printf("Damaged file count\t: %d\n", rv);
	printf("Missing file count\t: %d\n", i);
	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// jEEގ̃t@CgXCXT
// 0=, 1=G[, 2=LZ
long search_file_slice(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	long switch_v,			// x 0=ڍ׌, 1=ȈՌ, +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	long rv, num;
	slice_ctx sc[1];

	printf("\nInput File Slice found\t: %d\n", first_num);
	fflush(stdout);
	if (first_num > source_num)
		return 1;	// ô͂ǂԈĂ
	if ((first_num == source_num) || (block_size <= 4))
		return 0;	// TȂŏI

	// XCX̏
	memset(sc, 0, sizeof(slice_ctx));
	rv = init_verification(switch_v, files, s_blk, sc);
	if (rv < 0)	// vIȃG[܂̓XCXsv
		return 0;
	if (rv == 1)	// XChs邢͕sv
		switch_v |= 1;	// XChȂꍇ͊ȈՌɂ
	//printf("\n init_verification = %d, switch_v = %d\n", rv, switch_v);

	// t@CƂɌʂ\
	printf("\nFinding available slice:\n");
	printf("         Size Status   :  Filename\n");
	fflush(stdout);

	// jĂt@CƕEގt@C
	for (num = 0; num < entity_num; num++){
		// j 0x02Aǉ 0x10Ajĕʖ 0x28 Ȃ\[XEt@C
		//  0x01Aj 0x02 ŁÃt@C̃XCXoȂAt@CT
		// ŕt@CȂꍇAt@CT
		if ((files[num].state & 0x1B) == 0)
			continue;

		if (rv = cancel_progress())	// LZ
			goto error_end;

		if (rv = check_file_slice(ascii_buf, file_path, num, switch_v, files, s_blk, sc))
			goto error_end;
	}

	// w肳ꂽOt@C
	if ((first_num < source_num) && (list2_buf != NULL)){
		if (rv = check_external_file(ascii_buf, file_path, switch_v, files, s_blk, sc))
			goto error_end;
	}

	// ȈՌȊOȂÃt@C̃XCXSČoĂĂAt@CT
	num = 0;
	if (switch_v & 1)
		num = entity_num;
	for (; num < entity_num; num++){
		if (first_num >= source_num)
			break;

		if (rv = cancel_progress())	// LZ
			goto error_end;

		if (rv = search_file_split(ascii_buf, file_path, num, switch_v, files, s_blk, sc))
			goto error_end;
	}

	// fBNĝ̑̃t@C
	if (first_num < source_num){
		if (rv = search_additional_file(ascii_buf, file_path, switch_v, files, s_blk, sc))
			goto error_end;
	}

	// \[XEubN̐
	printf("\nInput File Slice found\t: %d\n", first_num);
	fflush(stdout);
	if (first_num > source_num){
		rv = 1;	// ô͂ǂԈĂ
	} else {
		rv = 0;
	}

error_end:
	if (sc->buf){
		free(sc->buf);
		if (sc->h){	// TuEXbhI
			sc->size = 0;	// Iw
			SetEvent(sc->run);
			WaitForSingleObject(sc->h, INFINITE);
			CloseHandle(sc->h);
		}
	}
	if (sc->order)
		free(sc->order);
	if (sc->hFile_tmp)
		CloseHandle(sc->hFile_tmp);
	if (sc->flk_buf)
		free(sc->flk_buf);

	return rv;
}

