// par2.c
// Copyright : 2016-10-17 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <malloc.h>
#include <stdio.h>

#include <windows.h>
#include <imagehlp.h>

#include "common2.h"
#include "par2.h"
#include "crc.h"
#include "create.h"
#include "search.h"
#include "list.h"
#include "verify.h"
#include "repair.h"
#include "ini.h"
#include "reedsolomon.h"

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// peB쐬
int par2_create(
	wchar_t *uni_buf,	// ƗpA͂ꂽRgĂ
	int packet_limit,	// JoEt@C̃pPbgJԂ̐
	int block_distri,	// peBEubN̕z@
	int switch_p)		// CfbNXEt@CȂ, jR[h̃t@CL^
{
	unsigned char *tmp_p, *common_buf = NULL, *footer_buf;
	int err = 0, i, packet_num, common_size, footer_size;
	HANDLE hFile, *rcv_hFile = NULL;
	file_ctx_c *files = NULL;
	source_ctx_c *s_blk = NULL;
	parity_ctx_c *p_blk = NULL;

	init_crc_table();	// CRC vZp̃e[u쐬

	// \[XEt@C̏
	files = (file_ctx_c *)malloc(sizeof(file_ctx_c) * file_num);
	if (files == NULL){
		printf("malloc, %d\n", sizeof(file_ctx_c) * file_num);
		err = 1;
		goto error_end;
	}

	// \[XEt@C̏W߂
	if (err = get_source_files(files))
		goto error_end;

	// pPbgi[obt@[
	common_size = 64 + 12 + (file_num * 16);	// Main packet
	common_size += ((64 + 56 + 3) * file_num) + (list_len * 3);	// File Description packet
	common_size += ((64 + 16) * entity_num) + (source_num * 20);	// Input File Slice Checksum packet
	if ((switch_p & 2) != 0)
		common_size += ((64 + 16 + 2) * file_num) + (list_len * 2);	// Unicode Filename packet
	common_size *= 2;	// 2{mۂ
	common_size += 64 + 12;	// Creator packet "par2j v*.*.*"
	if (uni_buf[0] != 0){
		//common_size += 64 + 3 + wcslen(uni_buf);	// ASCII Comment packet
		common_size += 64 + 16 + 2 + (int)(wcslen(uni_buf) * 2);	// Unicode Comment packet
	}
	common_buf = (unsigned char *)malloc(common_size);
	if (common_buf == NULL){
		printf("malloc, %d\n", common_size);
		err = 1;
		goto error_end;
	}

	// ʃpPbg쐬
	common_size = set_common_packet(common_buf, &packet_num, (switch_p & 2) >> 1, files);
	if (common_size <= 2){
		err = common_size;
		goto error_end;
	}
	memcpy(common_buf + common_size, common_buf, common_size);	// ̔ɑÔRs[
	// pPbg쐬
	footer_buf = common_buf + (common_size * 2);	// ʃpPbǧ
	footer_size = set_footer_packet(footer_buf, uni_buf, common_buf + 32);
	// 傫߂ɊmۂĂāATCYmɏk
	tmp_p = (unsigned char *)realloc(common_buf, common_size * 2 + footer_size);
	if (tmp_p == NULL){
		printf("realloc, %d\n", common_size * 2 + footer_size);
		err = 1;
		goto error_end;
	} else {
		common_buf = tmp_p;
		footer_buf = tmp_p + (common_size * 2);	// ʃpPbǧ
	}
	//  Set ID ̋L^ΏĂ
	if (recent_data != 0)
		reset_ini_file(common_buf + 32);

	printf("\n");
	// ɊSȃCfbNXEt@C݂Ȃ쐬Ȃ
/*	if (GetFileAttributes(recovery_file) != INVALID_FILE_ATTRIBUTES){
		hFile = CreateFile(recovery_file, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){
			if (GetFileSize(hFile, NULL) == common_size + footer_size){
				unsigned int crc, crc2;
				// ̃CfbNXEt@C CRC-32 ߂
				crc = file_crc_part(hFile);
				crc2 = crc_update(0xFFFFFFFF, common_buf, common_size);
				crc2 = crc_update(crc2, footer_buf, footer_size) ^ 0xFFFFFFFF;
				//printf("CRC = %08X, %08X\n", crc, crc2);
				if (crc == crc2){
					switch_p |= 1;
					printf("index file already exists\n");
				}
			}
			CloseHandle(hFile);
		}
	}*/
	if ((switch_p & 1) == 0){	// CfbNXEt@CƂ
		print_progress_text(0, "Making index file");
		// peBEubN܂܂ȂJoEt@C
		//move_away_file(recovery_file);	// ̃t@Cǂ
		hFile = CreateFile(recovery_file, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile == INVALID_HANDLE_VALUE){
			if (GetLastError() == ERROR_PATH_NOT_FOUND){	// Path not found (3)
				make_dir(recovery_file);	// r̃tH_݂Ȃ̂Ȃ쐬
				hFile = CreateFile(recovery_file, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			}
			if (hFile == INVALID_HANDLE_VALUE){
				print_win32_err();
				printf_cp("cannot create file, %s\n", recovery_file);
				err = 1;
				goto error_end;
			}
		}
		if (!WriteFile(hFile, common_buf, common_size, &i, NULL)){
			print_win32_err();
			CloseHandle(hFile);
			err = 1;
			goto error_end;
		}
		if (!WriteFile(hFile, footer_buf, footer_size, &i, NULL)){
			print_win32_err();
			CloseHandle(hFile);
			err = 1;
			goto error_end;
		}
		CloseHandle(hFile);
		print_progress_done();
	}
	if (parity_num == 0)
		goto creation_end;	// peBEubNȂꍇ͈Cɕ֒

	// peBEubN̗̈mۂ
	p_blk = (parity_ctx_c *)malloc(sizeof(parity_ctx_c) * parity_num);
	if (p_blk == NULL){
		printf("malloc, %d\n", sizeof(parity_ctx_c) * parity_num);
		err = 1;
		goto error_end;
	}
	rcv_hFile = (HANDLE *)calloc(recovery_num, sizeof(HANDLE));
	if (rcv_hFile == NULL){
		printf("calloc, %d\n", sizeof(HANDLE) * recovery_num);
		err = 1;
		goto error_end;
	}

	// JoEt@C쐬ċʃpPbgRs[
	err = create_recovery_file(uni_buf, packet_limit, block_distri,
			packet_num, common_buf, common_size, footer_buf, footer_size, rcv_hFile, p_blk);
	if (err){
		delete_recovery_file(uni_buf, block_distri, switch_p & 1, rcv_hFile);
		goto error_end;
	}
	// Recovery Slice packet p̃pPbgEwb_[쐬Ă
	set_packet_header((unsigned char *)uni_buf, common_buf + 32, 4, block_size + 4);
	free(common_buf);
	common_buf = NULL;

	// \[XEubNԍƂɁAǂǂݍނ̂ݒ肷
	s_blk = (source_ctx_c *)malloc(sizeof(source_ctx_c) * source_num);
	if (s_blk == NULL){
		printf("malloc, %d\n", sizeof(source_ctx_c) * source_num);
		err = 1;
		goto error_end;
	}
	common_size = 0;
	for (i = 0; i < entity_num; i++){	// recovery set ̏ԂŃubN蓖Ă
		footer_size = (int)(files[i].size / (__int64)block_size);
		while (footer_size > 0){	// tTCỸubN
			s_blk[common_size].file = i;
			s_blk[common_size].size = block_size;
			common_size++;
			footer_size--;
		}
		footer_size = (int)(files[i].size % (__int64)block_size);
		if (footer_size > 0){	// [ȃubN
			s_blk[common_size].file = i;
			s_blk[common_size].size = footer_size;
			common_size++;
		}
	}

	// peBEubN쐬
	print_progress_text(0, "Creating recovery slice");
	err = rs_encode(ini_path, (unsigned char *)uni_buf, rcv_hFile, files, s_blk, p_blk);
	if (err){
		delete_recovery_file(uni_buf, block_distri, switch_p & 1, rcv_hFile);
		goto error_end;
	}

creation_end:
	// \[XEt@C𕪊
	if (split_size >= 4){
		if (err = split_files(files, &common_size, &footer_size)){
			delete_split_files(files, common_size, footer_size);
			goto error_end;
		}
	// \[XEt@C̏ɂɃJoER[hǉ
	} else if (split_size == 1){
		if (err = append_recovery_file(list_buf + files[0].name, rcv_hFile, switch_p & 1))
			goto error_end;
	}

	printf("\nCreated successfully\n");
error_end:
	if (common_buf)
		free(common_buf);
	if (s_blk)
		free(s_blk);
	if (p_blk)
		free(p_blk);
	if (rcv_hFile){
		for (i = 0; i < recovery_num; i++){
			if (rcv_hFile[i])
				CloseHandle(rcv_hFile[i]);
		}
		free(rcv_hFile);
	}
	if (files)
		free(files);
	return err;
}

// JoEt@C̍\Z
int par2_trial(
	wchar_t *uni_buf,	// ƗpA͂ꂽRgĂ
	int packet_limit,	// JoEt@C̃pPbgJԂ̐
	int block_distri,	// peBEubN̕z@
	int switch_p)		// CfbNXEt@CȂ, jR[h̃t@CL^
{
	int packet_num, common_size, footer_size;
	__int64 total_data_size;

	// \[XEt@C̏񂩂狤ʃpPbg̃TCYvZ
	common_size = measure_common_packet(&packet_num, (switch_p & 2) >> 1);
	if (common_size <= 2)
		return common_size;

	// pPbg̃TCYvZ
	footer_size = measure_footer_packet(uni_buf);

	// JoEt@C̃TCYvZ
	printf("\nPAR File count\t: %d\n", recovery_num + 1 - (switch_p & 1));
	printf("         Size  Packet  Slice :  Filename\n");
	fflush(stdout);
	total_data_size = total_file_size;
	measure_recovery_file(uni_buf, packet_limit, block_distri, packet_num, common_size, footer_size, switch_p & 1);
	printf("\nPAR File total size\t: %I64d\n\n", total_file_size);

	// vZ
	if ((source_num == 0) || (total_file_size == 0)){
		packet_num = 0;
		footer_size = 0;
		common_size = 0;
	} else {
		packet_num = (int)((1000 * total_data_size) / ((__int64)block_size * (__int64)source_num));
		footer_size = (int)((1000 * (__int64)block_size * (__int64)parity_num) / total_file_size);
		common_size = (int)((1000 * total_data_size * (__int64)parity_num) / (total_file_size * (__int64)source_num));
	}
	printf("File data in Blocks\t: %d.%d%%\n", packet_num / 10, packet_num % 10);
	printf("Blocks in PAR files\t: %d.%d%%\n", footer_size / 10, footer_size % 10);
	printf("Efficiency rate\t\t: %d.%d%%\n", common_size / 10, common_size % 10);

	printf("\nTrial end\n");
	return 0;
}

// \[XEt@C̔j⌇𒲂ׂ
int par2_verify(
	wchar_t *uni_buf,	// Ɨp
	int switch_v)		// x 0=ڍ׌, +1=ȈՌ, +2=ǉ
{
	char ascii_buf[MAX_LEN * 3];
	unsigned char set_id[16], *work_buf = NULL;
	int err = 0, i, j, need_repair, parity_now, recovery_lost;
	file_ctx_r *files = NULL;
	source_ctx_r *s_blk = NULL;
	parity_ctx_r *p_blk = NULL;

	init_crc_table();	// CRC vZp̃e[u쐬

	// JoEt@C
	if (search_recovery_files(switch_v) != 0){
		err = 1;
		goto error_end;
	}

	// Main packet T (pPbgETCY SEARCH_SIZE * 2 ܂)
	work_buf = (unsigned char *)malloc(SEARCH_SIZE * 3);
	if (work_buf == NULL){
		printf("malloc, %d\n", SEARCH_SIZE * 3);
		err = 1;
		goto error_end;
	}
	if (err = search_main_packet(work_buf, set_id, switch_v)){
		printf("valid file is not found\n");
		goto error_end;
	}

	// \[XEt@C̏
	files = (file_ctx_r *)malloc(sizeof(file_ctx_r) * file_num);
	if (files == NULL){
		printf("malloc, %d\n", sizeof(file_ctx_r) * file_num);
		err = 1;
		goto error_end;
	}
	// Main packet  File ID ǂݎ
	for (i = 0; i < file_num; i++){
		memcpy(files[i].id, work_buf + (16 * i), 16);
		files[i].name = -1;
	}
	onepass_window_gen(block_size);	// ubNPʂł炵Č邽߂ CRC e[u

	i = check_ini_file(set_id);	// 邩ǂ
	if (i != 0){	// ς݂ȂL^ǂݍ
		if (read_ini_file(uni_buf, files))
			i = 0;	// L^ǂݍ߂Ȃ
	}
	if (i == 0){	// 
		// t@C̃pPbgT
		if (err = search_file_packet(ascii_buf, work_buf, uni_buf, set_id, switch_v | 32, files))
			goto error_end;
		write_ini_file(files);	// t@CL^Ă
	}
	if (err = set_file_data(ascii_buf, files))	// \[XEt@CmFďWv
		goto error_end;

	// \[XEubN̏
	s_blk = (source_ctx_r *)malloc(sizeof(source_ctx_r) * source_num);
	if (s_blk == NULL){
		printf("malloc, %d\n", sizeof(source_ctx_r) * source_num);
		err = 1;
		goto error_end;
	}
	for (i = 0; i < entity_num; i++){
		// t@CƂɃ\[XEubN̏ݒ肷
		j = files[i].b_off;	// ̃t@C̃ubN̊Jnԍ
		parity_now = (int)(files[i].size / (__int64)block_size);
		while (parity_now > 0){	// tTCỸubN
			s_blk[j].file = i;
			s_blk[j].size = block_size;
			s_blk[j].exist = 0;
			j++;
			parity_now--;
		}
		parity_now = (int)(files[i].size % (__int64)block_size);
		if (parity_now > 0){	// [ȃubN
			s_blk[j].file = i;
			s_blk[j].size = parity_now;
			s_blk[j].exist = 0;
			j++;
		}
	}
	if (parity_num > 0){
		p_blk = (parity_ctx_r *)malloc(sizeof(parity_ctx_r) * parity_num);
		if (p_blk == NULL){
			printf("malloc, %d\n", sizeof(parity_ctx_r) * parity_num);
			err = 1;
			goto error_end;
		}
		for (i = 0; i < parity_num; i++)
			p_blk[i].exist = 0;
	}

	// Cp̃pPbgT
	recovery_lost = search_recovery_packet(ascii_buf, work_buf, uni_buf, set_id, NULL, files, s_blk, p_blk);
	if (recovery_lost < 0){
		err = -recovery_lost;
		goto error_end;
	}
	free(work_buf);
	work_buf = NULL;
	// `FbNTĂ邩m߂
	for (i = 0; i < entity_num; i++){
		if (files[i].state & 0x80){
			//printf_cp("missing checksum, %s\n", list_buf + files[i].name);
			break;
		}
	}
	if (i == entity_num){
		write_ini_checksum(files, s_blk);	// `FbNTL^Ă
	} else {
		if (read_ini_checksum(files, s_blk)){	// `FbNTL^ĂȂǂݍ
			update_ini_checksum(files, s_blk);	// ݂`FbNTǂݏ
			printf("\nInput File Slice Checksum packet is missing\n");
		}
	}

	parity_now = first_num;	// p\ȃpeBEubN̐
	j = 0;
	for (i = 0; i < parity_num; i++){
		if (p_blk[i].exist != 0)
			j = i + 1;	// płől
	}
	if ((j > 0) && (j < parity_num)){	// ubNȂȂ
		// g܂łɏk
		parity_ctx_r *tmp_p_blk;
		tmp_p_blk = (parity_ctx_r *)realloc(p_blk, sizeof(parity_ctx_r) * j);
		if (tmp_p_blk != NULL)
			p_blk = tmp_p_blk;
		parity_num = j;	// {̃peBEubNƂĈ
	}
	if (parity_now == 0){	// peB
		parity_num = 0;
		free(p_blk);
		p_blk = NULL;
	}
	printf("\nRecovery Slice count\t: %d\n", parity_num);
	printf("Recovery Slice found\t: %d\n", parity_now);

	// \[XEt@CSǂ𒲂ׂ
	// t@C̏Ԃ SAAǉAj(SȃubN̐) 4
	if (err = check_file_complete(ascii_buf, uni_buf, files, s_blk))
		goto error_end;

	// \[XEt@CsSȂʖEړt@CT
	if (err = search_misnamed_file(ascii_buf, uni_buf, files, s_blk))
		goto error_end;

	// jEEގ̃t@CgXCXT
	if (err = search_file_slice(ascii_buf, uni_buf, switch_v, files, s_blk))
		goto error_end;

	// I烁[
	free(recv_buf);
	recv_buf = NULL;
	if (list2_buf){
		free(list2_buf);
		list2_buf = NULL;
	}

	// \[XEubNrāAp\ȃubN𑝂₷
	if ((first_num < source_num) &&
			(((switch_v & 1) == 0) ||	// ȈՌȊOȂ痘p\ȃubN𑝂₷
				(block_size <= 4))){	// 4oCgȉȂSċtZł
		search_calculable_slice(files, s_blk);
	}

	// ʂWv
	err = result_file_state(ascii_buf, &need_repair, parity_now, recovery_lost, files, s_blk);

error_end:
	close_ini_file();
	if (recv_buf)
		free(recv_buf);
	if (s_blk)
		free(s_blk);
	if (p_blk)
		free(p_blk);
	if (files)
		free(files);
	return err;
}

// \[XEt@C̔j⌇C
int par2_repair(
	wchar_t *uni_buf,	// Ɨp
	int switch_v)		// x 0=ڍ׌, +1=ȈՌ, +2=ǉ
{
	char ascii_buf[MAX_LEN * 3];
	unsigned char set_id[16], *work_buf = NULL;
	int err = 0, i, j, need_repair, recovery_lost;
	int parity_now, lost_num, block_count;
	HANDLE *rcv_hFile = NULL;
	file_ctx_r *files = NULL;
	source_ctx_r *s_blk = NULL;
	parity_ctx_r *p_blk = NULL;

	switch_v |= 16;		// ɕۑ
	init_crc_table();	// CRC vZp̃e[u쐬

	// JoEt@C
	if (search_recovery_files(switch_v) != 0){
		err = 1;
		goto error_end;
	}

	// Main packet T (pPbgETCY SEARCH_SIZE * 2 ܂)
	work_buf = (unsigned char *)malloc(SEARCH_SIZE * 3);
	if (work_buf == NULL){
		printf("malloc, %d\n", SEARCH_SIZE * 3);
		err = 1;
		goto error_end;
	}
	if (err = search_main_packet(work_buf, set_id, switch_v)){
		printf("valid file is not found\n");
		goto error_end;
	}

	// \[XEt@C̏
	files = (file_ctx_r *)malloc(sizeof(file_ctx_r) * file_num);
	if (files == NULL){
		printf("malloc, %d\n", sizeof(file_ctx_r) * file_num);
		err = 1;
		goto error_end;
	}
	// Main packet  File ID ǂݎ
	for (i = 0; i < file_num; i++){
		memcpy(files[i].id, work_buf + (16 * i), 16);
		files[i].name = -1;
	}
	onepass_window_gen(block_size);	// ubNPʂł炵Č邽߂ CRC e[u

	i = check_ini_file(set_id);	// 邩ǂ
	if (i != 0){	// ς݂ȂL^ǂݍ
		if (read_ini_file(uni_buf, files))
			i = 0;	// L^ǂݍ߂Ȃ
	}
	if (i == 0){	// 
		// t@C̃pPbgT
		if (err = search_file_packet(ascii_buf, work_buf, uni_buf, set_id, switch_v | 32, files))
			goto error_end;
		write_ini_file(files);	// t@CL^Ă
	}
	if (err = set_file_data(ascii_buf, files))	// \[XEt@CmFďWv
		goto error_end;

	// JoEt@C̃nh
	rcv_hFile = (HANDLE *)calloc(recovery_num, sizeof(HANDLE));
	if (rcv_hFile == NULL){
		printf("calloc, %d\n", sizeof(HANDLE) * recovery_num);
		err = 1;
		goto error_end;
	}
	// \[XEubN̏
	s_blk = (source_ctx_r *)malloc(sizeof(source_ctx_r) * source_num);
	if (s_blk == NULL){
		printf("malloc, %d\n", sizeof(source_ctx_r) * source_num);
		err = 1;
		goto error_end;
	}
	for (i = 0; i < entity_num; i++){
		// t@CƂɃ\[XEubN̏ݒ肷
		j = files[i].b_off;	// ̃t@C̃ubN̊Jnԍ
		parity_now = (int)(files[i].size / (__int64)block_size);
		while (parity_now > 0){	// tTCỸubN
			s_blk[j].file = i;
			s_blk[j].size = block_size;
			s_blk[j].exist = 0;
			j++;
			parity_now--;
		}
		parity_now = (int)(files[i].size % (__int64)block_size);
		if (parity_now > 0){	// [ȃubN
			s_blk[j].file = i;
			s_blk[j].size = parity_now;
			s_blk[j].exist = 0;
			j++;
		}
	}
	if (parity_num > 0){
		p_blk = (parity_ctx_r *)malloc(sizeof(parity_ctx_r) * parity_num);
		if (p_blk == NULL){
			printf("malloc, %d\n", sizeof(parity_ctx_r) * parity_num);
			err = 1;
			goto error_end;
		}
		for (i = 0; i < parity_num; i++)
			p_blk[i].exist = 0;
	}

	// Cp̃pPbgT
	recovery_lost = search_recovery_packet(ascii_buf, work_buf, uni_buf, set_id, rcv_hFile, files, s_blk, p_blk);
	if (recovery_lost < 0){
		err = -recovery_lost;
		goto error_end;
	}
	free(work_buf);
	work_buf = NULL;
	// `FbNTĂ邩m߂
	for (i = 0; i < entity_num; i++){
		if (files[i].state & 0x80)
			break;
	}
	if (i == entity_num){
		write_ini_checksum(files, s_blk);	// `FbNTL^Ă
	} else {
		if (read_ini_checksum(files, s_blk)){	// `FbNTL^ĂȂǂݍ
			update_ini_checksum(files, s_blk);	// ݂`FbNTǂݏ
			printf("\nInput File Slice Checksum packet is missing\n");
		}
	}

	parity_now = first_num;	// p\ȃpeBEubN̐
	j = 0;
	for (i = 0; i < parity_num; i++){
		if (p_blk[i].exist != 0)
			j = i + 1;	// płől
	}
	if ((j > 0) && (j < parity_num)){	// ubNȂȂ
		// g܂łɏk
		parity_ctx_r *tmp_p_blk;
		tmp_p_blk = (parity_ctx_r *)realloc(p_blk, sizeof(parity_ctx_r) * j);
		if (tmp_p_blk != NULL)
			p_blk = tmp_p_blk;
		parity_num = j;	// {̃peBEubNƂĈ
	}
	if (parity_now == 0){	// peB
		parity_num = 0;
		free(p_blk);
		p_blk = NULL;
	}
	printf("\nRecovery Slice count\t: %d\n", parity_num);
	printf("Recovery Slice found\t: %d\n", parity_now);

	// \[XEt@CSǂꗗ\
	// t@C̏Ԃ SAAǉAj(SȃubN̐) 4
	if (err = check_file_complete(ascii_buf, uni_buf, files, s_blk))
		goto error_end;

	// \[XEt@CsSȂʖEړt@CT
	if (err = search_misnamed_file(ascii_buf, uni_buf, files, s_blk))
		goto error_end;

	// Ejt@CȂA̍ƃt@C쐬
	wcscpy(uni_buf, base_dir);
	for (i = 0; i < entity_num; i++){
		if (files[i].state & 0x03){	//  0x01  j 0x02 Ȃ
			// Ɨp̃\[XEt@C
			get_temp_name(list_buf + files[i].name, uni_buf + base_len);
			if (create_temp_file(uni_buf, files[i].size)){
				printf_cp("cannot create file, %s\n", uni_buf);
				err = 1;
				goto error_end;
			}
		}
	}

	// jEEގ̃t@CgXCXT
	if (err = search_file_slice(ascii_buf, uni_buf, switch_v, files, s_blk))
		goto error_end;

	// I烁[
	free(recv_buf);
	recv_buf = NULL;
	if (list2_buf){
		free(list2_buf);
		list2_buf = NULL;
	}

	// \[XEubNrāAp\ȃubN𑝂₷
	block_count = 0;	// tZ\ȃubN
	if ((first_num < source_num) &&
			(((switch_v & 1) == 0) ||	// ȈՌȊOȂ痘p\ȃubN𑝂₷
				(block_size <= 4))){	// 4oCgȉȂSċtZł
		block_count = search_calculable_slice(files, s_blk);
	}

	// ʂWv
	err = result_file_state(ascii_buf, &need_repair, parity_now, recovery_lost, files, s_blk);
	lost_num = source_num - first_num;
	if (need_repair == 0){
		goto error_end;	// SĊSȂ̂ŏCKvȂ
	} else if ((lost_num > parity_now) && ((need_repair & 0x2FFFFFFF) == 0)){
		if (switch_b & 4)
			replace_incomplete(uni_buf, ascii_buf, files, s_blk);	// č\zt@CŒu
		goto error_end;	// ubNsŁAȈՏCč\złt@C
	} else if (need_repair == 0x40000000){
		goto error_end;	// non-recovery set ̃t@CEjĂ
	}
	if (need_repair & 0x20000000)	// Ejt@C̃XCXSėp\ȏꍇ
		block_count |= 0x20000000;	// C̊mFKvȈ

/*
	// C邩ǂ͂Ă炤
	printf(" continue ? [Yes/No] : ");
	i = _getche();
	printf("\n");
	if ((i != 'y') && (i != 'Y'))
		goto error_end;
*/

	// peBEubN̐CɕKvȗʂȂől𒲐߂
	// tšvZɎsɕʂ̃peBEubNg悤 +3͎cĂ
	if ((lost_num > 0) && (parity_now > lost_num + 3)){
		parity_ctx_r *tmp_p_blk;
		int max_num = 0;
		j = parity_num;
		for (i = 0; i < j; i++){
			if (p_blk[i].exist != 0){
				max_num++;
				if (max_num > lost_num + 3){
					max_num--;
					p_blk[i].exist = 0;
				} else {
					parity_num = i + 1;
				}
			}
		}
		tmp_p_blk = (parity_ctx_r *)realloc(p_blk, sizeof(parity_ctx_r) * parity_num);
		if (tmp_p_blk != NULL)
			p_blk = tmp_p_blk;
	}

	// ubN𕜌Ȃ̂ȂAɃJoEt@C
	if (lost_num == 0){
		for (i = 0; i < recovery_num; i++){
			if (rcv_hFile[i]){
				CloseHandle(rcv_hFile[i]);
				rcv_hFile[i] = NULL;
			}
		}
		free(rcv_hFile);
		rcv_hFile = NULL;
	}

	// ȒPȏCɍsA܂C̕Kvȃt@C̐߂
	need_repair = simple_repair(ascii_buf, need_repair & 0x0FFFFFFF, files);

	// ubNPʂŕ邱ƂłȂA܂͕KvȂ炱ŏI
	if ((((block_count & 0x20000000) == 0) && (lost_num > parity_now))
			|| ((lost_num == 0) && (need_repair == 0))){
		if (switch_b & 4)
			replace_incomplete(uni_buf, ascii_buf, files, s_blk);	// č\zt@CŒu
		goto repair_end;
	}
	block_count &= 0x0FFFFFFF;

	if ((lost_num > 0) || (block_count > 0))
		printf("\nRepairing file  :\n");
	if (block_size == 4){	// j\[XEt@C蒼
		if (err = restore_block4(uni_buf, files, s_blk))
			goto error_end;
	} else if (block_count > 0){	// ubN𗬗pA܂͋tZ
		if (err = restore_block(uni_buf, block_count, files, s_blk))
			goto error_end;
	}

	if ((lost_num > 0) && (lost_num <= parity_now)){	// ꂽubN𕜌
		err = rs_decode(uni_buf, lost_num, rcv_hFile, files, s_blk, p_blk);
		if (err)
			goto error_end;
	}

	if (rcv_hFile){	// OɃJoEt@C
		for (i = 0; i < recovery_num; i++){
			if (rcv_hFile[i])
				CloseHandle(rcv_hFile[i]);
		}
		free(rcv_hFile);
		rcv_hFile = NULL;
	}

	// CłׂČʕ\
	printf("\nVerifying repair: %d\n", need_repair);
	printf(" Status   :  Filename\n");
	fflush(stdout);
	if (err = verify_repair(uni_buf, ascii_buf, files, s_blk))
		goto error_end;

repair_end:
	err = 16;
	lost_num = 0;
	for (i = 0; i < file_num; i++){
		if (files[i].state & 0x3F)
			lost_num++;
	}
	if (lost_num == 0){	// SďCłȂ
		printf("\nRepaired successfully\n");
	} else {
		printf("\nFailed to repair %d file(s)\n", lost_num);
		err |= 4;
	}
	if (recovery_lost > 0)
		err |= 256;

error_end:
	close_ini_file();
	if (recv_buf)
		free(recv_buf);
	if (s_blk)
		free(s_blk);
	if (p_blk)
		free(p_blk);
	if (rcv_hFile){
		for (i = 0; i < recovery_num; i++){
			if (rcv_hFile[i])
				CloseHandle(rcv_hFile[i]);
		}
		free(rcv_hFile);
	}
	if (files){
		if (need_repair)
			delete_work_file(uni_buf, files);
		free(files);
	}
	return err;
}

// \[XEt@C̈ꗗ\
int par2_list(
	wchar_t *uni_buf,	// Ɨp
	int switch_h)		// nbVl\
{
	char ascii_buf[MAX_LEN * 3];
	unsigned char set_id[16], *work_buf = NULL;
	int err = 0, i, file_block;
	file_ctx_r *files = NULL;

	// Main packet T (Ή Main packet ̃TCY SEARCH_SIZE * 2 ܂)
	work_buf = (unsigned char *)malloc(SEARCH_SIZE * 3);
	if (work_buf == NULL){
		printf("malloc, %d\n", SEARCH_SIZE * 3);
		err = 1;
		goto error_end;
	}
	recv_buf = recovery_file;	// w肳ꂽJoEt@Cׂ
	recv_len = (int)wcslen(recovery_file);
	recovery_num = 1;
	if (err = search_main_packet(work_buf, set_id, 0)){
		printf("valid file is not found\n");
		goto error_end;
	}

	// \[XEt@C̏
	files = (file_ctx_r *)malloc(sizeof(file_ctx_r) * file_num);
	if (files == NULL){
		printf("malloc, %d\n", sizeof(file_ctx_r) * file_num);
		err = 1;
		goto error_end;
	}
	// Main packet  File ID ǂݎ
	for (i = 0; i < file_num; i++){
		memcpy(files[i].id, work_buf + (16 * i), 16);
		files[i].name = -2;
	}

	// t@C̃pPbgT
	if (err = search_file_packet(ascii_buf, work_buf, uni_buf, set_id, 0, files))
		goto error_end;
	free(work_buf);
	work_buf = NULL;

	// \[XEt@C̈ꗗ\
	printf("\nInput File list\t:\n");
	if (switch_h){
		printf("         Size  Slice             MD5 Hash             :  Filename\n");
	} else {
		printf("         Size  Slice :  Filename\n");
	}
	for (i = 0; i < file_num; i++){
		if (files[i].name < 0){	// t@C񂪖Ăp
			if (switch_h){
				printf("            ?      ?                 ?                : Unknown\n");
			} else {
				printf("            ?      ? : Unknown\n");
			}
			err |= 4;
			continue;
		}
		utf16_to_cp(list_buf + files[i].name, ascii_buf, cp_output);
		if (files[i].size > 0){
			total_file_size += files[i].size;
			if (i < entity_num){
				file_block = (int)((files[i].size + (__int64)block_size - 1) / (__int64)block_size);	// \[XEubN̐
				source_num += file_block;
			} else {
				file_block = 0;
			}
			if (switch_h){
				printf("%13I64d %6d ", files[i].size, file_block);
				print_hash(files[i].hash);
				printf(" : \"%s\"\n", ascii_buf);
			} else {
				printf("%13I64d %6d : \"%s\"\n", files[i].size, file_block, ascii_buf);
			}
		} else {	// ̃t@CtH_
			if (switch_h){
				printf("            0      0                                  : \"%s\"\n", ascii_buf);
			} else {
				printf("            0      0 : \"%s\"\n", ascii_buf);
			}
		}
	}

	printf("\nInput File total size\t: %I64d\n", total_file_size);
	printf("Input File Slice count\t: %d\n", source_num);
	if (err == 0){
		printf("\nListed successfully\n");
	} else {
		printf("\nFile Description packet is missing\n");
	}

error_end:
	if (work_buf)
		free(work_buf);
	if (files)
		free(files);
	return err;
}

// CRC-32 `FbNTgĎg̔jo
int par2_checksum(wchar_t *uni_buf)	// Ɨp
{
	unsigned char buf[4096];
	unsigned int rv, crc, chk;
	HANDLE hFile;

	init_crc_table();	// CRC vZp̃e[u쐬

	// st@C̃pX擾
	rv = GetModuleFileName(NULL, uni_buf, MAX_LEN);
	if ((rv == 0) || (rv >= MAX_LEN))
		return 1;
	//printf("%S\n", uni_buf);

	// PE checksum ؂
	rv = MapFileAndCheckSum(uni_buf, &crc, &chk);
	if ((rv != 0) || (crc != chk))
		return 1;

	// t@C CRC-32 vZ
	hFile = CreateFile(uni_buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE){
		print_win32_err();
		return 1;
	}
	crc = 0xFFFFFFFF;
	do {
		if (!ReadFile(hFile, buf, 4096, &rv, NULL) || (rv == 0))
			break;
		// CRC32 vZ
		crc = crc_update_std(crc, buf, rv);
	} while (rv > 0);
	CloseHandle(hFile);
	crc ^= 0xFFFFFFFF;

#ifndef _WIN64
	if (crc != 0x22222222)
#else
	if (crc != 0x22222A64)
#endif
		return 1;
	return 0;
}

