// reedsolomon.c
// Copyright : 2018-12-29 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <malloc.h>
#include <process.h>
#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "crc.h"
#include "gf16.h"
#include "phmd5.h"
#include "lib_opencl.h"
#include "rs_encode.h"
#include "rs_decode.h"
#include "reedsolomon.h"


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// chunk LbVɎ܂悤ɂΑȂI (Cache Blocking ƂœK@)
int try_cache_blocking(int unit_size)
{
	int limit_size, chunk_count, chunk_size;

	// CPULbVǂ̂炢܂Ŏg
	limit_size = cpu_flag & 0x7FFF8000;	// Œł 32KB ɂȂ
	if (limit_size == 0)	// LbVETCY擾łȂꍇ͍œKȂ
		limit_size = unit_size;

	// LbVɂ܂܂悤 chunk ̃TCY߂
	chunk_count = 1;
	chunk_size = unit_size;
	while (chunk_size - sse_unit > limit_size){	// TCY傫Ȃ
		// 𑝂₵ chunk ̃TCYZĂ݂
		chunk_count++;
		chunk_size = (unit_size + chunk_count - 1) / chunk_count;
	}
	chunk_size = (chunk_size + (sse_unit - 1)) & ~(sse_unit - 1);	// sse_unit ̔{ɂ

	return chunk_size;
}

// 󂫃[ʂt@CEANZX̃obt@[ETCYvZ
// io_size = unit_size - HASH_SIZE ɂȂ邱Ƃɒ (alloc_unit >= HASH_SIZE)
unsigned int get_io_size(
	unsigned int buf_num,	// ubN̗̈mۂ̂
	unsigned int *part_num,	// IȃGR[hp̍Ɨ̈
	size_t trial_alloc,		// mۂł邩mF̂
	int alloc_unit)			// [Pʂ̋E (sse_unit  MEM_UNIT)
{
	unsigned int unit_size, io_size, part_max, part_min;
	size_t mem_size, io_size64;

	if (part_num == NULL){	// w肪Β߂Ȃ
		part_max = 0;
		part_min = 0;
	} else {
		part_max = *part_num;	// lɂ͍őlZbg
		part_min = source_num >> PART_MIN_RATE;
		if (part_min < PART_MIN_NUM)
			part_min = PART_MIN_NUM;
		if (part_min > part_max)
			part_min = part_max;
	}
	// alloc_unit ̔{ɂ
	unit_size = (block_size + HASH_SIZE + (alloc_unit - 1)) & ~(alloc_unit - 1);

	if (trial_alloc){
		__int64 possible_size;
		possible_size = (__int64)unit_size * (buf_num + part_max);
#ifndef _WIN64	// 32-bit łȂ
		if (possible_size > MAX_MEM_SIZE)	// mۂőTCY 2GB ܂łɂ
			possible_size = MAX_MEM_SIZE;
		if (check_OS64() == 0){	// 32-bit OS ȂXɐ
			if (possible_size > MAX_MEM_SIZE32)
				possible_size = MAX_MEM_SIZE32;
		}
#endif
		trial_alloc = (size_t)possible_size;
		trial_alloc = (trial_alloc + 0xFFFF) & ~0xFFFF;	// 64KB ̔{ɂĂ
	}
	mem_size = get_mem_size(trial_alloc);
	io_size64 = mem_size / (buf_num + part_max) - HASH_SIZE;	// Kv

	// ubNETCY傫A܂̓ubNETCŶꍇ
	if ((io_size64 >= (size_t)block_size) || (block_size <= 1024)){
		io_size = unit_size - HASH_SIZE;	// ubNETCY - HASH_SIZE

	} else {	// ubNETCY𓙕
		unsigned int num, num2;
		io_size = (unsigned int)io_size64;
		num = (block_size + io_size - 1) / io_size;	// ubN邩
		if (part_min < part_max){	// ێʂɕȂ
			io_size64 = mem_size / (buf_num + part_min) - HASH_SIZE;	// mۂTCYŒɂꍇ
			io_size = (unsigned int)io_size64;
			num2 = (block_size + io_size - 1) / io_size;
		} else {
			num2 = num;
		}
		if (num > num2){	// mۗʂ炵قubN̕Ȃ
			io_size = (block_size + num2 - 1) / num2;
			if (io_size < 1024)
				io_size = 1024;
			num = (unsigned int)(mem_size / (io_size + HASH_SIZE)) - buf_num;
			if (num > part_max)
				num = part_max;
			if (num < part_min)
				num = part_min;
			*part_num = num;
		} else {
			io_size = (block_size + num - 1) / num;
			if (io_size < 1024)
				io_size = 1024;	// fЉꍇłubN 32768 KB ͎g
		}
		io_size = ((io_size + HASH_SIZE + (alloc_unit - 1)) & ~(alloc_unit - 1)) - HASH_SIZE;	// alloc_unit ̔{ - HASH_SIZE
	}

	return io_size;
}

// ubN܂Ƃ߂ăt@Cǂݍނ󂫃[ʂvZ
int read_block_num(
	int keep_num,			// ێpeBEubN
	int add_num,			// ]TubN
	size_t trial_alloc,		// mۂł邩mF̂
	int alloc_unit)			// [Pʂ̋E (sse_unit  MEM_UNIT)
{
	int buf_num, read_min;
	unsigned int unit_size;
	size_t mem_size;

	read_min = keep_num >> READ_MIN_RATE;
	if (read_min < READ_MIN_NUM)
		read_min = READ_MIN_NUM;
	if (read_min > source_num)
		read_min = source_num;
	unit_size = (block_size + HASH_SIZE + (alloc_unit - 1)) & ~(alloc_unit - 1);

	if (trial_alloc){
		__int64 possible_size;
		possible_size = (__int64)unit_size * (source_num + keep_num + add_num);
#ifndef _WIN64	// 32-bit łȂ
		if (possible_size > MAX_MEM_SIZE)	// mۂőTCY 2GB ܂łɂ
			possible_size = MAX_MEM_SIZE;
		if (check_OS64() == 0){	// 32-bit OS ȂXɐ
			if (possible_size > MAX_MEM_SIZE32)
				possible_size = MAX_MEM_SIZE32;
		}
#endif
		trial_alloc = (size_t)possible_size;
		trial_alloc = (trial_alloc + 0xFFFF) & ~0xFFFF;	// 64KB ̔{ɂĂ
	}
	mem_size = get_mem_size(trial_alloc) / unit_size;	// mۂł邩

	if (mem_size >= (size_t)(source_num + keep_num + add_num)){	// ő葽
		buf_num = source_num;
	} else if ((int)mem_size < read_min + keep_num + add_num){	// Ȃ
		buf_num = 0;	// [s̈
	} else {	// \[XEubN𓙕
		int split_num;
		buf_num = (int)mem_size - (keep_num + add_num);
		split_num = (source_num + buf_num - 1) / buf_num;	// ɕʂēǂݍނ
		buf_num = (source_num + split_num - 1) / split_num;
	}

	return buf_num;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// ː l ́uKƉpFORTRAN77v̋tšvZ@Qlɂ
// Gaussian Elimination Cčs̐ɂĂ݂

// ̃[ŋtsvZ (ppeBEubN̏)
static int invert_matrix_st(unsigned short *mat,
	int rows,				// s̐As̏cTCYAꂽ\[XEubN̐ = ppeBEubN
	int cols,				// c̐As̉TCYA{̃\[XEubN
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int i, j, row_start, row_start2, pivot, factor;
	unsigned int time_last = GetTickCount();

	// Gaussian Elimination with 1 matrix
	pivot = 0;
	row_start = 0;	// ̍s̊Jnʒu
	for (i = 0; i < rows; i++){
		// oߕ\
		if (GetTickCount() - time_last >= UPDATE_TIME){
			if (print_progress((i * 1000) / rows))
				return 2;
			time_last = GetTickCount();
		}

		// ̍s (peBEubN) ǂ̃\[XEubN̑p
		while ((pivot < cols) && (s_blk[pivot].exist != 0))
			pivot++;

		// Divide the row by element i,pivot
		factor = mat[row_start + pivot];	// mat(j, pivot)  0ȊÔ͂
		//printf("\nparity[ %u ] -> source[ %u ], factor = %u\n", id[col_find], col_find, factor);
		if (factor > 1){	// factor  1傫ȂA1ɂׂ factor Ŋ
			mat[row_start + pivot] = 1;	// ꂪsōς܂
			galois_region_divide(mat + row_start, cols, factor);
		} else if (factor == 0){	// factor = 0 ƁA̍s̋tsvZłȂ
			return (0x00010000 | pivot);	// ǂ̃\[XEubNŖ肪̂Ԃ
		}

		// ʂ̍s̓ pivot  0ȊOȂA̒l 0ɂ邽߂ɁA
		// i s{̂ XOR 
		for (j = rows - 1; j >= 0; j--){
			if (j == i)
				continue;	// s͂Ƃ΂
			row_start2 = cols * j;	// ̍s̊Jnʒu
			factor = mat[row_start2 + pivot];	// j s pivot ̒l
			mat[row_start2 + pivot] = 0;	// ꂪsōς܂
			// ̌vZɂAi s pivot ̒l͕K 1Ȃ̂ŁA factor {ɂȂ
			galois_region_multiply(mat + row_start, mat + row_start2, cols, factor);
		}
		row_start += cols;	// ̍sɂ炷
		pivot++;
	}

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// }`EvZbT[Ή

typedef struct {	// RS threading control struct
	unsigned short *mat;	// s
	int cols;	// s̒
	volatile int start;	// |s̐擪ʒu
	volatile int pivot;	// {ƂȂl̈ʒu
	volatile int skip;	// Ƃ΂s
	volatile int now;	// s
	HANDLE h;
	HANDLE run;
	HANDLE end;
} INV_TH;

// TuEXbh
static DWORD WINAPI thread_func(LPVOID lpParameter)
{
	unsigned short *mat;
	int j, cols, row_start2, factor;
	INV_TH *th;

	th = (INV_TH *)lpParameter;
	mat = th->mat;
	cols = th->cols;

	WaitForSingleObject(th->run, INFINITE);	// vZJn̍}҂
	while (th->skip >= 0){
		while ((j = InterlockedDecrement(&(th->now))) >= 0){	// j = --th_now
			if (j == th->skip)
				continue;
			row_start2 = cols * j;	// ̍s̊Jnʒu
			factor = mat[row_start2 + th->pivot];	// j s pivot ̒l
			mat[row_start2 + th->pivot] = 0;	// ꂪsōς܂
			// ̌vZɂAi s pivot ̒l͕K 1Ȃ̂ŁA factor {ɂȂ
			galois_region_multiply(mat + th->start, mat + row_start2, cols, factor);
		}
		_mm_sfence();	// [ւ݂̏
		SetEvent(th->end);	// vZIʒm
		WaitForSingleObject(th->run, INFINITE);	// vZJn̍}҂
	}

	// I
	CloseHandle(th->run);
	CloseHandle(th->end);
	return 0;
}

// }`EXbhŋtsvZ (ppeBEubN̏)
static int invert_matrix_mt(unsigned short *mat,
	int rows,				// s̐As̏cTCYAꂽ\[XEubN̐ = ppeBEubN
	int cols,				// c̐As̉TCYA{̃\[XEubN
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int j, row_start2, factor;
	unsigned int time_last = GetTickCount();
	INV_TH th[1];

	memset(th, 0, sizeof(INV_TH));

	// Cxg쐬
	th->run = CreateEvent(NULL, FALSE, FALSE, NULL);	// Ƃ Auto Reset ɂ
	if (th->run == NULL){
		print_win32_err();
		printf("error, inv-thread\n");
		return 1;
	}
	th->end = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (th->end == NULL){
		print_win32_err();
		CloseHandle(th->run);
		printf("error, inv-thread\n");
		return 1;
	}
	// TuEXbhN
	th->mat = mat;
	th->cols = cols;
	_mm_sfence();	// [ւ݂̏ĂXbhN
	th->h = (HANDLE)_beginthreadex(NULL, 65536, thread_func, (LPVOID)th, 0, NULL);
	if (th->h == NULL){
		print_win32_err();
		CloseHandle(th->run);
		CloseHandle(th->end);
		printf("error, inv-thread\n");
		return 1;
	}

	// Gaussian Elimination with 1 matrix
	th->pivot = 0;
	th->start = 0;	// ̍s̊Jnʒu
	for (th->skip = 0; th->skip < rows; th->skip++){
		// oߕ\
		if (GetTickCount() - time_last >= UPDATE_TIME){
			if (print_progress((th->skip * 1000) / rows)){
				th->skip = -1;	// Iw
				_mm_sfence();
				SetEvent(th->run);
				WaitForSingleObject(th->h, INFINITE);
				CloseHandle(th->h);
				return 2;
			}
			time_last = GetTickCount();
		}

		// ̍s (peBEubN) ǂ̃\[XEubN̑p
		while ((th->pivot < cols) && (s_blk[th->pivot].exist != 0))
			th->pivot++;

		// Divide the row by element i,pivot
		factor = mat[th->start + th->pivot];
		if (factor > 1){
			mat[th->start + th->pivot] = 1;	// ꂪsōς܂
			galois_region_divide(mat + th->start, cols, factor);
		} else if (factor == 0){	// factor = 0 ƁA̍s̋tsvZłȂ
			th->skip = -1;	// Iw
			_mm_sfence();
			SetEvent(th->run);
			WaitForSingleObject(th->h, INFINITE);
			CloseHandle(th->h);
			return (0x00010000 | th->pivot);	// ǂ̃\[XEubNŖ肪̂Ԃ
		}

		// ʂ̍s̓ pivot  0ȊOȂA̒l 0ɂ邽߂ɁA
		// i s{̂ XOR 
		th->now = rows;	// l + 1
		_mm_sfence();	// [ւ݂̏ĂXbhĊJ
		SetEvent(th->run);	// TuEXbhɌvZJn
		while ((j = InterlockedDecrement(&(th->now))) >= 0){	// j = --th_now
			if (j == th->skip)	// s͂Ƃ΂
				continue;
			row_start2 = cols * j;	// ̍s̊Jnʒu
			factor = mat[row_start2 + th->pivot];	// j s pivot ̒l
			mat[row_start2 + th->pivot] = 0;	// ꂪsōς܂
			// ̌vZɂAi s pivot ̒l͕K 1Ȃ̂ŁA factor {ɂȂ
			galois_region_multiply(mat + th->start, mat + row_start2, cols, factor);
		}

		WaitForSingleObject(th->end, INFINITE);	// TuEXbȟvZI̍}҂
		th->start += cols;
		th->pivot++;
	}

	// TuEXbhI
	th->skip = -1;	// Iw
	_mm_sfence();
	SetEvent(th->run);
	WaitForSingleObject(th->h, INFINITE);
	CloseHandle(th->h);
	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*
gflib ̍s쐬p֐s̋tϊp̊֐ɂāA
vẐ PAR 2.0 pɏCB

par-v1.1.tar.gz Ɋ܂܂ rs.doc
Dummies guide to Reed-Solomon coding. Qlɂ
*/

/*
5 * 5 Ȃ
 1   1    1     1     1     constant  0
 2   4   16   128   256  <- ̍s̒l constant Ƃ
 4  16  256 16384  4107     constant  2
 8  64 4096  8566  7099     constant  3
16 256 4107 43963  7166     constant  4

par2-specifications.pdf ɂƁAconstant  2̏搔ŁA
̎w (n%3 != 0 && n%5 != 0 && n%17 != 0 && n%257 != 0) ɂȂB
*/

// PAR 2.0 ̃peBs̓GR[hɂ̏Ő
// constant  facter  2̃xNgŕ\
// peBEubNƂ facter *= constant ōXVĂ
static void make_encode_constant(
	unsigned short *constant)	// constant ߂z
{
	unsigned short temp;
	int n, i;

	// constant  2̏搔ŁAW3,5,17,257̔{ɂȂ̂͏
	// 萔 2, 4, 16, 128, 256, 2048, 8192, ...
	n = 0;
	temp = 1;
	for (i = 0; i < source_num; i++){
		while (n <= 65535){
			temp = galois_multiply_fix(temp, 1);	// galois_multiply(temp, 2);
			n++;
			if ((n % 3 != 0) && (n % 5 != 0) && (n % 17 != 0) && (n % 257 != 0))
				break;
		}
		constant[i] = temp;
	}
}

// p̍sA\Ȑ̃peBEubNKv
static int make_decode_matrix(
	unsigned short *mat,	// p̍s
	int block_lost,			// sAs̏cTCYAꂽ\[XEubN̐ = KvȃpeBEubN
	source_ctx_r *s_blk,	// e\[XEubN̏
	parity_ctx_r *p_blk)	// epeBEubN̏
{
	unsigned short *id;		// ꂽ\[XEubNǂ̃peBEubNőp
	unsigned short constant;
	int i, j, k, n;

	// printf("\n parity_num = %d, rows = %d, cols = %d \n", parity_num, block_lost, source_num);
	// ꂽ\[XEubNǂ̃peBEubNőp邩
	id = mat + (block_lost * source_num);
	j = 0;
	for (i = 0; (i < parity_num) && (j < block_lost); i++){
		if (p_blk[i].exist == 1)	// ps̈󂪕tĂubN͖
			id[j++] = (unsigned short)i;
	}
	if (j < block_lost){	// peBEubN̐Ȃ
		printf("need more recovery slice\n");
		return 1;
	}

	// ݂ėppeBEubN̍s
	n = 0;
	constant = 1;
	for (i = 0; i < source_num; i++){	// 񂸂cɒlZbgĂ
		while (n <= 65535){
			constant = galois_multiply_fix(constant, 1);	// galois_multiply(constant, 2);
			n++;
			if ((n % 3 != 0) && (n % 5 != 0) && (n % 17 != 0) && (n % 257 != 0))
				break;
		}
//		printf("\n[%5d], 2 pow %5d = %5d", i, n, constant);

		k = 0;
		for (j = 0; j < source_num; j++){	// j s i 
			if (s_blk[j].exist == 0){	// Y̓peBEubNŕ₤̂Ȃ
				mat[source_num * k + i] = galois_power(constant, id[k]);
				k++;
			}
		}
	}

	if ((cpu_num == 1) || (source_num < 10) || (block_lost < 4)){	// s̓}`EXbhɂȂ
		k = invert_matrix_st(mat, block_lost, source_num, s_blk);
	} else {
		k = invert_matrix_mt(mat, block_lost, source_num, s_blk);
	}
	return k;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// [hE\găGR[h
int rs_encode(
	wchar_t *file_path,
	unsigned char *header_buf,	// Recovery Slice packet ̃pPbgEwb_[
	HANDLE *rcv_hFile,			// JoEt@C̃nh
	file_ctx_c *files,			// \[XEt@C̏
	source_ctx_c *s_blk,		// \[XEubN̏
	parity_ctx_c *p_blk)		// peBEubN̏
{
	unsigned short *constant = NULL;
	int err = 0;
	unsigned int len;
#ifdef TIMER
unsigned int time_total = GetTickCount();
#endif

	if (galois_create_table()){
		printf("galois_create_table\n");
		return 1;
	}

	if (source_num == 1){	// \[XEubNȂ
		err = encode_method1(file_path, header_buf, rcv_hFile, files, s_blk, p_blk);
		goto error_end;
	}

	// peBvZp̍s񉉎Z̏
	if (parity_num > source_num){
		len = sizeof(unsigned short) * (source_num + parity_num);
	} else {
		len = sizeof(unsigned short) * source_num * 2;
	}
	constant = malloc(len);
	if (constant == NULL){
		printf("malloc, %d\n", len);
		err = 1;
		goto error_end;
	}
#ifdef TIMER
	printf("\nmatrix size = %d.%d KB\n", len >> 10, (len >> 10) % 10);
#endif
	// peBs̊ɂȂ萔
	make_encode_constant(constant);
//	for (len = 0; (int)len < source_num; len++)
//		printf("constant[%5d] = %5d\n", len, constant[len]);

#ifdef TIMER
	err = 0;	// IO method : 0=Auto, -2=Read all, -3=Read some, -4=GPU all, -5=GPU some
	if (err == 0){
#endif
	if ((OpenCL_method != 0) && (block_size >= 65536) && (source_num >= 256) && (parity_num >= 32) &&
			((source_num + parity_num) * (__int64)block_size > 1048576 * 512)){
		// ubNȂAubNƂɃXbh蓖Ă (GPU g)
		if (read_block_num(parity_num, 2, 0, MEM_UNIT) != 0){
			err = -5;	// [ĂȂ Read some g
		} else {
			err = -4;	// [sȂ Read all ŃubNfЉ
		}
	} else {
		// \[XEubNSĒfГIɓǂݍނAۂƓǂݍނ߂
		if (read_block_num(parity_num, cpu_num - 1, 0, sse_unit) != 0){
			err = -3;	// [ĂȂ Read some g
		} else {
			err = -2;	// [sȂ Read all ŃubNfЉ
		}
	}
#ifdef TIMER
	}
#endif

	// t@CEANZX̕ɂĕ򂷂
	if (err == -5)	// ŏ̓ GPUgAȂ玟Ɉڂ
		err = encode_method5(file_path, header_buf, rcv_hFile, files, s_blk, p_blk, constant);
	if (err == -4)
		err = encode_method4(file_path, header_buf, rcv_hFile, files, s_blk, p_blk, constant);
	if (err == -3)	// \[XEf[^ǂݍޏꍇ
		err = encode_method3(file_path, header_buf, rcv_hFile, files, s_blk, p_blk, constant);
	if (err == -2)	// \[XEf[^Sēǂݍޏꍇ
		err = encode_method2(file_path, header_buf, rcv_hFile, files, s_blk, p_blk, constant);
#ifdef TIMER
	if (err != 1){
		time_total = GetTickCount() - time_total;
		printf("total  %d.%03d sec\n", time_total / 1000, time_total % 1000);
	}
#endif

error_end:
	if (constant)
		free(constant);
	galois_free_table();	// Galois Field ̃e[u
	return err;
}

// [hE\găfR[h
int rs_decode(
	wchar_t *file_path,
	int block_lost,			// ꂽ\[XEubN̐
	HANDLE *rcv_hFile,		// JoEt@C̃nh
	file_ctx_r *files,		// \[XEt@C̏
	source_ctx_r *s_blk,	// \[XEubN̏
	parity_ctx_r *p_blk)	// peBEubN̏
{
	unsigned short *mat = NULL, *id;
	int err = 0, i, j, k;
	unsigned int len;
#ifdef TIMER
unsigned int time_matrix = 0, time_total = GetTickCount();
#endif

	if (galois_create_table()){
		printf("galois_create_table\n");
		return 1;
	}

	if (source_num == 1){	// \[XEubNȂ
		err = decode_method1(file_path, rcv_hFile, files, s_blk, p_blk);
		goto error_end;
	}

	// p̍s񉉎Z̏
	len = sizeof(unsigned short) * block_lost * (source_num + 1);
	mat = malloc(len);
	if (mat == NULL){
		printf("malloc, %d\n", len);
		printf("matrix for recovery is too large\n");
		err = 1;
		goto error_end;
	}
#ifdef TIMER
	if (len & 0xFFF00000){
		printf("\nmatrix size = %d.%d MB\n", len >> 20, (len >> 20) % 10);
	} else {
		printf("\nmatrix size = %d.%d KB\n", len >> 10, (len >> 10) % 10);
	}
#endif
	// Ԗڂ̏\[XEubNǂ̃peBőւ邩
	id = mat + (block_lost * source_num);

#ifdef TIMER
time_matrix = GetTickCount();
#endif
	// p̍svZ
	print_progress_text(0, "Computing matrix");
	err = make_decode_matrix(mat, block_lost, s_blk, p_blk);
	while (err >= 0x00010000){	// tsvZłȂꍇ ( Petr Matas ̏CĂQlɎ)
		printf("\n");
		err ^= 0x00010000;	// G[Ns (\[XEubN̔ԍ)
		printf("fail at input slice %d\n", err);
		k = 0;
		for (i = 0; i < err; i++){
			if (s_blk[i].exist == 0)
				k++;
		}
		// id[k] G[NsɑΉpeBEubN̔ԍ
		p_blk[id[k]].exist = 0x100;	// ̃peBEubNgȂ悤ɂ
		printf("disable recovery slice %d\n", id[k]);
		j = 0;
		for (i = 0; i < parity_num; i++){
			if (p_blk[i].exist == 1)
				j++;	// p\ȃpeBEubN̐
		}
		if (j >= block_lost){	// gpeBEubN̐jubN̐ȏȂ
			print_progress_text(0, "Computing matrix");
			err = make_decode_matrix(mat, block_lost, s_blk, p_blk);
		} else {	// ւpeBEubN̐Ȃ
			printf("fail at recovery slice");
			for (i = 0; i < parity_num; i++){
				if (p_blk[i].exist == 0x100)
					printf(" %d", i);
			}
			printf("\n");
			err = 1;
		}
	}
	if (err)	// ȊÕG[Ȃ
		goto error_end;
	print_progress_done();	// sčs̐擪ɖ߂Ă
	//for (i = 0; i < block_lost; i++)
	//	printf("id[%d] = %d\n", i, id[i]);
#ifdef TIMER
time_matrix = GetTickCount() - time_matrix;
#endif

#ifdef TIMER
	err = 0;	// IO method : 0=Auto, -2=Read all, -3=Read some, -4=GPU all, -5=GPU some
	if (err == 0){
#endif
	if ((OpenCL_method != 0) && (block_size >= 65536) && (source_num >= 256) && (block_lost >= 32) &&
			((source_num + block_lost) * (__int64)block_size > 1048576 * 512)){
		// ubNȂAubNƂɃXbh蓖Ă (GPU g)
		if (read_block_num(block_lost, 2, 0, MEM_UNIT) != 0){
			err = -5;	// [ĂȂ Read some g
		} else {
			err = -4;	// [sȂ Read all ŃubNfЉ
		}
	} else {
		// \[XEubNSĒfГIɓǂݍނAۂƓǂݍނ߂
		if (read_block_num(block_lost, cpu_num - 1, 0, sse_unit) != 0){
			err = -3;	// [ĂȂ Read some g
		} else {
			err = -2;	// [sȂ Read all ŃubNfЉ
		}
	}
#ifdef TIMER
	}
#endif

	// t@CEANZX̕ɂĕ򂷂
	if (err == -5)
		err = decode_method5(file_path, block_lost, rcv_hFile, files, s_blk, p_blk, mat);
	if (err == -4)
		err = decode_method4(file_path, block_lost, rcv_hFile, files, s_blk, p_blk, mat);
	if (err == -3)	// \[XEf[^ǂݍޏꍇ
		err = decode_method3(file_path, block_lost, rcv_hFile, files, s_blk, p_blk, mat);
	if (err == -2)	// \[XEf[^Sēǂݍޏꍇ
		err = decode_method2(file_path, block_lost, rcv_hFile, files, s_blk, p_blk, mat);
#ifdef TIMER
	if (err != 1){
		time_total = GetTickCount() - time_total;
		printf("total  %d.%03d sec\n", time_total / 1000, time_total % 1000);
		printf("matrix %d.%03d sec\n", time_matrix / 1000, time_matrix % 1000);
	}
#endif

error_end:
	if (mat)
		free(mat);
	galois_free_table();	// Galois Field ̃e[u
	return err;
}

