// repair.c
// Copyright : 2019-05-02 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "crc.h"
#include "md5_crc.h"
#include "ini.h"
#include "repair.h"


// t@CEXg\
void print_file_list(
	char *ascii_buf,	// Ɨp
	file_ctx_r *files)
{
	int i;

	printf("\nInput File list      :\n");
	printf("         Size  Slice :  Filename\n");
	fflush(stdout);
	for (i = 0; i < file_num; i++){
		if (files[i].name < 0){	// File Description packet Ă
			printf("            ?      ? : Unknown\n");
		} else {
			if (files[i].name == 0){	// t@Cs
				ascii_buf[0] = 0;
			} else {
				utf16_to_cp(list_buf + files[i].name, ascii_buf, cp_output);
			}
			// t@CƂ̃ubNƊJnԍ
			if ((i < entity_num) && (files[i].size > 0)){
				printf("%13I64d %6d : \"%s\"\n", files[i].size, files[i].b_num, ascii_buf);
			} else {	// ̃t@CtH_A܂ non recovery set
				printf("%13I64d      0 : \"%s\"\n", files[i].size, ascii_buf);
			}
		}
	}
	printf("\nInput File total size\t: %I64d\n", total_file_size);
	printf("Input File Slice count\t: %d\n", source_num);
}

// fBNgL܂ł̒Ԃ (݂Ȃꍇ -1)
static int wcschr_dir(wchar_t *s)
{
	int i = 0;

	while (s[i] != 0){
		if (s[i] == '\\')
			return i;
		i++;
	}

	return -1;
}

// t@Cr
static int name_cmp(const void *elem1, const void *elem2)
{
	wchar_t *name1, *name2;
	int rv = 2, len1, len2;

	name1 = list_buf + ((file_ctx_r *)elem1)->name;
	name2 = list_buf + ((file_ctx_r *)elem2)->name;

	while (name1[0] + name2[0] != 0){
		len1 = wcschr_dir(name1);
		len2 = wcschr_dir(name2);

		// tH_ɂ
		if (len1 >= 0){
			if (len2 < 0)	// file1 TuEfBNg
				return -1;
		} else if (len2 >= 0){	// file2 TuEfBNg
			return 1;
		}

		// [U[̌ݒɂď߂
		rv = CompareString(LOCALE_USER_DEFAULT, 0, name1, len1, name2, len2);
		if ((rv == 2) && (len1 != -1) && (len2 != -1)){
			name1 += len1 + 1;
			name2 += len2 + 1;
		} else {
			break;
		}
	}

	return rv - 2;
//	return wcscmp(name1, name2);	// QuickPar ͂̏
}

// \[XEt@CmFďWv
int set_file_data(
	char *ascii_buf,	// Ɨp
	file_ctx_r *files)
{
	int i, bad_flag;

	// \[XEt@C̊{
	bad_flag = 0;
	total_file_size = 0;
	source_num = 0;
	for (i = 0; i < file_num; i++){
		if (files[i].name < 0){	// File Description packet Ă
			bad_flag |= 1;
		} else {
			if (files[i].name == 0){	// t@Cs
				bad_flag |= 2;
			} else {
				if (base_len + wcslen(list_buf + files[i].name) >= MAX_LEN - ADD_LEN)
					bad_flag |= 4;	// t@CEpX߂
			}
			// t@CƂ̃ubNƊJnԍ
			if ((i < entity_num) && (files[i].size > 0)){
				files[i].b_off = source_num;
				files[i].b_num = (int)((files[i].size + (__int64)block_size - 1) / (__int64)block_size);
				source_num += files[i].b_num;
				files[i].state = 0x80;	// `FbNTKv܂ǂݎĂȂ
			} else {	// ̃t@CtH_A܂ non recovery set
				files[i].b_off = 0;
				files[i].b_num = 0;
				files[i].state = 0;	// `FbNT͕KvȂ
			}
			total_file_size += files[i].size;
		}
	}
	if (bad_flag){
		print_file_list(ascii_buf, files);	// IOɃt@CEXg\
		if (bad_flag & 1){	// File Description packet sĂƌpłȂ
			printf("\nFile Description packet is missing\n");
		} else if (bad_flag & 2){
			printf("\nfilename is unknown\n");
		} else if (bad_flag & 4){
			printf("\nfilename is too long\n");
		}
		return 1;
	}

	// PAR2 dlł̓\[XEubN̍ől 32768 A
	// KiÕJoEf[^邩Ȃ (YencPowerPost A&A v11b ̃oO)
	if (source_num > MAX_SOURCE_NUM){
		parity_num = 0;	// KiOȂ烊JoEubN𖳌ɂ
	} else {
		// JoEubN̂͂ł邪AقȂXCX 65535܂
		parity_num = MAX_PARITY_NUM;
	}

	// If you want to see original order (sorted by File ID), comment out below lines.
	// t@CёւA\[XEubÑt@Cԍɉĕς邱
	// recovery set ̃t@Ct@C̏ɕёւ
	if (entity_num > 1)
		qsort(files, entity_num, sizeof(file_ctx_r), name_cmp);
	// non-recovery set ̃t@Ct@C̏ɕёւ
	if (file_num - entity_num > 1)
		qsort(&(files[entity_num]), file_num - entity_num, sizeof(file_ctx_r), name_cmp);

	print_file_list(ascii_buf, files);	// ёւꂽt@CEXg\

	return 0;
}

// \[XEt@ČʂWvāAC@𔻒肷
int result_file_state(
	char *ascii_buf,
	int *result,
	int parity_now,
	int recovery_lost,
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int i, num, find_num, b_last;
	int lost_num, need_repair, rejoin_num, repair_num, incomp_num;

	find_num = -1;	// ڂ\̈
	need_repair = 0;
	rejoin_num = 0;
	repair_num = 0;
	incomp_num = 0;
	for (num = 0; num < entity_num; num++){
		if (files[num].size == 0){	// tH_܂͋t@C
			if (files[num].state & 0x3F)	// t@CƃtH_݂ (0x40) ȊOȂ
				need_repair++;
		} else {	// \[XEt@C
			if (files[num].state & 0x03){	// (0x01)Aj(0x02) ȂXCXoʂ\
				if (find_num < 0){	// ڕ\܂Ȃ
					printf("\nCounting available slice:\n");
					printf(" Avail /  Slice :  Filename\n");	// WvꂽoXCX
				}
				utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);
				find_num = 0;
				if ((files[num].state & 0x80) == 0){	// `FbNT݂Ȃ
					b_last = files[num].b_off + files[num].b_num;
					for (i = files[num].b_off; i < b_last; i++){
						if (s_blk[i].exist != 0)
							find_num++;
					}
				}
				printf("%6d / %6d : \"%s\"\n", find_num, files[num].b_num, ascii_buf);
				if (find_num == files[num].b_num){
					need_repair |= 0x20000000;	// XCXĂ̂Ńt@Cč\zł
					rejoin_num++;
				} else {
					need_repair |= 0x10000000;	// XCXȂ
					repair_num++;
				}
			} else if (files[num].state & 0x30){	// ǉ(0x10)AʖEړ(0x20, 0x28)
				need_repair++;
			}
		}
	}
	for (num = entity_num; num < file_num; num++){
		if (files[num].state & 0x30){	// ǉ(0x10)AʖEړ(0x20)AtH_ړ(0x60)
			need_repair++;
		} else if (files[num].state & 0x03){	// (0x01)Aj(0x02)AtH_(0x41)
			if (files[num].size == 0){	// TCY 0Ȃ炷ɕł
				need_repair++;
			} else {
				need_repair |= 0x40000000;	// non-recovery set ̃t@CjďCłȂ
				incomp_num++;
			}
		}
	}

	// p\ȃ\[XEubN̐
	printf("\nInput File Slice avail\t: %d\n", first_num);
	// \[XEubN̐
	lost_num = source_num - first_num;
	printf("Input File Slice lost\t: %d\n\n", lost_num);
	if (recovery_lost > 0){	// sSȃJoEt@CȂ
		i = 256;
		printf("%d PAR File(s) Incomplete\n", recovery_lost);
	} else {
		i = 0;
	}

	// CKv邩ǂ
	if (need_repair == 0){
		if (i == 0)
			printf("All Files Complete\n");
	} else {
		i |= 4;
		if (need_repair & 0x0FFFFFFF){	// ȈՏC͉\
			printf("Ready to rename %d file(s)\n", need_repair & 0x0FFFFFFF);
			i |= 32;
		}
		if (need_repair & 0x20000000){	// č\z܂ł͉\
			printf("Ready to rejoin %d file(s)\n", rejoin_num);
			i |= 64;
		}
		if (need_repair & 0x10000000){	// \[XEubN̕Kv
			if (lost_num > parity_now){
				printf("Need %d more slice(s) to repair %d file(s)\n", lost_num - parity_now, repair_num);
				i |= 8;
			} else if ((lost_num == parity_now) && (lost_num >= 2)){	// tšvZŎs邩
				printf("Try to repair %d file(s)\n", repair_num);
				i |= 128 | 8;
			} else {
				printf("Ready to repair %d file(s)\n", repair_num);
				i |= 128;
			}
		}
		if (need_repair & 0x40000000)	// non-recovery set ̃t@C͏CłȂ
			printf("Cannot repair %d file(s)\n", incomp_num);
	}
	fflush(stdout);

	*result = need_repair;
	return i;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// ȒPȏCsA܂C̕Kvȃt@C̐߂
int simple_repair(
	char *ascii_buf,
	int need_repair,
	file_ctx_r *files)		// e\[XEt@C̏
{
	wchar_t file_path[MAX_LEN], old_path[MAX_LEN];
	int i, num, repaired_num;
	HANDLE hFile;

	if (need_repair){	// ȒPȏCłt@C̐
		printf("\nCorrecting file : %d\n", need_repair);
		printf(" Status   :  Filename\n");
		fflush(stdout);
		need_repair = 0x10000000;
	}
	repaired_num = 0;
	wcscpy(file_path, base_dir);
	wcscpy(old_path, base_dir);

	// recovery set ̃t@C
	for (num = 0; num < entity_num; num++){
		utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);
		wcscpy(file_path + base_len, list_buf + files[num].name);
		if (files[num].size == 0){	// tH_܂͋t@C蒼
			switch (files[num].state){
			case 1:		// ݂ȂĂTCY 0Ȃ炷ɕł
				hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				if ((hFile == INVALID_HANDLE_VALUE) && (GetLastError() == ERROR_PATH_NOT_FOUND)){	// Path not found (3)
					make_dir(file_path);	// r̃tH_݂Ȃ̂Ȃ쐬
					hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				}
				if (hFile != INVALID_HANDLE_VALUE){
					CloseHandle(hFile);
					files[num].state = 0;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			case 16:	// t@Cɓeꍇ͔jł͂ȂǉƌȂ
				if (shorten_file(file_path, 0) == 0){
					files[num].state = 0;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			case 32:	// {̏ꏊɖ߂
			case 96:	// tH_{̏ꏊɖ߂
				wcscpy(old_path + base_len, list_buf + files[num].name2);
				if (replace_file(file_path, old_path) == 0){
					files[num].state &= 0x40;	// 0  64 ɂȂ
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {	// t@C̕ύXɎs
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			case 65:	// tH_
				i = (int)wcslen(file_path);
				if (file_path[i - 1] == '\\')
					file_path[i - 1] = 0;
				if (CreateDirectory(file_path, NULL) == 0){
					i = GetLastError();
					if (i == ERROR_PATH_NOT_FOUND){	// Path not found (3)
						make_dir(file_path);	// r̃tH_݂Ȃ̂Ȃ쐬
						i = CreateDirectory(file_path, NULL);
					} else if (i == ERROR_ALREADY_EXISTS){	// Destination file is already exist (183)
						if ((GetFileAttributes(file_path) & FILE_ATTRIBUTE_DIRECTORY) == 0){
							// ̃t@C݂Ȃǂ
							move_away_file(file_path);
							i = CreateDirectory(file_path, NULL);
						}
					}
				}
				if (i != 0){
					files[num].state = 64;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			}
		} else {
			switch (files[num].state & 0x7F){	// `FbNT̗LɊ֌WȂł
			case 1:		// ŎꂽubN𕜌
			case 2:
				need_repair++;
				break;
			case 16:	// ̃S~菜
				if (shorten_file(file_path, files[num].size) == 0){
					write_ini_complete(num, file_path);
					files[num].state &= 0x80;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			case 32:	// t@C
			case 40:
				wcscpy(old_path + base_len, list_buf + files[num].name2);
				if (replace_file(file_path, old_path) == 0){
					files[num].state &= 0x80;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {	// t@C̕ύXɎs
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
				break;
			}
		}
	}

	// non-recovery set ̃t@C
	for (num = entity_num; num < file_num; num++){
		utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);
		wcscpy(file_path + base_len, list_buf + files[num].name);
		switch (files[num].state){
		case 1:		// 
		case 2:		// j
			if (files[num].size == 0){	// TCY 0Ȃ炷ɕł
				hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				if ((hFile == INVALID_HANDLE_VALUE) && (GetLastError() == ERROR_PATH_NOT_FOUND)){	// Path not found (3)
					make_dir(file_path);	// r̃tH_݂Ȃ̂Ȃ쐬
					hFile = CreateFile(file_path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				}
				if (hFile != INVALID_HANDLE_VALUE){
					CloseHandle(hFile);
					files[num].state = 0;
					printf(" Restored : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {
					printf(" Failed   : \"%s\"\n", ascii_buf);
				}
				fflush(stdout);
			}
			break;
		case 16:	// ǉ
			if (shorten_file(file_path, files[num].size) == 0){
				files[num].state = 0;
				printf(" Restored : \"%s\"\n", ascii_buf);
				repaired_num++;
			} else {
				printf(" Failed   : \"%s\"\n", ascii_buf);
			}
			fflush(stdout);
			break;
		case 32:	// {̏ꏊɖ߂A܂̓t@C
		case 40:
		case 96:	// tH_{̏ꏊɖ߂
			wcscpy(old_path + base_len, list_buf + files[num].name2);
			if (replace_file(file_path, old_path) == 0){
				files[num].state &= 0x40;	// 0  64 ɂȂ
				printf(" Restored : \"%s\"\n", ascii_buf);
				repaired_num++;
			} else {	// t@C̕ύXɎs
				printf(" Failed   : \"%s\"\n", ascii_buf);
			}
			fflush(stdout);
			break;
		case 65:	// tH_
			i = (int)wcslen(file_path);
			if (file_path[i - 1] == '\\')
				file_path[i - 1] = 0;
			if (CreateDirectory(file_path, NULL) == 0){
				i = GetLastError();
				if (i == ERROR_PATH_NOT_FOUND){	// Path not found (3)
					make_dir(file_path);	// r̃tH_݂Ȃ̂Ȃ쐬
					i = CreateDirectory(file_path, NULL);
				} else if (i == ERROR_ALREADY_EXISTS){	// Destination file is already exist (183)
					if ((GetFileAttributes(file_path) & FILE_ATTRIBUTE_DIRECTORY) == 0){
						// ̃t@C݂Ȃǂ
						move_away_file(file_path);
						i = CreateDirectory(file_path, NULL);
					}
				}
			}
			if (i != 0){
				files[num].state = 64;
				printf(" Restored : \"%s\"\n", ascii_buf);
				repaired_num++;
			} else {
				printf(" Failed   : \"%s\"\n", ascii_buf);
			}
			fflush(stdout);
			break;
		}
	}

	if (need_repair & 0x10000000)	// Cłt@C̐
		printf("\nRestored file count\t: %d\n", repaired_num);

	return need_repair & 0x0FFFFFFF;
}

// 4oCg̃\[XEubNtZă\[XEt@Cɏ
int restore_block4(
	wchar_t *file_path,
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int i, j, num, b_last;
	unsigned int data;
	unsigned int time_last = 0;
	HANDLE hFile;

	print_progress_text(0, "Restoring slice");
	wcscpy(file_path, base_dir);
	for (num = 0; num < entity_num; num++){
		// oߕ\
		if (GetTickCount() - time_last >= UPDATE_TIME){
			if (print_progress((num * 1000) / entity_num))
				return 2;
			time_last = GetTickCount();
		}

		if ((files[num].size > 0) && ((files[num].state & 0x80) == 0) &&
				((files[num].state & 7) != 0)){	// `FbNTƍƃt@C݂Ȃ
			// ƃt@CJ
			hFile = handle_temp_file(list_buf + files[num].name, file_path);
			if (hFile == INVALID_HANDLE_VALUE)
				return 1;

			// tZ\[XEubNł
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++){
				data = crc_reverse_zero(s_blk[i].crc, 4);	// CRC-32 ubNetZ
				if (!WriteFile(hFile, &data, s_blk[i].size, &j, NULL)){
					print_win32_err();
					CloseHandle(hFile);
					return 1;
				}
			}
			CloseHandle(hFile);
		}
	}
	print_progress_done();	// sčs̐擪ɖ߂Ă

	return 0;
}

// ẽ\[XEubN𗬗pA܂͓e킩ubN͋tZ
int restore_block(
	wchar_t *file_path,
	int reuse_num,			// p\ȃ\[XEubN̐
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int i, num, src_blk, src_file;
	unsigned int data;
	unsigned int time_last = 0, prog_num = 0;
	__int64 file_off;
	HANDLE hFile, hFile_src;

	print_progress_text(0, "Restoring slice");
	wcscpy(file_path, base_dir);
	for (num = 0; num < entity_num; num++){
		if ((files[num].size > 0) && ((files[num].state & 0x80) == 0) &&
				((files[num].state & 7) != 0)){	// `FbNTƍƃt@C݂Ȃ
			hFile = NULL;

			// p\ȃ\[XEubNRs[Ă
			i = files[num].b_off;
			for (file_off = 0; file_off < files[num].size; file_off += block_size){
				switch (s_blk[i].exist){
				case 3:	// eS 0 ̃ubN
					if (!hFile){	// ƃt@CJ
						hFile = handle_temp_file(list_buf + files[num].name, file_path);
						if (hFile == INVALID_HANDLE_VALUE)
							return 1;
					}
					// 0 Ŗ߂
					if (file_fill_data(hFile, file_off, 0, s_blk[i].size)){
						CloseHandle(hFile);
						printf("file_fill_data, %d\n", i);
						return 1;
					}
					break;
				case 4:	// t@CA܂͕ʂ̃t@Cɑ݂铯ubN
					if (!hFile){	// ƃt@CJ
						hFile = handle_temp_file(list_buf + files[num].name, file_path);
						if (hFile == INVALID_HANDLE_VALUE)
							return 1;
					}
					src_blk = s_blk[i].file;	// s_blk[i].file ɂ͂̃ubNԍĂ
					src_file = s_blk[src_blk].file;
/*					printf("copy block : off 0x%I64X block %d -> off 0x%I64X block %d\n",
						(__int64)(src_blk - files[src_file].b_off) * (__int64)block_size,
						src_blk, file_off, i);*/
					if ((files[src_file].state & 7) != 0){	// 蒼ƃt@Cǂݍ
						get_temp_name(list_buf + files[src_file].name, file_path + base_len);
					} else if (files[src_file].state & 0x20){	// Osɂ͕ʖt@Cǂݍ
						wcscpy(file_path + base_len, list_buf + files[src_file].name2);
					} else {	// Sȃ\[XEt@Cǂݍ (ǉs)
						wcscpy(file_path + base_len, list_buf + files[src_file].name);
					}
					hFile_src = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
					if (hFile_src == INVALID_HANDLE_VALUE){
						print_win32_err();
						CloseHandle(hFile);
						printf_cp("cannot open file, %s\n", file_path);
						return 1;
					}
					// Rs[
					if (file_copy_data(hFile_src, (__int64)(src_blk - files[src_file].b_off) * (__int64)block_size,
							hFile, file_off, s_blk[i].size)){
						print_win32_err();
						CloseHandle(hFile);
						printf("file_copy_data, %d\n", i);
						return 1;
					}
					CloseHandle(hFile_src);
					break;
				case 5:	// etZ邱ƂłubN
					if (!hFile){	// ƃt@CJ
						hFile = handle_temp_file(list_buf + files[num].name, file_path);
						if (hFile == INVALID_HANDLE_VALUE)
							return 1;
					}
					data = crc_reverse_zero(s_blk[i].crc, block_size);	// CRC-32 ubNetZ
					if (file_write_data(hFile, file_off, (unsigned char *)(&data), s_blk[i].size)){
						CloseHandle(hFile);
						printf("file_write_data, %d\n", i);
						return 1;
					}
					break;
				}
				if (s_blk[i].exist >= 3){
					s_blk[i].file = num;

					// oߕ\
					prog_num++;
					if (GetTickCount() - time_last >= UPDATE_TIME){
						if (print_progress((prog_num * 1000) / reuse_num))
							return 2;
						time_last = GetTickCount();
					}
				}
				i++;
			}
			if (hFile)
				CloseHandle(hFile);
		}
	}
	print_progress_done();	// sčs̐擪ɖ߂Ă

	return 0;
}

// CłׂČʕ\
int verify_repair(
	wchar_t *file_path,
	char *ascii_buf,
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	wchar_t temp_path[MAX_LEN];
	int i, num, b_last, bad_flag, repaired_num;

	repaired_num = 0;
	wcscpy(file_path, base_dir);
	for (num = 0; num < entity_num; num++){
		// V蒼\[XEt@CȂ
		if ((files[num].size > 0) && ((files[num].state & 7) != 0)){
			bad_flag = 0;
			// ēxJȂ
			wcscpy(file_path + base_len, list_buf + files[num].name);
			get_temp_name(file_path, temp_path);
			if (files[num].state & 0x80){	// `FbNT\[XEt@C
				i = file_hash_direct(num, temp_path, list_buf + files[num].name, files, NULL);
			} else {
				i = file_hash_direct(num, temp_path, list_buf + files[num].name, files, s_blk);
			}
			if (i == -2)
				return 2;	// mFɃLZꂽ
			if (i == -4){
				bad_flag = 1;	// Missing
			} else if (i != -3){
				bad_flag = 2;	// Failed
			}

			// ʂ\
			utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);
			if (bad_flag){	// s
				if (((files[num].state & 0x80) == 0) &&
						(bad_flag == 2) && (switch_b & 4)){	// CɎsꍇłÃt@Cu
					// SȃubN܂܂Ă邩ǂ
					b_last = files[num].b_off + files[num].b_num;
					for (i = files[num].b_off; i < b_last; i++){
						if (s_blk[i].exist != 0){
							i = -1;
							break;
						}
					}
					if (i < 0){	// t@CւAjt@Cu
						if (replace_file(file_path, temp_path) == 0){
							files[num].state = 2;	// jt@Cɂ
							printf(" Replaced : \"%s\"\n", ascii_buf);
							fflush(stdout);
							continue;
						}
					}
				}
				printf(" Failed   : \"%s\"\n", ascii_buf);
			} else {	// C
				if (replace_file(file_path, temp_path) == 0){	// Ct@C߂
					write_ini_complete(num, file_path);
					files[num].state &= 0x80;
					b_last = files[num].b_off + files[num].b_num;
					for (i = files[num].b_off; i < b_last; i++){
						if (s_blk[i].exist == 0)
							first_num++;	// ubN
						s_blk[i].exist = 1;
					}
					printf(" Repaired : \"%s\"\n", ascii_buf);
					repaired_num++;
				} else {	// t@C߂Ȃꍇ́AʖɂďCt@Cc
					files[num].state = (files[num].state & 0x80) | 0x20;
					printf(" Locked   : \"%s\"\n", ascii_buf);
				}
			}
			fflush(stdout);
		}
	}

	// Cłt@C̐ƏC̃ubN
	printf("\nRepaired file count\t: %d\n", repaired_num);
	printf("Input File Slice avail\t: %d\n", first_num);

	return 0;
}

// Ɨp̃\[XEt@C폜
void delete_work_file(
	wchar_t *file_path,
	file_ctx_r *files)		// e\[XEt@C̏
{
	int num;

	wcscpy(file_path, base_dir);
	for (num = 0; num < entity_num; num++){
		//printf("files[%d].state = %d\n", num, files[num].state);
		if ((files[num].size > 0) && ((files[num].state & 7) != 0)){	// ƃt@C݂Ȃ
			// ƃt@C폜
			get_temp_name(list_buf + files[num].name, file_path + base_len);
			//printf_cp("delete %s\n", file_path);
			if (DeleteFile(file_path) == 0){
				//printf("error = %d\n", GetLastError());
				// Anti-Virus\tgݒ̃t@CăbN邱Ƃ
				if (GetLastError() == 32){	// ERROR_SHARING_VIOLATION
					Sleep(100);	// ҂ĂĒ킷
					DeleteFile(file_path);
				}
			}
		}
	}
}

// ubNPʂ̕łȂĂAč\zt@CŒu
void replace_incomplete(
	wchar_t *file_path,
	char *ascii_buf,
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	wchar_t temp_path[MAX_LEN];
	int i, num, b_last, first_time;

	first_time = 1;
	wcscpy(file_path, base_dir);
	for (num = 0; num < entity_num; num++){
		if ((files[num].size > 0) && ((files[num].state & 0x80) == 0) &&
				((files[num].state & 7) != 0)){	// `FbNTƍƃt@C݂Ȃ
			// SȃubN܂܂Ă邩ǂ
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++){
				if (s_blk[i].exist != 0){
					i = -1;
					break;
				}
			}
			if (i >= 0)
				continue;	// SȃubNSȂꍇ͂

			// ƃt@C݂΁At@CւAjt@Cu
			wcscpy(file_path + base_len, list_buf + files[num].name);
			get_temp_name(file_path, temp_path);
			if (replace_file(file_path, temp_path) == 0){
				files[num].state = 2;	// jt@Cɂ
				if (first_time){
					printf("\nPutting incomplete file :\n");
					printf(" Status   :  Filename\n");
					first_time = 0;
				}
				utf16_to_cp(list_buf + files[num].name, ascii_buf, cp_output);
				printf(" Replaced : \"%s\"\n", ascii_buf);
			}
		}
	}
}

