// search.c
// Copyright : 2018-12-12 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "crc.h"
#include "md5_crc.h"
#include "ini.h"
#include "search.h"

#define MIN_PACKET_SIZE	68

// t@C̃t@C̕R[hϊȂ
static int convert_filename(unsigned int new_CP, unsigned int old_CP, file_ctx_r *files)
{
	char ascii_buf[MAX_LEN * 3];
	wchar_t uni_buf[MAX_LEN];
	int i, j, len;

	// SẴt@Cϊ\Ɋm߂
	for (i = 0; i < file_num; i++){
		if (files[i].name <= 0)
			continue;	// t@C擾łȂt@C͂Ƃ΂
		// old_CP ŕϊꂽjR[h猳̃f[^ɖ߂
		if (utf16_to_cp(list_buf + files[i].name, ascii_buf, old_CP))
			return 1;
		// new_CP ōēxϊȂ
		if (cp_to_utf16(ascii_buf, uni_buf, new_CP))
			return 1;
	}

	// ɊmFς݂Ȃ̂ŁAϊG[͔Ȃ͂
	for (i = 0; i < file_num; i++){
		if (files[i].name <= 0)
			continue;	// t@C擾łȂt@C͂Ƃ΂
		// old_CP ŕϊꂽjR[h猳̃f[^ɖ߂
		utf16_to_cp(list_buf + files[i].name, ascii_buf, old_CP);
		// new_CP ōēxϊȂ
		cp_to_utf16(ascii_buf, uni_buf, new_CP);
		// ϊÕt@CXg菜
		len = (int)wcslen(list_buf + files[i].name);
		list_len = remove_file_path(list_buf, list_len, files[i].name);
		for (j = 0; j < file_num; j++){
			if (files[j].name > files[i].name)
				files[j].name -= (len + 1);	// XgŌ̂炵Ă
		}
		// ϊȂt@Cǉ
		files[i].name = list_len;
		if (add_file_path(uni_buf))
			return 2;
	}
	return 0;
}

// UTF-8 ŋL^Ȃ PAR2 client ǂ
static int non_utf8_client(char *creator)
{
	int version;

	if (strncmp(creator, "QuickPar ", 9) == 0){
		// QuickPar 0.9
		version = creator[9] - 48;
		version *= 10;
		version += creator[10] - 48;
		if (version <= 9)
			return 1;
	} else if (strncmp(creator, "Created by phpar2 version ", 26) == 0){
		// Created by phpar2 version 1.3.
		version = creator[26] - 48;
		version *= 10;
		version += creator[28] - 48;
		if (version <= 13)
			return 1;
	}
	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// JoEt@Căt@CEXgɒǉ
int search_recovery_files(int check_all)
{
	wchar_t recovery_base[MAX_LEN], search_path[MAX_LEN], file_ext[EXT_LEN];
	wchar_t *tmp_p;
	int len, dir_len, ext_len, l_max;
	HANDLE hFind;
	WIN32_FIND_DATA FindData;

	get_base_dir(recovery_file, recovery_base);
	dir_len = (int)wcslen(recovery_base);

	// JoEt@C̖O̊
	get_base_filename(recovery_file, search_path, file_ext);
	if (check_all & 2){	// ǉȂ瓯fBNg̑St@C
		wcscpy(search_path, recovery_base);
		wcscat(search_path, L"*");
		if (file_ext[0] != 0)	// gqȂu*.gqvŌ
			wcscat(search_path, file_ext);
	} else {
		if (file_ext[0] != 0){	// gqȂu.*gqvŌ
			file_ext[0] = '*';
			wcscat(search_path, L".");
			wcscat(search_path, file_ext);
			file_ext[0] = '.';
		} else {
			wcscat(search_path, L"*");
		}
	}
	ext_len = (int)wcslen(file_ext);

	l_max = ALLOC_LEN;
	recv_len = 0;
	recv_buf = (wchar_t *)malloc(l_max * 2);
	if (recv_buf == NULL){
		printf("malloc, %d\n", l_max * 2);
		return 1;
	}

	// JoEt@C
	hFind = FindFirstFile(search_path, &FindData);
	if (hFind == INVALID_HANDLE_VALUE){
		print_win32_err();
		printf_cp("cannot find recovery file, %s\n", search_path);
		return 1;
	}
	do {
		if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0){
			len = (int)wcslen(FindData.cFileName);
			if (dir_len + len >= MAX_LEN)
				continue;	// t@C͖
			if (file_ext[0] != 0){	// gqt@C
				if ((len <= ext_len) || (_wcsicmp(FindData.cFileName + (len - ext_len), file_ext) != 0))
					continue;
			}
			if (recv_len + dir_len + len >= l_max){	// ̈悪ȂȂȂg
				l_max += ALLOC_LEN;
				tmp_p = (wchar_t *)realloc(recv_buf, l_max * 2);
				if (tmp_p == NULL){
					FindClose(hFind);
					printf("realloc, %d\n", l_max * 2);
					return 1;
				} else {
					recv_buf = tmp_p;
				}
			}

			// XgɃRs[
			wcscpy(recv_buf + recv_len, recovery_base);
			recv_len += dir_len;
			wcscpy(recv_buf + recv_len, FindData.cFileName);
			recv_len += len + 1;
			recovery_num++;
		}
	} while (FindNextFile(hFind, &FindData));	// ̃t@C
	FindClose(hFind);
	// JoEt@C̊gq .par2 ȊOȂČ
	if ((file_ext[0] != 0) && (_wcsicmp(file_ext, L".par2") != 0)){
		get_base_filename(recovery_file, search_path, file_ext);
		wcscat(search_path, L".");
		wcscat(search_path, L"*");
		wcscat(search_path, L".par2");	// u.*.par2vŌ
		hFind = FindFirstFile(search_path, &FindData);
		if (hFind != INVALID_HANDLE_VALUE){
			do {
				if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0){
					len = (int)wcslen(FindData.cFileName);
					if (dir_len + len >= MAX_LEN)
						continue;	// t@C͖
					if (recv_len + dir_len + len >= l_max){	// ̈悪ȂȂȂg
						l_max += ALLOC_LEN;
						tmp_p = (wchar_t *)realloc(recv_buf, l_max * 2);
						if (tmp_p == NULL){
							FindClose(hFind);
							printf("realloc, %d\n", l_max * 2);
							return 1;
						} else {
							recv_buf = tmp_p;
						}
					}

					// XgɃRs[
					wcscpy(recv_buf + recv_len, recovery_base);
					recv_len += dir_len;
					wcscpy(recv_buf + recv_len, FindData.cFileName);
					recv_len += len + 1;
					recovery_num++;
				}
			} while (FindNextFile(hFind, &FindData));	// ̃t@C
			FindClose(hFind);
		}
	}
	if (recovery_num > 1)
		sort_list(recv_buf, recv_len);	// XgŃt@Cɕёւ (Ot@C͕ёւȂ)

	// w肳ꂽΏۂɃJoEt@C܂܂邩Ȃ
	if (list2_buf){
		int list2_off = 0;
		if (file_ext[0] != 0){	// JoEt@C̊gq
			ext_len = (int)wcslen(file_ext);
		} else {
			ext_len = MAX_LEN;	// gqȗĂꍇ͔rȂ
		}
		while (list2_off < list2_len){
			len = (int)wcslen(list2_buf + list2_off);
			// t@CdȂ悤ɂ
			if (search_file_path(recv_buf, recv_len, list2_buf + list2_off)){
				list2_off += len + 1;
				continue;
			}
			// gqu.par2v邢̓JoEt@CƓOt@C
			if (((len > 5) && (_wcsicmp(list2_buf + (list2_off + len - 5), L".par2") == 0)) ||
				((len > ext_len) && (_wcsicmp(list2_buf + (list2_off + len - ext_len), file_ext) == 0))){
				if (recv_len + len >= l_max){	// ̈悪ȂȂȂg
					l_max += ALLOC_LEN;
					tmp_p = (wchar_t *)realloc(recv_buf, l_max * 2);
					if (tmp_p == NULL){
						printf("realloc, %d\n", l_max * 2);
						return 1;
					} else {
						recv_buf = tmp_p;
					}
				}
				// XgɃRs[
				wcscpy(recv_buf + recv_len, list2_buf + list2_off);
				recv_len += len + 1;
				recovery_num++;
			}
			list2_off += len + 1;	// ̃t@C
		}
	}
/*{
FILE *fp;
fp = fopen("par_list.txt", "wb");
fwrite(recv_buf, 2, recv_len, fp);
fclose(fp);
}*/

	return 0;
}

// Magic sequence ƈv邩 (match = 0, fail = 1)
static int match_magic(unsigned char *buf)
{
	if ((*buf++) != 'P')
		return 1;
	if ((*buf++) != 'A')
		return 1;
	if ((*buf++) != 'R')
		return 1;
	if ((*buf++) != '2')
		return 1;
	if ((*buf++) != 0)
		return 1;
	if ((*buf++) != 'P')
		return 1;
	if ((*buf++) != 'K')
		return 1;
	if ((*buf++) != 'T')
		return 1;

	return 0;
}

// Main packet 𖖔kĒT
int search_main_packet(
	unsigned char *buf,		// ƃobt@[AFile ID ߂
	unsigned char *set_id,	// Recovery Set ID ߂
	int switch_v)			// x 0=S̈, +1=㔼
{
	unsigned char hash[16];
	int num, recv_off, len, off;
	unsigned int rv, packet_size, time_last;
	__int64 file_size, file_off, end_size;
	HANDLE hFile;

	// JoEt@C̈ꗗ\
	printf("PAR File list :\n");
	printf("         Size :  Filename\n");
	total_file_size = 0;
	recv_off = 0;
	while (recv_off < recv_len){
		// t@CJƂł邩ATCY擾ł邩m߂
		hFile = CreateFile(recv_buf + recv_off, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE){
			recv_len = remove_file_path(recv_buf, recv_len, recv_off);	// Xg菜
			recovery_num--;
			continue;
		}
		// t@C̃TCY擾
		if (!GetFileSizeEx(hFile, (PLARGE_INTEGER)&file_size)){
			CloseHandle(hFile);
			recv_len = remove_file_path(recv_buf, recv_len, recv_off);	// Xg菜
			recovery_num--;
			continue;
		}
		CloseHandle(hFile);
		total_file_size += file_size;
		// JoEt@C̖O
		if (compare_directory(recovery_file, recv_buf + recv_off) == 0){	// ꏊȂ
			utf16_to_cp(offset_file_name(recv_buf + recv_off), buf, cp_output);	// t@Cɂ
		} else {
			path_to_cp(recv_buf + recv_off, buf, cp_output);	// pX\
		}
		printf("%13I64d : \"%s\"\n", file_size, buf);
		while (recv_buf[recv_off] != 0)	// ̃t@C̈ʒuɂ炷
			recv_off++;
		recv_off++;
	}
	printf("\nPAR File total size\t: %I64d\n", total_file_size);
	printf("PAR File possible count\t: %d\n\n", recovery_num);

	recv_off = 0;	// 擪ɖ߂Ă
	prog_last = -1;
	end_size = 0;
	for (num = 0; num < recovery_num; num++){
		if (cancel_progress() != 0)	// LZ
			return 2;

		// JoEt@CJ
		if (num == 0){	// ܂͎w肳ꂽJoEt@CT
			hFile = CreateFile(recovery_file, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		} else {
			if (_wcsicmp(recv_buf + recv_off, recovery_file) == 0){	// ŏɌJoEt@C͂Ƃ΂
				while (recv_buf[recv_off] != 0)
					recv_off++;
				recv_off++;
			}
			hFile = CreateFile(recv_buf + recv_off, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
			while (recv_buf[recv_off] != 0)
				recv_off++;
			recv_off++;
		}
		if (hFile == INVALID_HANDLE_VALUE)
			continue;	// G[玟̃JoEt@C𒲂ׂ

		// t@C̃TCY擾
		if (!GetFileSizeEx(hFile, (PLARGE_INTEGER)&file_size)){
			CloseHandle(hFile);
			continue;	// G[玟̃JoEt@C𒲂ׂ
		}
		if (file_size < MIN_PACKET_SIZE){
			CloseHandle(hFile);
			continue;	// t@C͌Ȃ
		}
		// ǂݎTCY͍ő SEARCH_SIZE
		len = SEARCH_SIZE;
		if (file_size < SEARCH_SIZE)
			len = (unsigned int)file_size;
		//printf("num = %d, file_size = %I64d\n", num, file_size);
		time_last = GetTickCount();

		// kēǂݍł
		file_off = file_size;
		while (len > 0){
			file_off -= len;	// ǂݎJnʒuɂȂ
			// SEARCH_SIZE ǂݍŃobt@[̐擪ɓ
			if (file_read_data(hFile, file_off, buf, len)){
				len = 0;	// ǂݍݎɃG[t@C͂ȏ㌟Ȃ
				break;
			}

			// Main packet T
			off = 0;
			while (off < len){
				if (match_magic(buf + off) == 0){
					memcpy(&packet_size, buf + (off + 12), 4);	// pPbgETCY̏4oCg0ȊOƂ
					if (packet_size != 0){
						off += 8;
						continue;
					}
					memcpy(&packet_size, buf + (off + 8), 4);	// pPbgETCYm߂
					if ((packet_size & 3) || (packet_size < MIN_PACKET_SIZE) || (off + packet_size > SEARCH_SIZE * 3)){
						off += 8;
						continue;
					}
					// pPbgŜobt@[ɂΔjĂȂ𒲂ׂ
					data_md5(buf + (off + 32), (packet_size - 32), hash);
					if (memcmp(buf + (off + 16), hash, 16) == 0){	// SȃpPbg
						if (memcmp(buf + (off + 48), "PAR 2.0\0Main\0\0\0\0", 16) == 0){
							// Ô߃f[^̐
							rv = 0;
							memcpy(&block_size, buf + (off + 68), 4);	// Slice size ̏ 4oCgm߂
							if (block_size != 0)	// ubNETCY 4GBȏゾƃG[
								rv++;
							memcpy(&block_size, buf + (off + 64), 4);	// Slice size
							if (block_size > MAX_BLOCK_SIZE)	// ΉubNETCY 1GB ܂
								rv++;
							if ((block_size & 3) != 0)	// ubNETCY 4 ̔{̂͂
								rv++;
							memcpy(&entity_num, buf + (off + 72), 4);	// Number of files in the recovery set.
							file_num = (packet_size - 76) / 16;
							if (file_num <= 0)
								rv++;
							if (entity_num > file_num)
								rv++;
							if (rv == 0){
								memcpy(set_id, buf + (off + 32), 16);	// Recovery Set ID
								memmove(buf, buf + (off + 76), packet_size - 76);	// File ID obt@[̐擪Ɉڂ
								CloseHandle(hFile);
								// Recovery Set ̏\
								printf("Recovery Set ID\t\t: ");
								print_hash(set_id);
								printf("\n");
								printf("Input File Slice size\t: %u\n", block_size);
								printf("Input File total count\t: %d\n", file_num);
								printf("Recovery Set file count : %d\n", entity_num);
								return 0;
							}
						}
						off += packet_size;	// pPbg̏I[܂ňCɔ
					} else {
						off += 8;
					}
				} else {
					off++;
				}
			}

			// ̈𐧌
			if (((switch_v & 1) != 0) && (file_off < file_size / 2)){	// Œł㔼͌
				len = 0;
				break;
			}

			// obt@[̑O SEARCH_SIZE * 2 ̓ǂݍ݃TCYɂ炷
			len = SEARCH_SIZE;
			if (file_off < SEARCH_SIZE)
				len = (unsigned int)file_off;
			if (len > 0)
				memmove(buf + len, buf, SEARCH_SIZE * 2);

			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress((int)(((end_size + file_size - file_off) * 1000) / total_file_size))){
					CloseHandle(hFile);
					return 2;
				}
				time_last = GetTickCount();
			}
		}
		CloseHandle(hFile);
		end_size += file_size;
	}
	if ((prog_last >= 0) && (prog_last != 1000))
		printf("100.0%%\r");

	return 1;
}

// t@C̃pPbgT
int search_file_packet(
	char *ascii_buf,
	unsigned char *buf,		// ƃobt@[
	wchar_t *par_comment,	// Unicode Rg
	unsigned char *set_id,	// Recovery Set ID m߂
	int switch_v,			// x 0=SČ, 1=pPbg͂Ƃ΂, +32=t@C򉻂
	file_ctx_r *files)		// e\[XEt@C̏
{
	char par_client[COMMENT_LEN], ascii_comment[COMMENT_LEN];
	unsigned char hash[16];
	wchar_t uni_buf[MAX_LEN];
	int i, j, k, recv_off, find_num;
	int len, off, max, used_CP = CP_UTF8;
	unsigned int packet_size, time_last;
	__int64 file_size, file_off, file_next, end_size;
	HANDLE hFile;

	par_client[0] = 0;
	par_comment[0] = 0;
	ascii_comment[0] = 0;

	list_len = 1;	// 擪ɕsp null u
	list_max = ALLOC_LEN;
	list_buf = (wchar_t *)malloc(list_max * 2);
	if (list_buf == NULL){
		printf("malloc, %d\n", list_max * 2);
		return 1;
	}
	list_buf[0] = 0;

	find_num = 0;
	recv_off = 0;
	end_size = 0;
	while (recv_off < recv_len){
		if (cancel_progress() != 0)	// LZ
			return 2;

		//utf16_to_cp(recv_buf + recv_off, ascii_buf, cp_output);
		//printf("verifying %s\n", ascii_buf);
		// JoEt@CJ
		hFile = CreateFile(recv_buf + recv_off, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		while (recv_buf[recv_off] != 0)	// ̃t@C̈ʒuɂ炷
			recv_off++;
		recv_off++;
		if (hFile == INVALID_HANDLE_VALUE)
			continue;	// G[玟̃JoEt@C𒲂ׂ
		// t@C̃TCY擾
		if (!GetFileSizeEx(hFile, (PLARGE_INTEGER)&file_size)){
			CloseHandle(hFile);
			continue;	// G[玟̃JoEt@C𒲂ׂ
		}
		if (file_size < MIN_PACKET_SIZE){
			CloseHandle(hFile);
			continue;	// t@C͌Ȃ
		}
		file_off = 0;
		time_last = GetTickCount();

		// ŏ̓t@C̐擪 SEARCH_SIZE * 3 ǂݍ
		off = 0;
		len = SEARCH_SIZE * 3;
		if (file_size < SEARCH_SIZE * 3)
			len = (unsigned int)file_size;
		// ő SEARCH_SIZE * 3 ǂݍŃobt@[̐擪ɓ
		if (file_read_data(hFile, 0, buf, len)){
			CloseHandle(hFile);
			continue;	// G[玟̃JoEt@C𒲂ׂ
		}
		file_next = len;	// ̓ǂݍ݊Jnʒu
		max = len;
		if (len > SEARCH_SIZE)
			max = SEARCH_SIZE;

		// pPbgT
		while (len > 0){
			while (off < max){
				if (match_magic(buf + off) == 0){
					memcpy(&packet_size, buf + (off + 12), 4);	// pPbgETCY̏4oCg0ȊOƂ
					if (packet_size != 0){
						off += 8;
						continue;
					}
					memcpy(&packet_size, buf + (off + 8), 4);	// pPbgETCYm߂
					if ((packet_size & 3) || (packet_size < MIN_PACKET_SIZE) || (file_off + (__int64)off + (__int64)packet_size > file_size)){
						off += 8;
						continue;
					}
					if (off + packet_size > SEARCH_SIZE * 3){	// 傫ăobt@[Ɏ܂ĂȂȂ
						if (packet_size > 64 + 4 + block_size){	// Recovery Slice packet 傫pPbg͖͂
							off += 8;
							continue;
						}
						if ((switch_v & 1) == 0){
							// pPbgjĂȂ𒲂ׂ
							if (file_md5(hFile, file_off + off + 32, packet_size - 32, hash)){
								off += 8;	// vZłȂ
							} else {
								if (memcmp(buf + (off + 16), hash, 16) == 0){	// SȃpPbg
									// obt@[̃ItZbgƃpPbgETCY炷
									if (file_next < file_size)
										file_next = file_off + off + packet_size;
									off = max;	// Cɖ܂ł
								} else {
									off += 8;	// jpPbgȂ
								}
							}
						} else {	// ȈՌł͋pPbgSׂ͒Ȃ
							// obt@[̃ItZbgƃpPbgETCY炷
							if (file_next < file_size)
								file_next = file_off + off + packet_size;
							off = max;	// Cɖ܂ł
						}
						continue;
					}
					// pPbgjĂȂ𒲂ׂ
					data_md5(buf + (off + 32), (packet_size - 32), hash);
					if (memcmp(buf + (off + 16), hash, 16) == 0){	// SȃpPbg
						if (memcmp(buf + (off + 32), set_id, 16) != 0){	// Recovery Set ID pPbg
							off += packet_size;
							continue;
						}
/*
memset(ascii_buf, 0, 9);
memcpy(ascii_buf, buf + (off + 56), 8);
printf(" packet : %s, size = %u, file_off = %I64d, off = %d\n", ascii_buf, packet_size, file_off, off);
*/
						if ((memcmp(buf + (off + 48), "PAR 2.0\0FileDesc", 16) == 0) && (packet_size - 120 < MAX_LEN * 3)){
							// File Description packet
							memcpy(ascii_buf, buf + (off + 120), packet_size - 120);
							ascii_buf[packet_size - 120] = 0;	//  null ɂĂ
							j = -1;	// File ID dĂȂmF
							for (i = 0; i < file_num; i++){
								if (memcmp(buf + (off + 64), files[i].id, 16) == 0){	// File ID łǂ̃t@CT
									if (files[i].name < 0){	// V̂Ȃ
										break;
									} else {	// 񂪊ɍ݂ꍇ
										j = i;
									}
								}
							}
							if (i < file_num){
								memcpy(files[i].hash, buf + (off + 80), 32);
								memcpy(&(files[i].size), buf + (off + 112), 8);
								if ((j >= 0) && (i != j)){	// File ID t@Cɑ݂
									// t@CeقȂ̂ɓ File ID ɂȂƋʂłȂ̂őʖځI
									// tɁAt@Ce (nbVlƃTCY) ȂȂH
									if ((files[i].size != files[j].size) ||
											 (memcmp(files[i].hash, files[j].hash, 32) != 0)){
										printf("same File ID, %d and %d\n", j, i);
										return 1;
									}
								}
								// pPbgɋL^Ăt@CjR[hɕϊ
								if (used_CP != CP_UTF8){	// QuickPar Ȃǃt@C UTF-8 ȊOȂ
									// ϊł邩ׂ
									j = cp_to_utf16(ascii_buf, uni_buf, used_CP);
									if (j == ERROR_NO_UNICODE_TRANSLATION){	// CP1252 ł͕ϊG[͔Ȃ
										j = cp_to_utf16(ascii_buf, uni_buf, 1252);
										if (j == 0){
											k = convert_filename(1252, used_CP, files);	// ܂ł̃t@CϊȂ
											if (k != 0){
												printf("convert_filename\n");
												return 1;
											}
										}
										used_CP = 1252;	// ȍ~̃t@C Latin-1 CP1252 Ƃ݂Ȃ
									}
								} else if (check_utf8(ascii_buf) != 0){	// UTF-8 ȊO݂̕
									used_CP = CP_ACP;	// ȍ~̃t@C͑S UTF-8 ȊOƂ݂Ȃ
									// ACP ŕϊł邩ׂ
									j = cp_to_utf16(ascii_buf, uni_buf, used_CP);
									if (j == ERROR_NO_UNICODE_TRANSLATION){	// CP1252 ł͕ϊG[͔Ȃ
										j = cp_to_utf16(ascii_buf, uni_buf, 1252);
										used_CP = 1252;	// ȍ~̃t@C Latin-1 CP1252 Ƃ݂Ȃ
									}
									if (j == 0){
										k = convert_filename(used_CP, CP_UTF8, files);	// ܂ł̃t@CϊȂ
										if (k == 1){	// CP1252 ł͕ϊG[͔Ȃ
											j = cp_to_utf16(ascii_buf, uni_buf, 1252);
											k = convert_filename(1252, CP_UTF8, files);
											used_CP = 1252;	// ȍ~̃t@C Latin-1 CP1252 Ƃ݂Ȃ
										}
										if (k != 0){
											printf("convert_filename\n");
											return 1;
										}
									}
								} else {
									utf8_to_utf16(ascii_buf, uni_buf);
									j = 0;
								}
								if (j == 0){
									files[i].name = list_len;
									if (add_file_path(uni_buf)){
										printf("add_file_path\n");
										return 1;
									}
								} else {
									files[i].name = 0;	// pPbg݂͑邯ǃt@C̕ϊɎs
								}
								find_num++;	// S File Description packet ̐
							}
						} else if ((par_client[0] == 0) && (memcmp(buf + (off + 48), "PAR 2.0\0Creator\0", 16) == 0)){
							// Creater packet
							i = packet_size - 64;	// Creater ̃oCg
							if (i >= COMMENT_LEN)
								i = COMMENT_LEN - 1;
							memcpy(par_client, buf + (off + 64), i);
							par_client[i] = 0;	//  null ɂ
						} else if ((par_comment[0] == 0) && (ascii_comment[0] == 0) && (memcmp(buf + (off + 48), "PAR 2.0\0CommASCI", 16) == 0)){
							// ASCII Comment packet
							i = packet_size - 64;	// Rg̃oCg
							if (i >= COMMENT_LEN)
								i = COMMENT_LEN - 1;
							memcpy(ascii_comment, buf + (off + 64), i);
							ascii_comment[i] = 0;	//  null ɂ
						} else if ((par_comment[0] == 0) && (memcmp(buf + (off + 48), "PAR 2.0\0CommUni\0", 16) == 0)){
							// Unicode Comment packet
							i = packet_size - 80;	// Rg̃oCg
							if (i >= COMMENT_LEN * 2)
								i = COMMENT_LEN * 2 - 2;
							memcpy(par_comment, buf + (off + 80), i);
							par_comment[i / 2] = 0;	//  null ɂ
						} else if ((memcmp(buf + (off + 48), "PAR 2.0\0UniFileN", 16) == 0) && (packet_size - 80 < MAX_LEN * 2)){
							// Unicode Filename packet
							memset(uni_buf, 0, sizeof(uni_buf));
							memcpy(uni_buf, buf + (off + 80), packet_size - 80);
							for (i = 0; i < file_num; i++){
								if (memcmp(buf + (off + 64), files[i].id, 16) == 0)	// File ID v
									break;
							}
							if (i < file_num){	// File Description packet ɓǂݍłԂłFȂ
								if (files[i].name == 0){	// pPbg݂͑邯ǃt@C̕ϊɎsĂꍇ
									// Vt@C
									files[i].name = list_len;
									if (add_file_path(uni_buf)){
										printf("add_file_path\n");
										return 1;
									}
								} else if ((files[i].name > 0) && (wcscmp(uni_buf, list_buf + files[i].name) != 0)){
									// pPbg݂ăt@C擾Ă邯ǃjR[hłƂ͈قȂꍇ
									k = (int)wcslen(list_buf + files[i].name);
									list_len = remove_file_path(list_buf, list_len, files[i].name);
									for (j = 0; j < file_num; j++){
										if (files[j].name > files[i].name)
											files[j].name -= (k + 1);	// XgŌ̂炵Ă
									}
									// Vt@C
									files[i].name = list_len;
									if (add_file_path(uni_buf)){
										printf("add_file_path\n");
										return 1;
									}
								}
							}
						}
						off += packet_size;	// pPbg̏I[܂ňCɔ
					} else {
						off += 8;
					}
				} else {
					off++;
				}
			}
			// SẴt@C擾Ă܂Δ
			if ((find_num >= file_num) && (par_client[0] != 0))
				break;

			if (file_next < file_size){	// t@CEf[^܂cĂ
				if (file_next > file_off + SEARCH_SIZE * 3){	// ̓ǂݍ݈ʒuO SEARCH_SIZE * 3 ȏ㗣ĂȂ
					file_off = file_next;
					// ǂݎTCY͍ő SEARCH_SIZE * 3
					off = 0;
					len = SEARCH_SIZE * 3;
					if (file_size < file_next + SEARCH_SIZE * 3)
						len = (unsigned int)(file_size - file_next);
					// ő SEARCH_SIZE * 3 ǂݍŃobt@[̐擪ɓ
					if (file_read_data(hFile, file_next, buf, len)){
						off = len;		// ǂݍݎɃG[͌Ȃ
						file_next = file_size;	// ͓ǂݍ܂Ãt@ČI
					}
					file_next += len;	// ̓ǂݍ݊Jnʒu
					max = len;
					if (len > SEARCH_SIZE)
						max = SEARCH_SIZE;
				} else {	//  SEARCH_SIZE ǂݍ
					// obt@[̓eOɂ炷
					memcpy(buf, buf + SEARCH_SIZE, SEARCH_SIZE);
					memcpy(buf + SEARCH_SIZE, buf + SEARCH_SIZE * 2, SEARCH_SIZE);
					file_off += SEARCH_SIZE;
					// ǂݎTCY͍ő SEARCH_SIZE
					off -= max;
					len = SEARCH_SIZE;
					if (file_size < file_next + SEARCH_SIZE)
						len = (unsigned int)(file_size - file_next);
					// ő SEARCH_SIZE ǂݍŃobt@[̖ɓ
					if (file_read_data(hFile, file_next, buf + SEARCH_SIZE * 2, len)){
						memset(buf + SEARCH_SIZE * 2, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
						file_next = file_size;	// ͓ǂݍ܂Ãt@ČI
					}
					file_next += len;	// ̓ǂݍ݊Jnʒu
					max = SEARCH_SIZE;
					len += SEARCH_SIZE * 2;	// f[^̃TCYɎcĂ SEARCH_SIZE * 2 𑫂
				}
			} else {	// obt@[̎cf[^
				off -= max;
				len -= max;
				if (len > 0){
					if (len > SEARCH_SIZE){
						max = SEARCH_SIZE;
						memcpy(buf, buf + SEARCH_SIZE, SEARCH_SIZE);
						memcpy(buf + SEARCH_SIZE, buf + SEARCH_SIZE * 2, len - SEARCH_SIZE);
					} else {
						max = len;
						memcpy(buf, buf + SEARCH_SIZE, len);	// obt@[̓eOɂ炷
					}
					file_off += SEARCH_SIZE;
				}
			}

			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress((int)(((end_size + file_off) * 1000) / total_file_size))){
					CloseHandle(hFile);
					return 2;
				}
				time_last = GetTickCount();
			}
		}
		CloseHandle(hFile);
		end_size += file_size;

		// SẴt@C擾Ă܂Δ
		if ((find_num >= file_num) && (par_client[0] != 0))
			break;
	}

	// QuickPar  phpar2 ̓t@C UTF-8 ŋL^ȂƂ킩Ă
	if ((used_CP == CP_UTF8) && (par_client[0] != 0) && (non_utf8_client(par_client) != 0)){
		k = convert_filename(CP_ACP, CP_UTF8, files);	// ܂ł̃t@CϊȂ
		if (k == 1){
			used_CP = 1252;	// Latin-1 CP1252 ŕϊ݂
			k = convert_filename(1252, CP_UTF8, files);
		}
		if (k != 0){
			printf("convert_filename\n");
			return 1;
		}
	}

	// 쐬NCAgƃRg\
	if (par_client[0] != 0){
		for (i = 0; i < COMMENT_LEN; i++){	// \O sanitalize 
			if (par_client[i] == 0){
				break;
			} else if ((par_client[i] <= 31) || (par_client[i] >= 127)){	// 䕶A ASCII 
				par_client[i] = ' ';
			}
		}
		printf("Creator : %s\n", par_client);
	}
	if ((par_comment[0] == 0) && (ascii_comment[0] != 0)){	// jR[h̃RgD悷
		if (!MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, ascii_comment, -1, par_comment, COMMENT_LEN))
			par_comment[0] = 0;
	}
	if (par_comment[0] != 0){
		for (i = 0; i < COMMENT_LEN; i++){	// \O sanitalize 
			if (par_comment[i] == 0){
				break;
			} else if ((par_comment[i] <= 31) || (par_comment[i] == 127)){	// 䕶
				par_comment[i] = ' ';
			}
		}
		if (!utf16_to_cp(par_comment, ascii_buf, cp_output))
			printf("Comment : %s\n", ascii_buf);
	}
	write_ini_file2(par_client, par_comment);

	// Xg̃t@CāA肪Ώ򉻂
	// łɃfBNgLu\vɓꂷ
	if (switch_v & 32){
		max = 0;
		for (i = 0; i < file_num; i++){
			if (files[i].name <= 0)
				continue;	// t@C擾łȂt@C͂Ƃ΂
			wcscpy(uni_buf, list_buf + files[i].name);
			off = sanitize_filename(uni_buf, files, i);
			if (off != 0){
				if (off == 1){	// fBNgL܂ł
					wcscpy(list_buf + files[i].name, uni_buf);
				} else {
					if (max == 0){
						max = 1;
						printf("\nchecking filename...\n");
					}
					if (off == 16){
						max++;
						printf("file %d: filename is invalid\n", i);
					} else {
						utf16_to_cp(uni_buf, ascii_buf, cp_output);
						printf("file %d: sanitized to \"%s\"\n", i, ascii_buf);
						if (off & 4){	// ς
							k = (int)wcslen(list_buf + files[i].name);
							list_len = remove_file_path(list_buf, list_len, files[i].name);
							for (j = 0; j < file_num; j++){
								if (files[j].name > files[i].name)
									files[j].name -= (k + 1);	// XgŌ̂炵Ă
							}
							// Vt@C
							files[i].name = list_len;
							if (add_file_path(uni_buf)){
								printf("add_file_path\n");
								return 1;
							}
						} else {	// Ȃ猳̏ꏊɃRs[
							wcscpy(list_buf + files[i].name, uni_buf);
						}
					}
				}
			}
		}
		if (max > 1)
			return 1;
	}

	return 0;
}

// Cp̃pPbgT
// 0~= sSȃJoEt@C̐ԂA-2=Cansel
int search_recovery_packet(
	char *ascii_buf,
	unsigned char *buf,		// ƃobt@[
	wchar_t *file_path,
	unsigned char *set_id,	// Recovery Set ID m߂
	HANDLE *rcv_hFile,		// eJoEt@C̃nh (verify Ȃ NULL)
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	parity_ctx_r *p_blk)	// epeBEubN̏
{
	unsigned char hash[16];
	int i, j, recv_off, num, packet_count, bad_flag, file_block;
	int find_num, find_new, recovery_lost;
	int len, off, max;
	unsigned int packet_size, time_last, meta_data[7];
	__int64 file_size, file_off, file_next;
	HANDLE hFile;

	printf("\nLoading PAR File       :\n");
	printf(" Packet Slice Status   :  Filename\n");
	fflush(stdout);
	count_last = 0;
	recovery_lost = 0;	// sSȃJoEt@C̐
	first_num = 0;	// ߂ČpeBEubN̐
	num = 0;
	recv_off = 0;
	while (recv_off < recv_len){
		if (cancel_progress() != 0)	// LZ
			return -2;

		//utf16_to_cp(recv_buf + recv_off, ascii_buf, cp_output);
		//printf("verifying %s\n", ascii_buf);
		// JoEt@CJ
		hFile = CreateFile(recv_buf + recv_off, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE){
			i = -1;
		} else {
			// 郊JoEt@Cł΁AČKv͖
			i = check_ini_recovery(hFile, meta_data);
		}
		if (i < 0){	// G[玟̃JoEt@C𒲂ׂ
			while (recv_buf[recv_off] != 0)	// ̃t@C̈ʒuɂ炷
				recv_off++;
			recv_off++;
			continue;
		}
		if (i == 0){
			memcpy(&file_size, meta_data, 8);
			find_num = 0;
			find_new = 0;
			file_off = 0;
			prog_last = -1;
			time_last = GetTickCount();

			// ŏ̓t@C̐擪 SEARCH_SIZE * 3 ǂݍ
			bad_flag = 0;
			off = 0;
			len = SEARCH_SIZE * 3;
			if (file_size < SEARCH_SIZE * 3)
				len = (unsigned int)file_size;
			if (file_size < MIN_PACKET_SIZE){	// t@C͌Ȃ
				bad_flag |= 1;
				len = 0;
			}
			// ő SEARCH_SIZE * 3 ǂݍŃobt@[̐擪ɓ
			if (file_read_data(hFile, 0, buf, len)){
				off = len;		// ǂݍݎɃG[͌Ȃ
				bad_flag |= 128;
				file_next = file_size;	// ͓ǂݍ܂Ãt@ČI
			} else {
				file_next = len;	// ̓ǂݍ݊Jnʒu
			}
			max = len;
			if (len > SEARCH_SIZE)
				max = SEARCH_SIZE;
			//printf("file_size = %I64d, max = %d, off = %d, len = %d\n", file_size, max, off, len);

			// pPbgT
			packet_count = 0;
			while (len > 0){
				while (off < max){
					if (match_magic(buf + off) == 0){
						memcpy(&packet_size, buf + (off + 12), 4);	// pPbgETCY̏4oCg0ȊOƂ
						if (packet_size != 0){
							bad_flag |= 1;
							off += 8;
							continue;
						}
						memcpy(&packet_size, buf + (off + 8), 4);	// pPbgETCYm߂
						if ((packet_size & 3) || (packet_size < MIN_PACKET_SIZE) || (file_off + (__int64)off + (__int64)packet_size > file_size)){
							bad_flag |= 1;
							off += 8;
							continue;
						}
						if (off + packet_size > SEARCH_SIZE * 3){	// 傫ăobt@[Ɏ܂ĂȂȂ
							if (packet_size > 64 + 4 + block_size){	// Recovery Slice packet 傫pPbg͖͂
								off += 8;
								continue;
							}
							// pPbgjĂȂ𒲂ׂ
							if (file_md5(hFile, file_off + off + 32, packet_size - 32, hash)){
								off += 8;	// vZłȂ
							} else {
								if (memcmp(buf + (off + 16), hash, 16) == 0){	// SȃpPbg
									if (memcmp(buf + (off + 32), set_id, 16) == 0){	// Recovery Set ID Ȃ
										// ȂƂpPbg̐擪 SEARCH_SIZE * 2 ܂ł̓obt@[ɑ݂
										// obt@[Ɏ܂ȂpPbg Recovery Slice packet ̂͂
										if (memcmp(buf + (off + 48), "PAR 2.0\0RecvSlic", 16) == 0){
											// Recovery Slice packet
											memcpy(&j, buf + (off + 64), 4);	// peBEubN̔ԍ
											j &= 0xFFFF;	// ԍ 16-bit (65536ȏ 0`65535 ̌JԂ)
											if (j == 65535)	// (0  65535 ͓)
												j = 0;
											if (j < parity_num){
												if (p_blk[j].exist == 0){
													find_new++;	// JoEt@C̐VpeBEubN̐
													first_num++;
													p_blk[j].exist = 1;
													p_blk[j].file = num;
													p_blk[j].off = file_off + off + 68;
												}
												write_ini_recovery(j, file_off + off + 68);
												find_num++;	// JoEt@C̃peBEubN̐
											}
										}
										packet_count++;
									} else {
										bad_flag |= 2;	// ʂ Set ID Ă
									}
									// obt@[̃ItZbgƃpPbgETCY炷
									if (file_next < file_size)
										file_next = file_off + off + packet_size;
									off = max;	// Cɖ܂ł
								} else {
									off += 8;	// jpPbgȂ
								}
							}
							continue;
						}
						// pPbgjĂȂ𒲂ׂ
						data_md5(buf + (off + 32), (packet_size - 32), hash);
						if (memcmp(buf + (off + 16), hash, 16) == 0){	// SȃpPbg
							if (memcmp(buf + (off + 32), set_id, 16) != 0){	// Recovery Set ID pPbg
								bad_flag |= 2;	// ʂ Set ID Ă
								off += packet_size;
								continue;
							}
/*
memset(ascii_buf, 0, 9);
memcpy(ascii_buf, buf + (off + 56), 8);
printf(" packet : %s, size = %u, file_off = %I64d, off = %d\n", ascii_buf, packet_size, file_off, off);
*/
							if (memcmp(buf + (off + 48), "PAR 2.0\0IFSC\0\0\0\0", 16) == 0){
								// Input File Slice Checksum packet
								for (j = 0; j < entity_num; j++){
									if (memcmp(buf + (off + 64), files[j].id, 16) == 0){	// File ID v
										if (files[j].state & 0x80)	// `FbNTV̂Ȃ
											break;
									}
								}
								file_block = files[j].b_num;	// \[XEubN̐
								if ((j < entity_num) && ((int)((packet_size - 80) / 20) == file_block)){
									files[j].state = 0;	// ̃t@C̃`FbNT
									for (i = 0; i < file_block; i++){
										memcpy(s_blk[files[j].b_off + i].hash, buf + (off + 80 + (20 * i)), 20);
										memcpy(&(s_blk[files[j].b_off + i].crc), buf + (off + 80 + (20 * i) + 16), 4);
										s_blk[files[j].b_off + i].crc ^= window_mask;	// CRC ̏lƍŏI 0xFFFFFFFF 菜
									}
								}
							} else if (memcmp(buf + (off + 48), "PAR 2.0\0RecvSlic", 16) == 0){
								// Recovery Slice packet
								memcpy(&j, buf + (off + 64), 4);	// peBEubN̔ԍ
								j &= 0xFFFF;	// ԍ 16-bit (65536ȏ 0`65535 ̌JԂ)
								if (j == 65535)	// (0  65535 ͓)
									j = 0;
								if ((packet_size == 64 + 4 + block_size) && (j < parity_num)){
									if (p_blk[j].exist == 0){
										find_new++;	// JoEt@C̐VpeBEubN̐
										first_num++;
										p_blk[j].exist = 1;
										p_blk[j].file = num;
										p_blk[j].off = file_off + off + 68;
									}
									write_ini_recovery(j, file_off + off + 68);
									find_num++;	// JoEt@C̃peBEubN̐
								}
							}
							packet_count++;
							off += packet_size;	// pPbg̏I[܂ňCɔ
						} else {
							bad_flag |= 1;
							off += 8;
						}
					} else {
						bad_flag |= 1;
						off++;
					}
				}

				if (file_next < file_size){	// t@CEf[^܂cĂ
					if (file_next > file_off + SEARCH_SIZE * 3){	// ̓ǂݍ݈ʒuO SEARCH_SIZE * 3 ȏ㗣ĂȂ
						file_off = file_next;
						// ǂݎTCY͍ő SEARCH_SIZE * 3
						off = 0;
						len = SEARCH_SIZE * 3;
						if (file_size < file_next + SEARCH_SIZE * 3)
							len = (unsigned int)(file_size - file_next);
						// ő SEARCH_SIZE * 3 ǂݍŃobt@[̐擪ɓ
						if (file_read_data(hFile, file_next, buf, len)){
							off = len;		// ǂݍݎɃG[͌Ȃ
							bad_flag |= 128;
							file_next = file_size;	// ͓ǂݍ܂Ãt@ČI
						}
						file_next += len;	// ̓ǂݍ݊Jnʒu
						max = len;
						if (len > SEARCH_SIZE)
							max = SEARCH_SIZE;
					} else {	//  SEARCH_SIZE ǂݍ
						// obt@[̓eOɂ炷
						memcpy(buf, buf + SEARCH_SIZE, SEARCH_SIZE);
						memcpy(buf + SEARCH_SIZE, buf + SEARCH_SIZE * 2, SEARCH_SIZE);
						file_off += SEARCH_SIZE;
						// ǂݎTCY͍ő SEARCH_SIZE
						off -= max;
						len = SEARCH_SIZE;
						if (file_size < file_next + SEARCH_SIZE)
							len = (unsigned int)(file_size - file_next);
						// ő SEARCH_SIZE ǂݍŃobt@[̖ SEARCH_SIZE ɓ
						if (file_read_data(hFile, file_next, buf + SEARCH_SIZE * 2, len)){
							memset(buf + SEARCH_SIZE * 2, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
							bad_flag |= 128;
							file_next = file_size;	// ͓ǂݍ܂Ãt@ČI
						}
						file_next += len;	// ̓ǂݍ݊Jnʒu
						max = SEARCH_SIZE;
						len += SEARCH_SIZE * 2;	// f[^̃TCYɎcĂ SEARCH_SIZE * 2 𑫂
					}
				} else {	// obt@[̎cf[^
					//printf("max = %d, off = %d, len = %d\n", max, off, len);
					off -= max;
					len -= max;
					if (len > 0){
						if (len > SEARCH_SIZE){
							max = SEARCH_SIZE;
							memcpy(buf, buf + SEARCH_SIZE, SEARCH_SIZE);
							memcpy(buf + SEARCH_SIZE, buf + SEARCH_SIZE * 2, len - SEARCH_SIZE);
						} else {
							max = len;
							memcpy(buf, buf + SEARCH_SIZE, len);	// obt@[̓eOɂ炷
						}
						file_off += SEARCH_SIZE;
					}
				}

				// oߕ\
				if (GetTickCount() - time_last >= UPDATE_TIME){
					if (print_progress_file((int)((file_off * 1000) / file_size), first_num, recv_buf + recv_off)){
						CloseHandle(hFile);
						write_ini_recovery2(-1, 0, 0, meta_data);
						return -2;
					}
					time_last = GetTickCount();
				}
			}
			write_ini_recovery2(packet_count, find_num, bad_flag, meta_data);
		} else {	// ς݂ȂL^ǂݍ
			find_new = read_ini_recovery(num, &packet_count, &find_num, &bad_flag, p_blk);
			if (find_new < 0){
				bad_flag = 1;
				packet_count = 0;
				find_num = 0;
			} else {
				first_num += find_new;	// VɔpeBEubN̐v
			}
		}
		print_progress_file(-1, first_num, NULL);	// dOvubN\
		if ((find_new > 0) && (rcv_hFile != NULL)){
			rcv_hFile[num] = hFile;	// ォǂݍ߂悤ɊJ܂܂ɂ
		} else {
			CloseHandle(hFile);
		}

		// JoEt@C̖O
		if (compare_directory(recovery_file, recv_buf + recv_off) == 0){	// ꏊȂ
			utf16_to_cp(offset_file_name(recv_buf + recv_off), ascii_buf, cp_output);	// t@Cɂ
		} else {
			path_to_cp(recv_buf + recv_off, ascii_buf, cp_output);	// pX\
		}
		if (bad_flag == 0){
			// ǍD (pPbgPʂȂ̂ŊSɌƓ͔ʂłȂ)
			printf("%7d %5d Good     : \"%s\"\n", packet_count, find_num, ascii_buf);
			// ̃t@C̈ʒuɂ炷
			while (recv_buf[recv_off] != 0)
				recv_off++;
			recv_off++;
		} else if (packet_count == 0){
			// pPbgSȂ (JoEt@Cł͂Ȃ)
			// ʂ Set ID ̃JoEt@C܂
			printf("      0     0 Useless  : \"%s\"\n", ascii_buf);
			if (bad_flag == 2){	// ʂ Set ID ̃JoEt@CŗǍDȂ
				// ̃t@C̈ʒuɂ炷
				while (recv_buf[recv_off] != 0)
					recv_off++;
				recv_off++;
			} else {	// JoEt@CłȂ΃Xg菜 (t@C͂̂܂)
				recv_len = remove_file_path(recv_buf, recv_len, recv_off);
			}
			recovery_lost++;
		} else {
			printf("%7d %5d Damaged  : \"%s\"\n", packet_count, find_num, ascii_buf);
			// jJoEt@C̓Xg菜 (t@C͂̂܂)
			recv_len = remove_file_path(recv_buf, recv_len, recv_off);
			recovery_lost++;
		}
		fflush(stdout);
		num++;	// ̃t@C
	}
/*{
FILE *fp;
fp = fopen("par_list2.txt", "wb");
fwrite(recv_buf, 2, recv_len, fp);
fclose(fp);
}*/

	return recovery_lost;
}

