// verify.c
// Copyright : 2018-12-12 Yutaka Sawada
// License : GPL

#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <process.h>
#include <stdio.h>

#include <windows.h>

#include "common2.h"
#include "crc.h"
#include "md5_crc.h"
#include "ini.h"
#include "verify.h"


// ꂽt@CׂɃt@Cw肷
static void set_splited_filename(
	wchar_t *find_name,		// *filename* ̃tEpX
	wchar_t *file_name,		// {̃t@C filename.ext ܂ filename
	int dir_len)			// tEpXɂfBNg̒
{
	wchar_t *tmp_p;

	wcscpy(find_name, base_dir);
	if (dir_len > base_len){	// TuEfBNgLꍇ
		wcscpy(find_name + base_len, file_name);
		find_name[dir_len] = '*';
		wcscpy(find_name + dir_len + 1, file_name + (dir_len - base_len));
	} else {	// TuEfBNgꍇ
		find_name[base_len] = '*';
		wcscpy(find_name + base_len + 1, file_name);
	}
	tmp_p = wcsrchr(find_name + dir_len + 2, '.');	// fBNgƐ擪́u.v͖
	if (tmp_p != NULL){
		if (wcslen(tmp_p) < EXT_LEN){	// gq菜āu*vɊ
			*tmp_p = '*';
			tmp_p++;
			*tmp_p = 0;
			return;
		}
	}
	wcscat(find_name, L"*");
}

// t@C̃t@CׂɃt@Cw肷
static int set_similar_filename(
	wchar_t *find_name,		// file*name.ext ̃tEpX
	wchar_t *file_name,		// {̃t@C fileHname.ext
	int dir_len)			// tEpXɂfBNg̒
{
	int i, len, count, ext_len;

	wcscpy(find_name, base_dir);
	wcscpy(find_name + base_len, file_name);

	// t@C non-ASCII ̐
	count = 0;
	i = 0;
	ext_len = -1;
	len = dir_len;	// fBNg͍̕lȂ
	while (find_name[len] != 0){
		if (find_name[len] >= 0x7F){
			count++;	// non-ASCII ̐
		} else {
			i++;	// ASCII ̐
			if (find_name[len] == '.')
				ext_len = len;	// gq̈ʒu
		}
		len++;
	}
	ext_len = len - ext_len;	// gq܂܂Ȃꍇ͌̕𒴂
	//printf("non = %d, ascii = %d, ext = %d\n", count, i, ext_len);

	// non-ASCII ܂܂Ȃꍇ͒TȂ
	// gqȊO ASCII ܂܂ȂA܂ ASCII ȂATȂ
	if ((count == 0) || (i == ext_len) || (i < count))
		return 0;

	// non-ASCII u*vɒu
	count = dir_len;
	while (count < len){
		if (find_name[count] >= 0x80){
			if ((count > 0) && (find_name[count - 1] == '*')){	// ̕u*vȂ
				// ȍ~Oɂ炷
				for (i = count; i < len; i++)
					find_name[i] = find_name[i + 1];
				len--;
				count--;
			} else {
				find_name[count] = '*';
			}
		}
		count++;
	}

	return 1;
}

// tĂ镔t@CƂđÓׂ
static int check_extra_part(
	wchar_t *find_name,		// oꂽt@C
	wchar_t *file_name,		// {̃t@C
	int len)				// {̃t@C̕
{
	int num = (int)wcslen(find_name);
	if (_wcsnicmp(find_name, file_name, len) == 0){	// ɕtĂ
		// ǉꂽ̐擪u.vu_vȊOȂ疳
		if ((find_name[len] != '.') && (find_name[len] != '_'))
			return 1;

		// ǉꂽlȊOȂ疳
		num = 0;
		len++;
		while (find_name[len] != 0){
			if ((find_name[len] < '0') || (find_name[len] > '9'))
				return 1;
			num = (num * 10) + (find_name[len] - '0');	// ԍǂݎ
			len++;
		}
		if ((num > 99999) || (num < 0))
			return 1;	// t@C͈̔͊OȂ疳
		return 0;

	} else if ((num > len) && (_wcsnicmp(find_name + (num - len), file_name, len) == 0)){	// 擪ɕtĂ
		if (num >= len + EXT_LEN)
			return 1;	// ǉꂽ
		// t@C̕sv̍Ōオu_vȊOȂ疳
		if (find_name[num - len - 1] != '_')
			return 1;
		return 0;

	} else {	// ȊȌꍇ
		wchar_t name_part[MAX_LEN], ext_part[EXT_LEN], file_ext[EXT_LEN], *tmp_p;

		wcscpy(name_part, find_name);
		ext_part[0] = 0;
		tmp_p = wcsrchr(name_part, '.');
		if (tmp_p != NULL){
			if (wcslen(tmp_p) < EXT_LEN){
				wcscpy(ext_part, tmp_p);	// gqL^Ă
				*tmp_p = 0;	// gq菜
			}
		}
		file_ext[0] = 0;
		tmp_p = wcsrchr(file_name, '.');
		if (tmp_p != NULL){
			if (wcslen(tmp_p) < EXT_LEN)
				wcscpy(file_ext, tmp_p);	// gqL^Ă
		}
		len -= (int)wcslen(file_ext);	// {̃t@C̒Agq̒
		//printf("name length = %d \n", len);

		// gqvȂA܂͒ǉꂽgqlȊȌꍇ͖
		if (_wcsicmp(file_ext, ext_part) != 0){
			if (ext_part[0] == 0)
				return 1;	// gqΑʖ

			// gqlȊOȂ疳
			num = 0;
			tmp_p = ext_part + 1;
			while (*tmp_p != 0){
				if ((*tmp_p < '0') || (*tmp_p > '9'))
					return 1;
				num = (num * 10) + (*tmp_p - '0');	// ԍǂݎ
				tmp_p++;
			}
			if ((num > 99999) || (num < 0))
				return 1;	// t@C͈̔͊OȂ疳

			// gqɂȂĂAȊOSɈv΋e
			if ((name_part[len] == 0) && (_wcsnicmp(find_name, file_name, len) == 0))
				return 0;

			// XɑO̊gq{
			tmp_p = wcsrchr(name_part, '.');
			if (tmp_p != NULL){
				if (wcslen(tmp_p) < EXT_LEN){
					wcscpy(ext_part, tmp_p);	// gqL^Ă
					*tmp_p = 0;	// gq菜
				}
			} else {
				return 1;
			}
			if (_wcsicmp(file_ext, ext_part) != 0)
				return 1;	// vȂΑʖ
		}

		// t@Cǂ܂ňv邩ׂ
		if (_wcsnicmp(find_name, file_name, len) == 0){	// gqƂ̊ԂɂtĂ
			// t@C̕sv̍ŏu.vƁu_vȊOȂ疳
			if ((name_part[len] != '.') && (name_part[len] != '_'))
				return 1;
			// t@C̕sv̍ŏȍ~Ɂu.v܂ނȂ疳
			if (wcschr(name_part + (len + 1), '.') != NULL)
				return 1;

			// gqƕtƂlȂAւ̒ǉƔ肷
			len++;
			while (name_part[len] != 0){
				if ((name_part[len] < '0') || (name_part[len] > '9')){
					len = 0;
					break;
				}
				len++;
			}
			if (len > 0){	// tl̂
				len = 1;
				while (file_ext[len] != 0){
					if ((file_ext[len] < '0') || (file_ext[len] > '9')){
						len = 0;
						break;
					}
					len++;
				}
				if (len > 0)	// gql̂
					return 1;
			}
			return 0;

		} else {	// ӏɕtĂ
			wchar_t name_lower[MAX_LEN];
			int i, j;
			// rpɏɂ
			wcscpy(name_lower, file_name);
			_wcslwr(name_lower);
			if (file_ext[0] != 0)
				wcscat(name_part, file_ext);	// gq߂
			_wcslwr(name_part);
			// ǂ̂炢v邩𒲂ׂ
			num = 0;
			i = 0;
			j = 0;
			while ((name_part[i] != 0) && (name_lower[j] != 0)){
				if (name_part[i] == name_lower[j]){
					num++;
					i++;
					j++;
				} else if (name_lower[j] >= 0x7F){	// {̃t@C non-ASCII ΂Ƃ΂
					j++;
				} else {
					i++;
				}
			}
			//printf("match = %d, i = %d, j = %d\n", num, i, j);
			if ((num * 2 < i) || (num * 2 < j))
				return 1;	// vȂƑʖ
			return 0;
		}
	}
}

// j\[XEt@C̍ƃt@C𖳎
static int avoid_temp_file(
	wchar_t *comp_path,		// rt@C̃pX
	file_ctx_r *files)		// e\[XEt@C̏
{
	int i, len, len2;

	len2 = (int)wcslen(comp_path);
	// ƃt@C̖͌܂Ă wcslen(L"_par.tmp") = 8
	if (len2 <= 8)
		return 0;
	if (wcscmp(comp_path + (len2 - 8), L"_par.tmp") != 0)
		return 0;

	// \[XEt@CƂɔr
	for (i = 0; i < entity_num; i++){
		// ̃t@CtH_͍ƃt@C݂Ȃ
		if (files[i].size == 0)
			continue;
		// SEǉEʖEړ̃t@C͍ƃt@C݂Ȃ
		if ((files[i].state & 7) == 0)
			continue;

		len = (int)wcslen(list_buf + files[i].name);
		if ((len2 == len + 8) && (_wcsnicmp(list_buf + files[i].name, comp_path, len) == 0))
			return 1;	// ƃt@C
	}
	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// 񕪒T@ēL[ɑΉ
static int binary_search(
	int *order,			// z
	int high,			// z̗vf = T͈͂̏vf +1
	unsigned int key,	// ړI̒l
	source_ctx_r *s_blk)
{
	int mid, low = 0;	// T͈͂̉vf

	while (low < high){
		mid = (low + high) >> 1;	// z̒ʒuvZ
		if (s_blk[order[mid]].crc > key){			// ړI̒l̕
			high = mid;		// ʒuύX
		} else if (s_blk[order[mid]].crc < key){	// ړI̒l̕傫
			low = mid + 1;	// ʒuύX
		} else {	// ړI̒lƈv
			//  key ̃ubN݂邩Ȃ̂
			while ((mid > low) && (s_blk[order[mid - 1]].crc == key))
				mid--;
			return mid;
		}
	}

	return 0x00FFFFFF;	// Ȃ
}

// Richard Newcombe ɂǌ^̃NCbN\[g
static void quick_sort(
	int *order,
	int left,
	int right,
	source_ctx_r *s_blk)
{
	int loop1, loop2, part;

	while (right > left){
		loop1 = left;
		loop2 = right;
		part = order[left];
		while (loop1 < loop2){
			while (s_blk[order[loop2]].crc > s_blk[part].crc)
				loop2--;
			order[loop1] = order[loop2];
			while ((loop1 < loop2) && (s_blk[order[loop1]].crc <= s_blk[part].crc))
				loop1++;
			order[loop2] = order[loop1];
		}
		order[loop1] = part;
		quick_sort(order, left, loop1 - 1, s_blk);
		left = loop1 + 1;
	}
}

// 񕪒T@ĈvȂꍇ high Ԃ
static int binary_search_high(
	unsigned int *keys,	// z
	int low,			// T͈͂̉vf
	int high,			// z̗vfAT͈͂̏vf+1
	unsigned int key)	// ړI̒l
{
	int mid;

	while (low < high){		// ʒu̕ʒu𒴂AړI̒l݂͑Ȃ
		mid = (low + high) >> 1;	// z̒ʒuvZ
		if (keys[mid] > key){			// ړI̒l̕
			high = mid;		// ʒuύX
		} else if (keys[mid] < key){	// ړI̒l̕傫
			low = mid + 1;	// ʒuύX
		} else {						// ړI̒lƈv
			//  key ̃ubN݂邩Ȃ̂
			while ((mid > low) && (keys[mid - 1] == key))
				mid--;
			return mid;
		}
	}

	return high;	// Ȃꍇ́Aɑ傫ʒuԂ
}

// \[gꂽf[^ɑ΂ĈԊuƂɃCfbNXB
// ړI̒l -> CfbNXŒO̒l -> `T ňv邩ǂ
static void init_index_search(
	unsigned int *keys,	// f[^̔z
	int data_count,		// f[^
	int *index,			// ڎ
	int index_bit)		// ڎ̑傫A(32-bitl >> shift) = ڎ̍
{
	int i, off = 0;

	for (i = 0; i < (1 << index_bit); i++){
		off = binary_search_high(keys, off, data_count, i << (32 - index_bit));
		index[i] = off;
	}
}

// ڎ̑傫ɂĒTxςB
static int index_search(
	unsigned int *keys,	// z
	int data_count,		// z̗vf = T͈͂̏vf +1
	unsigned int key,	// ړI̒l
	int *index,			// ڎ
	int index_shift)	// (32-bitl >> shift) = ڎ̍
{
	int i;

	i = index[key >> index_shift];	// ẑǂɂ邩
	// jAET[`Ŏc肩T
	while (i < data_count){
		if (keys[i] > key)
			return 0x00FFFFFF;	// ȂړI̒l݂͑Ȃ
		if (keys[i] == key)
			return i;
		i++;
	}
	return 0x00FFFFFF;	// Ȃ
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// ǂݍݗp̃TuEXbh
static DWORD WINAPI thread_read(LPVOID lpParameter)
{
	unsigned char *buf;
	unsigned int rv;
	slice_ctx *sc;

	sc = (slice_ctx *)lpParameter;
	buf = sc->buf + (block_size * 2);

	WaitForSingleObject(sc->run, INFINITE);	// ǂݍ݊Jn̍}҂
	while (sc->size){	// ǂ݂݃G[Ă[v甲Ȃ
		// t@Cǂݍ
		if (!ReadFile(sc->hFile, buf, sc->size, &rv, NULL)){
			print_win32_err();	// 0x17 = ERROR_CRC, 0x21 = ERROR_LOCK_VIOLATION
			//memset(buf, 0, sc->size);	// ǂݍݎɃG[ 0 ɂĂ
			sc->size = 0xFFFFFFFF;	// ȏ̌𒆎~
		} else if (sc->size < rv){
			memset(buf + rv, 0, sc->size - rv);	// wTCYǂݍ߂Ȃ 0 ɂĂ
			// G[ł͂ȂĤős
		}
		_mm_sfence();	// [ւ݂̏
		SetEvent(sc->end);	// ǂݍݏIʒm
		WaitForSingleObject(sc->run, INFINITE);	// ǂݍ݊Jn̍}҂
	}

	// I
	CloseHandle(sc->run);
	CloseHandle(sc->end);
	return 0;
}

// [ȃXCX܂ŃXCh邩
//#define MAX_SHORT_CRC 100

// XCX̏
// -1=XCXłȂA܂͕sv, 0=, 1=XCh
int init_verification(
	int switch_v,			// @A0=W, 1=Ȉ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)
{
	unsigned char *short_use;
	int i, j, num, file_block, block_count, index_bit, short_count;
	int *order = NULL, *short_crcs;
	unsigned int last_size;
//	unsigned int time_last;
#ifdef MAX_SHORT_CRC
	unsigned int *short_tbls, *short_tbl;
#endif

	// ƃt@Cp
	sc->num = -1;
	sc->hFile_tmp = NULL;

	// XChXCX݂邩
	j = 0;
	block_count = 0;
	short_count = 0;
	sc->min_size = block_size;
	for (num = 0; num < entity_num; num++){
		if ((files[num].size > 0) && ((files[num].state & 0x80) == 0)){	// `FbNTt@Cr
			file_block = (int)(files[num].size / (__int64)block_size);	// tTCỸubN̐
			block_count += file_block;
			last_size = (unsigned int)(files[num].size - ((__int64)file_block * (__int64)block_size));
			if (last_size > 0){
				short_count++;	// [ȃubN܂
				if ((sc->min_size > last_size) && (sc->min_size > 4))	// 4oCg傫
					sc->min_size = last_size;
			}
			if (files[num].state & 0x03)	//  0x01Aj 0x02 ȂXCXT
				j++;	// Kv\[XEt@C̐
		}
	}
	//printf("target = %d, full = %d, short = %d, min_size = %d\n", j, block_count, short_count, sc->min_size);
	if (j == 0)
		return -1;	// S܂̓`FbNT̂ŁAXCXTȂĂ
	if (block_count == 0)
		return 1;	// XChKvȂAȈՌŏ\
	sc->block_count = block_count;
	sc->short_count = short_count;

	// CfbNXET[`Ŏgڎ
	index_bit = 4;	// ڎ̑傫 ubN / 5`8 ɂ
	while ((1 << (index_bit + 3)) < block_count)
		index_bit++;
	// CRC-32 ̏i[obt@[mۂ
	i = sizeof(int) * ((block_count * 2) + (1 << index_bit));
	if (short_count > 0){
		i += sizeof(int) * entity_num + ((entity_num + 3) & ~3);	// short_crc p̗̈
#ifdef MAX_SHORT_CRC
		if (((switch_v & 1) == 0) && (short_count <= MAX_SHORT_CRC))	// XCh̃e[ü
			i += sizeof(unsigned int) * 257 * short_count;	// XCh CRC L^镪P
#endif
	}
	order = (int *)malloc(i);
	if (order == NULL)
		return -1;	// CRC-32 rłȂ̂ŊȈՌłȂ
	j = 0;
	for (num = 0; num < entity_num; num++){
		if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
			file_block = (int)(files[num].size / (__int64)block_size);	// tTCỸubN̐
			for (i = files[num].b_off; i < files[num].b_off + file_block; i++){
				order[j] = i;	// ŏ̓ubNԍɂĂ
				j++;
			}
		}
	}
	// ɕёւ
	quick_sort(order, 0, block_count - 1, s_blk);
	// ёւꂽ CRC L^Ă
	for (i = 0; i < block_count; i++){
		order[block_count + i] = s_blk[order[i]].crc;	// ёւ̏ɂ
		//printf("crc[%2d]: Block[%2d], 0x%08X\n", i, order[i], s_blk[order[i]].crc);
	}
	// CfbNXET[`p̖ڎ
	init_index_search(order + block_count, block_count, order + (block_count * 2), index_bit);
	sc->index_shift = 32 - index_bit;
	sc->order = order;

	// ڍ׌p̍Ɨ̈mۂ
	if (((switch_v & 1) == 0) && (block_size * 3 < get_mem_size(0)))
		sc->buf = (unsigned char *)malloc(block_size * 3);
	if (sc->buf == NULL)
		return 1;	// [sŃXChłȂAȈՌɂ

//time_last = GetTickCount();
	if (((switch_v & 1) == 0) && (short_count > 0)){	// [ȃubNr鏀
		short_crcs = order + ((block_count * 2) + (1 << index_bit));
		short_use = (unsigned char *)(short_crcs + entity_num);
#ifdef MAX_SHORT_CRC
		short_tbls = (unsigned int *)(short_use + ((entity_num + 3) & ~3));
#endif
		for (num = 0; num < entity_num; num++){
			short_use[num] = 0;	// `FbNTȂA܂͔[ȃubNłȂ
			if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
				last_size = (unsigned int)(files[num].size % (__int64)block_size);
				if (last_size > 0){
					//file_block = (int)(files[num].size / (__int64)block_size);	// tTCỸubN̐
					//j = files[num].b_off + file_block;	// ubN̔ԍ
					//printf("block[%4d] : size = %d, pad = %d\n", j, s_blk[j].size, block_size - s_blk[j].size);
					// ubNETCY傫ƃpfBO菜̂ɎԂ邩AKvɂȂĂs
					//short_crcs[num] = crc_reverse_zero(s_blk[j].crc, block_size - s_blk[j].size);
					if (files[num].b_num > 1){
						short_use[num] = 2;	// ̔[ȃubN
					} else {
						short_use[num] = 1;	// ȃt@C
					}
#ifdef MAX_SHORT_CRC
					// XChp̃e[u͍ŏSėpӂȂƂȂ
					// SłȂt@C 4oCg傫Ȕ[XCXT
					if ((short_count <= MAX_SHORT_CRC) && (files[num].state & 0x03) && (last_size > 4)){
						short_use[num] |= 8;	// XCh
						short_tbl = short_tbls + 257 * num;
						onepass_window_gen_short(last_size, short_tbl);

						// pfBO菜 CRC-32 tZ
						j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
						short_crcs[num] = crc_reverse_zero(s_blk[j].crc, block_size - last_size);
						short_use[num] |= 4;	// CRC-32 vZς݂̈
						//printf("block[%4d] : size = %d, pad = %d\n", j, last_size, block_size - last_size);
					}
#endif
				}
			}
		}
	}
//time_last = GetTickCount() - time_last;
//printf("CRC setup: %d mil sec\n", time_last);

	// ǂݍݗpXbh̏
	sc->run = CreateEvent(NULL, FALSE, FALSE, NULL);	// Ƃ Auto Reset ɂ
	if (sc->run == NULL){
		free(sc->buf);
		sc->buf = NULL;
		return 1;
	}
	sc->end = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (sc->end == NULL){
		free(sc->buf);
		sc->buf = NULL;
		CloseHandle(sc->run);
		sc->run = NULL;
		return 1;
	}
	_mm_sfence();	// [ւ݂̏ĂXbhN
	sc->h = (HANDLE)_beginthreadex(NULL, 65536, thread_read, (LPVOID)sc, 0, NULL);
	if (sc->h == NULL){
		free(sc->buf);
		sc->buf = NULL;
		CloseHandle(sc->run);
		CloseHandle(sc->end);
		sc->run = NULL;
		sc->end = NULL;
		return 1;
	}

	return 0;
}

// XCXfЂrpɃ[Ɉꎞۊǂ
void save_flake(
	unsigned char *buf,
	int id,			// ubNԍ
	int flake_size,	// fЂ̃TCY
	int side,		// ǂ瑤 1=front, 0=rear
	slice_ctx *sc)
{
	unsigned char *p;
	int i, rv;
	flake_ctx *fc;

	rv = -1;	// g邩ǂ (󂫗̈̔ԍ)
	if (sc->flake_count > 0){	// ۊǏꏊ邩ׂ
		p = sc->flk_buf;
		for (i = 0; i < sc->flake_count; i++){
			fc = (flake_ctx *)p;
			p += sizeof(flake_ctx);
			if (fc->id == id){	// ɃXCXfЂL^Ă
				//printf("flake[%d] = %d, size = %d, add ok\n", i, id, flake_size);
				if (side){	// Oɏ㏑Rs[
					memcpy(p, buf, flake_size);
					fc->front_size = flake_size;
					if (fc->rear_size < 0)	// ς݂̈
						fc->rear_size = -(fc->rear_size);
				} else {	// 㔼ɏ㏑Rs[
					memcpy(p + (block_size - flake_size), buf, flake_size);
					fc->rear_size = flake_size;
					if (fc->front_size < 0)	// ς݂̈
						fc->front_size = -(fc->front_size);
				}
				return;	// ǉďI
			} else if (fc->id == -1){	// 󂫗̈悪݂
				rv = i;	// gKvȂ
			}
			p += block_size;	// ̕ۊǗ̈
		}
	}

	if (rv == -1){	// XCXfЂ̋L^̈g
		int max_count;
		__int64 mem_size;
		mem_size = get_mem_size(0) - (4 << 20);	// 4MB ]TĂ
		max_count = (int)(mem_size / (__int64)(sizeof(flake_ctx) + block_size));
		if (max_count > source_num / 2)
			max_count = source_num / 2;	// IɕfЂ̓\[XEubN̔ȉ
		//printf("mem_size = %I64d MB, max_count = %d \n", mem_size >> 20, max_count);
		if (sc->flake_count < max_count){
			i = sc->flake_count + 1;
			i *= sizeof(flake_ctx) + block_size;
			p = (unsigned char *)realloc(sc->flk_buf, i);
			if (p != NULL){
				sc->flk_buf = p;
				rv = sc->flake_count;	// VK쐬̈̔ԍ
				sc->flake_count += 1;
			}
		}
		if (rv == -1){
			if (sc->flake_count > 0){	// ȏgłȂȂ疖ɓ
				rv = 0;	// 擪󂯂Ă炷
			} else {	// ̈掩̂mۂłȂꍇ͕ۊǂȂ
				sc->flake_count = -1;
				return;
			}
		}
	}
	if (rv < sc->flake_count - 1){	// ̈ȊO󂢂ĂȂ
		i = (sizeof(flake_ctx) + block_size) * rv;
		p = sc->flk_buf + i;
		i = (sizeof(flake_ctx) + block_size) * (sc->flake_count - rv - 1);
		//printf("slide from %d to %d, %d bytes \n", p + ((sizeof(flake_ctx) + block_size)), p, i);
		memmove(p, p + ((sizeof(flake_ctx) + block_size)), i);
		rv = sc->flake_count - 1;	// Oɂ炵Ė̈ɕۊǂ
	}

	//printf("flake[%d] = %d, size = %d, save ok\n", rv, id, flake_size);
	p = sc->flk_buf;
	p += rv * (sizeof(flake_ctx) + block_size);
	fc = (flake_ctx *)p;
	p += sizeof(flake_ctx);
	if (side){	// Oɏ㏑Rs[
		memcpy(p, buf, flake_size);
		fc->front_size = flake_size;
		fc->rear_size = 0;
	} else {	// 㔼ɏ㏑Rs[
		memcpy(p + (block_size - flake_size), buf, flake_size);
		fc->front_size = 0;
		fc->rear_size = flake_size;
	}
	fc->id = id;
}

// ۊǂĂXCXfЂ𒲂ׂĊSȃXCXT
int check_flake(
	wchar_t *temp_path,			// ƗpAfBNgĂ
	int switch_v,				// +16=oɕۑ
	file_ctx_r *files,			// e\[XEt@C̏
	source_ctx_r *s_blk,		// e\[XEubN̏
	slice_ctx *sc)
{
	unsigned char *p, err_mag;
	int i, j, rv, num, err_off;
	flake_ctx *fc;

	p = sc->flk_buf;
	for (j = 0; j < sc->flake_count; j++){
		fc = (flake_ctx *)p;
		p += sizeof(flake_ctx);
		i = fc->id;
		if (i != -1){	// XCXfЂL^Ă
			if (s_blk[i].exist != 0){	// ubN̒fЂۊǂɁÃubNĂ
				fc->id = -1;	// svɂȂ̈󂯂
				//printf("flake[%d] = %d, release\n", j, i);
			} else if (fc->front_size + fc->rear_size + 1 >= (int)block_size){	// Oƌ㔼̍vubNETCYȏ
				// XCX̓ubNETCŶ̂
				// ς݂ƗƂ̒lȂ̂ŁAvĂubNETCY𒴂Ȃ͂
				rv = correct_error(p, s_blk[i].size,
							s_blk[i].hash, s_blk[i].crc, &err_off, &err_mag);
				//printf("flake[%d] = %d, check = %d\n", j, i, rv);
				if (rv >= 0){	// SȃubNVɔ (ς݂͐ɏOĂ)
					if (switch_v & 16){	// Rs[
						num = s_blk[i].file;
						if (open_temp_file(temp_path, num, files, sc))
							return 1;
						if (file_write_data(sc->hFile_tmp,
								(__int64)(i - files[num].b_off) * (__int64)block_size, p, s_blk[i].size)){
							printf("file_write_data, %d\n", i);
							return 1;
						}
					}
					s_blk[i].exist = 0x1002;	// ̃t@CŒfЂv
					first_num++;
					fc->id = -1;	// rÏ󂯂
				} else {	// nbVlقȂꍇ́Aς݂̈Ƃĕɂ
					fc->front_size = -(fc->front_size);
					fc->rear_size = -(fc->rear_size);
				}
			}
		}
		p += block_size;	// ̕ۊǗ̈
	}

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define MISS_LIMIT 6

// \[XEubÑ`FbNT𒲂ׂ
// t@Cԍmȏꍇ́AOɓɃS~tȂΈʑ̂ɂΉ
// ubNPʂł̓ǂݍ݃G[𖳎Čp
// -2=LZ, -1=G[, 0=Ȃ, 1`=
static int search_block_simple(
	wchar_t *temp_path,		// ƗpAfBNgĂ
	int num1,				// file_ctx ɂt@Cԍ (mȂ -1)
	unsigned int last_size,	// ubÑTCY
	wchar_t *file_name,		// \t@C
	HANDLE hFile,			// t@C̃nh
	__int64 file_size,		// ݂t@C̃TCY
	__int64 last_off,		// ǂ猟Jn邩 (܂ł͊Ɍς)
	int switch_v,			// +16=oɕۑ, +32=͌Ȃ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)
{
	unsigned char hash[20];
	int i, j, b_last, find_num, find_flag, find_next, short_next;
	int block_count, num, i1, i2, i3, i4, miss_num, miss_max;
	int *order, *index, index_shift;
	unsigned int crc, *crcs;
	unsigned int time_last;
	__int64 file_off, short_off;

	if (file_size < last_off + last_size)
		return 0;	// t@Cׂ͒Ȃ
	block_count = sc->block_count;
	miss_num = 0;	// AŌołȂ
	miss_max = (int)((file_size >> 4) / (__int64)block_size);	// size/16 ubN܂ (6%)
	if (miss_max < MISS_LIMIT)
		miss_max = MISS_LIMIT;
	find_num = 0;	// ̃t@CŉubN
	find_next = -1;	// ɌƗ\zubN̔ԍ
	short_next = -1;
	if (num1 >= 0){	// t@Cԍw肳ĂȂ
		b_last = files[num1].b_off + files[num1].b_num - 1;	// ubN̔ԍ
		find_next = (int)(last_off / (__int64)block_size);	// JnʒũubNԍ
		find_next += files[num1].b_off;
		if ((last_off < files[num1].size) &&	// t@C{̃TCYȂAubN͖o
				(last_size < block_size)){		// ̔[ȃubN̔ԍƑzʒu
			short_next = b_last;
			if (find_next == short_next)
				find_next = -1;	// \zd疖ubNƂĒT
			short_off = files[num1].size - last_size;
		}
		//printf("file = %d, find_next = %d\n", num1, find_next);
		//printf("short_off = %I64d, short_next = %d\n", short_off, short_next);
	}
	// CfbNXET[`p
	order = sc->order;
	crcs = order + block_count;
	index = crcs + block_count;
	index_shift = sc->index_shift;
	time_last = GetTickCount();

	// ubNETCYƂɒT
	if (block_count > 0){
		// O珇Ƀ`FbNTr
		file_off = last_off;	// Jnʒu璲ׂ
		//printf("search from %I64d, file %d, next = %d\n", file_off, num1, find_next);
		while (file_off + (__int64)block_size <= file_size){
			find_flag = -2;
			// ̔ԍ̃ubN̈ʒuɂ邩ɒׂ (ς݂ł)
			if ((short_next >= 0) && (file_off == short_off)){
				i = short_next;
				if (file_md5_crc32_block(hFile, file_off, s_blk[i].size, hash) != 0){
					return find_num;	// G[Ȃ猟I
				} else {
					if (memcmp(hash, s_blk[i].hash, 20) == 0)	// `FbNTv邩m߂
						find_flag = 0;
				}
			}
			if (find_flag < 0){
				if (file_md5_crc32_block(hFile, file_off, block_size, hash) != 0)
					return find_num;	// G[Ȃ猟I
				if ((find_next >= 0) && (memcmp(hash, s_blk[find_next].hash, 20) == 0)){	// `FbNTv邩m߂
					i = find_next;
					find_flag = 3;
				}
				if (find_flag < 0){	// \zubNȂꍇ͑SẴubNƔr
					memcpy(&crc, hash + 16, 4);
					crc ^= window_mask;	// L^Ă`FbNT珉lƍŏI 0xFFFFFFF 菜
					// CRC-32 vԍ
//					j = binary_search(order, block_count, crc, s_blk);
//					j = index_search(crcs, block_count, crc, index, index_shift);
					j = 0x00FFFFFF;	// Ȃ
					i = index[crc >> index_shift];	// ẑǂɂ邩
					// jAET[`Ŏc肩T
					while (i < block_count){
						if (crcs[i] > crc)
							break;	// ȂړI̒l݂͑Ȃ
						if (crcs[i] == crc){
							j = i;
							break;
						}
						i++;
					}
					// vubNDxʂɋL^
					i1 = i2 = i3 = i4 = -1;
					for (; j < block_count; j++){	// ubNv邩Ȃ̂
						if (crcs[j] != crc)
							break;	// CRC-32 vȂȂ甲
						i = order[j];
						if (memcmp(hash, s_blk[i].hash, 20) == 0){	// `FbNTv邩m߂
							find_flag = 4;
							if ((s_blk[i].exist & 0x1000) == 0){	// ̃t@CŖ̃ubNDIɒT (edĂꍇɏۂ)
								if (s_blk[i].file == num1){	// w肳ꂽt@Cԍ̃ubN
									i1 = i;
									break;	// ŗD̃ubNꍇ͒Ƀ[v甲
								} else {
									i2 = i;
									if (num1 < 0)
										break;
								}
							} else {	// ̃t@CŔς݂̃ubNr (eRs[ĒǉςF)
								if (s_blk[i].file == num1){
									i3 = i;
								} else {
									i4 = i;
								}
							}
						}
					}
					// łDx̍ubNƂĔF
					if (i1 >= 0){
						i = i1;	// w肳ꂽt@CԍŖ̃ubN
					} else if (i2 >= 0){
						i = i2;	// ̃t@CԍŖ̃ubN
					} else if (i3 >= 0){
						i = i3;	// w肳ꂽt@CԍŔς݂̃ubN
					} else if (i4 >= 0){
						i = i4;	// ̃t@CԍŔς݂̃ubN
					}
				}
			}
			if (find_flag >= 0){	// ̈ʒuŃubÑ`FbNTv
				num = s_blk[i].file;	// ubNt@Cԍ
				if (s_blk[i].exist == 0){	// ̃ubNȂ
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num, files, sc))
							return -1;
						if (file_copy_data(hFile, file_off, sc->hFile_tmp,
								(__int64)(i - files[num].b_off) * (__int64)block_size, s_blk[i].size)){
							printf("file_copy_data, %d\n", i);
							return -1;
						}
					}
					s_blk[i].exist = 2;
					first_num++;
				}
				if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
					find_num++;
					write_ini_verify(i, 0, file_off);
				}
				s_blk[i].exist |= 0x1000;	// ̃t@CŌ
/*				if (find_flag == 0){
					printf("%9I64d : L %d, F %d\n", file_off, i, s_blk[i].file);	// Last
				} else if (find_flag == 3){
					printf("%9I64d : N %d, F %d\n", file_off, i, s_blk[i].file);	// Next
				} else {
					printf("%9I64d : S %d, F %d\n", file_off, i, s_blk[i].file);	// Search
				}*/
				// ɌubN\
				find_next = i + 1;
				if (find_next >= source_num){	// Ō܂ł
					short_next = -1;
					find_next = -1;
				} else if (s_blk[find_next].file != num){	// قȂt@C͘AȂ
					short_next = -1;
					find_next = -1;
				} else if (s_blk[find_next].size < block_size){	// [ȃubN͕ʂɒׂ
					short_next = find_next;
					short_off = file_off + block_size;
					//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
					find_next = -1;
				} else {
					short_next = files[num].b_off + files[num].b_num - 1;
					if (s_blk[short_next].size < block_size){	// [ȃubN͕ʂɒׂ
						short_off = file_off + (__int64)(short_next - i) * (__int64)block_size;
						//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
					} else {
						short_next = -1;
					}
				}
				file_off += s_blk[i].size;
				last_off = file_off;	// ŌɌubN̏I[
				miss_num = 0;
			} else {
				file_off += block_size;
				miss_num++;
				//printf("miss = %d / %d\n", miss_num, miss_max);
				if (miss_num >= miss_max)
					break;
			}
			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress_file((int)((file_off * 1000) / file_size), first_num, file_name))
					return -2;
				time_last = GetTickCount();
			}
		}
	}
	// ̔[ȃubŇ
	if ((short_next >= 0) && (short_off + s_blk[short_next].size <= file_size) && ((s_blk[short_next].exist & 0x1000) == 0)){
		file_off = short_off;
		i = short_next;
		if (file_md5_crc32_block(hFile, file_off, s_blk[i].size, hash) != 0){
			return find_num;	// G[Ȃ猟I
		} else {
			if (memcmp(hash, s_blk[i].hash, 20) == 0){	// `FbNTv邩m߂
				num = s_blk[i].file;	// ubNt@Cԍ
				if (s_blk[i].exist == 0){	// ̃ubNȂ
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num, files, sc))
							return -1;
						if (file_copy_data(hFile, file_off, sc->hFile_tmp,
								(__int64)(i - files[num].b_off) * (__int64)block_size, s_blk[i].size)){
							printf("file_copy_data, %d\n", i);
							return -1;
						}
					}
					s_blk[i].exist = 2;
					first_num++;
				}
				if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
					find_num++;
					write_ini_verify(i, 0, file_off);
				}
				s_blk[i].exist |= 0x1000;	// ̃t@CŌ
				//printf("%9I64d : L2 %d, F %d\n", file_off, i, s_blk[i].file);	// Last
			}
		}
	}
	if ((num1 >= 0) && (files[num1].b_num >= 2) && (file_size >= last_size) && ((s_blk[b_last].exist & 0x1000) == 0)){
		if (file_size >= files[num1].size){	// {̃TCY傫Ȃ
			file_off = files[num1].size - last_size;
		} else if (file_size >= block_size + last_size){	// ubN{傫Ȃ
			file_off = last_off;
		} else {	// ubÑTCYȂ
			file_off = 0;
		}
		if (file_md5_crc32_block(hFile, file_off, last_size, hash) != 0){
			return find_num;	// G[Ȃ猟I
		} else {
			i = b_last;
			if (memcmp(hash, s_blk[i].hash, 20) == 0){	// `FbNTv邩m߂
				if (s_blk[i].exist == 0){	// ̃ubNȂ
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num1, files, sc))
							return -1;
						if (file_copy_data(hFile, file_off, sc->hFile_tmp, file_off, last_size)){
							printf("file_copy_data, %d\n", i);
							return -1;
						}
					}
					s_blk[i].exist = 2;
					first_num++;
				}
				find_num++;
				write_ini_verify(i, 0, file_off);
				s_blk[i].exist |= 0x1000;	// ̃t@CŌ
				//printf("%9I64d : L1 %d, F %d\n", file_off, i, s_blk[i].file);	// Last
			}
		}
	}

	// t@Cԍw肳ĂȂꍇ͌̌Ȃ
	// ŌɌubNt@C̏I[ȂAȏ̌Ȃ
	if ((num1 < 0) || (file_size <= last_off + last_size))
		return find_num;
	// w肳ꂽt@CƓTCYȂAʑ͖̂Ƃ݂Ȃ
	if ((miss_num < miss_max) && (file_size == files[num1].size))
		return find_num;
	// t@CȂ̌Ȃ (ގt@CƂ̓TCYŋʂ)
	if ((switch_v & 32) && (file_size <= files[num1].size / 2))
		return find_num;

	// ubŇ
	file_off = file_size - last_size;	// ɂ͂̏I[ubN̈ʒu
	miss_num = 0;
	if ((s_blk[b_last].exist & 0x1000) == 0){
		miss_num = 1;
		if (file_off >= last_off){
			if (file_md5_crc32_block(hFile, file_off, last_size, hash) != 0)
				return find_num;	// G[Ȃ猟I
			i = b_last;
			if (memcmp(hash, s_blk[i].hash, 20) == 0){	// `FbNTv邩m߂
				if (s_blk[i].exist == 0){	// ̃ubNȂ
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num1, files, sc))
							return -1;
						if (file_copy_data(hFile, file_off, sc->hFile_tmp, files[num1].size - last_size, last_size)){
							printf("file_copy_data, %d\n", i);
							return -1;
						}
					}
					s_blk[i].exist = 2;
					first_num++;
				}
				find_num++;
				write_ini_verify(i, 0, file_off);
				s_blk[i].exist |= 0x1000;	// ̃t@CŌ
				//printf("%9I64d : RL %d, F %d\n", file_off, i, s_blk[i].file);	// Last
				miss_num = 0;
			}
		}
	}
	// t@CɃubNȂkĒT
	if (files[num1].b_num >= 2){	//  block_count > 0 ɂȂ
		file_off -= block_size;	// ÖʒuɂĂ
		//printf("sencond search from = %I64d to %I64d\n", file_off, last_off);
		find_next = b_last - 1;
		while (file_off > last_off){	// ǑŌŌ̃ubN܂
			find_flag = -2;
			// ̔ԍ̃ubN̈ʒuɂ邩ɒׂ (ς݂ł)
			if (file_md5_crc32_block(hFile, file_off, block_size, hash) != 0){
				return find_num;	// G[Ȃ猟I
			} else {
				if ((find_next >= 0) && (memcmp(hash, s_blk[find_next].hash, 20) == 0)){	// `FbNTv邩m߂
					i = find_next;
					find_flag = 3;
				}
				if (find_flag < 0){
					memcpy(&crc, hash + 16, 4);
					crc ^= window_mask;	// L^Ă`FbNT珉lƍŏI 0xFFFFFFF 菜
					// CRC-32 vԍ
//					j = binary_search(order, block_count, crc, s_blk);
//					j = index_search(crcs, block_count, crc, index, index_shift);
					j = 0x00FFFFFF;	// Ȃ
					i = index[crc >> index_shift];	// ẑǂɂ邩
					// jAET[`Ŏc肩T
					while (i < block_count){
						if (crcs[i] > crc)
							break;	// ȂړI̒l݂͑Ȃ
						if (crcs[i] == crc){
							j = i;
							break;
						}
						i++;
					}
					// vubNDxʂɋL^
					i1 = i2 = i3 = i4 = -1;
					for (; j < block_count; j++){	// ubNv邩Ȃ̂
						if (crcs[j] != crc)
							break;	// CRC-32 vȂȂ甲
						i = order[j];
						if (memcmp(hash, s_blk[i].hash, 20) == 0){	// `FbNTv邩m߂
							find_flag = 4;
							if ((s_blk[i].exist & 0x1000) == 0){	// ̃t@CŖ̃ubNDIɒT
								if (s_blk[i].file == num1){	// w肳ꂽt@Cԍ̃ubN
									i1 = i;
									break;	// ŗD̃ubNꍇ͒Ƀ[v甲
								} else {
									i2 = i;
								}
							} else {	// ̃t@CŔς݂̃ubN
								if (s_blk[i].file == num1){
									i3 = i;
								} else {
									i4 = i;
								}
							}
						}
					}
					// łDx̍ubNƂĔF (O̎Ƃ͏قȂ)
					if (i1 >= 0){
						i = i1;	// w肳ꂽt@CԍŖ̃ubN
					} else if (i3 >= 0){
						i = i3;	// w肳ꂽt@CԍŔς݂̃ubN
					} else if (i2 >= 0){
						i = i2;	// ̃t@CԍŖ̃ubN
					} else if (i4 >= 0){
						i = i4;	// ̃t@CԍŔς݂̃ubN
					}
				}
			}
			if (find_flag >= 0){	// ̈ʒuŃubÑ`FbNTv
				num = s_blk[i].file;	// ubNt@Cԍ
				if (s_blk[i].exist == 0){	// ̃ubNȂ
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num, files, sc))
							return -1;
						if (file_copy_data(hFile, file_off, sc->hFile_tmp,
								(__int64)(i - files[num].b_off) * (__int64)block_size, block_size)){
							printf("file_copy_data, %d\n", i);
							return -1;
						}
					}
					s_blk[i].exist = 2;
					first_num++;
				}
				if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
					find_num++;
					write_ini_verify(i, 0, file_off);
				}
				s_blk[i].exist |= 0x1000;	// ̃t@CŌ
/*				if (find_flag == 3){
					printf("%9I64d : RN %d, F %d\n", file_off, i, s_blk[i].file);	// Next
				} else {
					printf("%9I64d : RS %d, F %d\n", file_off, i, s_blk[i].file);	// Search
				}*/
				// ɌubN\
				find_next = i - 1;
				if (find_next < 0){	// ŏ܂ł
					find_next = -1;
				} else if (s_blk[find_next].file != num){	// قȂt@C͘AȂ
					find_next = -1;
				}
				miss_num = 0;
			} else {
				miss_num++;
				//printf("miss = %d / %d\n", miss_num, miss_max);
				if (miss_num >= miss_max)
					break;
			}
			file_off -= block_size;
			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress_file((int)(((file_size - file_off) * 1000) / (file_size - last_off)), first_num, file_name))
					return -2;
				time_last = GetTickCount();
			}
		}
	}

	return find_num;
}

#define FAIL_MAX 8
#define FAIL_LIMIT 10

#ifndef MAX_SHORT_CRC	// [ȃXCXXChȂꍇ

// XChŃ\[XEubNT (TuEXbhubNǂݍ)
// ubNETCY * 3 < 4GB ł邱
// -2=LZ, -1=G[, 0=Ȃ, 1`=
static int search_block_slide(
	wchar_t *temp_path,		// ƗpAfBNgĂ
	int num1,				// file_ctx ɂ鏉Ԃ̃t@Cԍ (mȂ -1)
	unsigned int last_size,	// ubÑTCY
	wchar_t *file_name,		// \t@C
	HANDLE hFile,			// t@C̃nh
	__int64 file_size,		// ݂t@C̃TCY
	__int64 last_off,		// ǂ猟Jn邩 (܂ł͊Ɍς)
	int switch_v,			// +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)
{
	unsigned char *buf, hash[16], err_mag, *short_use;
	int i, j, find_num, find_flag, find_next, find_last, short_next;
	int block_count, short_count, tiny_count, tiny_skip, num, i1, i2, i3, i4;
	int *order, *index, index_shift;
	unsigned int len, off, end_off, err_off;
	unsigned int prev_crc, fail_count, rear_off;
	unsigned int crc, *crcs, *short_crcs;
	unsigned int time_last;
	__int64 file_off, file_next, short_off, fail_off;

	if (file_size + 1 < last_off + (__int64)(sc->min_size))
		return 0;	// t@Cׂ͒Ȃ
	find_num = 0;	// ̃t@CŉubN
	find_next = -1;	// ɌƗ\zubN̔ԍ
	find_last = -1;	// ŌɌubN̔ԍ (-1=s)
	short_next = -1;
	fail_count = 0;	// CRC ͈v MD5 
	fail_off = 0;
	rear_off = 0;
	if (num1 >= 0){	// t@Cԍw肳ĂȂ
		find_next = (int)(last_off / (__int64)block_size);	// JnʒũubNԍ
		find_next += files[num1].b_off;
		if (last_off > 0)	// SȃubNĂȂ
			find_last = find_next - 1;	// ŌɌubN̔ԍ
		if ((last_off >= files[num1].size) || (last_off + block_size > file_size + 1))
			find_next = -1;	// \zʒut@CETCY𒴂Ƒʖ
		if ((last_size < block_size) && (files[num1].b_num >= 2) &&	// ̔[ȃubN̔ԍƑzʒu
				(last_off < files[num1].size) && (files[num1].size <= file_size + 1)){
			short_next = files[num1].b_off + files[num1].b_num - 1;	// ubN̔ԍ
			if (find_next == short_next)
				find_next = -1;	// \zd疖ubNƂĒT
			short_off = files[num1].size - last_size;
		}
		if (file_size > files[num1].size){
			rear_off = (unsigned int)((file_size - files[num1].size) % (__int64)block_size);
		} else if (file_size < files[num1].size){
			rear_off = block_size - (unsigned int)((files[num1].size - file_size) % (__int64)block_size);
		}
		//printf("file = %d, find_next = %d, find_last = %d\n", num1, find_next, find_last);
		//printf("short_off = %I64d, short_next = %d, rear_off = %d\n", short_off, short_next, rear_off);
	}
	file_off = last_off;	// Jnʒu璲ׂ
	buf = sc->buf;
	// CfbNXET[`p
	block_count = sc->block_count;
	order = sc->order;
	crcs = order + block_count;
	index = crcs + block_count;
	index_shift = sc->index_shift;
	// [ȃubÑpfBO菜 CRC-32
	short_count = sc->short_count;
	short_crcs = index + (unsigned int)(1 << (32 - index_shift));
	short_use = (unsigned char *)(short_crcs + entity_num);
	tiny_count = 0;
	tiny_skip = 0;

	// ŏ̓ubNETCY̔{܂œǂݍ
	if (file_size < file_off + ((__int64)block_size * 2)){
		len = (unsigned int)(file_size - file_off);
		memset(buf + len, 0, (block_size * 2) - len);
	} else {
		len = block_size * 2;
	}
	if (file_read_data(hFile, file_off, buf, len))
		//memset(buf, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
		return 0;	// G[Ȃ猟I
	if (file_size <= file_off + (__int64)block_size){	// ͈͂ubNETCYȉȂ
		file_next = file_size + 1;	// ŏ̃[vŌI
	} else {
		file_next = file_off + len;	// t@CE|C^[̈ʒu
	}
	sc->hFile = hFile;
	time_last = GetTickCount();
	if (short_count > 0){	// ȃt@Č
		for (num = 0; num < entity_num; num++){
			if (short_use[num] & 1)
				tiny_count++;
		}
	}
	// ȃt@C̔[ȃubŇ
	if ((short_count > 0) && (last_off == 0)){
		//printf("tiny search from %I64d, size = %d, count = %d, %d\n", file_off, len, short_count, tiny_count);
		for (num = 0; num < entity_num; num++){	// t@Cԍ
			if (short_use[num] == 0)
				continue;	// [ȃubN܂܂Ȃt@C͏O
			i = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
			last_size = s_blk[i].size;
			// ŁAf[^菬ȁA[ȖubNȂ
			if ((last_size <= len) && ((s_blk[i].exist & 0x1000) == 0)){
				if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
					short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - last_size);
					short_use[num] |= 4;	// CRC-32 vZς݂̈
				}
				//printf("tiny %d, size = %d, CRC = 0x%08X, 0x%08X\n", num, last_size, crc, short_crcs[num]);
				if (crc_update(0, buf, last_size) == short_crcs[num]){	// CRC-32 v
					data_md5_block(buf, last_size, hash);
					if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
						if (s_blk[i].exist == 0){	// ̃ubNȂ
							if (switch_v & 16){	// Rs[
								if (open_temp_file(temp_path, num, files, sc))
									return -1;
								if (file_write_data(sc->hFile_tmp,
										(__int64)(i - files[num].b_off) * (__int64)block_size, buf, last_size)){
									printf("file_write_data, %d\n", i);
									return -1;
								}
							}
							s_blk[i].exist = 2;
							first_num++;
						}
						if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
							find_num++;
							write_ini_verify(i, 0, file_off);
						}
						s_blk[i].exist |= 0x1000;	// ̃t@CŌ
						//printf("%9I64d,%8d : T %d, F %d\n", file_off, last_size, i, s_blk[i].file);	// Tiny
						if (last_off < file_off + last_size)
							last_off = file_off + last_size;	// ԑ傫Ȕ[ȃubN̏I[
						find_next = -2;	// ȃt@C = ubNo̗\zOꂽ
						if (i == short_next)
							short_next = -1;	// ubN͌oς

						// oߕ\
						if (GetTickCount() - time_last >= UPDATE_TIME){
							if (print_progress_file(0, first_num, file_name))
								return -2;
							time_last = GetTickCount();
						}
					}	// ̂傫ȃt@CƂvĂ邩Ȃ̂ős
				}
			}
		}
		if (find_next != -2){	// ȃt@CȂȂ
			tiny_skip = -1;
			if ((*((unsigned short *)buf) == 0x7A37) && (*((unsigned int *)(buf + 2)) == 0x1C27AFBC)){	// 7-Zipɂ SignatureHeader
				tiny_skip = 32;
				//printf("tiny_skip = 32 (7-Zip header size)\n");
			} else {
				i1 = 0;
				while (*((unsigned int *)(buf + i1)) == 0x04034b50){	// ZIPɂ local file header
					i2 = *((unsigned int *)(buf + i1 + 18));	// compressed size
					i3 = *((unsigned int *)(buf + i1 + 22));	// uncompressed size
					if (i2 != i3)
						break;	// kĂ
					i3 = *((unsigned short *)(buf + i1 + 26));	// file name length
					i4 = *((unsigned short *)(buf + i1 + 28));	// extra field length
					if (i1 + 30 + i3 + i4 + i2 > file_size)
						break;	// t@Cr܂
					i1 += 30 + i3 + i4;
					if (i2 > 0){	// ̃t@CiTuEfBNgj͖
						tiny_skip = i1;
						//printf("tiny_skip = %d (ZIP header size + %d + %d)\n", tiny_skip, i3, i4);
						break;
					}
				}
			}
		}
	}

	// ubNETCYƂɒT
	if (((block_count > 0) && ((file_off + (__int64)block_size <= file_size)
			|| (find_next >= 0))) || (short_next >= 0)){	// ubN̈ʒu\zĒT
		// OXChȂ`FbNTr
		//printf("slide search from %I64d, file %d, next = %d\n", file_off, num1, find_next);
		off = 0;	// buf ł̃ItZbg
		if (file_size >= (__int64)block_size){
			end_off = block_size;
		} else {
			end_off = (unsigned int)file_size;
		}
		crc = crc_update(0, buf, block_size);
		while (1){
			//printf("Loop from %9I64d+%8d for %d\n", file_off, off, end_off);
			if (file_next < file_size){	// t@C̏I[ɒBĂȂ΁Acǂݍ
				if ((file_next + (__int64)block_size) > file_size){
					len = (unsigned int)(file_size - file_next);
				} else {
					len = block_size;
				}
				sc->size = len;
				_mm_sfence();
				SetEvent(sc->run);	// TuEXbhɓǂݍ݂Jn
				//printf("read from %I64d, %d byte\n", file_next, len);
			}

			while (off < end_off){
				find_flag = -2;
				// ̔ԍ̃ubN̈ʒuɂ邩ɒׂ (ς݂ł)
				if ((short_next >= 0) && (file_off + off == short_off)){	// [ȃubNȂ
					i = short_next;
					num = s_blk[i].file;
					if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
						short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - s_blk[i].size);
						short_use[num] |= 4;	// CRC-32 vZς݂̈
					}
					//printf("short[%d], size = %d, short_crc = 0x%08X\n", i, s_blk[i].size, short_crcs[num]);
					find_flag = correct_error(buf + off, s_blk[i].size, s_blk[i].hash, short_crcs[num], &err_off, &err_mag);
					if (find_flag == 0)
						find_flag = 2;
				} else if ((find_next >= 0) && (file_off + off == last_off)){	// tTCỸubNȂ
					i = find_next;
					if (crc == s_blk[i].crc){
						data_md5(buf + off, block_size, hash);
						find_flag = -3;	// MD5 vZς݂̈
						if (memcmp(hash, s_blk[i].hash, 16) == 0)	// X MD5 v
							find_flag = 3;
					} else {	// ΈʒuȎG[݂
						find_flag = correct_error2(buf + off, block_size, crc, s_blk[i].hash, s_blk[i].crc, &err_off, &err_mag);
					}
				}
				if (find_flag < 0){	// \zubNȂꍇ͑SẴubNƔr
//					j = binary_search(order, block_count, crc, s_blk);
//					j = index_search(crcs, block_count, crc, index, index_shift);
					j = 0x00FFFFFF;	// Ȃ
					i = index[crc >> index_shift];	// ẑǂɂ邩
					// jAET[`Ŏc肩T
					while (i < block_count){
						if (crcs[i] > crc)
							break;	// ȂړI̒l݂͑Ȃ
						if (crcs[i] == crc){
							j = i;
							break;
						}
						i++;
					}
					// vubNDxʂɋL^
					i1 = i2 = i3 = i4 = -1;
					for (; j < block_count; j++){	// ubNv邩Ȃ̂
						if (crcs[j] != crc)
							break;	// CRC-32 vȂȂ甲
						i = order[j];
						// OubNo͈͂ł́Aoς݂̃ubN𖳎
						if ((file_off + off < last_off) && ((s_blk[i].exist & 0x1000) != 0))
							continue;
						if (find_flag != -3){	// CRC-32 v MD5 vZ
							data_md5(buf + off, block_size, hash);
							find_flag = -3;	// MD5 vZς݂̈
						}
						if (memcmp(hash, s_blk[i].hash, 16) == 0){	// MD5 v邩m߂
							if ((s_blk[i].exist & 0x1000) == 0){	// ̃t@CŖ̃ubNDIɒT (edĂꍇɏۂ)
								if (s_blk[i].file == num1){	// w肳ꂽt@Cԍ̃ubN
									i1 = i;
									break;	// ŗD̃ubNꍇ͒Ƀ[v甲
								} else {
									i2 = i;
									if (num1 < 0)
										break;
								}
							} else {	// ̃t@CŔς݂̃ubNr (eRs[ĒǉςF)
										// [ȃubN̓XChŌȂ̂ŁAΈʒuQlɂ邽
								if (s_blk[i].file == num1){
									i3 = i;
								} else {
									i4 = i;
								}
							}
						} else {			// CRC-32 ͈vĂ MD5 ႤƂ́ARɂ
							find_flag = -3;	// ŁAԊu̕ςŃt[Y肷
						}
					}
					// łDx̍ubNƂĔF
					if (i1 >= 0){
						find_flag = 4;
						i = i1;	// w肳ꂽt@CԍŖ̃ubN
					} else if (i2 >= 0){
						find_flag = 4;
						i = i2;	// ̃t@CԍŖ̃ubN
					} else if (i3 >= 0){
						find_flag = 4;
						i = i3;	// w肳ꂽt@CԍŔς݂̃ubN
					} else if (i4 >= 0){
						find_flag = 4;
						i = i4;	// ̃t@CԍŔς݂̃ubN
					}
				}
				// ubNȂꍇ́AO񌟏oubŇゾAȃt@CƔr
				// rΏۂƒxȂ̂ŁA͈͂ŌȂ΂߂
				if ((find_flag < 0) && (tiny_count > 0) && (file_off + off == last_off + tiny_skip)){
					//printf("tiny search at %d\n", off);
					i1 = -1;
					i2 = 0;
					for (num = 0; num < entity_num; num++){	// t@Cԍ
						if ((short_use[num] & 3) != 1)
							continue;	// ȃt@Cr
						i = files[num].b_off;	// ȃt@C̐擪ubN̔ԍ
						if ((s_blk[i].exist & 0x1000) != 0)
							continue;	// t@CŌoς݂Ȃ珜O
						last_size = s_blk[i].size;
						if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
							short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - last_size);
							short_use[num] |= 4;	// CRC-32 vZς݂̈
						}
						if (crc_update(0, buf + off, last_size) == short_crcs[num]){	// CRC-32 v
							data_md5_block(buf + off, last_size, hash);
							if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
								// ̃XCXƈvꍇ͑傫̗p
								if (last_size > (unsigned int)i2){
									i1 = i;
									i2 = last_size;
								}
							} else {
								find_flag = -3;
							}
						}
					}
					if (i1 >= 0){	// ȃt@C
						find_flag = 4;
						i = i1;
					} else if (tiny_skip == 0){	// ubNȂ
						i1 = 0;
						while (*((unsigned int *)(buf + off + i1)) == 0x04034b50){	// ZIPɂ local file header
							i2 = *((unsigned int *)(buf + off + i1 + 18));	// compressed size
							i3 = *((unsigned int *)(buf + off + i1 + 22));	// uncompressed size
							if (i2 != i3)
								break;	// kĂ
							i3 = *((unsigned short *)(buf + off + i1 + 26));	// file name length
							i4 = *((unsigned short *)(buf + off + i1 + 28));	// extra field length
							if (last_off + i1 + 30 + i3 + i4 + i2 > file_size)
								break;	// t@Cr܂
							i1 += 30 + i3 + i4;
							if (i2 > 0){	// ̃t@CiTuEfBNgj͖
								tiny_skip = i1;
								//printf("tiny_skip = %d (header size + %d + %d)\n", tiny_skip, i3, i4);
								break;
							}
						}
					} else {
						tiny_skip = 0;
					}
				}
				if (find_flag >= 0){	// ̈ʒuŃubÑ`FbNTv
					num = s_blk[i].file;	// ubNt@Cԍ
					// t@Crn܂ĂȂAubNĂƉ肷
					// ʂ̋L^ǂݎ₷悤ɁA{̌oubNɋL^
					if ((sc->flake_count >= 0) && (file_off == 0) && (off > 1)){	// fЂ 2oCgȏKv
						i1 = i - 1;	// ÕubN̔ԍ
						if (((i1 == files[num].b_off) && (off + 1 == block_size))	// ubNETCY-1 Ȃł
								|| (i1 > files[num].b_off)){	// 擪ubN͏O
							// ̃t@CōŏɃubNȂ̂ŁÃt@Cł͖
							//printf("slice[%3d] : rear  flake size = %d \n", i1, off);
							find_num++;
							write_ini_verify(i1, 8, off);	// fЂ̃TCY
							if (s_blk[i1].exist == 0)	// Ȃ㔼̒fЂۊǂ
								save_flake(buf, i1, off, 0, sc);
						}
					}
					if (s_blk[i].exist == 0){	// ̃ubNȂ
						if (switch_v & 16){	// Rs[
							if (open_temp_file(temp_path, num, files, sc))
								return -1;
							if (file_write_data(sc->hFile_tmp,
									(__int64)(i - files[num].b_off) * (__int64)block_size, buf + off, s_blk[i].size)){
								printf("file_write_data, %d\n", i);
								return -1;
							}
						}
						s_blk[i].exist = 2;
						first_num++;
					}
					if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
						find_num++;
						write_ini_verify(i, find_flag, file_off + off);
					}
					if (find_flag == 1)	// G[߂Ă
						buf[err_off + off] ^= err_mag;
					if (find_flag > 3){	// XChŌꍇ
						if (file_off + off + 1 < last_off){	// ÕubNƍ̂dȂĂȂ
							find_flag = 5;	// dȂĂȂ玟̃ubNT (O̃ubNdȂ̂͋ۂ)
							err_off = (unsigned int)(last_off - file_off);	// 2oCgȏジ
							//printf("cover [%I64d to %I64d], last [%I64d to %I64d], next off = %d\n",
							//		file_off + off, file_off + off + block_size, last_off - block_size, last_off, err_off);
						} else if ((find_last < i) && (find_last >= files[num].b_off)){
							// O񌩂ubNt@CɏĂ
							if (file_off + off == last_off + ((__int64)block_size * (__int64)(i - find_last - 1)))
								find_flag = 3;	// 񌩂ubN̈ʒuĂȂ
						}
					} else if (s_blk[i].exist & 0x1000){
						// ȈʒuŌꍇłAt@CŌoς݂̂Ȃ
						find_flag = 4;	// jĂ\
					}
					s_blk[i].exist |= 0x1000;	// ̃t@CŌ
					last_off = file_off + off + s_blk[i].size;	// ŌɌubN̏I[
					find_last = i;
/*					if (find_flag == 1){
						printf("%9I64d+%8u : C %d, F %d\n", file_off, off, i, s_blk[i].file);	// Corrected
					} else if (find_flag == 2){
						printf("%9I64d+%8u : L %d, F %d\n", file_off, off, i, s_blk[i].file);	// Last
					} else if (find_flag == 3){
						printf("%9I64d+%8u : N %d, F %d\n", file_off, off, i, s_blk[i].file);	// Next
					} else if (s_blk[i].size < block_size){
						printf("%9I64d+%8u : T %d, F %d, Size %d\n", file_off, off, i, s_blk[i].file, s_blk[i].size);	// Tiny
					} else {
						printf("%9I64d+%8u : S %d, F %d\n", file_off, off, i, s_blk[i].file);	// Search
					}*/
					// ɌubN\
					find_next = i + 1;
					if ((find_next >= source_num) || (s_blk[find_next].file != num)){
						// Ō܂łA܂̓t@CقȂ
						short_next = -1;
						find_next = -1;
					} else if (s_blk[find_next].size < block_size){	// [ȃubN͕ʂɒׂ
						short_next = find_next;
						short_off = file_off + off + block_size;
						//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
						find_next = -1;
					} else {
						short_next = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
						if (s_blk[short_next].size < block_size){	// [ȃubN͕ʂɒׂ
							short_off = file_off + off + (__int64)(short_next - i) * (__int64)block_size;
							//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
						} else {
							short_next = -1;
						}
					}
					tiny_skip = 0;	// ȃt@CubNɈ񂾂T
					// t@CrŏIĂȂAubNĂƉ肷
					if ((sc->flake_count >= 0) &&
							(file_off + (__int64)(off + s_blk[i].size + block_size - 1) > file_size) &&
							(file_off + (__int64)(off + s_blk[i].size) + 1 < file_size)){	// fЂ 2`ubNETCY-2 oCg
						i1 = i + 1;	// ubN̔ԍ (t@C̖ubN͏)
						i3 = files[num].b_off + files[num].b_num - 1;	// ̃t@C̖̃ubNԍ
						//printf("id = %d, start = %d, max = %d \n", i1, files[num].b_off, i3);
						if ((i1 < i3) && ((s_blk[i1].exist & 0x1000) == 0)){	// t@CŖȂ
							i2 = (int)(file_size - file_off) - off - s_blk[i].size;	// fЂ̃TCY
							//printf("slice[%3d] : front flake size = %d \n", i1, i2);
							find_num++;
							write_ini_verify(i1, 9, file_off + (__int64)(off + s_blk[i].size));	// fЂ̈ʒu
							if (s_blk[i1].exist == 0)	// Ȃ㔼̒fЂۊǂ
								save_flake(buf + (off + s_blk[i].size), i1, i2, 1, sc);
						}
					}
					if (find_flag <= 3){	// ̂ȃubNȂ
						// ̃ubÑ͍ubŇɑƗ\z
						off += s_blk[i].size;
						if (off <= end_off)
							crc = crc_update(0, buf + off, block_size);
					} else { // ubNԍԒʂɂȂĂȂȂ (jĂ)
						// t@CeɏdƁÃubNɌĂ܂āA
						// ubNETCY炷Ɩ{̃ubNȂȂ̂ 1oCg炷
						prev_crc = crc;
						crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
						off++;
						if (crc == prev_crc){	//  CRC ̃ubNdȂ͈͓ŔȂ悤ɂ
							//int off2 = off - 1;
							while ((off < end_off) && (file_off + off < last_off) && (crc == prev_crc)){
								crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
								off++;
							}
							//printf("skip %d after find\n", off - off2);
						}
						if ((find_flag == 5) && (off < err_off)){
							off = err_off;	// O񔭌ubN̏Iʒu
							if (off <= end_off)
								crc = crc_update(0, buf + off, block_size);
							//printf("off = %d after cover\n", off);
						}
					}
					fail_count = 0;	// 댟o񐔂
					fail_off = file_off + off;	// XCh̊Jnʒu
				} else {	// łȂAʒu 1oCg炷
					prev_crc = crc;
					crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
					off++;
					if (crc == prev_crc){	// 1oCg炵Ă CRC ȂACRC Ԃ͖
						// قȂf[^œ CRC ɂȂXCXgĂA
						// XChɕK CRC ω̂ŁÂŌƂ͖I
						//int off2 = off - 1;
						while ((off < end_off) && (crc == prev_crc)){
							crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
							off++;
						}
						//printf("skip %d\n", off - off2);
					} else if (find_flag == -3){
						fail_count++;
						//printf("MD5 fail %u, off = %I64d, Ave = %u\n", fail_count, file_off + off, (unsigned int)((file_off + off - fail_off) / (__int64)fail_count));
						if (fail_count == FAIL_MAX){
							// CRC  MD5 قȂ邱Ƃ ( 8̔Ԋu 1KB ȉ) Ȃ
							if (file_off + off - fail_off <= (__int64)(FAIL_MAX << FAIL_LIMIT)){
								if (off <= rear_off){	// ꎞIɊȈՌ̑OvEvɐ؂ւ
									if (off < rear_off){
										off = rear_off;
										crc = crc_update(0, buf + off, block_size);
									}
									//printf("skip to rear %d, off = %I64d\n", off, file_off + off);
								} else if (off < end_off){
									off = end_off;
									if (off == block_size)	// ̃[v̕vZĂ
										crc = crc_update(0, buf + off, block_size);
									//printf("skip to block, off = %I64d\n", file_off + off);
								}
							}
							fail_count = 0;	// 񐔂𐔂Ȃ
							fail_off = file_off + off;
						}
					}
				}
			}

			if (file_next > file_size)
				break;	// obt@[̏I[łt@C̎c肪ȂI
			// ubN̏I[ɒB̂Ȃobt@[e炷
			//printf("%9I64d, off = %d, next = %d\n", file_off, off, find_next);
			memcpy(buf, buf + block_size, block_size);	// ڂ擪Ɉڂ
			off -= block_size;
			if (file_next < file_size){	// t@C̏I[ɒBĂȂ΁Acǂݍ
/*				if ((file_next + (__int64)block_size) > file_size){
					len = (unsigned int)(file_size - file_next);
					memset(buf + len, 0, block_size - len);
				} else {
					len = (unsigned int)block_size;
				}
				if (!ReadFile(hFile, buf + block_size, len, &i, NULL) || (len != (unsigned int)i))
					memset(buf + block_size, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
*/
				WaitForSingleObject(sc->end, INFINITE);	// TuEXbh̓ǂݍݏI̍}҂
				if (sc->size == 0xFFFFFFFF)
					return find_num;	// ǂ݂ݎɃG[AI
				memcpy(buf + block_size, buf + (block_size * 2), len);	// ǂݍłڂ
				memset(buf + (block_size + len), 0, block_size - len);
				file_next += len;	// t@CE|C^[̈ʒu
			} else if (file_next == file_size){	// ɓǂݍ݂IĂȂ
				end_off = (unsigned int)(file_size - file_off - (__int64)block_size);	// Ō̃[v͈͂
				//printf("last loop: off = %u, end_off = %u\n", off, end_off);
				if (off >= end_off)
					break;	// 鏊cĂȂ
				memset(buf + end_off, 0, (block_size * 2) - end_off);
				file_next++;	// Ƀ[vȂ悤ɂĂ
			}
			if (off > 0)	// CRCvZȂĂ
				crc = crc_update(0, buf + off, block_size);
			file_off += block_size;

			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress_file((int)((file_off * 1000) / file_size), first_num, file_name))
					return -2;
				time_last = GetTickCount();
			}
		}
	}

	// ȃt@C܂͖̔[ȃubŇ
	if ((short_count > 0) && (last_off + (__int64)(sc->min_size) <= file_size)){
		if ((file_off == 0) && (file_size <= (__int64)block_size * 2)){	// 擪͊ɓǂݍł
			len = (int)file_size;
			i2 = 0;
		} else {
			len = block_size * 2 - 1;	// őŃubNETCY * 2 - 1 oCgǂݍ
			if ((__int64)len > file_size)
				len = (int)file_size;
			file_off = file_size - len;
			//printf("last_off = %I64d, min size = %d\n", last_off, sc->min_size);
			if (file_off < last_off){
				file_off = last_off;
				len = (int)(file_size - file_off);
			}
			i2 = -1;	// ܂t@Cf[^ǂݍłȂ
		}
		//printf("last search from %I64d, size = %d\n", file_off, len);
		for (num = 0; num < entity_num; num++){	// t@Cԍ
			if (short_use[num] == 0)
				continue;	// [ȃubN܂܂Ȃt@C͏O
			i = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
			last_size = s_blk[i].size;
			// ŁAf[^菬ȁA[ȖubNȂ
			if ((last_size <= len) && ((s_blk[i].exist & 0x1000) == 0)){
				if (i2 < 0){	// KvɂȂď߂ēǂݍ
					i2 = 0;
					if (file_read_data(hFile, file_off, buf, len))
						return find_num;	// G[Ȃ猟I
					//buf[len] = 0;	// 炷 0 Ŗ߂Ă
				}
				if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
					short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - last_size);
					short_use[num] |= 4;	// CRC-32 vZς݂̈
				}
				off = len - last_size;
				if (crc_update(0, buf + off, last_size) == short_crcs[num]){	// CRC-32 v
					data_md5_block(buf + off, last_size, hash);
					if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
						// ubNt@C̓rɂ΁ÃubNĂƉ肷
						if ((sc->flake_count >= 0) && (file_off == 0) && (off > 1) && (off < block_size)){
							i1 = i - 1;	// ÕubN̔ԍ
							if (((i1 == files[num].b_off) && (off + 1 == block_size))	// ubNETCY-1 Ȃł
									|| (i1 > files[num].b_off)){	// 擪ubN͏O
								// ̃t@CōŏɃubNȂ̂ŁÃt@Cł͖
								//printf("slice[%3d] : rear  flake size = %d \n", i1, off);
								find_num++;
								write_ini_verify(i1, 8, off);	// fЂ̃TCY
								if (s_blk[i1].exist == 0)	// Ȃ㔼̒fЂۊǂ
									save_flake(buf, i1, off, 0, sc);
							}
						}
						if (s_blk[i].exist == 0){	// ̃ubNȂ
							if (switch_v & 16){	// Rs[
								if (open_temp_file(temp_path, num, files, sc))
									return -1;
								if (file_write_data(sc->hFile_tmp,
										(__int64)(i - files[num].b_off) * (__int64)block_size, buf + off, last_size)){
									printf("file_write_data, %d\n", i);
									return -1;
								}
							}
							s_blk[i].exist = 2;
							first_num++;
						}
						if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
							find_num++;
							write_ini_verify(i, 0, file_off + off);
						}
						s_blk[i].exist |= 0x1000;	// ̃t@CŌ
						//printf("%9I64d,%8d : E %d, F %d\n", file_off + off, last_size, i, s_blk[i].file);	// End

						// oߕ\
						if (GetTickCount() - time_last >= UPDATE_TIME){
							if (print_progress_file(1000, first_num, file_name))
								return -2;
							time_last = GetTickCount();
						}
					}	// ̂傫ȖubNƂvĂ邩Ȃ̂ős
				}
			}
		}
	}

	return find_num;
}

#else	// [ȃXCXXChꍇ

// XChŃ\[XEubNT (TuEXbhubNǂݍ)
// ubNETCY * 3 < 4GB ł邱
// -2=LZ, -1=G[, 0=Ȃ, 1`=
static int search_block_slide(
	wchar_t *temp_path,		// ƗpAfBNgĂ
	int num1,				// file_ctx ɂ鏉Ԃ̃t@Cԍ (mȂ -1)
	unsigned int last_size,	// ubÑTCY
	wchar_t *file_name,		// \t@C
	HANDLE hFile,			// t@C̃nh
	__int64 file_size,		// ݂t@C̃TCY
	__int64 last_off,		// ǂ猟Jn邩 (܂ł͊Ɍς)
	int switch_v,			// +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)
{
	unsigned char *buf, hash[16], err_mag, *short_use;
	int i, j, find_num, find_flag, find_next, find_last, short_next;
	int block_count, short_count, tiny_count, tiny_skip, num, i1, i2, i3, i4;
	int *order, *index, index_shift;
	unsigned int len, off, end_off, err_off;
	unsigned int prev_crc, fail_count, rear_off;
	unsigned int crc, *crcs, *short_crcs, *short_tbls, *short_tbl;
	unsigned int time_last;
	__int64 file_off, file_next, short_off, fail_off;

	if (file_size + 1 < last_off + (__int64)(sc->min_size))
		return 0;	// t@Cׂ͒Ȃ
	find_num = 0;	// ̃t@CŉubN
	find_next = -1;	// ɌƗ\zubN̔ԍ
	find_last = -1;	// ŌɌubN̔ԍ (-1=s)
	short_next = -1;
	fail_count = 0;	// CRC ͈v MD5 
	fail_off = 0;
	rear_off = 0;
	if (num1 >= 0){	// t@Cԍw肳ĂȂ
		find_next = (int)(last_off / (__int64)block_size);	// JnʒũubNԍ
		find_next += files[num1].b_off;
		if (last_off > 0)	// SȃubNĂȂ
			find_last = find_next - 1;	// ŌɌubN̔ԍ
		if ((last_off >= files[num1].size) || (last_off + block_size > file_size + 1))
			find_next = -1;	// \zʒut@CETCY𒴂Ƒʖ
		if ((last_size < block_size) && (files[num1].b_num >= 2) &&	// ̔[ȃubN̔ԍƑzʒu
				(last_off < files[num1].size) && (files[num1].size <= file_size + 1)){
			short_next = files[num1].b_off + files[num1].b_num - 1;	// ubN̔ԍ
			if (find_next == short_next)
				find_next = -1;	// \zd疖ubNƂĒT
			short_off = files[num1].size - last_size;
		}
		if (file_size > files[num1].size){
			rear_off = (unsigned int)((file_size - files[num1].size) % (__int64)block_size);
		} else if (file_size < files[num1].size){
			rear_off = block_size - (unsigned int)((files[num1].size - file_size) % (__int64)block_size);
		}
		//printf("file = %d, find_next = %d, find_last = %d\n", num1, find_next, find_last);
		//printf("short_off = %I64d, short_next = %d, rear_off = %d\n", short_off, short_next, rear_off);
	}
	file_off = last_off;	// Jnʒu璲ׂ
	buf = sc->buf;
	// CfbNXET[`p
	block_count = sc->block_count;
	order = sc->order;
	crcs = order + block_count;
	index = crcs + block_count;
	index_shift = sc->index_shift;
	// [ȃubÑpfBO菜 CRC-32
	short_count = sc->short_count;
	short_crcs = index + (unsigned int)(1 << (32 - index_shift));
	short_use = (unsigned char *)(short_crcs + entity_num);
	short_tbls = (unsigned int *)(short_use + ((entity_num + 3) & ~3));
	tiny_count = 0;
	tiny_skip = 0;

	// ŏ̓ubNETCY̔{܂œǂݍ
	if (file_size < file_off + ((__int64)block_size * 2)){
		len = (unsigned int)(file_size - file_off);
		memset(buf + len, 0, (block_size * 2) - len);
	} else {
		len = block_size * 2;
	}
	if (file_read_data(hFile, file_off, buf, len))
		//memset(buf, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
		return 0;	// G[Ȃ猟I
	if (file_size <= file_off + (__int64)block_size){	// ͈͂ubNETCYȉȂ
		file_next = file_size + 1;	// ŏ̃[vŌI
	} else {
		file_next = file_off + len;	// t@CE|C^[̈ʒu
	}
	sc->hFile = hFile;
	time_last = GetTickCount();
	if (short_count > 0){	// ȃt@Č
		for (num = 0; num < entity_num; num++){
			if (short_use[num] & 1)
				tiny_count++;
		}
	}
	// ȃt@C̔[ȃubŇiXChłȂꍇ̂݁j
	if ((short_count > MAX_SHORT_CRC) && (last_off == 0)){
		//printf("tiny search from %I64d, size = %d, count = %d, %d\n", file_off, len, short_count, tiny_count);
		for (num = 0; num < entity_num; num++){	// t@Cԍ
			if (short_use[num] == 0)
				continue;	// [ȃubN܂܂Ȃt@C͏O
			i = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
			last_size = s_blk[i].size;
			// ŁAf[^菬ȁA[ȖubNȂ
			if ((last_size <= len) && ((s_blk[i].exist & 0x1000) == 0)){
				if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
					short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - last_size);
					short_use[num] |= 4;	// CRC-32 vZς݂̈
				}
				//printf("tiny %d, size = %d, CRC = 0x%08X, 0x%08X\n", num, last_size, crc, short_crcs[num]);
				if (crc_update(0, buf, last_size) == short_crcs[num]){	// CRC-32 v
					data_md5_block(buf, last_size, hash);
					if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
						if (s_blk[i].exist == 0){	// ̃ubNȂ
							if (switch_v & 16){	// Rs[
								if (open_temp_file(temp_path, num, files, sc))
									return -1;
								if (file_write_data(sc->hFile_tmp,
										(__int64)(i - files[num].b_off) * (__int64)block_size, buf, last_size)){
									printf("file_write_data, %d\n", i);
									return -1;
								}
							}
							s_blk[i].exist = 2;
							first_num++;
						}
						if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
							find_num++;
							write_ini_verify(i, 0, file_off);
						}
						s_blk[i].exist |= 0x1000;	// ̃t@CŌ
						//printf("%9I64d,%8d : T %d, F %d\n", file_off, last_size, i, s_blk[i].file);	// Tiny
						if (last_off < file_off + last_size)
							last_off = file_off + last_size;	// ԑ傫Ȕ[ȃubN̏I[
						find_next = -2;	// ȃt@C = ubNo̗\zOꂽ
						if (i == short_next)
							short_next = -1;	// ubN͌oς

						// oߕ\
						if (GetTickCount() - time_last >= UPDATE_TIME){
							if (print_progress_file(0, first_num, file_name))
								return -2;
							time_last = GetTickCount();
						}
					}	// ̂傫ȃt@CƂvĂ邩Ȃ̂ős
				}
			}
		}
		if (find_next != -2){	// ȃt@CȂȂ
			tiny_skip = -1;
			if ((*((unsigned short *)buf) == 0x7A37) && (*((unsigned int *)(buf + 2)) == 0x1C27AFBC)){	// 7-Zipɂ SignatureHeader
				tiny_skip = 32;
				//printf("tiny_skip = 32 (7-Zip header size)\n");
			} else {
				i1 = 0;
				while (*((unsigned int *)(buf + i1)) == 0x04034b50){	// ZIPɂ local file header
					i2 = *((unsigned int *)(buf + i1 + 18));	// compressed size
					i3 = *((unsigned int *)(buf + i1 + 22));	// uncompressed size
					if (i2 != i3)
						break;	// kĂ
					i3 = *((unsigned short *)(buf + i1 + 26));	// file name length
					i4 = *((unsigned short *)(buf + i1 + 28));	// extra field length
					if (i1 + 30 + i3 + i4 + i2 > file_size)
						break;	// t@Cr܂
					i1 += 30 + i3 + i4;
					if (i2 > 0){	// ̃t@CiTuEfBNgj͖
						tiny_skip = i1;
						//printf("tiny_skip = %d (ZIP header size + %d + %d)\n", tiny_skip, i3, i4);
						break;
					}
				}
			}
		}
	}

	// ubNETCYƂɒT
	if ((((block_count > 0) || ((short_count > 0) && (short_count <= MAX_SHORT_CRC)))
			&& ((file_off + (__int64)block_size <= file_size)
			|| (find_next >= 0))) || (short_next >= 0)){	// ubN̈ʒu\zĒT
		// OXChȂ`FbNTr
		//printf("slide search from %I64d, file %d, next = %d\n", file_off, num1, find_next);
		off = 0;	// buf ł̃ItZbg
		if (file_size >= (__int64)block_size){
			end_off = block_size;
		} else {
			end_off = (unsigned int)file_size;
		}
		crc = crc_update(0, buf, block_size);
		if ((short_count > 0) && (short_count <= MAX_SHORT_CRC)){
			for (num = 0; num < entity_num; num++){	// t@Cԍ
				if (short_use[num] & 8){
					short_tbl = short_tbls + 257 * num;
					j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
					short_tbl[256] = crc_update(0, buf, s_blk[j].size);
					//printf("CRC[%2d] = %08x, %d byte\n", num, short_tbl[256], s_blk[j].size);
				}
			}
		}
		while (1){
			//printf("Loop from %9I64d+%8d for %d\n", file_off, off, end_off);
			if (file_next < file_size){	// t@C̏I[ɒBĂȂ΁Acǂݍ
				if ((file_next + (__int64)block_size) > file_size){
					len = (unsigned int)(file_size - file_next);
				} else {
					len = block_size;
				}
				sc->size = len;
				_mm_sfence();
				SetEvent(sc->run);	// TuEXbhɓǂݍ݂Jn
				//printf("read from %I64d, %d byte\n", file_next, len);
			}

			while (off < end_off){
				find_flag = -2;
				// ̔ԍ̃ubN̈ʒuɂ邩ɒׂ (ς݂ł)
				if ((short_next >= 0) && (file_off + off == short_off)){	// [ȃubNȂ
					i = short_next;
					num = s_blk[i].file;
					if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
						short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - s_blk[i].size);
						short_use[num] |= 4;	// CRC-32 vZς݂̈
					}
					//printf("short[%d], size = %d, short_crc = 0x%08X\n", i, s_blk[i].size, short_crcs[num]);
					find_flag = correct_error(buf + off, s_blk[i].size, s_blk[i].hash, short_crcs[num], &err_off, &err_mag);
					if (find_flag == 0)
						find_flag = 2;
				} else if ((find_next >= 0) && (file_off + off == last_off)){	// tTCỸubNȂ
					i = find_next;
					if (crc == s_blk[i].crc){
						data_md5(buf + off, block_size, hash);
						find_flag = -3;	// MD5 vZς݂̈
						if (memcmp(hash, s_blk[i].hash, 16) == 0)	// X MD5 v
							find_flag = 3;
					} else {	// ΈʒuȎG[݂
						find_flag = correct_error2(buf + off, block_size, crc, s_blk[i].hash, s_blk[i].crc, &err_off, &err_mag);
					}
				}
				if (find_flag < 0){	// \zubNȂꍇ͑SẴubNƔr
//					j = binary_search(order, block_count, crc, s_blk);
//					j = index_search(crcs, block_count, crc, index, index_shift);
					j = 0x00FFFFFF;	// Ȃ
					i = index[crc >> index_shift];	// ẑǂɂ邩
					// jAET[`Ŏc肩T
					while (i < block_count){
						if (crcs[i] > crc)
							break;	// ȂړI̒l݂͑Ȃ
						if (crcs[i] == crc){
							j = i;
							break;
						}
						i++;
					}
					// vubNDxʂɋL^
					i1 = i2 = i3 = i4 = -1;
					for (; j < block_count; j++){	// ubNv邩Ȃ̂
						if (crcs[j] != crc)
							break;	// CRC-32 vȂȂ甲
						i = order[j];
						// OubNo͈͂ł́Aoς݂̃ubN𖳎
						if ((file_off + off < last_off) && ((s_blk[i].exist & 0x1000) != 0))
							continue;
						if (find_flag != -3){	// CRC-32 v MD5 vZ
							data_md5(buf + off, block_size, hash);
							find_flag = -3;	// MD5 vZς݂̈
							// CRC-32 ͈vĂ MD5 ႤƂ́ARɂ
							// ŁAԊu̕ςŃt[Y肷
						}
						if (memcmp(hash, s_blk[i].hash, 16) == 0){	// MD5 v邩m߂
							if ((s_blk[i].exist & 0x1000) == 0){	// ̃t@CŖ̃ubNDIɒT (edĂꍇɏۂ)
								if (s_blk[i].file == num1){	// w肳ꂽt@Cԍ̃ubN
									i1 = i;
									break;	// ŗD̃ubNꍇ͒Ƀ[v甲
								} else {
									i2 = i;
									if (num1 < 0)
										break;
								}
							} else {	// ̃t@CŔς݂̃ubNr (eRs[ĒǉςF)
										// [ȃubN̓XChŌȂ̂ŁAΈʒuQlɂ邽
								if (s_blk[i].file == num1){
									i3 = i;
								} else {
									i4 = i;
								}
							}
						}
					}
					// łDx̍ubNƂĔF
					if (i1 >= 0){
						find_flag = 4;
						i = i1;	// w肳ꂽt@CԍŖ̃ubN
					} else if (i2 >= 0){
						find_flag = 4;
						i = i2;	// ̃t@CԍŖ̃ubN
					} else if (i3 >= 0){
						find_flag = 4;
						i = i3;	// w肳ꂽt@CԍŔς݂̃ubN
					} else if (i4 >= 0){
						find_flag = 4;
						i = i4;	// ̃t@CԍŔς݂̃ubN
					}
				}
				// [ȃXCXr
				if ((find_flag < 0) && (short_count > 0) && (short_count <= MAX_SHORT_CRC)){
					i1 = -1;
					i2 = 0;
					for (num = 0; num < entity_num; num++){	// t@Cԍ
						if (short_use[num] & 8){
							short_tbl = short_tbls + 257 * num;
							i = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
							last_size = s_blk[i].size;
							if (short_tbl[256] == short_crcs[num]){	// CRC-32 v
								data_md5_block(buf + off, last_size, hash);
								if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
									// ̃XCXƈvꍇ͑傫̗p
									if (last_size > (unsigned int)i2){
										i1 = i;
										i2 = last_size;
									}
								} else {
									find_flag = -3;
								}
							}
						}
					}
					if (i1 >= 0){	// [ȃXCX
						find_flag = 4;
						i = i1;
						//printf("short search, found %d (file %d) at %d\n", i, s_blk[i].file, off);
					}
				}
				// ubNȂꍇ́AO񌟏oubŇゾAȃt@CƔr
				// rΏۂƒxȂ̂ŁA͈͂ŌȂ΂߂
				if ((find_flag < 0) && (short_count > MAX_SHORT_CRC) && (tiny_count > 0) && (file_off + off == last_off + tiny_skip)){
					//printf("tiny search at %d\n", off);
					i1 = -1;
					i2 = 0;
					for (num = 0; num < entity_num; num++){	// t@Cԍ
						if ((short_use[num] & 3) != 1)
							continue;	// ȃt@Cr
						i = files[num].b_off;	// ȃt@C̐擪ubN̔ԍ
						if ((s_blk[i].exist & 0x1000) != 0)
							continue;	// t@CŌoς݂Ȃ珜O
						last_size = s_blk[i].size;
						if ((short_use[num] & 4) == 0){	// pfBO菜 CRC-32 tZ
							short_crcs[num] = crc_reverse_zero(s_blk[i].crc, block_size - last_size);
							short_use[num] |= 4;	// CRC-32 vZς݂̈
						}
						if (crc_update(0, buf + off, last_size) == short_crcs[num]){	// CRC-32 v
							data_md5_block(buf + off, last_size, hash);
							if (memcmp(hash, s_blk[i].hash, 16) == 0){	// X MD5 v
								// ̃XCXƈvꍇ͑傫̗p
								if (last_size > (unsigned int)i2){
									i1 = i;
									i2 = last_size;
								}
							} else {
								find_flag = -3;
							}
						}
					}
					if (i1 >= 0){	// ȃt@C
						find_flag = 4;
						i = i1;
					} else if (tiny_skip == 0){	// ubNȂ
						i1 = 0;
						while (*((unsigned int *)(buf + off + i1)) == 0x04034b50){	// ZIPɂ local file header
							i2 = *((unsigned int *)(buf + off + i1 + 18));	// compressed size
							i3 = *((unsigned int *)(buf + off + i1 + 22));	// uncompressed size
							if (i2 != i3)
								break;	// kĂ
							i3 = *((unsigned short *)(buf + off + i1 + 26));	// file name length
							i4 = *((unsigned short *)(buf + off + i1 + 28));	// extra field length
							if (last_off + i1 + 30 + i3 + i4 + i2 > file_size)
								break;	// t@Cr܂
							i1 += 30 + i3 + i4;
							if (i2 > 0){	// ̃t@CiTuEfBNgj͖
								tiny_skip = i1;
								//printf("tiny_skip = %d (header size + %d + %d)\n", tiny_skip, i3, i4);
								break;
							}
						}
					} else {
						tiny_skip = 0;
					}
				}
				if (find_flag >= 0){	// ̈ʒuŃubÑ`FbNTv
					num = s_blk[i].file;	// ubNt@Cԍ
					// t@Crn܂ĂȂAubNĂƉ肷
					// ʂ̋L^ǂݎ₷悤ɁA{̌oubNɋL^
					if ((sc->flake_count >= 0) && (file_off == 0) && (off > 1)){	// fЂ 2oCgȏKv
						i1 = i - 1;	// ÕubN̔ԍ
						if (((i1 == files[num].b_off) && (off + 1 == block_size))	// ubNETCY-1 Ȃł
								|| (i1 > files[num].b_off)){	// 擪ubN͏O
							// ̃t@CōŏɃubNȂ̂ŁÃt@Cł͖
							//printf("slice[%3d] : rear  flake size = %d \n", i1, off);
							find_num++;
							write_ini_verify(i1, 8, off);	// fЂ̃TCY
							if (s_blk[i1].exist == 0)	// Ȃ㔼̒fЂۊǂ
								save_flake(buf, i1, off, 0, sc);
						}
					}
					if (s_blk[i].exist == 0){	// ̃ubNȂ
						if (switch_v & 16){	// Rs[
							if (open_temp_file(temp_path, num, files, sc))
								return -1;
							if (file_write_data(sc->hFile_tmp,
									(__int64)(i - files[num].b_off) * (__int64)block_size, buf + off, s_blk[i].size)){
								printf("file_write_data, %d\n", i);
								return -1;
							}
						}
						s_blk[i].exist = 2;
						first_num++;
					}
					if ((s_blk[i].exist & 0x1000) == 0){	// t@CŏdĂĂ񂾂L^
						find_num++;
						write_ini_verify(i, find_flag, file_off + off);
					}
					if (find_flag == 1)	// G[߂Ă
						buf[err_off + off] ^= err_mag;
					if (find_flag > 3){	// XChŌꍇ
						if (file_off + off + 1 < last_off){	// ÕubNƍ̂dȂĂȂ
							find_flag = 5;	// dȂĂȂ玟̃ubNT (O̃ubNdȂ̂͋ۂ)
							err_off = (unsigned int)(last_off - file_off);	// 2oCgȏジ
							//printf("cover [%I64d to %I64d], last [%I64d to %I64d], next off = %d\n",
							//		file_off + off, file_off + off + block_size, last_off - block_size, last_off, err_off);
						} else if ((find_last < i) && (find_last >= files[num].b_off)){
							// O񌩂ubNt@CɏĂ
							if (file_off + off == last_off + ((__int64)block_size * (__int64)(i - find_last - 1)))
								find_flag = 3;	// 񌩂ubN̈ʒuĂȂ
						}
					} else if (s_blk[i].exist & 0x1000){
						// ȈʒuŌꍇłAt@CŌoς݂̂Ȃ
						find_flag = 4;	// jĂ\
					}
					if ((short_count > 0) && (short_count <= MAX_SHORT_CRC))
						short_use[num] &= ~8;	// x[ȃXCX̓XCh珜O
					s_blk[i].exist |= 0x1000;	// ̃t@CŌ
					last_off = file_off + off + s_blk[i].size;	// ŌɌubN̏I[
					find_last = i;
/*					if (find_flag == 1){
						printf("%9I64d+%8u : C %d, F %d\n", file_off, off, i, s_blk[i].file);	// Corrected
					} else if (find_flag == 2){
						printf("%9I64d+%8u : L %d, F %d\n", file_off, off, i, s_blk[i].file);	// Last
					} else if (find_flag == 3){
						printf("%9I64d+%8u : N %d, F %d\n", file_off, off, i, s_blk[i].file);	// Next
					} else if (s_blk[i].size < block_size){
						printf("%9I64d+%8u : T %d, F %d, Size %d\n", file_off, off, i, s_blk[i].file, s_blk[i].size);	// Tiny
					} else {
						printf("%9I64d+%8u : S %d, F %d\n", file_off, off, i, s_blk[i].file);	// Search
					}*/
					// ɌubN\
					find_next = i + 1;
					if ((find_next >= source_num) || (s_blk[find_next].file != num)){
						// Ō܂łA܂̓t@CقȂ
						short_next = -1;
						find_next = -1;
					} else if (s_blk[find_next].size < block_size){	// [ȃubN͕ʂɒׂ
						short_next = find_next;
						short_off = file_off + off + block_size;
						//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
						find_next = -1;
					} else {
						short_next = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
						if (s_blk[short_next].size < block_size){	// [ȃubN͕ʂɒׂ
							short_off = file_off + off + (__int64)(short_next - i) * (__int64)block_size;
							//printf("short_off = %I64d, short_next = %d, file = %d\n", short_off, short_next, num);
						} else {
							short_next = -1;
						}
					}
					tiny_skip = 0;	// ȃt@CubNɈ񂾂T
					// t@CrŏIĂȂAubNĂƉ肷
					if ((sc->flake_count >= 0) &&
							(file_off + (__int64)(off + s_blk[i].size + block_size - 1) > file_size) &&
							(file_off + (__int64)(off + s_blk[i].size) + 1 < file_size)){	// fЂ 2`ubNETCY-2 oCg
						i1 = i + 1;	// ubN̔ԍ (t@C̖ubN͏)
						i3 = files[num].b_off + files[num].b_num - 1;	// ̃t@C̖̃ubNԍ
						//printf("id = %d, start = %d, max = %d \n", i1, files[num].b_off, i3);
						if ((i1 < i3) && ((s_blk[i1].exist & 0x1000) == 0)){	// t@CŖȂ
							i2 = (int)(file_size - file_off) - off - s_blk[i].size;	// fЂ̃TCY
							//printf("slice[%3d] : front flake size = %d \n", i1, i2);
							find_num++;
							write_ini_verify(i1, 9, file_off + (__int64)(off + s_blk[i].size));	// fЂ̈ʒu
							if (s_blk[i1].exist == 0)	// Ȃ㔼̒fЂۊǂ
								save_flake(buf + (off + s_blk[i].size), i1, i2, 1, sc);
						}
					}
					if (find_flag <= 3){	// ̂ȃubNȂ
						// ̃ubÑ͍ubŇɑƗ\z
						off += s_blk[i].size;
						if (off <= end_off){
							crc = crc_update(0, buf + off, block_size);
							if ((short_count > 0) && (short_count <= MAX_SHORT_CRC)){
								for (num = 0; num < entity_num; num++){	// t@Cԍ
									if (short_use[num] & 8){
										short_tbl = short_tbls + 257 * num;
										j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
										short_tbl[256] = crc_update(0, buf + off, s_blk[j].size);
									}
								}
							}
						}
					} else { // ubNԍԒʂɂȂĂȂȂ (jĂ)
						// t@CeɏdƁÃubNɌĂ܂āA
						// ubNETCY炷Ɩ{̃ubNȂȂ̂ 1oCg炷
						prev_crc = crc;
						crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
						off++;
						if (crc == prev_crc){	//  CRC ̃ubNdȂ͈͓ŔȂ悤ɂ
							//int off2 = off - 1;
							while ((off < end_off) && (file_off + off < last_off) && (crc == prev_crc)){
								crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
								off++;
							}
							//printf("skip %d after find\n", off - off2);
						}
						if ((find_flag == 5) && (off < err_off)){
							off = err_off;	// O񔭌ubN̏Iʒu
							if (off <= end_off){
								crc = crc_update(0, buf + off, block_size);
								if ((short_count > 0) && (short_count <= MAX_SHORT_CRC)){
									for (num = 0; num < entity_num; num++){	// t@Cԍ
										if (short_use[num] & 8){
											short_tbl = short_tbls + 257 * num;
											j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
											short_tbl[256] = crc_update(0, buf + off, s_blk[j].size);
										}
									}
								}
							}
							//printf("off = %d after cover\n", off);
						}
					}
					fail_count = 0;	// 댟o񐔂
					fail_off = file_off + off;	// XCh̊Jnʒu
				} else {	// łȂAʒu 1oCg炷
					prev_crc = crc;
					crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
					if ((short_count > 0) && (short_count <= MAX_SHORT_CRC)){
						for (num = 0; num < entity_num; num++){	// t@Cԍ
							if (short_use[num] & 8){
								short_tbl = short_tbls + 257 * num;
								j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
								short_tbl[256] = crc_table[(short_tbl[256] & 0xFF) ^ buf[off + s_blk[j].size]] ^ (short_tbl[256] >> 8) ^ short_tbl[buf[off]];
							}
						}
					}
					off++;
					if (crc == prev_crc){	// 1oCg炵Ă CRC ȂACRC Ԃ͖
						// قȂf[^œ CRC ɂȂXCXgĂA
						// XChɕK CRC ω̂ŁÂŌƂ͖I
						//int off2 = off - 1;
						while ((off < end_off) && (crc == prev_crc)){
							crc = CRC_SLIDE_CHAR(crc, buf[off + block_size], buf[off]);
							off++;
						}
						//printf("skip %d\n", off - off2);
					} else if (find_flag == -3){
						fail_count++;
						//printf("MD5 fail %u, off = %I64d, Ave = %u\n", fail_count, file_off + off, (unsigned int)((file_off + off - fail_off) / (__int64)fail_count));
						if (fail_count == FAIL_MAX){
							// CRC  MD5 قȂ邱Ƃ ( 8̔Ԋu 1KB ȉ) Ȃ
							if (file_off + off - fail_off <= (__int64)(FAIL_MAX << FAIL_LIMIT)){
								if (off <= rear_off){	// ꎞIɊȈՌ̑OvEvɐ؂ւ
									if (off < rear_off){
										off = rear_off;
										crc = crc_update(0, buf + off, block_size);
									}
									//printf("skip to rear %d, off = %I64d\n", off, file_off + off);
								} else if (off < end_off){
									off = end_off;
									if (off == block_size)	// ̃[v̕vZĂ
										crc = crc_update(0, buf + off, block_size);
									//printf("skip to block, off = %I64d\n", file_off + off);
								}
							}
							fail_count = 0;	// 񐔂𐔂Ȃ
							fail_off = file_off + off;
						}
					}
				}
			}

			if (file_next > file_size)
				break;	// obt@[̏I[łt@C̎c肪ȂI
			// ubN̏I[ɒB̂Ȃobt@[e炷
			//printf("%9I64d, off = %d, next = %d\n", file_off, off, find_next);
			memcpy(buf, buf + block_size, block_size);	// ڂ擪Ɉڂ
			off -= block_size;
			if (file_next < file_size){	// t@C̏I[ɒBĂȂ΁Acǂݍ
/*				if ((file_next + (__int64)block_size) > file_size){
					len = (unsigned int)(file_size - file_next);
					memset(buf + len, 0, block_size - len);
				} else {
					len = (unsigned int)block_size;
				}
				if (!ReadFile(hFile, buf + block_size, len, &i, NULL) || (len != (unsigned int)i))
					memset(buf + block_size, 0, len);	// ǂݍݎɃG[ 0 ɂĂ
*/
				WaitForSingleObject(sc->end, INFINITE);	// TuEXbh̓ǂݍݏI̍}҂
				if (sc->size == 0xFFFFFFFF)
					return find_num;	// ǂ݂ݎɃG[AI
				memcpy(buf + block_size, buf + (block_size * 2), len);	// ǂݍłڂ
				memset(buf + (block_size + len), 0, block_size - len);
				file_next += len;	// t@CE|C^[̈ʒu
			} else if (file_next == file_size){	// ɓǂݍ݂IĂȂ
				end_off = (unsigned int)(file_size - file_off - (__int64)block_size);	// Ō̃[v͈͂
				//printf("last loop: off = %u, end_off = %u\n", off, end_off);
				if (off >= end_off)
					break;	// 鏊cĂȂ
				memset(buf + end_off, 0, (block_size * 2) - end_off);
				file_next++;	// Ƀ[vȂ悤ɂĂ
			}
			if (off > 0){	// CRCvZȂĂ
				crc = crc_update(0, buf + off, block_size);
				if ((short_count > 0) && (short_count <= MAX_SHORT_CRC)){
					for (num = 0; num < entity_num; num++){	// t@Cԍ
						if (short_use[num] & 8){
							short_tbl = short_tbls + 257 * num;
							j = files[num].b_off + files[num].b_num - 1;	// ubN̔ԍ
							short_tbl[256] = crc_update(0, buf, s_blk[j].size);
						}
					}
				}
			}
			file_off += block_size;

			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress_file((int)((file_off * 1000) / file_size), first_num, file_name))
					return -2;
				time_last = GetTickCount();
			}
		}
	}

	return find_num;
}

#endif

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// t@CƂɌXCX\
static int show_file_slice(
	char *ascii_buf,
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	int i, id, find_num, find_total;

	find_total = 0;	// p\ȃ\[XEubN̐
	find_num = 0;
	id = -1;	// t@Cԍ
	for (i = 0; i < source_num; i++){
		if (s_blk[i].exist != 0){
			find_total++;
			if (s_blk[i].exist & 0x1000){	// ̌Ŕ
				if (s_blk[i].file != id){
					if (id >= 0){
						utf16_to_cp(list_buf + files[id].name, ascii_buf, cp_output);
						printf("            = %8d : \"%s\"\n", find_num, ascii_buf);
					}
					id = s_blk[i].file;	// XCXt@Cԍ
					find_num = 0;
				}
				find_num++;
				s_blk[i].exist &= 0x0FFF;	// t@CŌö
			}
		}
	}
	if (id >= 0){
		utf16_to_cp(list_buf + files[id].name, ascii_buf, cp_output);
		printf("            = %8d : \"%s\"\n", find_num, ascii_buf);
	}

	return find_total;
}

// jt@C̐擪jӏ܂łƃt@CɃRs[
static int file_copy_size(
	int num1,			// t@Cԍ
	wchar_t *file_name,	// \t@C
	__int64 file_size,	// o߂rt@CETCY
	__int64 copy_size,	// Rs[TCY
	HANDLE hFile,		// t@C̃nh
	HANDLE hFile_tmp)	// ƃt@C̃nh
{
	unsigned char buf[IO_SIZE];
	unsigned int rv, len;
	unsigned int time_last, block_end;
	__int64 copy_end;
	LARGE_INTEGER qwi;	// Quad Word Integer

	// t@Cʒu擪ɂ
	qwi.QuadPart = 0;
	if (!SetFilePointerEx(hFile, qwi, NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}
	if (!SetFilePointerEx(hFile_tmp, qwi, NULL, FILE_BEGIN)){
		print_win32_err();
		return 1;
	}

	// Rs[
	time_last = GetTickCount();
	block_end = 0;
	copy_end = 0;
	while (copy_size > 0){
		len = IO_SIZE;
		if (copy_size < IO_SIZE)
			len = (unsigned int)copy_size;
		copy_size -= len;
		block_end += len;
		if (!ReadFile(hFile, buf, len, &rv, NULL)){
			print_win32_err();
			return 1;
		}
		if (len != rv)
			return 1;	// wTCYǂݍ߂ȂG[ɂȂ
		if (!WriteFile(hFile_tmp, buf, len, &rv, NULL)){
			print_win32_err();
			return 1;
		}

		if (block_end >= block_size){	// ubNETCYƂ
			block_end -= block_size;
			copy_end += block_size;
			// oߕ\
			if (GetTickCount() - time_last >= UPDATE_TIME){
				if (print_progress_file((int)((copy_end * 1000) / file_size), -1, file_name))
					return 2;
				time_last = GetTickCount();
			}
		}
	}

	return 0;
}

// \[XEt@C̃XCXT (t@C)
// 0=, 1=G[, 2=LZ
int check_file_slice(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	int num,				// file_ctx ɂt@Cԍ
	int switch_v,			// x +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)			// XCXp̏
{
	wchar_t temp_path[MAX_LEN], *file_name;
	int i, find_num, b_last, dir_len, name_off, name_len, num1;
	unsigned int last_size, meta_data[7];
	__int64 file_size;	// ݂t@C̃TCY͖{̃TCYƂ͈قȂ邱Ƃ
	HANDLE hFile, hFind;
	WIN32_FIND_DATA FindData;

	file_name = list_buf + files[num].name;
	wcscpy(temp_path, base_dir);	// fBNgĂ

	// XCX̑傫 (PAR2 ̃`FbNT̓pfBO܂)
	last_size = (unsigned int)(files[num].size % (__int64)block_size);
	if (last_size == 0)
		last_size = block_size;
	b_last = files[num].b_off + files[num].b_num;
	if (files[num].state & 0x80){
		num1 = -1;	// `FbNT݂Ȃꍇ̓t@Cԍw肵Ȃ
	} else {
		num1 = num;
	}

	if (files[num].state & 0x1A){	// j 0x02Aǉ 0x10Ajĕʖ 0x28 Ȃ\[XEt@C
		int comp_num;
		wcscpy(file_path, base_dir);
		wcscpy(file_path + base_len, file_name);
		hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)	// ݂͂̃\[XEt@CɃANZXłȂ
			return 1;	// XCXFƃt@C̍Đݒ肪߂ǂȂ̂ŃG[ɂ
		prog_last = -1;	// oߕ\܂̈
		find_num = check_ini_verify(file_name, hFile, num1, meta_data, switch_v, files, s_blk, sc);
		// find_num = t@CŌoXCX (̃t@C̃XCX܂)
		memcpy(&file_size, meta_data, 8);
		//printf("ini = %d, file_size = %I64d, first count = %d\n", find_num, file_size, first_num);
		if (file_size + 1 < (__int64)(sc->min_size)){	// t@Cׂ͒Ȃ
			find_num = 0;
		} else if (find_num != -1){	// G[ȊOȂ
			// jt@C̐擪ɊSȃXCX݂邩
			__int64 file_off = 0;
			comp_num = 0;	// 擪̊SȃXCX̐
			if (files[num].state & 2){	// jȂ 24-bit ɐ擪̊SȃXCXL^Ă
				comp_num = (unsigned int)(files[num].state) >> 8;
				files[num].state &= 0xFF;	//  24-bit ̋L^Ă
				if (comp_num > 0){	// jt@C̐擪ɊSȃXCXĂȂ
					for (i = files[num].b_off; i < files[num].b_off + comp_num; i++){
						s_blk[i].exist = 0x1002;	// ̃t@CŌ
						file_off += block_size;
					}
					if (switch_v & 16){	// Rs[
						if (open_temp_file(temp_path, num, files, sc)){
							CloseHandle(hFile);
							return 1;
						}
						if (i = file_copy_size(num1, file_name, file_size, file_off, hFile, sc->hFile_tmp)){
							CloseHandle(hFile);
							return i;
						}
					}
				}
			} else if (files[num].state & 8){	// jĕʖĂAjӏ͌
				comp_num = (unsigned int)(files[num].state) >> 8;
				files[num].state &= 0xFF;	//  24-bit ̋L^Ă
				if (comp_num > 0){
					for (i = files[num].b_off; i < files[num].b_off + comp_num; i++){
						s_blk[i].exist = 0x1001;	// ̃t@CŌ (ʖt@Cł͊S)
						file_off += block_size;
					}
				}
			} else if (files[num].state & 16){	// ǉȂSẴXCXSȂ͂
				comp_num = files[num].b_num;
				for (i = files[num].b_off; i < b_last; i++)
					s_blk[i].exist = 0x1001;	// ̃t@CŌ ({̃TCY܂ł͊S)
			}
			if (comp_num == files[num].b_num)
				file_off = files[num].size;	// Ō܂ŊS
			//printf("first search = %d, file_off = %I64d, state = 0x%08X\n", comp_num, file_off, files[num].state);

			// ʂƂċL^̂ file_off ȍ~ŌXCX̂
			if (find_num >= 0){	// ʂ̋L^
				find_num += comp_num;
			} else if (find_num == -3){	// ʂ̋L^
				//printf("switch_v = %d, file_off = %I64d\n", switch_v, file_off);
				// jȍ~𒲂ׂ
				if (switch_v & 1){	// ȈՌ
					find_num = search_block_simple(temp_path, num1, last_size, file_name,
							hFile, file_size, file_off, switch_v, files, s_blk, sc);
				} else {	// ڍ׌
					find_num = search_block_slide(temp_path, num1, last_size, file_name,
							hFile, file_size, file_off, switch_v, files, s_blk, sc);
				}
				if (find_num >= 0){	// ʂL^
					write_ini_verify2(num1, meta_data, switch_v, find_num);
					find_num += comp_num;
				} else {	// G[
					write_ini_verify2(num1, meta_data, switch_v, -1);	// ̋L^j
				}
			}
		}
		CloseHandle(hFile);	// t@C
		if (find_num < 0)	// G[
			return -find_num;	// ɃG[
		if (find_num > 0){	// XCXoꂽ
			if (sc->flake_count > 0){	// XCXfЂ̈v𒲂ׂ
				if (check_flake(temp_path, switch_v, files, s_blk, sc) != 0)
					return 1;
			}
			//printf("find item = %d, first count = %d\n", find_num, first_num);
			print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\
		}

		// \[XEt@C̓XCXołȂĂʂ\
		utf16_to_cp(file_name, ascii_buf, cp_output);
		if (files[num].state & 16){	// ǉȂ
			printf("%13I64d Appended : \"%s\"\n", file_size, ascii_buf);
		} else {	// jA܂͔jĕʖ
			printf("%13I64d Damaged  : \"%s\"\n", file_size, ascii_buf);
		}
		// w肳ꂽt@CɑXCX
		comp_num = 0;
		for (i = files[num].b_off; i < b_last; i++){
			if (s_blk[i].exist & 0x1000){
				comp_num++;
				s_blk[i].exist &= 0x0FFF;	// t@CŌö
			}
		}
		printf("            = %8d : \"%s\"\n", comp_num, ascii_buf);
		if (find_num > comp_num)	// ̃t@CɑXCX
			show_file_slice(ascii_buf, files, s_blk);
		fflush(stdout);
		find_num = comp_num;

	} else {	// ȂAŃXCXĂȂm߂
		find_num = 0;
		for (i = files[num].b_off; i < b_last; i++){
			if (s_blk[i].exist != 0)
				find_num++;
		}
	}

	// ̃t@C̃XCXSČoς݂ȂAt@CTȂ
	if (find_num == files[num].b_num)
		return 0;

	// t@Cގ̃t@CT
	get_base_dir(file_name, file_path);	// L^Ăt@C̃TuEfBNg
	dir_len = base_len + (int)wcslen(file_path);	// fBNg̒
	set_splited_filename(file_path, file_name, dir_len);
	//printf_cp("search  %s\n", file_path);
	hFind = FindFirstFile(file_path, &FindData);
	if ((hFind == INVALID_HANDLE_VALUE) && (files[num].state == 1)){	// Ń`FbNT
		// ̃t@CĂ̂ɁAt@CSȂ
		if (set_similar_filename(file_path, file_name, dir_len) != 0){	// t@CT
			//printf_cp("similar %s\n", file_path);
			hFind = FindFirstFile(file_path, &FindData);
		}
	}
	if (hFind == INVALID_HANDLE_VALUE)
		return 0;
	name_off = (int)(offset_file_name(file_name) - list_buf);	// t@CƂ̔rpɃt@C̑Έʒu
	name_len = (int)wcslen(list_buf + name_off);
	do {
		if (cancel_progress() != 0){	// LZ
			FindClose(hFind);
			return 2;
		}

		//printf_cp("find = %s\n", FindData.cFileName);
		// tH_͖
		if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0)
			continue;
		// t@Cꍇ͖
		if (dir_len + wcslen(FindData.cFileName) >= MAX_LEN)
			continue;
		// t@CETCYŏubNt@C͖
		file_size = ((__int64)(FindData.nFileSizeHigh) << 32) | (__int64)(FindData.nFileSizeLow);
		if (file_size + 1 < (__int64)(sc->min_size))
			continue;
		// t@CɕtĂ镔ÓłȂt@C͖
		if (check_extra_part(FindData.cFileName, list_buf + name_off, name_len))
			continue;

		// jĂȂJoEt@C͖
		wcscpy(temp_path + base_len, file_path + base_len);
		wcscpy(temp_path + dir_len, FindData.cFileName);	// St@CEpXɂ
		if (search_file_path(recv_buf, recv_len, temp_path))
			continue;
		// \[XEt@C⌟ς݂̕Eގt@C͖
		wcscpy(file_path, temp_path + base_len);	// fBNg̑΃t@CEpXɂ
		if (search_file_path(list_buf + 1, list_len - 1, file_path))
			continue;
		// j\[XEt@C̍ƃt@C͖EEEt`FbNĂ̂ŕsv
		//printf_cp("verify = %s\n", file_path);

		// t@C
		hFile = CreateFile(temp_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){	// t@CJȂe
			prog_last = -1;	// oߕ\܂̈
			find_num = check_ini_verify(FindData.cFileName, hFile, num1, meta_data, switch_v, files, s_blk, sc);
			//printf("ini = %d, file_size = %I64d\n", find_num, file_size);
			if (find_num == -3){	// ʂ̋L^
				if (switch_v & 1){	// ȈՌ
					find_num = search_block_simple(temp_path, num1, last_size, FindData.cFileName,
								hFile, file_size, 0, switch_v | 32, files, s_blk, sc);
				} else {	// ڍ׌
					find_num = search_block_slide(temp_path, num1, last_size, FindData.cFileName,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				}
				// ʂL^
				write_ini_verify2(num1, meta_data, switch_v, find_num);
			}
			CloseHandle(hFile);	// t@C
			if (add_file_path(file_path)){	// ς݃t@C̃t@CL^
				printf("add_file_path\n");
				find_num = -1;
			}
			if (find_num < 0){
				FindClose(hFind);
				return -find_num;	// ɃG[
			}
			if (find_num > 0){	// XCXoꂽ
				if (sc->flake_count > 0){	// XCXfЂ̈v𒲂ׂ
					if (check_flake(temp_path, switch_v, files, s_blk, sc) != 0){
						FindClose(hFind);
						return 1;
					}
				}
				//printf("find item = %d, first count = %d\n", find_num, first_num);
				print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\

				// t@C\ (̃t@CETCYɂ)
				utf16_to_cp(file_path, ascii_buf, cp_output);
				printf("%13I64d Found    : \"%s\"\n", file_size, ascii_buf);
				// t@CƂɌXCX\
				show_file_slice(ascii_buf, files, s_blk);
				fflush(stdout);
				if (first_num >= source_num){	// SẴXCX
					FindClose(hFind);	// ̎_Ō𒆎~
					return 0;
				}
			} else {
				print_progress_done();	// oߕ\ 100% ɂĂ
			}
		}
	} while (FindNextFile(hFind, &FindData));	// ̃t@C
	FindClose(hFind);

	return 0;
}

// t@CɊ܂܂鑼̃t@C̃XCXT
// 0=, 1=G[, 2=LZ
int search_file_split(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	int num,				// file_ctx ɂt@Cԍ
	int switch_v,			// x +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)			// XCXp̏
{
	wchar_t temp_path[MAX_LEN], *file_name;
	int find_num, dir_len, name_off, name_len;
	unsigned int meta_data[7];
	__int64 file_size;	// ݂t@C̃TCY͖{̃TCYƂ͈قȂ邱Ƃ
	HANDLE hFile, hFind;
	WIN32_FIND_DATA FindData;

	if (files[num].state & 0x03){	// Ɍς݂Ȃ珜O
		int i, b_last;
		b_last = files[num].b_off + files[num].b_num;
		find_num = 0;
		for (i = files[num].b_off; i < b_last; i++){
			if (s_blk[i].exist != 0)
				find_num++;
		}
		if (find_num < files[num].b_num)
			return 0;	// ƔjŁÃt@C̃XCXsĂꍇ͊Ɍς
	}

	file_name = list_buf + files[num].name;
	wcscpy(temp_path, base_dir);	// fBNgĂ

	// t@CT
	get_base_dir(file_name, file_path);	// L^Ăt@C̃TuEfBNg
	dir_len = base_len + (int)wcslen(file_path);	// fBNg̒
	set_splited_filename(file_path, file_name, dir_len);
	//printf_cp("search  %s\n", file_path);
	hFind = FindFirstFile(file_path, &FindData);
	if (hFind == INVALID_HANDLE_VALUE)
		return 0;
	name_off = (int)(offset_file_name(file_name) - list_buf);	// t@CƂ̔rpɃt@C̑Έʒu
	name_len = (int)wcslen(list_buf + name_off);
	do {
		if (cancel_progress() != 0){	// LZ
			FindClose(hFind);
			return 2;
		}

		//printf_cp("find = %s\n", FindData.cFileName);
		// tH_͖
		if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0)
			continue;
		// t@Cꍇ͖
		if (dir_len + wcslen(FindData.cFileName) >= MAX_LEN)
			continue;
		// t@CETCYŏubNt@C͖
		file_size = ((__int64)(FindData.nFileSizeHigh) << 32) | (__int64)(FindData.nFileSizeLow);
		if (file_size < (__int64)(sc->min_size))
			continue;
		// t@CɕtĂ镔ÓłȂt@C͖
		if (check_extra_part(FindData.cFileName, list_buf + name_off, name_len))
			continue;

		// jĂȂJoEt@C͖
		wcscpy(temp_path + base_len, file_path + base_len);
		wcscpy(temp_path + dir_len, FindData.cFileName);	// St@CEpXɂ
		if (search_file_path(recv_buf, recv_len, temp_path))
			continue;
		// \[XEt@C⌟ς݂̕Eގt@C͖
		wcscpy(file_path, temp_path + base_len);	// fBNg̑΃t@CEpXɂ
		if (search_file_path(list_buf + 1, list_len - 1, file_path))
			continue;
		// j\[XEt@C̍ƃt@C͖EEEt`FbNĂ̂ŕsv
		//printf_cp("verify = %s\n", file_path);

		// t@C
		hFile = CreateFile(temp_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){	// t@CJȂe
			prog_last = -1;	// oߕ\܂̈
			find_num = check_ini_verify(FindData.cFileName, hFile, -1, meta_data, switch_v, files, s_blk, sc);
			//printf("ini = %d, file_size = %I64d\n", find_num, file_size);
			if (find_num == -3){	// ʂ̋L^
				if (switch_v & 1){	// ȈՌ
					find_num = search_block_simple(temp_path, -1, 0, FindData.cFileName,
								hFile, file_size, 0, switch_v | 32, files, s_blk, sc);
				} else {	// ڍ׌
					find_num = search_block_slide(temp_path, -1, 0, FindData.cFileName,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				}
				// ʂL^
				write_ini_verify2(-1, meta_data, switch_v, find_num);
			}
			CloseHandle(hFile);	// t@C
			if (add_file_path(file_path)){	// ς݃t@C̃t@CL^
				printf("add_file_path\n");
				find_num = -1;
			}
			if (find_num < 0){
				FindClose(hFind);
				return -find_num;	// ɃG[
			}
			if (find_num > 0){	// XCXoꂽ
				if (sc->flake_count > 0){	// XCXfЂ̈v𒲂ׂ
					if (check_flake(temp_path, switch_v, files, s_blk, sc) != 0){
						FindClose(hFind);
						return 1;
					}
				}
				print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\

				// t@C\ (̃t@CETCYɂ)
				utf16_to_cp(file_path, ascii_buf, cp_output);
				printf("%13I64d Found    : \"%s\"\n", file_size, ascii_buf);
				// t@CƂɌXCX\
				show_file_slice(ascii_buf, files, s_blk);
				fflush(stdout);
				if (first_num >= source_num){	// SẴXCX
					FindClose(hFind);	// ̎_Ō𒆎~
					return 0;
				}
			} else {
				print_progress_done();	// oߕ\ 100% ɂĂ
			}
		}
	} while (FindNextFile(hFind, &FindData));	// ̃t@C
	FindClose(hFind);

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// w肳ꂽOt@C
// 0=, -1=G[, -2=LZ
int check_external_file(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	int switch_v,			// x +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)			// XCXp̏
{
	wchar_t *file_name;
	int list2_off = 0, len, find_num;
	unsigned int meta_data[7];
	__int64 file_size;
	HANDLE hFile;
	WIN32_FILE_ATTRIBUTE_DATA AttrData;

/*{
FILE *fp;
fp = fopen("list_buf.txt", "wb");
fwrite(list_buf, 2, list_len, fp);
fclose(fp);
}*/

	wcscpy(file_path, base_dir);	// fBNgĂ
	while (list2_off < list2_len){
		if (cancel_progress() != 0)	// LZ
			return 2;

		file_name = list2_buf + list2_off;
		len = (int)wcslen(file_name);
		if (!GetFileAttributesEx(file_name, GetFileExInfoStandard, &AttrData)){
			list2_off += len + 1;
			continue;
		}

		// t@CETCYŏubNt@C͖
		file_size = ((__int64)(AttrData.nFileSizeHigh) << 32) | (__int64)(AttrData.nFileSizeLow);
		if (file_size < (__int64)(sc->min_size)){
			list2_off += len + 1;
			continue;
		}
		// jĂȂJoEt@C͖
		if (search_file_path(recv_buf, recv_len, file_name)){
			list2_off += len + 1;
			continue;
		}
		if (_wcsnicmp(base_dir, file_name, base_len) == 0){	// fBNgȂ
			// \[XEt@C⌟ς݂̕Eގt@C͖
			// j\[XEt@C̍ƃt@C͖
			if ((search_file_path(list_buf + 1, list_len - 1, file_name + base_len)) ||
					(avoid_temp_file(file_name + base_len, files))){
				list2_off += len + 1;
				continue;
			}
		}
		utf16_to_cp(file_name, ascii_buf, cp_output);
		//printf("\n verifying, %s\n", ascii_buf);

		// t@CăXCXT
		hFile = CreateFile(file_name, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){
			prog_last = -1;	// oߕ\܂̈
			find_num = check_ini_verify(file_name, hFile, -1, meta_data, switch_v, files, s_blk, sc);
			if (find_num == -3){	// ʂ̋L^
				if (switch_v & 1){	// ȈՌ
					find_num = search_block_simple(file_path, -1, 0, file_name,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				} else {	// ڍ׌
					find_num = search_block_slide(file_path, -1, 0, file_name,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				}
				// ʂL^
				write_ini_verify2(-1, meta_data, switch_v, find_num);
			}
			CloseHandle(hFile);	// t@C
			if (find_num < 0){
				return find_num;	// ɃG[
			} else if (find_num > 0){	// XCXoꂽ
				if (sc->flake_count > 0){	// XCXfЂ̈v𒲂ׂ
					if (check_flake(file_path, switch_v, files, s_blk, sc) != 0)
						return -1;
				}
				print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\

				// t@C\
				if (_wcsnicmp(base_dir, file_name, base_len) == 0){	// fBNgȉȂ
					utf16_to_cp(file_name + base_len, ascii_buf, cp_output);	// ΃pXɂ
					printf("%13I64d Found    : \"%s\"\n", file_size, ascii_buf);
				} else {	// fBNg̊OȂ
					path_to_cp(file_name, ascii_buf, cp_output);	// pX\
					printf("%13I64d External : \"%s\"\n", file_size, ascii_buf);
				}
				// t@CƂɌXCX\
				show_file_slice(ascii_buf, files, s_blk);
				fflush(stdout);
				if (first_num >= source_num)	// SẴXCXΔ
					return 0;
			} else {
				print_progress_done();	// oߕ\ 100% ɂĂ
			}
		}

		list2_off += len + 1;	// ̃t@C
	}

	return 0;
}

// ̕ʖt@Cɋʂ镔΁Ãt@CƗ\z
static int check_common_misname(
	wchar_t *find_name,		// ̃t@C߂
	file_ctx_r *files)		// e\[XEt@C̏
{
	wchar_t common_part[MAX_LEN], filename[MAX_LEN], *tmp_p;
	int i, len, misname_count, lost_count;

	common_part[0] = 0;
	misname_count = 0;
	lost_count = 0;
	for (i = 0; i < entity_num; i++){
		if ((files[i].state & 0x28) == 0x20){	// ʖȂ (jĕʖ͊܂߂Ȃ)
			wcscpy(filename, list_buf + files[i].name2);
			if (wcschr(filename, '\\') != NULL)	// TuEfBNg܂ޏꍇ͔s\
				return 0;
			_wcslwr(filename);	// ɕϊĔr
			//printf_cp("misname %s\n", filename);
			if (common_part[0] == 0){	// ŏȂgq́u.vȍ~ȂăRs[
				wcscpy(common_part, filename);
				tmp_p = wcsrchr(common_part + 1, '.');	// 擪́u.v͖
				if (tmp_p != NULL){
					if (wcslen(tmp_p) < EXT_LEN)	// sIhcĊgq菜
						tmp_p[1] = 0;
				}
			} else {	// ڈȍ~͋ʕr
				len = 0;
				while (common_part[len] == filename[len]){
					if (filename[len] == 0)
						break;
					len++;
				}
				if (len < 2)
					return 0;	// Œł 2͋ʕKv
				common_part[len] = 0;
			}
			misname_count++;
		} else if (files[i].state == 0x01){	//  (`FbNT͖)
			lost_count++;
		}
	}

	// ɂ́Aʖt@CȏAt@CȏKv
	if ((misname_count < 2) || (lost_count < 1))
		return 0;

	//printf("common = \"%S\", len = %d\n", common_part, len);
	// l̓rȂA̎O܂łɂ
	// hoge.part1.txt  hoge.part10.txt ̋ʕ́uhoge.part1vA
	// uhoge.part1*vŌĂ hoge.part2.txt ͌Ȃ
	while (len > 0){
		i = common_part[len - 1];
		if ((i < '0') || (i > '9')){	// lłȂ΂
			break;
		} else {	// ʕ̖lȂ菜
			len--;
			common_part[len] = 0;
		}
	}
	if (len < 2)
		return 0;	// Œł 2͋ʕKv

	common_part[len    ] = '*';	// ŌɌ
	common_part[len + 1] = 0;
	wcscpy(find_name, common_part);
	return 1;
}

// fBNgāAOقȂĂ\[XEt@CT
// ÖقȂt@Cڍ׌̂ŁAA[JCũXCXoł
// 0=, -1=G[, -2=LZ
int search_additional_file(
	char *ascii_buf,		// Ɨp
	wchar_t *file_path,		// Ɨp
	int switch_v,			// x +16=oɕۑ
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk,	// e\[XEubN̏
	slice_ctx *sc)			// XCXp̏
{
	int find_num;
	unsigned int meta_data[7];
	__int64 file_size;
	HANDLE hFind, hFile;
	WIN32_FIND_DATA FindData;

	wcscpy(file_path, base_dir);
	if (switch_v & 2){	// ǉȂfBNg̃t@CSĒT
		wcscpy(file_path + base_len, L"*");
	} else {	// ̕ʖt@Cɋʂ镔΁AɂĒǉ
		if (check_common_misname(file_path + base_len, files) == 0)
			return 0;	// ǉȂݒŋʕ΁AȂ
	}

	// fBNg
	//printf_cp("\n search path = %s \n", file_path);
	hFind = FindFirstFile(file_path, &FindData);
	if (hFind == INVALID_HANDLE_VALUE)
		return 0;
	do {
		if (cancel_progress() != 0){	// LZ
			FindClose(hFind);
			return 2;
		}

		// tH_͖
		if ((FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0)
			continue;
		// t@CETCYŏubNt@C͖
		file_size = ((__int64)(FindData.nFileSizeHigh) << 32) | (__int64)(FindData.nFileSizeLow);
		if (file_size < (__int64)(sc->min_size))
			continue;
		// jĂȂJoEt@C͖
		wcscpy(file_path + base_len, FindData.cFileName);
		if (search_file_path(recv_buf, recv_len, file_path))
			continue;
		// \[XEt@C⌟ς݂̕Eގt@C͖
		if (search_file_path(list_buf + 1, list_len - 1, FindData.cFileName))
			continue;
		// j\[XEt@C̍ƃt@C͖
		if (avoid_temp_file(FindData.cFileName, files))
			continue;
		// ς݂̎wt@C͖
		if (list2_buf){
			if (search_file_path(list2_buf, list2_len, file_path))
				continue;
		}
		utf16_to_cp(FindData.cFileName, ascii_buf, cp_output);
		//printf("\n verifying, %s\n", ascii_buf);

		// t@Că\[XEubNT
		hFile = CreateFile(file_path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){
			prog_last = -1;	// oߕ\܂̈
			find_num = check_ini_verify(FindData.cFileName, hFile, -1, meta_data, switch_v, files, s_blk, sc);
			if (find_num == -3){	// ʂ̋L^
				if (switch_v & 1){	// ȈՌ
					find_num = search_block_simple(file_path, -1, 0, FindData.cFileName,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				} else {	// ڍ׌
					find_num = search_block_slide(file_path, -1, 0, FindData.cFileName,
								hFile, file_size, 0, switch_v, files, s_blk, sc);
				}
				// ʂL^
				write_ini_verify2(-1, meta_data, switch_v, find_num);
			}
			CloseHandle(hFile);	// t@C
			if (find_num < 0){
				FindClose(hFind);
				return find_num;	// ɃG[
			} else if (find_num > 0){	// XCXoꂽ
				if (sc->flake_count > 0){	// XCXfЂ̈v𒲂ׂ
					if (check_flake(file_path, switch_v, files, s_blk, sc) != 0){
						FindClose(hFind);
						return -1;
					}
				}
				print_progress_file(-1, first_num, NULL);	// dOp\ȃ\[XEubN\

				// t@C\
				utf16_to_cp(FindData.cFileName, ascii_buf, cp_output);
				printf("%13I64d Found    : \"%s\"\n", file_size, ascii_buf);
				// t@CƂɌXCX\
				show_file_slice(ascii_buf, files, s_blk);
				fflush(stdout);
				if (first_num >= source_num){	// SẴXCXΔ
					FindClose(hFind);
					return 0;
				}
			} else {
				print_progress_done();	// oߕ\ 100% ɂĂ
			}
		}
	} while (FindNextFile(hFind, &FindData));	// ̃t@C
	FindClose(hFind);

	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// XCXtZ邩AʂĂXCXT
int search_calculable_slice(
	file_ctx_r *files,		// e\[XEt@C̏
	source_ctx_r *s_blk)	// e\[XEubN̏
{
	unsigned char hash[20];
	int i, j, k, num, b_last, lost_count, block_count;
	int zero_count, reve_count, dupl_count;
	int *order = NULL;

	block_count = 0;
	lost_count = 0;
	for (num = 0; num < entity_num; num++){
		if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++){
				if (s_blk[i].exist != 0){
					block_count++;	// r\ȃXCX̐
				} else {
					lost_count++;	// ĂXCX̐
				}
			}
		}
	}
	if (lost_count == 0)
		return 0;	// rȂŏI

	if (block_size <= 4){	// ubNETCY 4oCgȉȂSċtZł
		reve_count = lost_count - first_num;
		first_num += reve_count;
		for (num = 0; num < entity_num; num++){
			if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
				if (files[num].state & 0x0A){	// j 0x02Ajĕʖ 0x28 Ȃ
					files[num].state &= 0xFF;	//  24-bit ̋L^Ă
					// {͐擪̊SȃXCX̏Ԃ 2 ARs[ɑSĕ
					if (files[num].state & 0x02){	// jłSẴXCX𗘗pł
						b_last = files[num].b_off + files[num].b_num;
						for (i = files[num].b_off; i < b_last; i++)
							s_blk[i].exist = 5;	// CRC œe𕜌ł
					}
				}
			}
		}
		printf("\nComparing lost slice\t: %d\n", reve_count);
		printf("Reversible slice count\t: %d\n", reve_count);
		fflush(stdout);
		return reve_count;
	}

	//printf("lost_count = %d, block_count = %d\n", lost_count, block_count);
	if (block_count > 0){
		// CRC-32 ̏i[obt@[mۂ
		order = (int *)malloc(block_count * 4);
		if (order == NULL)
			return 0;
		block_count = 0;
		for (num = 0; num < entity_num; num++){
			if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
				b_last = files[num].b_off + files[num].b_num;
				for (i = files[num].b_off; i < b_last; i++){
					if (s_blk[i].exist != 0){	// r\ȃXCX
						order[block_count] = i;	// ŏ̓ubNԍɂĂ
						block_count++;
					}
				}
			}
		}
		// ɕёւ
		quick_sort(order, 0, block_count - 1, s_blk);
	}

	printf("\nComparing lost slice\t: %d within %d\n", lost_count, block_count);
	fflush(stdout);
	zero_count = 0;
	reve_count = 0;
	dupl_count = 0;
	data_md5_crc32_zero(hash);	// S 0̃ubÑ`FbNTvZĂ
	for (num = 0; num < entity_num; num++){
		if ((files[num].state & 0x80) == 0){	// `FbNTt@Cr
			b_last = files[num].b_off + files[num].b_num;
			for (i = files[num].b_off; i < b_last; i++){
				if (s_blk[i].exist == 0){	// ĂXCX
					if (memcmp(s_blk[i].hash, hash, 20) == 0){
						s_blk[i].exist = 3;	// eS 0 ̃ubN
						zero_count++;
						first_num++;
						//printf(" block[%d] = zero only\n", i);

					} else if (s_blk[i].size <= 4){
						// ̃ubNe 4oCgȉȂtZ
						s_blk[i].exist = 5;	// CRC œe𕜌ł
						reve_count++;
						first_num++;
						//printf(" block[%d] = reversible\n", i);

					} else if (block_count > 0){
						// ꂽXCXƓẽXCXT
/*						for (j = 0; j < block_count; j++){	// linear search
							k = order[j];
							if (s_blk[i].size == s_blk[k].size){	// TCYv
								if (memcmp(s_blk[i].hash, s_blk[k].hash, 20) == 0){
									// ubÑ`FbNTvȂ
									s_blk[i].exist = 4;	// ẽ\[XEubN݂
									s_blk[i].file = k;	// ̃ubNԍL^Ă
									dupl_count++;
									first_num++;
									//printf(" lost block[%d] = existent block[%d]\n", i, k);
									break;
								}
							}
						}
*/
						j = binary_search(order, block_count, s_blk[i].crc, s_blk);	// CRC-32 vԍ
						for (; j < block_count; j++){	// ubNv邩Ȃ̂
							k = order[j];
							if (s_blk[i].crc != s_blk[k].crc)
								break;	// CRC-32 vȂȂ甲
							if (s_blk[i].size == s_blk[k].size){	// TCYv
								if (memcmp(s_blk[i].hash, s_blk[k].hash, 16) == 0){
									// ubÑ`FbNTvȂ
									s_blk[i].exist = 4;	// ẽ\[XEubN݂
									s_blk[i].file = k;	// ̃ubNԍL^Ă
									dupl_count++;
									first_num++;
									//printf(" lost block[%d] = existent block[%d]\n", i, k);
									break;
								}
							}
						}
					}
					if (zero_count + reve_count + dupl_count >= lost_count)
						break;	// \Ȑ̃ubN甲
				}
			}
		}
	}
	printf("Null byte slice count\t: %d\n", zero_count);
	printf("Reversible slice count\t: %d\n", reve_count);
	printf("Duplicate slice count\t: %d\n", dupl_count);
	fflush(stdout);

	if (order)
		free(order);
	return zero_count + reve_count + dupl_count;
}

